'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _search = require('./search');

var _search2 = _interopRequireDefault(_search);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dialog = function (_React$Component) {
  _inherits(Dialog, _React$Component);

  function Dialog(props) {
    _classCallCheck(this, Dialog);

    var _this = _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props));

    _this.onEsc = function (e) {
      if (_tinsoEditorEngine2.default.isHotkey('esc', e)) {
        _this.close();
      }
    };

    _this.extends = function () {
      _this.props.engine.dialog = {
        set: _this.set,
        close: _this.close,
        store: _this.store,
        restore: _this.restore
      };
    };

    _this.set = function (state) {
      if (!state) {
        _this.close();
      }
      var engine = _this.props.engine;

      _this.setState(state);
      localStorage.setItem('zacheditor-dialog', state.name);
      engine.toolbar.updateState();
    };

    _this.close = function () {
      _this.setState({
        name: 'none'
      });
      localStorage.setItem('zacheditor-dialog', 'none');
    };

    _this.store = function (config) {
      var engine = _this.props.engine;

      _this.storeConfig = config;
      engine.dialog.storeConfig = config;
    };

    _this.restore = function () {
      _this.set(_this.storeConfig);
    };

    _this.state = {
      name: 'none'
    };
    return _this;
  }

  _createClass(Dialog, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      _tinsoEditorEngine2.default.$(document).on('keydown', this.onEsc);
      this.extends();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _tinsoEditorEngine2.default.$(document).off('keydown', this.onEsc);
    }
  }, {
    key: 'render',
    value: function render() {
      var name = this.state.name;

      return name === 'none' ? null : _react2.default.createElement(
        'div',
        { className: 'zacheditor-dialog' },
        name === 'search' && _react2.default.createElement(_search2.default, _extends({}, this.props, { onClose: this.close })),
        ' '
      );
    }
  }]);

  return Dialog;
}(_react2.default.Component);

exports.default = Dialog;