'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/tabs/style');

require('antd/lib/input/style');

require('antd/lib/button/style');

var _engine = require('../editor/engine');

var _engine2 = _interopRequireDefault(_engine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabPane = _antd.Tabs.TabPane;
/**
 * @fileOverview 搜索会话框
 */

var DialogSearch = function (_React$Component) {
  _inherits(DialogSearch, _React$Component);

  function DialogSearch() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DialogSearch);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DialogSearch.__proto__ || Object.getPrototypeOf(DialogSearch)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      searchValue: null,
      replacement: ''
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DialogSearch, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var engine = this.props.engine;
      var search = engine.search;

      search.clear();
      search.off('after:select', this.onAfterSelect);
      engine.off('change', this.onDocChange);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var engine = this.props.engine;
      var search = engine.search;

      var input = this.inputRef.input;

      var onAfterSelect = function onAfterSelect() {
        _this2.setState({
          engine: engine
        });
      };

      var onDocChange = function onDocChange() {
        if (!engine.command.queryState('search')) {
          return;
        }
        engine.search.reFind();
      };

      this.onAfterSelect = onAfterSelect;
      this.onDocChange = onDocChange;
      search.on('after:select', onAfterSelect);
      input.focus(); // 初始化自动聚焦查找框
      // 编辑时候更新搜索结果
      engine.on('change', onDocChange);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          engine = _props.engine,
          onClose = _props.onClose;

      var search = engine.search;
      var locale = engine.locale.search;
      var _state = this.state,
          searchValue = _state.searchValue,
          replacement = _state.replacement;

      var count = search.count();
      var searchInput = _react2.default.createElement(
        'p',
        { style: { marginBottom: '12px' } },
        _react2.default.createElement(_antd.Input, {
          accessbilityid: 'search-input',
          placeholder: locale.pleaseEnter,
          onKeyDown: function onKeyDown(e) {
            if (_engine2.default.isHotkey('enter', e)) {
              search.next();
            }
          },
          onChange: function onChange(e) {
            var ranges = search.find(e.target.value);
            search.select(ranges[0]);
            _this3.setState({
              searchValue: e.target.value
            });
            search.scrollIntoView();
          },
          ref: function ref(element) {
            return _this3.inputRef = element;
          },
          value: searchValue,
          suffix: count === 0 ? _react2.default.createElement(
            'span',
            { className: 'count' },
            '0'
          ) : _react2.default.createElement(
            'span',
            { className: 'count' },
            count[0] / count[1]
          )
        })
      );
      var replacementInput = _react2.default.createElement(
        'p',
        { style: { marginBottom: '16px' } },
        _react2.default.createElement(_antd.Input, {
          accessbilityid: 'replace-input',
          placeholder: locale.pleaseEnter,
          onChange: function onChange(e) {
            _this3.setState({
              replacement: e.target.value
            });
          }
        })
      );
      var next = _react2.default.createElement(
        _antd.Button,
        {
          onClick: function onClick() {
            search.next();
          },
          disabled: !!(count === 0 || count[0] === count[1])
        },
        locale.next
      );
      var prev = _react2.default.createElement(
        _antd.Button,
        {
          onClick: function onClick() {
            search.prev();
          },
          disabled: !!(count === 0 || count[0] === count[1])
        },
        locale.previous
      );
      return _react2.default.createElement(
        _antd.Tabs,
        {
          defaultActiveKey: 'search',
          animated: false,
          className: 'zacheditor-search',
          style: { padding: '0 2px' },
          tabBarExtraContent: _react2.default.createElement('span', {
            className: 'zacheditor-icon zacheditor-icon-close',
            accessbilityid: 'searchreplace-close-button',
            onClick: function onClick() {
              return onClose();
            }
          })
        },
        _react2.default.createElement(
          TabPane,
          { tab: locale.search, key: 'search' },
          searchInput,
          _react2.default.createElement(
            'p',
            { style: { textAlign: 'right' } },
            prev,
            next
          )
        ),
        _react2.default.createElement(
          TabPane,
          { tab: locale.replace, key: 'replace' },
          _react2.default.createElement(
            'p',
            { style: { textAlign: 'right' } },
            locale.search
          ),
          searchInput,
          _react2.default.createElement(
            'p',
            null,
            locale.replaceTo
          ),
          replacementInput,
          _react2.default.createElement(
            'p',
            { style: { textAlign: 'right' } },
            _react2.default.createElement(
              _antd.Button,
              {
                onClick: function onClick() {
                  search.replaceAll(replacement);
                  search.scrollIntoView();
                },
                style: { marginLeft: '0px' },
                disabled: count === 0
              },
              locale.replaceAll
            ),
            _react2.default.createElement(
              _antd.Button,
              {
                onClick: function onClick() {
                  search.replace(replacement);
                  search.scrollIntoView();
                },
                disabled: count === 0
              },
              locale.replace
            ),
            prev,
            next
          )
        )
      );
    }
  }]);

  return DialogSearch;
}(_react2.default.Component);

exports.default = DialogSearch;