'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lozad = require('lozad');

var _lozad2 = _interopRequireDefault(_lozad);

var _engine = require('./engine');

var _engine2 = _interopRequireDefault(_engine);

var _en = require('../lang/en');

var _en2 = _interopRequireDefault(_en);

var _zhCn = require('../lang/zh-cn');

var _zhCn2 = _interopRequireDefault(_zhCn);

var _config = require('../schema/config');

var _config2 = _interopRequireDefault(_config);

var _iframe = require('../helper/iframe');

var _iframe2 = _interopRequireDefault(_iframe);

var _string = require('../utils/string');

var _outline = require('../utils/outline');

var _outline2 = _interopRequireDefault(_outline);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var linkDomain = ['zacheditor.com'];

var language = {
  en: _en2.default,
  'zh-cn': _zhCn2.default
};

var markdownPlaceholder = {
  PLACEHOLDER: '<div id="markdown-toc"></div>',
  TAG_ID: 'markdown-toc'
};

window.lozad_observer = (0, _lozad2.default)('.lozad', {
  rootMargin: '10px 0px',
  threshold: 0.1
});

var ContentView = function (_React$Component) {
  _inherits(ContentView, _React$Component);

  function ContentView() {
    _classCallCheck(this, ContentView);

    var _this = _possibleConstructorReturn(this, (ContentView.__proto__ || Object.getPrototypeOf(ContentView)).call(this));

    _this.containsMarkdownToc = function (content) {
      return !!content && content.includes(markdownPlaceholder.PLACEHOLDER);
    };

    _this.adaptContent = function (content) {
      if (!content) return '';
      content += '';
      var sechema = new _engine2.default.Schema();
      sechema.add(_config2.default);
      var parser = new _engine2.default.HTMLParser(content, sechema);
      _this.docVerstion = (0, _string.getDocVersion)(content);
      return parser.toLowerValue();
    };

    _this.addRelToLink = function () {
      _engine2.default.$(_this.viewArea.current).find('a[target=_blank]').each(function (node) {
        if (node.closest('[data-section-key=file]') || node.closest('[data-section-key=localdoc]')) return;
        var isDomain = function isDomain(href) {
          if (!/^(?:\w{1,20}:){0,1}\/\//i.test(href)) return true;
          var url = void 0;
          try {
            url = new URL(href);
          } catch (e) {
            return false;
          }
          var hostname = url.hostname;
          if (!hostname) return false;
          for (var i = 0; linkDomain.length > i; i++) {
            var domain = linkDomain[i];
            if (hostname === domain || hostname.endsWith('.'.concat(domain))) return true;
          }
          return false;
        };

        if (!isDomain(node.href)) _engine2.default.$(node).attr('rel', 'noopener noreferrer');
      });
    };

    _this.addHeadingAnchor = function () {
      _engine2.default.$(_this.viewArea.current).find('h1,h2,h3,h4,h5,h6').each(function (node) {
        node = _engine2.default.$(node);
        var id = node.attr('id');
        if (id) {
          node.prepend('<a class="zacheditor-anchor" href="#'.concat(id, '"></a>'));
        }
      });
    };

    _this.removeInvalidStyles = function () {
      _engine2.default.$(_this.viewArea.current).children().each(function (child) {
        child = _engine2.default.$(child);
        _engine2.default.NodeUtils.removeMinusStyle(child, 'text-indent');
      });
    };

    _this.renderContent = function () {
      var _this$props = _this.props,
          lang = _this$props.lang,
          onBeforeRenderImage = _this$props.onBeforeRenderImage,
          customMaximizeRestore = _this$props.customMaximizeRestore,
          customMaximize = _this$props.customMaximize,
          autoMaximizeSection = _this$props.autoMaximizeSection,
          renderParser = _this$props.renderParser,
          content = _this$props.content,
          genAnchor = _this$props.genAnchor,
          genOutline = _this$props.genOutline,
          onLoad = _this$props.onLoad,
          options = _objectWithoutProperties(_this$props, ['lang', 'onBeforeRenderImage', 'customMaximizeRestore', 'customMaximize', 'autoMaximizeSection', 'renderParser', 'content', 'genAnchor', 'genOutline', 'onLoad']);

      var view = _engine2.default.$(_this.viewArea.current);
      var contentViewEngine = _engine2.default.ContentView.create(view, _extends({
        lang: lang,
        section: _engine2.default.section,
        plugin: _engine2.default.plugin,
        onBeforeRenderImage: onBeforeRenderImage,
        customMaximizeRestore: customMaximizeRestore,
        autoMaximizeSection: autoMaximizeSection,
        customMaximize: customMaximize
      }, options));
      contentViewEngine.docVerstion = _this.docVerstion;
      contentViewEngine.iframeHelper = new _iframe2.default();
      contentViewEngine.locale = language[lang];
      contentViewEngine.schema.add(_config2.default);
      _engine2.default.section.renderAll(_this.viewArea.current, undefined, contentViewEngine);
      _this.container = view;

      if (autoMaximizeSection) {
        var autoNode = _engine2.default.$(document.getElementById(autoMaximizeSection));
        if (autoNode) {
          _engine2.default.section.maximize({
            sectionRoot: autoNode,
            contentView: contentViewEngine
          });
        }
      }
      // 处理链接
      _this.addRelToLink();
      _this.removeInvalidStyles();
      if (renderParser) {
        var parentNode = _this.viewArea.current.parentNode;
        renderParser.parse(_this.viewArea.current);
        parentNode.appendChild(_this.viewArea.current);
      }
      // 处理锚点
      if (genAnchor) {
        _this.addHeadingAnchor();
      }
    };

    _this.viewArea = _react2.default.createRef();
    return _this;
  }

  _createClass(ContentView, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.renderContent();
      var config = {
        outline: []
      };
      if (true === this.props.genOutline) {
        config.outline = _outline2.default.extractFromDom(this.viewArea.current);
        if (this.containsMarkdownToc(this.props.content)) {
          this.renderMarkdownToc(config.outline);
        }
      }
      // 渲染完毕后激活 onReady
      // 不应该复用 ContentViewer 去根据传入的 content 来渲染不同的内容
      // 由业务层保证不同的内容用 key 控制生成不同的实例，保持 ContentViewer 的简洁性
      if (typeof this.props.onLoad === 'function') {
        this.props.onLoad(this.viewArea.current, config);
      }
      this.container.attr('tabindex', 0);
      this.container.on('keydown', function (event) {
        if (_engine2.default.isHotkey('mod+a', event)) {
          event.preventDefault();
          window.getSelection().getRangeAt(0).selectNode(_this2.container[0]);
        }
      });
      if (window.lozad_observer) {
        window.lozad_observer.observe();
      }
    }
  }, {
    key: 'renderMarkdownToc',
    value: function renderMarkdownToc(outline) {
      if (outline.length === 0) return;
      var prepend = document.createElement('div');
      this.viewArea.current.prepend(prepend);
      _reactDom2.default.render(_react2.default.createElement(
        'div',
        { className: 'zacheditor-embed-outline' },
        _react2.default.createElement(
          'h3',
          null,
          language[this.props.lang].toc.title
        ),
        _react2.default.createElement(
          'ul',
          null,
          outline.map(function (item) {
            return _react2.default.createElement(
              'li',
              {
                className: 'zacheditor-embed-outline zacheditor-embed-outline-'.concat(item.depth),
                key: item.id
              },
              _react2.default.createElement(
                'a',
                { href: '#'.concat(encodeURIComponent(item.id)) },
                _react2.default.createElement(
                  'span',
                  null,
                  item.text
                )
              )
            );
          })
        )
      ));
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(props) {
      return this.props.content !== props.content;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (this.props.content !== prevProps.content) {
        this.renderContent();
      }
    }
    // 修复安全漏洞，target="blank" 属性，触发钓鱼风险
    // http://www.zerokeeper.com/web-security/target-blank-property-triggering-fishing-risk.html

  }, {
    key: 'render',
    value: function render() {
      var content = this.adaptContent(this.props.content);
      return _react2.default.createElement('div', {
        className: 'zacheditor-engine-view',
        ref: this.viewArea,
        dangerouslySetInnerHTML: { __html: content }
      });
    }
  }]);

  return ContentView;
}(_react2.default.Component);

ContentView.defaultProps = {
  lang: 'zh-cn',
  content: '',
  genAnchor: false,
  genOutline: true,
  onLoad: function onLoad() {},
  onBeforeRenderImage: function onBeforeRenderImage(url) {
    return url;
  },
  image: {
    display: 'block',
    align: 'center'
  }
};

exports.default = ContentView;