'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _en = require('../lang/en');

var _en2 = _interopRequireDefault(_en);

var _zhCn = require('../lang/zh-cn');

var _zhCn2 = _interopRequireDefault(_zhCn);

var _string = require('../utils/string');

var _antd = require('antd');

var _html = require('../parser/html');

var _html2 = _interopRequireDefault(_html);

var _helper = require('../helper');

var _helper2 = _interopRequireDefault(_helper);

var _migrate = require('../helper/migrate');

var _migrate2 = _interopRequireDefault(_migrate);

var _config = require('../schema/config');

var _config2 = _interopRequireDefault(_config);

var _engine = require('./engine');

var _engine2 = _interopRequireDefault(_engine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var language = {
  en: _en2.default,
  'zh-cn': _zhCn2.default
};

var migrate = new _migrate2.default();

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor(props) {
    _classCallCheck(this, Editor);

    var _this = _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).call(this, props));

    _this.extendEngine = function (engine) {
      engine.getContent = function () {
        return (0, _string.addMentionAttrs)(engine.getValue());
      };

      engine.getPureContent = function () {
        return (0, _string.addMentionAttrs)(engine.getPureValue());
      };

      engine.disable = function (disabled) {
        engine.toolbar.disable(disabled);
        engine.readonly(disabled);
        engine.isDisabled = disabled;
      };

      engine.messageSuccess = function (msg) {
        _antd.message.success(msg);
      };

      engine.messageError = function (msg) {
        _antd.message.error(msg);
      };

      engine.getPureHtml = function () {
        return engine.getHtml(new _html2.default());
      };

      //helper(engine, "pasteFileTransfer", {})
    };

    _this.engine = null;
    _this.locale = language[props.lang];
    _this.container = _react2.default.createRef();
    return _this;
  }

  _createClass(Editor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          onEngineReady = _props.onEngineReady,
          ot = _props.ot;

      this.engine = this.renderEditor();
      if (!ot) this.engine.setDefaultValue(this.engine.options.defaultValue);
      this.extendEngine(this.engine);
      onEngineReady(this.engine);
    }
  }, {
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(_ref) {
      var onSave = _ref.onSave,
          onChange = _ref.onChange;

      this.engine.options = _extends({}, this.engine.options, {
        onSave: onSave,
        onChange: onChange
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.engine) {
        this.engine.destroy();
      }
    }
  }, {
    key: 'renderEditor',
    value: function renderEditor() {
      var _this2 = this;

      var _props2 = this.props,
          defaultValue = _props2.defaultValue,
          options = _objectWithoutProperties(_props2, ['defaultValue']);

      var value = ((defaultValue || '<p><br /></p>') + '').trim();
      value = _engine2.default.StringUtils.removeBookmarkTags(value);
      options.defaultValue = value;
      options.parentNode = this.container.current.parentNode;
      var engine = _engine2.default.create(this.container.current, options);
      var version = (0, _string.getDocVersion)(defaultValue);
      engine.schema.add(_config2.default);
      engine.locale = this.locale;
      engine.on('change', function (value) {
        value = (0, _string.addMentionAttrs)(value);
        _this2.engine.options.onChange(value);
        _this2.engine.toolbar.updateState();
      });
      engine.on('select', function () {
        _this2.engine.toolbar.updateState();
      });
      engine.setDefaultValue = function (defaultValue) {
        var value = ((defaultValue || '') + '').trim();
        value = _engine2.default.StringUtils.removeBookmarkTags(value);
        _this2.engine.history.stop();
        _this2.engine.setValue(value || '<p><br /></p>');
        if (value) {
          migrate.update(version, _string.DocVersion, _this2.engine.container);
        }
        _this2.engine.history.start();
        _this2.engine.history.save(true, false);
      };
      return engine;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('div', { ref: this.container });
    }
  }]);

  return Editor;
}(_react2.default.Component);

Editor.defaultProps = {
  lang: 'zh-cn',
  fontsize: {
    defaultNumber: '小四'
  },
  onChange: function onChange() {},
  onEngineReady: function onEngineReady() {},
  onBeforeRenderImage: function onBeforeRenderImage(url) {
    return url;
  },
  onBeforePreviewFile: function onBeforePreviewFile(url) {
    return url;
  },
  onBeforeDownloadFile: function onBeforeDownloadFile(url) {
    return url;
  },
  mxgraph: {
    url: 'http://www.draw.io/?embed=1&ui=atlas&spin=1&proto=json&configure=1&lang=zh'
  },
  emoji: {
    action: 'https://cdn-object.itellyou.com/emoji/'
  },
  lockedtext: {
    action: '/api/crypto'
  },
  image: {
    action: '/api/upload/file',
    display: 'block',
    align: 'center'
  },
  file: {
    action: '/api/upload/file'
  },
  video: {
    action: {
      create: '/api/upload/video',
      save: '/api/upload/video/save',
      query: '/api/upload/video/query'
    }
  },
  translate: {
    action: '/api/translate'
  },
  mention: {
    action: '/api/user/search',
    paramName: 'q',
    default: []
  },
  onlinedoc: {
    action: '/hwme-service/richFilemanager/index.html'
  },
  // markdown: {
  //   action: '/api/document/convert',
  //   items: [
  //     'codeblcok',
  //     'code',
  //     'mark',
  //     'bold',
  //     'strikethrough',
  //     'italic',
  //     'sup',
  //     'sub',
  //     'orderedlist',
  //     'unorderedlist',
  //     'tasklist',
  //     'checkedtasklist',
  //     'h1',
  //     'h2',
  //     'h3',
  //     'h4',
  //     'h5',
  //     'h6',
  //     'quote',
  //     'link',
  //   ],
  // },
  ot: false
};
exports.default = Editor;