'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _en = require('../lang/en');

var _en2 = _interopRequireDefault(_en);

var _zhCn = require('../lang/zh-cn');

var _zhCn2 = _interopRequireDefault(_zhCn);

var _helper = require('../helper');

var _helper2 = _interopRequireDefault(_helper);

var _engine = require('./engine');

var _engine2 = _interopRequireDefault(_engine);

var _dialog = require('../dialog');

var _dialog2 = _interopRequireDefault(_dialog);

var _toolbar = require('../toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _sidebar = require('../sidebar');

var _sidebar2 = _interopRequireDefault(_sidebar);

var _editor = require('./editor');

var _editor2 = _interopRequireDefault(_editor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var language = {
  en: _en2.default,
  'zh-cn': _zhCn2.default
};

var FullEditor = function (_React$Component) {
  _inherits(FullEditor, _React$Component);

  function FullEditor(props) {
    _classCallCheck(this, FullEditor);

    var _this = _possibleConstructorReturn(this, (FullEditor.__proto__ || Object.getPrototypeOf(FullEditor)).call(this));

    _this.onEngineReady = function (engine) {
      _this.engine = engine;
      _this.setState({
        engine: engine
      }, function () {
        (0, _helper2.default)(engine, 'search', {
          target: _this.contentEditor.current
        });

        (0, _helper2.default)(engine, 'translate');
        var _engine$options = engine.options,
            image = _engine$options.image,
            file = _engine$options.file;

        (0, _helper2.default)(engine, 'uploader', {
          actions: {
            image: image ? image.action : '',
            file: file ? file.action : ''
          }
        });

        (0, _helper2.default)(engine, 'iframeHelper');

        _this.bindScrollEvent();

        engine.on('maximizesection', function () {
          engine.container.closest('.zacheditor-pro').addClass('zacheditor-maximize-section');
        });

        engine.on('restoresection', function () {
          engine.container.closest('.zacheditor-pro').removeClass('zacheditor-maximize-section');
        });

        _this.props.onLoad(engine);
      });
    };

    _this.handleScroll = function () {
      if (_this.zacheditorFullEditorWrapperContent[0].scrollTop > 16) {
        _this.zacheditorToolbar.addClass('zacheditor-toolbar-active');
      } else {
        _this.zacheditorToolbar.removeClass('zacheditor-toolbar-active');
      }
    };

    _this.state = {
      engine: null,
      toolbar: props.toolbar
    };

    _this.locale = language[props.lang];
    _this.contentEditor = _react2.default.createRef();
    return _this;
  }

  _createClass(FullEditor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _engine2.default.$(document.body).css({
        'overscroll-behavior-x': '',
        'overflow-y': ''
      });
    }
  }, {
    key: 'bindScrollEvent',
    value: function bindScrollEvent() {
      this.zacheditorToolbar = _engine2.default.$('.zacheditor-toolbar');
      this.zacheditorFullEditorWrapperContent = _engine2.default.$('.zacheditor-max-editor-wrapper-content');
      this.zacheditorFullEditorWrapperContent.on('scroll', this.handleScroll);
      _engine2.default.$(document.body).css({
        'overscroll-behavior-x': 'none',
        'overflow-y': 'hidden'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          engine = _state.engine,
          toolbar = _state.toolbar;
      var _props = this.props,
          type = _props.type,
          header = _props.header;

      var toolbarOptions = {
        type: type,
        engine: engine,
        toolbar: toolbar,
        locale: this.locale
      };

      var editorOptions = function (props) {
        var options = Object.assign({}, props);

        var onLoad = options.onLoad,
            header = options.header,
            type = options.type,
            toolbar = options.toolbar,
            editorOptions = _objectWithoutProperties(options, ['onLoad', 'header', 'type', 'toolbar']);

        return editorOptions;
      }(this.props);
      return _react2.default.createElement(
        'div',
        { className: 'zacheditor-pro zacheditor-max-editor' },
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-max-editor-wrapper' },
          engine && _react2.default.createElement(_dialog2.default, { engine: engine }),
          engine && _react2.default.createElement(_toolbar2.default, Object.assign({ hasMore: false }, toolbarOptions)),
          engine && _react2.default.createElement(_sidebar2.default, { engine: engine }),
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-max-editor-wrapper-content' },
            _react2.default.createElement(
              'div',
              { className: 'zacheditor-max-editor-content' },
              _react2.default.createElement(
                'div',
                { className: 'zacheditor-content-editor', ref: this.contentEditor },
                header && _react2.default.createElement(
                  'div',
                  { className: 'zacheditor-content-editor-extra' },
                  header
                ),
                _react2.default.createElement(_editor2.default, Object.assign({
                  onEngineReady: this.onEngineReady
                }, editorOptions))
              )
            )
          )
        )
      );
    }
  }]);

  return FullEditor;
}(_react2.default.Component);

FullEditor.defaultProps = {
  lang: 'zh-cn',
  type: 'max',
  tabIndex: 2,
  toolbar: [['section'], ['save', 'undo', 'redo', 'paintformat', 'removeformat'], ['heading', 'fontsize'], ['bold', 'italic', 'strikethrough', 'underline', 'moremark'], ['fontcolor', 'highlight'], ['alignment'], ['unorderedlist', 'orderedlist', 'tasklist', 'indent-list'], ['link', 'quote', 'hr'], ['search', 'translate', 'toc']],
  onLoad: function onLoad() {}
};
exports.default = FullEditor;