"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IFrame = function () {
    function IFrame(cfg) {
        _classCallCheck(this, IFrame);

        this.options = _extends({
            limit: 100
        }, cfg);
        this.iframeItems = [];
    }

    _createClass(IFrame, [{
        key: "add",
        value: function add(item) {
            if (this.canAdd()) {
                this.iframeItems.push(item);
                return true;
            } else {
                console.warn("can not add embed section more than ".concat(this.options.limit));
                return false;
            }
        }
    }, {
        key: "setSrc",
        value: function setSrc(iframe, src, isLozad) {
            if (isLozad) {
                var lozad = window.lozad_observer;
                iframe.addClass("lozad");
                iframe.attr("data-src", src);
                if (lozad) {
                    lozad.observe();
                }
            } else iframe.attr("src", src);
        }
    }, {
        key: "render",
        value: function render(cfg, delay, lozad) {
            var _this = this;

            var iframe = cfg.iframe,
                url = cfg.url;

            if (delay) {
                setTimeout(function () {
                    _this.setSrc(iframe, url, lozad);
                }, delay);
            } else {
                this.setSrc(iframe, url, lozad);
            }
        }
    }, {
        key: "remove",
        value: function remove(item) {
            var index = this.iframeItems.indexOf(item);
            if (index > -1) {
                this.iframeItems.splice(index, 1);
            }
        }
    }, {
        key: "canAdd",
        value: function canAdd() {
            return this.iframeItems.length < this.options.limit;
        }
    }, {
        key: "clear",
        value: function clear() {
            this.iframeItems = [];
        }
    }, {
        key: "destroy",
        value: function destroy() {
            this.options = undefined;
            this.iframeItems = undefined;
        }
    }]);

    return IFrame;
}();

exports.default = IFrame;