'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (engine, name) {
    var options = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {};
    if (engine && helper[name]) {
        options = Object.assign({}, options, {
            engine: engine
        });
        engine[name] = new helper[name](options);
    }
};

var _search = require('./search');

var _search2 = _interopRequireDefault(_search);

var _translate = require('./translate');

var _translate2 = _interopRequireDefault(_translate);

var _iframe = require('./iframe');

var _iframe2 = _interopRequireDefault(_iframe);

var _uploader = require('./uploader');

var _uploader2 = _interopRequireDefault(_uploader);

var _transfer = require('./transfer');

var _transfer2 = _interopRequireDefault(_transfer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var helper = {
    search: _search2.default,
    translate: _translate2.default,
    uploader: _uploader2.default,
    iframeHelper: _iframe2.default,
    pasteFileTransfer: _transfer2.default
};