'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _request = require('../utils/request');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transfer = function () {
  function Transfer(options) {
    _classCallCheck(this, Transfer);

    this.options = Object.assign({
      needTransferSections: ['file', 'localdoc'],
      engine: null
    }, options);

    this.action = this._getAttachmentCopyAction();
    this.bindEvent();
  }

  _createClass(Transfer, [{
    key: '_getAttachmentCopyAction',
    value: function _getAttachmentCopyAction() {
      var fileOptions = this.options.engine.options.file || {};
      var copyAction = fileOptions.copyAction,
          action = fileOptions.action;

      if (copyAction) return copyAction;
      if (action) {
        return action.replace(/token=[^&]+&/, '');
      }
      return '';
    }
  }, {
    key: '_transferFile',
    value: function _transferFile(node, value) {
      var engine = this.options.engine;

      (0, _request.post)(this.action, {
        attachments: [value.refSrc.replace(/(.*?)attachments\//, '')]
      }).then(function (res) {
        var url = res.data[0].url;
        _tinsoEditorEngine2.default.UploadUtils.updateSection(engine, node, url ? {
          src: url,
          status: 'done'
        } : {
          status: 'error',
          message: '\u8F6C\u5B58\u5931\u8D25\uFF1A\u8D44\u6E90\u4E0D\u5B58\u5728\u6216\u8005\u65E0\u6743\u8BBF\u95EE'
        }, true);
      }).catch(function () {
        _tinsoEditorEngine2.default.UploadUtils.updateSection(engine, node, {
          status: 'error'
        }, true);
      });
    }
  }, {
    key: 'bindEvent',
    value: function bindEvent() {
      var _this = this;

      var _options = this.options,
          engine = _options.engine,
          needTransferSections = _options.needTransferSections;

      engine.on('paste:each', function (node) {
        var data = node.attr('data-ready-section');
        if (needTransferSections.indexOf(data) > -1) {
          var value = engine.section.getValue(node);
          var src = value.src;
          if (src) {
            value.src = '';
            value.status = 'transfering';
            value.refSrc = src;
            engine.section.setValue(node, value);
          }
        }
      });
      var selector = '[data-section-key=' + needTransferSections.join('],[data-section-key=') + ']';
      engine.on('paste:after', function () {
        engine.container.find(selector).each(function (node) {
          var section = _tinsoEditorEngine2.default.$(node);
          var value = engine.section.getComponent(section).value;
          if (value.status === 'transfering' && value.refSrc) {
            _this._transferFile(section, value);
          }
        });
      });
    }
  }]);

  return Transfer;
}();

exports.default = Transfer;