'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventemitter = require('eventemitter2');

var _antd = require('antd');

var _string = require('../utils/string');

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var android = _tinsoEditorEngine2.default.userAgent.android;

var request = new _request2.default();
var ajax = function ajax(options) {
  return request.ajax(options);
};

var Uploader = function (_EventEmitter) {
  _inherits(Uploader, _EventEmitter);

  function Uploader(options) {
    _classCallCheck(this, Uploader);

    var _this = _possibleConstructorReturn(this, (Uploader.__proto__ || Object.getPrototypeOf(Uploader)).call(this));

    _this.options = Object.assign({}, options, {
      cache: {}
    });
    _this.uploadingSections = {};
    _this.uploadingFiles = {};
    _this.updateHistorySection = {};
    _this.sectionIds = {};
    return _this;
  }

  _createClass(Uploader, [{
    key: 'getUid',
    value: function getUid(text) {
      return Date.now() + '-' + text;
    }
  }, {
    key: 'addUploadingSection',
    value: function addUploadingSection(uid, section) {
      this.uploadingSections[uid] = section;
    }
  }, {
    key: 'getAccept',
    value: function getAccept(itemName) {
      if ('image' === itemName) {
        return android ? 'image/*' : _tinsoEditorEngine2.default.EXTS.IMAGE_EXT_STR;
      } else if (itemName === 'file') {
        return _tinsoEditorEngine2.default.EXTS.FILE_EXT_STR;
      } else if (itemName === 'localdoc') {
        return _tinsoEditorEngine2.default.EXTS.OFFICE_EXT_STR; //+ ", " + Engine.EXTS.MAC_OFFICE_STR
      } else return undefined;
    }
  }, {
    key: 'getAllowedExtensions',
    value: function getAllowedExtensions(itemName) {
      return 'image' === itemName ? _tinsoEditorEngine2.default.EXTS.IMAGE_EXT_STR : this.getAccept(itemName) || '';
    }
  }, {
    key: 'parseExtension',
    value: function parseExtension(file) {
      var ext = _tinsoEditorEngine2.default.UploadUtils.getFileExtname(file);
      var extension = {
        raw: ext,
        actual: ext
      };
      if (/\.mindnode\.zip$/.test(file.name)) {
        extension.actual = 'mindnode';
      } else if (/\.xmind\.zip$/.test(file.name)) {
        extension.actual = 'xmind';
      }
      return extension;
    }
  }, {
    key: 'request',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(type, files, options) {
        var _this2 = this;

        var engine, onBeforeUpload, onAfterUpload, uidList, i, file, beforeResult, upload;
        return regeneratorRuntime.wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                engine = this.options.engine;
                onBeforeUpload = options.onBeforeUpload, onAfterUpload = options.onAfterUpload;
                uidList = files.map(function (file, index) {
                  if (!file.uid) {
                    file.uid = _this2.getUid(index);
                  }
                  return file.uid;
                });
                i = 0;

              case 4:
                if (!(i < files.length)) {
                  _context3.next = 13;
                  break;
                }

                file = files[i];
                _context3.next = 8;
                return this.handleBeforeUpload(type, file, files, options);

              case 8:
                beforeResult = _context3.sent;

                if (!beforeResult) {
                  delete this.uploadingFiles[beforeResult.uid];
                }

              case 10:
                i++;
                _context3.next = 4;
                break;

              case 13:

                if (onBeforeUpload) {
                  onBeforeUpload();
                }

                upload = function () {
                  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    var _loop;

                    return regeneratorRuntime.wrap(function _callee$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
                              var file, formData, sectionId, options, action, locale, access_token;
                              return regeneratorRuntime.wrap(function _loop$(_context) {
                                while (1) {
                                  switch (_context.prev = _context.next) {
                                    case 0:
                                      file = files[i];
                                      formData = new FormData();
                                      sectionId = _this2.sectionIds[file.uid];

                                      if (sectionId) {
                                        formData.append('element_id', sectionId);
                                      }
                                      formData.append('file', file, file.name);
                                      options = _this2.options.engine.options[type];

                                      if ('localdoc' === type && !options) options = _this2.options.engine.options['file'];
                                      action = options.action;
                                      locale = engine.locale[type] || {};
                                      access_token = localStorage.getItem('AccessToken');
                                      _context.next = 12;
                                      return ajax({
                                        headers: {
                                          Accept: 'application/json',
                                          Authorization: 'Bearer ' + access_token
                                        },
                                        xhr: function xhr() {
                                          var xhr = new window.XMLHttpRequest();
                                          xhr.upload.addEventListener('progress', function (evt) {
                                            if (evt.lengthComputable) {
                                              _this2.handleChange(type, 'uploading', {
                                                uid: file.uid,
                                                progress: {
                                                  percent: parseInt(evt.loaded / evt.total * 100, 10)
                                                }
                                              });
                                            }
                                          }, false);
                                          return xhr;
                                        },
                                        url: action,
                                        data: formData,
                                        dataType: 'json',
                                        success: function success(_ref3) {
                                          var errCode = _ref3.errCode,
                                              fileSrc = _ref3.content.fileSrc,
                                              message = _ref3.message;

                                          if (errCode === 0) {
                                            _this2.handleChange(type, 'done', {
                                              uid: file.uid,
                                              uidList: uidList,
                                              src: fileSrc,
                                              preview: fileSrc,
                                              download: fileSrc
                                            });
                                          } else {
                                            _this2.handleChange(type, 'error', {
                                              uid: file.uid,
                                              uidList: uidList,
                                              message: message
                                            });
                                          }
                                        },
                                        error: function error(err) {
                                          var message = '';
                                          if (err && err.xhr && err.xhr.response) try {
                                            message = JSON.parse(err.xhr.response).message || '';
                                          } catch (e) {
                                            message = '';
                                          } else {
                                            message = err.message;
                                          }
                                          if (!message) {
                                            message = locale.uploadFailed;
                                          }
                                          _this2.handleChange(type, 'error', {
                                            uid: file.uid,
                                            uidList: uidList,
                                            message: message
                                          });
                                        },
                                        method: 'POST',
                                        processData: true
                                      });

                                    case 12:
                                    case 'end':
                                      return _context.stop();
                                  }
                                }
                              }, _loop, _this2);
                            });

                          case 1:
                            if (!(i < files.length)) {
                              _context2.next = 6;
                              break;
                            }

                            return _context2.delegateYield(_loop(), 't0', 3);

                          case 3:
                            i++;
                            _context2.next = 1;
                            break;

                          case 6:
                          case 'end':
                            return _context2.stop();
                        }
                      }
                    }, _callee, _this2);
                  }));

                  return function upload() {
                    return _ref2.apply(this, arguments);
                  };
                }();

                i = 0;
                upload();
                if (onAfterUpload) {
                  onAfterUpload();
                }

              case 18:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee2, this);
      }));

      function request(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return request;
    }()
  }, {
    key: 'post',
    value: function post(type, files) {
      var options = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {};
      if (type === 'file') {
        files = files.filter(function (file) {
          return _tinsoEditorEngine2.default.UploadUtils.isFile(file);
        });
      } else if (type === 'image') {
        files = files.filter(function (file) {
          return _tinsoEditorEngine2.default.UploadUtils.isImage(file);
        });
      } else if (type === 'localdoc') {
        files = files.filter(function (file) {
          return _tinsoEditorEngine2.default.UploadUtils.isFile(file);
        });
      }
      if (files.length !== 0) {
        this.request(type, files, options);
        return true;
      }
    }
  }, {
    key: 'handleBeforeUpload',
    value: function handleBeforeUpload(type, file, files, options) {
      var _this3 = this;

      var onBeforeInsertSection = options.onBeforeInsertSection;
      var engine = this.options.engine;
      var iframeHelper = engine.iframeHelper;
      var uid = file.uid,
          name = file.name,
          size = file.size;

      var fileType = file.type;
      var extension = this.parseExtension(file);
      var sizeError = engine.locale[type].sizeError;

      if (type === 'localdoc' && !iframeHelper.canAdd()) {
        engine.messageError(engine.locale.section.iframeOverLimit.replace('${limit}', iframeHelper.options.limit));
        return false;
      }
      var allowedExts = this.getAllowedExtensions(type);
      if (!extension.actual || allowedExts && 0 > allowedExts.indexOf(extension.actual)) {
        engine.messageError(engine.locale[type].formatError);
        return false;
      }
      var docType = type;
      if (type === 'localdoc') {
        if (_tinsoEditorEngine2.default.UploadUtils.isOffice(file)) {
          docType = 'previewOffice';
          sizeError = engine.locale.preview.office;
        } else if (_tinsoEditorEngine2.default.UploadUtils.isMacOffice(file) || 'mindnode' === extension.actual || 'xmind' === extension.actual) {
          docType = 'previewMacOffice';
          sizeError = engine.locale.preview.macOffice;
        }
      }
      if (!_tinsoEditorEngine2.default.UploadUtils.isSizeLimit(docType, size)) {
        _antd.message.error(sizeError);
        return false;
      }

      return new Promise(function (resolve, reject) {
        var fileReader = new FileReader();
        fileReader.addEventListener('load', function () {
          var handle = true;
          _this3.uploadingFiles[uid] = {
            uid: uid,
            src: fileReader.result,
            name: name,
            size: size,
            type: fileType,
            ext: extension.raw,
            progress: {
              percent: 0
            }
          };
          for (var l = 0; files.length > l; l++) {
            if (!_this3.uploadingFiles[files[l].uid]) {
              handle = false;
              break;
            }
          }
          if (handle) {
            files.forEach(function (file) {
              _this3.handleChange(type, 'before', _this3.uploadingFiles[file.uid], {
                file: file,
                onBeforeInsertSection: onBeforeInsertSection
              });
              delete _this3.uploadingFiles[file.uid];
            });
          }
          resolve(file);
        }, false);

        fileReader.addEventListener('error', function () {
          reject(file);
        });

        fileReader.readAsDataURL(file);
      });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(type, status, data) {
      var options = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : {};
      var engine = this.options.engine;
      var uid = data.uid,
          uidList = data.uidList;

      var fileOptions = Object.assign({}, data);
      var onBeforeInsertSection = options.onBeforeInsertSection,
          file = options.file;

      if (type === 'image' && (0, _string.isBase64Image)(fileOptions.src)) {
        delete fileOptions.src;
      }
      fileOptions.status = status;
      if (status !== 'before') {
        var section = this.uploadingSections[uid];
        if (section && section.closest('body').length !== 0) {
          if ('uploading' !== status) {
            if ('error' === status) {
              var msg = fileOptions.message || engine.locale[type].uploadFailed;
              _antd.message.error(msg);
            }
            delete this.uploadingSections[uid];
            delete this.uploadingFiles[uid];
            _tinsoEditorEngine2.default.UploadUtils.updateSection(engine, section, fileOptions, this.updateHistorySection[uid]);
          } else {
            _tinsoEditorEngine2.default.UploadUtils.updateSectionProgress(section, fileOptions);
          }
        } else {
          delete this.uploadingSections[uid];
        }
      } else {
        if (onBeforeInsertSection) {
          onBeforeInsertSection(file, fileOptions);
        }

        if (this.uploadingSections[uid]) {
          this.updateHistorySection[uid] = true;
        } else {
          var _section = _tinsoEditorEngine2.default.UploadUtils.insertSection(engine, type, fileOptions);
          var id = _section.attr('id');
          if (id) {
            this.sectionIds[uid] = id;
          }
          this.addUploadingSection(uid, _section);
        }
      }
    }
  }]);

  return Uploader;
}(_eventemitter.EventEmitter2);

exports.default = Uploader;