'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PdfExportParser = exports.htmlToZachEditor = exports.DocVersion = exports.DoNothingExportParser = exports.WordExportParser = exports.ExportParser = exports.Outline = exports.HotKeys = exports.ContentView = exports.LineEditor = exports.MobileEditor = exports.MultiMiniEditor = exports.MiniEditor = exports.TinsoEditor = exports.FullEditor = exports.BaseEditor = exports.Engine = undefined;

require('tinso-editor-engine/lib/index.css');

var _hotkey = require('./config/hotkey');

var _hotkey2 = _interopRequireDefault(_hotkey);

var _engine = require('./editor/engine');

var _engine2 = _interopRequireDefault(_engine);

var _full = require('./editor/full');

var _full2 = _interopRequireDefault(_full);

var _editor = require('./editor/editor');

var _editor2 = _interopRequireDefault(_editor);

var _tinso = require('./editor/tinso');

var _tinso2 = _interopRequireDefault(_tinso);

var _mini = require('./editor/mini');

var _mini2 = _interopRequireDefault(_mini);

var _multiMini = require('./editor/multi-mini');

var _multiMini2 = _interopRequireDefault(_multiMini);

var _mobile = require('./editor/mobile');

var _mobile2 = _interopRequireDefault(_mobile);

var _line = require('./editor/line');

var _line2 = _interopRequireDefault(_line);

var _outline = require('./utils/outline');

var _outline2 = _interopRequireDefault(_outline);

var _contentView = require('./editor/content-view');

var _contentView2 = _interopRequireDefault(_contentView);

var _export = require('./parser/export');

var _export2 = _interopRequireDefault(_export);

var _word = require('./parser/word');

var _word2 = _interopRequireDefault(_word);

var _pdf = require('./parser/pdf');

var _pdf2 = _interopRequireDefault(_pdf);

var _doNothing = require('./parser/do-nothing');

var _doNothing2 = _interopRequireDefault(_doNothing);

var _string = require('./utils/string');

var _zacheditor = require('./parser/zacheditor');

var _zacheditor2 = _interopRequireDefault(_zacheditor);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HotKeys = (0, _hotkey2.default)().map(function (item) {
  item.text = item.text.replace(/<br.*?>/, '');
  return item;
});
_engine2.default.registerClipboardExportParser(new _export2.default());

_full2.default.tinso = _tinso2.default;
_full2.default.mini = _mini2.default;
_full2.default.mobile = _mobile2.default;
_full2.default.line = _line2.default;
_full2.default.view = _contentView2.default;

exports.default = _full2.default;
exports.Engine = _engine2.default;
exports.BaseEditor = _editor2.default;
exports.FullEditor = _full2.default;
exports.TinsoEditor = _tinso2.default;
exports.MiniEditor = _mini2.default;
exports.MultiMiniEditor = _multiMini2.default;
exports.MobileEditor = _mobile2.default;
exports.LineEditor = _line2.default;
exports.ContentView = _contentView2.default;
exports.HotKeys = HotKeys;
exports.Outline = _outline2.default;
exports.ExportParser = _export2.default;
exports.WordExportParser = _word2.default;
exports.DoNothingExportParser = _doNothing2.default;
exports.DocVersion = _string.DocVersion;
exports.htmlToZachEditor = _zacheditor2.default;
exports.PdfExportParser = _pdf2.default;