'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _userAgent = require('tinso-editor-engine/lib/utils/user-agent');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CTRL = _userAgent.macos ? '\u2318' : 'Ctrl';
var backgroundOrColor = {
  fontColor: '字体颜色',
  bgColor: '背景颜色',
  moreColor: '更多颜色'
};
var layoutLocale = {
  layout: '布局方式',
  layoutBlock: '独占一行',
  layoutInline: '嵌入行内'
};
var alignmentLocale = {
  alignment: '对齐方式',
  alignLeft: '靠左对齐',
  alignCenter: '居中对齐',
  alignRight: '靠右对齐'
};

var uploadLocale = {
  uploadFailed: '文件上传失败，请重试',
  notSupportExt: '不支持该文件类型'
};

var dndLocale = {
  dndTips: '<span>拖动 调整位置<br />点击 打开更多菜单</span>',
  dndInsert: '插入空行',
  dndClone: '克隆',
  dndCopy: '拷贝锚点',
  dndCopySuccess: '已拷贝到粘贴板',
  dndEdit: '编辑锚点',
  dndDelete: '删除'
};
var linkLocale = {
  linkPlaceholder: '请输入链接地址或者锚点',
  linkSave: '保存',
  linkEdit: '编辑',
  linkDelete: '取消链接',
  linkOpen: '打开链接'
};
var editorModalLocale = {
  editorModalClose: '关闭',
  editorModalPopupTips: '确认要放弃刚才编辑的草稿吗？',
  editorModalPopupCancel: '返回编辑',
  editorModalPopupConfirm: '确认',
  editorModalSave: '保存并插入',
  editorModalConfirm: '要在退出前保存本次修改吗？',
  editorModalDissectionAndExit: '放弃编辑并退出',
  editorModalCancel: '取消',
  editorModalSaveAndExit: '保存并退出'
};

exports.default = {
  pure: {
    support: '支持'
  },
  editor: {
    save: '保存草稿',
    print: '打印',
    file: '文档',
    edit: '编辑',
    view: '视图',
    insert: '插入',
    format: '格式',
    lab: '实验室',
    version: '历史',
    help: '帮助',
    publish: '发布更新'
  },
  alignment: {
    buttonTitle: '对齐方式',
    alignLeft: '左对齐',
    alignCenter: '居中对齐',
    alignRight: '右对齐',
    alignJustify: '两端对齐'
  },
  background: backgroundOrColor,
  blockquote: {
    buttonTitle: '插入引用',
    menuTitle: '引用',
    question: '选定区域设置为小题',
    questionDesc: '设置为小题',
    answer: '选定区域设置为答案',
    answerDesc: '设置为答案',
    analysis: '设置为解析',
    analysisDesc: '选定区域设置为解析'
  },
  bold: {
    macTitle: '粗体 ⌘+B',
    winTitle: '粗体 Ctrl+B',
    text: '粗体'
  },
  paintformat: {
    buttonTitle: '格式刷'
  },
  clearFormat: {
    buttonTitle: '清除格式'
  },
  code: {
    macTitle: '行内代码',
    winTitle: '行内代码',
    text: '行内代码'
  },
  codeBlock: _extends({}, dndLocale, {
    buttonTitle: '插入代码块',
    menuTitle: '代码块',
    preview: '预览',
    delete: '删除',
    copyCode: '复制代码',
    copySuccess: '复制成功！'
  }),
  color: backgroundOrColor,
  emoji: {
    buttonTitle: 'Emoji 表情'
  },
  localdoc: _extends({}, uploadLocale, {
    formatError: '不支持该文件嵌入预览',
    allowDownload: '\u5728\u9605\u8BFB\u9875\u4E0B\u5141\u8BB8\u4E0B\u8F7D\u6587\u4EF6'
  }),
  preview: {
    office: 'Office 预览，上传文件大小限制为 100 MB',
    macOffice: '本地文件预览，文件大小限制为 200 MB',
    pdf: 'PDF 预览，上传文件大小限制为 100 MB'
  },
  file: _extends({}, uploadLocale, dndLocale, {
    buttonTitle: '\u4E0A\u4F20\u9644\u4EF6',
    menuTitle: '\u9644\u4EF6',
    stillUploading: '\u6709\u6587\u4EF6\u8FD8\u5728\u4E0A\u4F20\u4E2D',
    stillTransfering: '\u6709\u6587\u4EF6\u8FD8\u5728\u8F6C\u5B58\u4E2D',
    formatError: '\u8BE5\u7C7B\u578B\u6587\u4EF6\u8BF7\u538B\u7F29\u4E3A ZIP \u6587\u4EF6\u4E0A\u4F20',
    sizeError: '\u4E0A\u4F20\u5931\u8D25\uFF0C\u9644\u4EF6\u5927\u5C0F\u9650\u5236\u4E3A 500M',
    placeholder: '\u4E0A\u4F20\u9644\u4EF6\uFF0C\u9650\u5236 500M',
    preview: '\u9884\u89C8',
    replace: '\u66FF\u6362',
    download: '\u4E0B\u8F7D',
    delete: '\u5220\u9664',
    transfering: '\u8F6C\u5B58\u4E2D\u2026',
    invalid: '\u9644\u4EF6\u5DF2\u5931\u6548',
    failReadFile: '\u6587\u4EF6\u8BFB\u53D6\u5931\u8D25\uFF0C\u8BF7\u91CD\u65B0\u4E0A\u4F20'
  }),
  'table:file': {
    uploadFailed: '附件上传失败，请重试'
  },
  heading: _extends({}, dndLocale, {
    buttonTitle: '正文与标题',
    normal: '正文',
    heading_1: '标题 1',
    heading_2: '标题 2',
    heading_3: '标题 3',
    heading_4: '标题 4',
    heading_5: '标题 5',
    heading_6: '标题 6'
  }),
  fontsize: {
    buttonTitle: '字号'
  },
  history: {
    undo: '撤销',
    redo: '重做'
  },
  hr: _extends({}, dndLocale, {
    buttonTitle: '插入分割线',
    menuTitle: '分割线'
  }),
  divider: _extends({}, dndLocale, {
    buttonTitle: '插入分题线',
    menuTitle: '分题线'
  }),
  blankmark: {
    title: '填空标记',
    description: '可直接插入当前填空标记'
  },
  subdivider: _extends({}, dndLocale, {
    buttonTitle: '插入小题分割线',
    menuTitle: '小题分割线'
  }),
  image: _extends({}, uploadLocale, layoutLocale, alignmentLocale, dndLocale, linkLocale, (_extends2 = {
    buttonTitle: '\u63D2\u5165\u56FE\u7247',
    menuTitle: '\u56FE\u7247',
    sizeError: '\u4E0A\u4F20\u56FE\u7247\u5931\u8D25\uFF1A\u56FE\u7247\u5927\u5C0F\u8D85\u8FC7 10M',
    uploadFailed: '\u4E0A\u4F20\u56FE\u7247\u5931\u8D25\uFF0C\u8BF7\u91CD\u8BD5',
    stillUploading: '\u6709\u56FE\u7247\u8FD8\u5728\u4E0A\u4F20\u4E2D',
    uploadTips: '\u5C06\u56FE\u7247\u62D6\u81F3\u6B64\u5904\u6216\u70B9\u51FB\u9009\u62E9\u4E00\u4E2A\u4E0A\u4F20\uFF0C\u5927\u5C0F\u9650\u5236\u4E3A 10M',
    copyFailed: '\u590D\u5236\u56FE\u7247\u5931\u8D25',
    copyFailedTips: '\u56FE\u7247\u4E0D\u652F\u6301\u62F7\u8D1D\u590D\u5236\uFF0C\u8BF7\u5355\u72EC\u590D\u5236\u4E0A\u4F20',
    loadFailed: '\u7F51\u7EDC\u5F02\u5E38\uFF0C\u56FE\u7247\u65E0\u6CD5\u5C55\u793A',
    placeholder: '\u4E0A\u4F20\u56FE\u7247\uFF0C\u9650\u5236 10M',
    sizeTitle: '\u5927\u5C0F',
    formatError: '\u4E0D\u652F\u6301\u8BE5\u6587\u4EF6\u7C7B\u578B',
    width: '\u5BBD\u5EA6',
    height: '\u9AD8\u5EA6',
    originSize: '\u539F\u59CB\u5927\u5C0F',
    linkTitle: '\u94FE\u63A5',
    linkPlaceholder: '\u76EE\u6807\u94FE\u63A5',
    linkTargetTips: '\u5728\u5F53\u524D\u9875\u9762\u6253\u5F00',
    preferences: '\u56FE\u7247\u8BBE\u7F6E',
    replace: '\u66FF\u6362',
    delete: '\u5220\u9664'
  }, _defineProperty(_extends2, 'preferences', '\u56FE\u7247\u8BBE\u7F6E'), _defineProperty(_extends2, 'inlineMode', '嵌入行内'), _defineProperty(_extends2, 'blockMode', '独占一行'), _extends2)),
  'table:image': {
    uploadFailed: '上传图片失败，请重试'
  },
  indent: {
    buttonTitle: '缩进',
    decrease: '减少缩进',
    increase: '增加缩进'
  },
  italic: {
    macTitle: '斜体 ⌘+I',
    winTitle: '斜体 Ctrl+I',
    text: '斜体'
  },
  link: _extends({}, linkLocale, {
    buttonTitle: '插入链接',
    menuTitle: '链接'
  }),
  list: {
    buttonTitle: '列表',
    orderedList: '有序列表',
    unorderedList: '无序列表',
    taskList: '任务列表'
  },
  mark: {
    macTitle: '高亮文字',
    winTitle: '高亮文字',
    text: '高亮文字'
  },
  math: _extends({}, layoutLocale, alignmentLocale, dndLocale, linkLocale, {
    buttonTitle: '\u516C\u5F0F',
    menuTitle: '\u516C\u5F0F',
    success: '\u64CD\u4F5C\u6210\u529F',
    placeholder: '根据 LaTeX 生成公式',
    edit: '\u7F16\u8F91',
    copy: '\u62F7\u8D1D\u6E90\u7801',
    delete: '\u5220\u9664',
    cancel: '\u53D6\u6D88',
    save: '\u786E\u5B9A',
    sourceCodeRequired: '\u8BF7\u8F93\u5165\u6E90\u7801',
    syntaxInvalid: '\u8F93\u5165\u516C\u5F0F\u4E0D\u5408\u6CD5',
    help: '\u4E86\u89E3 LaTeX \u8BED\u6CD5',
    enterTooltips: ''.concat(CTRL, ' + Enter')
  }),
  mindmap: _extends({}, alignmentLocale, dndLocale, editorModalLocale, {
    menuTitle: '\u601D\u7EF4\u5BFC\u56FE',
    buttonTitle: '\u601D\u7EF4\u5BFC\u56FE',
    editorTitle: '\u601D\u7EF4\u5BFC\u56FE',
    edit: '\u7F16\u8F91',
    delete: '\u5220\u9664',
    saveDraft: '\u4FDD\u5B58',
    help: '\u5E2E\u52A9',
    undo: '\u64A4\u9500',
    redo: '\u91CD\u505A',
    insertSibling: '\u63D2\u5165\u540C\u7EA7',
    insertChild: '\u63D2\u5165\u5B50\u7EA7',
    collapse: '\u6298\u53E0',
    expand: '\u5C55\u5F00',
    autoAdjust: '\u9002\u5E94\u753B\u5E03'
  }),
  moremark: {
    buttonTitle: '更多文本样式'
  },
  paste: {
    copy: '复制',
    cut: '剪切',
    paste: '粘贴',
    pastePlainText: '粘贴纯文本',
    pasteMarkdown: '粘贴 Markdown',
    selectAll: '全选'
  },
  textDiagram: _extends({}, alignmentLocale, dndLocale, editorModalLocale, {
    edit: '\u7F16\u8F91',
    save: '\u4FDD\u5B58',
    preview: '\u9884\u89C8',
    template: '\u6A21\u677F',
    help: '\u5E2E\u52A9',
    genImageError: '\u751F\u6210\u9884\u89C8\u5931\u8D25\uFF0C\u8BF7\u4FEE\u6539\u5185\u5BB9',
    winPreviewTooltip: 'Ctrl+Shift+P',
    macPreviewTooltip: '\u2318+Shift+P'
  }),
  riddle: _extends({}, dndLocale, {
    buttonTitle: 'Riddle',
    menuTitle: 'Riddle',
    active: 'Click to active',
    replace: '替换',
    delete: '删除',
    addressInvalid: '请输入正确的链接地址',
    placeholder: '输入 Riddle 地址，按 Enter 生成'
  }),
  strikethrough: {
    macTitle: '删除线 ⌘+Shift+X',
    winTitle: '删除线 Ctrl+Shift+X',
    text: '删除线'
  },
  sub: {
    macTitle: '下标',
    winTitle: '下标',
    text: '下标'
  },
  sup: {
    macTitle: '上标',
    winTitle: '上标',
    text: '上标'
  },
  table: {
    buttonTitle: '插入表格',
    menuTitle: '表格',
    copy: '复制',
    cut: '剪切',
    merge: '合并单元格',
    unmerge: '拆分单元格',
    clear: '清空选中区域',
    deleteColumn: '删除选中列',
    deleteRow: '删除选中行',
    deleteTable: '删除表格'
  },
  underline: {
    macTitle: '下划线 ⌘+U',
    winTitle: '下划线 Ctrl+U',
    text: '下划线'
  },
  video: _extends({}, dndLocale, {
    buttonTitle: '插入视频',
    menuTitle: '视频',
    play: '播放',
    replace: '替换',
    download: '下载',
    delete: '删除',
    sizeError: '上传失败，视频大小限制为 2G'
  }),
  toc: {
    title: '题库录入工具',
    open: '打开大纲',
    close: '关闭大纲'
  },
  section: {
    mindmapFile: '\u8111\u56FE',
    designingFile: '\u8BBE\u8BA1\u6587\u4EF6',
    officeFile: '\u529E\u516C\u6587\u4EF6',
    localdocSubTitle: '\u652F\u6301Office\u3001XMind\u3001Sketch \u7B49',
    label: '\u72B6\u6001',
    labelDescription: '\u7B80\u6613\u6587\u672C\u72B6\u6001',
    date: '日期',
    dateDescription: '可直接插入当前的日期',
    localdoc: '\u672C\u5730\u6587\u4EF6',
    localdocDescription: '\u652F\u6301 Word, Excel, PPT, PDF',
    iframeOverLimit: '\u6587\u6863\u6700\u591A\u652F\u6301 ${limit} \u5F20\u5D4C\u5165Section',
    placeholder: 'Section\u540D',
    embed: '\u5D4C\u5165',
    onlinedoc: '在线文档',
    onlinedocDescription: '\u652F\u6301\u5D4C\u5165\u8BED\u96C0\u6587\u6863\u3001\u8868\u683C\u3001\u8111\u56FE',
    website: '嵌入网址',
    websiteDescription: '嵌入一个网址',
    buttonTitle: '\u63D2\u5165\u56FE\u7247\u3001\u8868\u683C\u3001<br />\u9644\u4EF6\u3001\u4EE3\u7801\u5757\u7B49Section',
    normal: ' ',
    media: '\u5A92\u4F53',
    engineering: '\u5DE5\u7A0B',
    description: '\u8F93\u5165  <code>'.concat(CTRL, '</code> + <code>/</code>  快速插入区块'),
    table: '\u8868\u683C',
    tableDescription: '\u63D2\u5165\u5728\u7EBF\u8868\u683C',
    image: '\u56FE\u7247',
    imageDescription: '\u4E0A\u4F20\u4E00\u5F20\u6216\u591A\u5F20\u56FE\u7247',
    video: '\u672C\u5730\u89C6\u9891',
    videoDescription: '\u4E0A\u4F20\u4E00\u4E2A\u672C\u5730\u89C6\u9891',
    youku: '\u5728\u7EBF\u89C6\u9891',
    youkuName: '\u4F18\u9177',
    youkuDescription: '\u63D2\u5165\u4F18\u9177\u89C6\u9891',
    youkuSubTitle: '\u652F\u6301\u4F18\u9177\u3001\u54D4\u54E9\u54D4\u54E9',
    bilibili: 'bilibili',
    bilibiliName: '\u54D4\u54E9\u54D4\u54E9',
    bilibiliDescription: '\u63D2\u5165\u54D4\u54E9\u54D4\u54E9\u89C6\u9891',
    codeblock: '\u4EE3\u7801\u5757',
    codeblockDescription: '\u8F93\u5165\u4EE3\u7801\u7247\u6BB5',
    file: '\u9644\u4EF6',
    fileDescription: '\u4E0A\u4F20\u5355\u4E2A\u6216\u591A\u4E2A\u9644\u4EF6',
    math: '\u516C\u5F0F',
    mathDescription: '\u8F93\u5165 Latex \u516C\u5F0F',
    riddle: '\u4EE3\u7801\u6F14\u793A\uFF08Riddle\uFF09',
    riddleDescription: '\u63D2\u5165 Riddle \u4EE3\u7801\u7247\u6BB5',
    mindmap: '\u8111\u56FE',
    mindmapDescription: '\u7ED8\u5236\u7B80\u6613\u8111\u56FE',
    puml: 'PlantUML',
    pumlDescription: '\u7ED8\u5236 PlantUML \u56FE',
    flowchart: 'Flowchart',
    flowchartDescription: '\u7ED8\u5236 Flowchart \u56FE',
    mermaid: 'Mermaid',
    mermaidDescription: '\u7ED8\u5236 Mermaid \u56FE',
    diagram: '\u6587\u672C\u7ED8\u56FE',
    diagramDescription: '\u901A\u8FC7\u4EE3\u7801\u7ED8\u56FE',
    diagramSubTitle: '\u652F\u6301PlantUML\u3001Mermaid \u7B49',
    graphviz: 'Graphviz',
    graphvizDescription: '\u7ED8\u5236 Graphviz \u56FE',
    lockedtextTitle: '\u52A0\u5BC6\u6587\u672C',
    lockedtextDescription: '\u9700\u8981\u5BC6\u7801\u624D\u53EF\u67E5\u770B'
  },
  mention: {
    text: '提及'
  },
  markdown: {
    pasteTitle: '是否需要做样式转换？',
    pasteContent: '检测到粘贴内容符合 Markdown 语法，是否需要做样式转换？',
    pasteButton: '立即转换'
  },
  search: {
    searchAndReplace: '\u67E5\u627E\u5E76\u66FF\u6362',
    search: '\u67E5\u627E',
    replace: '\u66FF\u6362',
    replaceAll: '\u66FF\u6362\u5168\u90E8',
    replaceTo: '\u66FF\u6362\u4E3A',
    pleaseEnter: '\u8BF7\u8F93\u5165',
    next: '\u4E0B\u4E00\u4E2A',
    previous: '\u4E0A\u4E00\u4E2A'
  },
  translate: {
    title: '翻译',
    subTitle: '源 & 目标',
    automaticDetection: '自动检测',
    zh: '中文',
    en: '英文',
    translation: '译文',
    insertDoc: '插入文档',
    placeholder: '请在文档中选择需要翻译的内容'
  }
};