'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/tooltip/style');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Button);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Button.__proto__ || Object.getPrototypeOf(Button)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      visible: false
    }, _this.onClick = function (event) {
      var _this$props = _this.props,
          name = _this$props.name,
          onClick = _this$props.onClick,
          isPrevent = _this$props.isPrevent,
          disabled = _this$props.disabled;


      if (isPrevent !== false) {
        event.preventDefault();
      }

      if (disabled) return;

      _this.setState({
        visible: false
      });

      onClick && onClick(event, name);
    }, _this.onMouseOver = function (event) {
      var _this$props2 = _this.props,
          onMouseOver = _this$props2.onMouseOver,
          disabled = _this$props2.disabled;

      if (disabled) return;
      onMouseOver && onMouseOver();
      event.preventDefault();
    }, _this.onMouseDown = function (event) {
      event.preventDefault();
      var _this$props3 = _this.props,
          name = _this$props3.name,
          onMouseDown = _this$props3.onMouseDown,
          disabled = _this$props3.disabled;

      if (disabled) return;
      // fix：避免执行工具栏的 mousedown 事件里的 engine.focus()，这个会导致格式刷功能失效
      if (name === 'paintformat' || name === 'video') {
        event.stopPropagation();
      }
      onMouseDown && onMouseDown(event);
    }, _this.onMouseEnter = function (event) {
      var _this$props4 = _this.props,
          outerVisible = _this$props4.outerVisible,
          onMouseEnter = _this$props4.onMouseEnter;

      if (onMouseEnter) {
        onMouseEnter(event);
      }
      if (!outerVisible) {
        _this.setState({
          visible: true
        });
      }
    }, _this.onMouseLeave = function (event) {
      var _this$props5 = _this.props,
          outerVisible = _this$props5.outerVisible,
          onMouseLeave = _this$props5.onMouseLeave;

      if (onMouseLeave) {
        onMouseLeave(event);
      }
      if (!outerVisible) {
        _this.setState({
          visible: false
        });
      }
    }, _this.getIcon = function () {
      var icon = _this.props.icon;

      if (icon && typeof icon === 'string') {
        return _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: icon } });
      }
      if (icon) {
        return icon;
      }
      return null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          name = _props.name,
          className = _props.className,
          title = _props.title,
          hotkey = _props.hotkey,
          active = _props.active,
          disabled = _props.disabled,
          hasArrow = _props.hasArrow,
          currentText = _props.currentText,
          content = _props.content,
          mobile = _props.mobile,
          contentVisible = _props.contentVisible,
          tooltip = _props.tooltip;

      if (hotkey) {
        title = _react2.default.createElement(
          'div',
          { style: { textAlign: 'center' } },
          title,
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            'span',
            { className: 'zacheditor-button-hotkey' },
            hotkey
          )
        );
      }

      var visible = this.state.visible;
      // 没有 title 时，不展示 tooltip

      if (!title || mobile) {
        visible = false;
      }
      var accessbilityid = 'main-'.concat(name, '-button');
      var showContent = contentVisible === undefined ? true : contentVisible;

      var button = _react2.default.createElement(
        'button',
        {
          accessbilityid: accessbilityid,
          className: (0, _classnames2.default)('zacheditor-button', className, {
            'zacheditor-button-active': active,
            'zacheditor-button-disabled': disabled
          }),
          onClick: this.onClick,
          onMouseDown: this.onMouseDown,
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.onMouseLeave,
          onMouseOver: this.onMouseOver
        },
        showContent && content,
        currentText && _react2.default.createElement(
          'span',
          { className: 'zacheditor-button-inner-text' },
          currentText
        ),
        this.getIcon(),
        name !== 'emoji' && name !== 'table:emoji' && hasArrow && _react2.default.createElement('span', { className: 'zacheditor-icon zacheditor-icon-arrow' })
      );
      return tooltip === undefined || tooltip === true ? _react2.default.createElement(
        _antd.Tooltip,
        {
          title: title,
          placement: 'bottom',
          visible: visible,
          overlayClassName: 'zacheditor-toolbar-tooltip'
        },
        button
      ) : button;
    }
  }]);

  return Button;
}(_react2.default.Component);

exports.default = Button;