'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/collapse/style');

require('antd/lib/popover/style');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _tableSelector = require('./table-selector');

var _tableSelector2 = _interopRequireDefault(_tableSelector);

var _upload = require('./upload');

var _upload2 = _interopRequireDefault(_upload);

var _collapseItem = require('./collapse-item');

var _collapseItem2 = _interopRequireDefault(_collapseItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Panel = _antd.Collapse.Panel;

var _class = function (_React$Component) {
  _inherits(_class, _React$Component);

  function _class(props) {
    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

    _this.handleClick = function (e, item, opts) {
      e.preventDefault();
      e.stopPropagation();
      _this.props.onClick();
      item.onClick(opts);
    };

    _this.listNode = _react2.default.createRef();
    _this.engine = props.engine;
    return _this;
  }

  _createClass(_class, [{
    key: 'renderItem',
    value: function renderItem(item, index) {
      var _this2 = this;

      var onClick = function onClick() {};

      if (item.type !== 'upload') {
        onClick = function onClick(e) {
          return _this2.handleClick(e, item);
        };
      }

      return _react2.default.createElement(_collapseItem2.default, {
        item: item,
        index: index,
        itemOnClick: onClick,
        toggleDropdown: this.props.onClick,
        hideDropdown: this.props.hideDropdown,
        showDropdown: this.props.showDropdown,
        removeSelect: this.props.removeSelect,
        key: 'collapseItem'.concat(index),
        engine: this.engine
      });
    }
  }, {
    key: 'renderVideo',
    value: function renderVideo(item, index) {
      return _react2.default.createElement(_collapseItem2.default, {
        item: item,
        index: index,
        type: 'video',
        key: 'collapseItem'.concat(index),
        onToolBarClick: this.props.onClick,
        engine: this.engine
      });
    }
  }, {
    key: 'renderTable',
    value: function renderTable(item, index) {
      var _this3 = this;

      return _react2.default.createElement(
        _antd.Popover,
        {
          key: index,
          content: _react2.default.createElement(_tableSelector2.default, {
            onSelect: function onSelect(e, rows, cols) {
              _this3.handleClick(e, item, {
                rows: rows,
                cols: cols
              });
            }
          }),
          placement: 'rightTop'
        },
        _react2.default.createElement(
          'div',
          null,
          this.renderItem(item, index)
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props = this.props,
          className = _props.className,
          data = _props.data,
          description = _props.description,
          active = _props.active,
          activeKeys = _props.activeKeys;

      var toolbarDesc = '';
      if (description) {
        toolbarDesc = _react2.default.createElement(
          'div',
          { className: 'zacheditor-toolbar-collapse-description' },
          _react2.default.createElement('div', { className: 'description', dangerouslySetInnerHTML: { __html: description } })
        );
      }
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('zacheditor-button-set-list', className, {
            'zacheditor-toolbar-collapse-no-header': data.length <= 1,
            'zacheditor-button-set-list-active': active
          }),
          ref: this.listNode,
          'data-aspm': 'section_selector'
        },
        toolbarDesc,
        _react2.default.createElement(
          _antd.Collapse,
          { className: 'zacheditor-toolbar-collapse', defaultActiveKey: activeKeys },
          data.map(function (row, index) {
            return _react2.default.createElement(
              Panel,
              { showArrow: false, header: row.title, collapsible: 'disabled', key: index },
              row.items.map(function (item, i) {
                if (item.type === 'upload') {
                  var uploadProps = _extends({}, _this4.props);
                  uploadProps.name = item.name;
                  uploadProps.getEngine = item.getEngine;
                  if (!uploadProps.getEngine) {
                    uploadProps.getEngine = function () {
                      return uploadProps.engine;
                    };
                  }

                  return _react2.default.createElement(
                    _upload2.default,
                    Object.assign({}, { key: i }, uploadProps),
                    _this4.renderItem(item, i)
                  );
                }

                if (item.name === 'table') {
                  return _this4.renderTable(item, i);
                }

                if (item.name === 'video') {
                  return _this4.renderVideo(item, i);
                }

                return _this4.renderItem(item, i);
              })
            );
          })
        )
      );
    }
  }]);

  return _class;
}(_react2.default.Component);

exports.default = _class;