'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _antd = require('antd');

require('antd/lib/tooltip/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this));

    _this.onSelect = function (e, value) {
      e.preventDefault();
      e.stopPropagation();
      _this.props.onSelect(value);
    };
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          name = _props.name,
          data = _props.data,
          active = _props.active,
          currentValue = _props.currentValue,
          className = _props.className,
          engine = _props.engine;

      var withDot = name !== 'emoji' && name !== 'table:emoji';
      var emoji = name === 'emoji' || name === 'table:emoji';
      var isIconList = className === 'zacheditor-button-icon-list';

      var options = engine.options.emoji || {};
      var emojiUrl = options.action || '/emoji/';

      if (!Array.isArray(currentValue)) {
        currentValue = [currentValue];
      }

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('zacheditor-button-set-list', {
            'zacheditor-button-set-list-active': active,
            'zacheditor-button-set-list-with-dot': withDot,
            'zacheditor-button-set-list-emoji-mini': emoji
          })
        },
        data.map(function (row, index) {
          if (emoji) {
            return _react2.default.createElement(
              'a',
              {
                key: index,
                className: (0, _classnames2.default)('zacheditor-button-set-list-item', row.className),
                onClick: function onClick(e) {
                  return _this2.onSelect(e, row.point);
                }
              },
              _react2.default.createElement('img', { src: emojiUrl + row.point + '.svg' })
            );
          }

          if (isIconList) {
            return _react2.default.createElement(
              _antd.Tooltip,
              { key: index, title: row.shortcut, placement: 'right' },
              _react2.default.createElement(
                'a',
                {
                  className: (0, _classnames2.default)('zacheditor-button-set-list-item', row.className),
                  onClick: function onClick(e) {
                    return _this2.onSelect(e, row.key);
                  }
                },
                currentValue.indexOf(row.key) >= 0 && _react2.default.createElement('span', { className: 'zacheditor-icon zacheditor-icon-dot' }),
                _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: row.icon } }),
                _react2.default.createElement(
                  'span',
                  { style: { fontSize: 12 } },
                  row.title
                )
              )
            );
          }

          return _react2.default.createElement(
            'a',
            {
              key: index,
              className: (0, _classnames2.default)('zacheditor-button-set-list-item', row.className),
              onClick: function onClick(e) {
                return _this2.onSelect(e, row.key);
              }
            },
            currentValue.indexOf(row.key) >= 0 && _react2.default.createElement('span', { className: 'zacheditor-icon zacheditor-icon-dot' }),
            _react2.default.createElement(
              'span',
              null,
              row.value
            )
          );
        })
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

exports.default = Dropdown;