'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _toolbar = require('../config/toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _toolbarPlugins = require('./toolbar-plugins');

var _toolbarPlugins2 = _interopRequireDefault(_toolbarPlugins);

var _toolbarGroup = require('./toolbar-group');

var _toolbarGroup2 = _interopRequireDefault(_toolbarGroup);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _string = require('../utils/string');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Toolbar = function (_React$Component) {
  _inherits(Toolbar, _React$Component);

  function Toolbar() {
    _classCallCheck(this, Toolbar);

    var _this = _possibleConstructorReturn(this, (Toolbar.__proto__ || Object.getPrototypeOf(Toolbar)).call(this));

    _this.state = {
      pluginToolbar: [],
      toolbarState: {}
    };

    _this.handleH5Scroll = function () {
      var _this$props = _this.props,
          engine = _this$props.engine,
          mobile = _this$props.mobile;

      if (mobile) {
        document.body.appendChild(_tinsoEditorEngine2.default.$('.zacheditor-toolbar')[0]);
        _this.toolbarEl = _tinsoEditorEngine2.default.$('.zacheditor-toolbar');
        engine.on('select', function () {
          _this.toolbarEl.css({
            position: 'absolute',
            top: document.body.scrollTop + 'px'
          });
        });
        window.addEventListener('blur', function () {
          _this.toolbarEl.css({
            position: 'fixed',
            top: 0
          });
        });
        window.addEventListener('scroll', function () {
          if ('absolute' === _this.toolbarEl.css('position')) {
            _this.toolbarEl.css({
              top: document.body.scrollTop + 'px'
            });
          }
        });
      }
    };

    _this.set = function (config) {
      var _this$props2 = _this.props,
          engine = _this$props2.engine,
          type = _this$props2.type;
      //if(type === "mini"){
      //    engine.toolbar.disable(true)
      //}else{

      var nameList = [];
      var subNameList = [];
      config.forEach(function (item) {
        if ('separator' === item.type) {
          nameList.push(subNameList);
          subNameList = [];
        } else {
          subNameList.push(item.name);
        }
      });
      if (subNameList.length > 0) {
        nameList.push(subNameList);
      }
      _this.setToolbar(nameList, config, true);
      //}
    };

    _this.restore = function () {
      var _this$props3 = _this.props,
          engine = _this$props3.engine,
          type = _this$props3.type;

      if (!engine.isDestroyed) {
        //if( type === "mini" ) {
        //    engine.toolbar.disable(false)
        //}else{
        _this.setState({
          pluginToolbar: []
        });
        //}
      }
    };

    _this.disable = function (disabled, exclude) {
      var engine = _this.props.engine;

      if (!engine.isDestroyed) {
        exclude = exclude || ['save', 'undo', 'redo', 'toc'];

        var toolbarState = Object.assign({}, _this.state.toolbarState);
        Object.keys(toolbarState).forEach(function (name) {
          if (exclude.indexOf(name) < 0) {
            toolbarState[name].disabled = disabled;
          }
        });
        engine.toolbar.isDisabled = disabled;
        _this.setState({
          toolbarState: toolbarState
        });
      }
    };

    _this.show = function () {
      var engine = _this.props.engine;

      engine.container.closest('.zacheditor-pro').removeClass('zacheditor-toolbar-hidden');
    };

    _this.hide = function () {
      var engine = _this.props.engine;

      engine.container.closest('.zacheditor-pro').addClass('zacheditor-toolbar-hidden');
    };

    _this.updateState = function () {
      var _this$props4 = _this.props,
          type = _this$props4.type,
          engine = _this$props4.engine;

      if (!engine.isDestroyed) {
        if (type === 'mobile') {
          _this.restore();
        }
        var isPluginToolbar = _this.state.pluginToolbar.length > 0;
        var toolbarState = Object.assign({}, isPluginToolbar ? _this.state.pluginToolbarState : _this.state.toolbarState);
        if (0 !== Object.keys(toolbarState).length) {
          var modified = false;
          Object.keys(toolbarState).forEach(function (name) {
            if (_this.executeGetter(toolbarState[name])) {
              if (!modified) {
                modified = true;
              }
            }
          });
          if (modified) {
            _this.setState(isPluginToolbar ? { pluginToolbarState: toolbarState } : { toolbarState: toolbarState });
          }
        }
      }
    };
    return _this;
  }

  _createClass(Toolbar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          toolbar = _props.toolbar,
          engine = _props.engine;

      this.setToolbar(toolbar, (0, _toolbar2.default)(engine));
      engine.toolbar = {
        set: this.set,
        updateState: this.updateState,
        restore: this.restore,
        disable: this.disable,
        show: this.show,
        hide: this.hide
      };
      this.handleH5Scroll();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // const toolbar = Engine.$('.zacheditor-toolbar');
      // const toolbarElement = toolbar ? toolbar[0] : null;
      // if (toolbarElement) {
      //   toolbarElement.remove();
      // }
    }
  }, {
    key: 'setToolbar',
    value: function setToolbar(nameList, configList, isPluginToolbar) {
      var _this2 = this;

      var toolbarState = {};
      var toolbarConfigMap = {};
      configList.forEach(function (row) {
        toolbarConfigMap[row.name] = row;
      });

      var getKeys = function getKeys(keyString) {
        var keys = null;
        if (keyString) {
          keys = [];
          keyString.split('+').forEach(function (key) {
            keys.push(key.trim(), '+');
          });
          if (keys.length > 0) delete keys[keys.length - 1];
        }
        return keys;
      };

      var setItemObject = function setItemObject(item) {
        toolbarConfigMap[item.name].title = item.title || toolbarConfigMap[item.name].title;
        toolbarConfigMap[item.name].icon = item.icon || toolbarConfigMap[item.name].icon;
        var keys = getKeys(item.hotkey);
        toolbarConfigMap[item.name].hotkey = keys ? (0, _string.getHotkeyText)(keys) : toolbarConfigMap[item.name].hotkey;
        toolbarState[item.name] = toolbarConfigMap[item.name];
        _this2.executeGetter(toolbarState[item.name]);
      };

      nameList.forEach(function (group) {
        group.forEach(function (item) {
          if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object') {
            var configMap = toolbarConfigMap[item.name] || {};
            if (item.name === 'section') {
              var data = [];
              if (_typeof(item.items) === 'object' && item.items.length > 0) {
                configMap.data.forEach(function (group) {
                  var items = [];
                  group.items.forEach(function (sectionItem) {
                    var childItem = item.items.find(function (temp) {
                      return typeof temp === 'string' && temp === sectionItem.name || (typeof temp === 'undefined' ? 'undefined' : _typeof(temp)) === 'object' && temp.name === sectionItem.name;
                    });
                    if (childItem) {
                      if ((typeof childItem === 'undefined' ? 'undefined' : _typeof(childItem)) === 'object') {
                        sectionItem.title = childItem.title || sectionItem.title;
                        sectionItem.icon = childItem.icon || sectionItem.icon;
                      }
                      items.push(sectionItem);
                    }
                  });
                  if (items && items.length > 0) {
                    data.push({
                      title: group.title,
                      items: items
                    });
                  }
                });
              }
              if (data.length > 0) {
                configMap.data = data;
                configMap.title = item.title || configMap.title;
                configMap.icon = item.icon || configMap.icon;
                toolbarState[item.name] = configMap;
                _this2.executeGetter(toolbarState[item.name]);
                return;
              }
            } else if (item.name === 'heading' || item.name === 'fontsize' || item.name === 'moremark' || item.name === 'alignment') {
              var _data = [];
              if (_typeof(item.items) === 'object' && item.items.length > 0) {
                configMap.data.map(function (dataItem) {
                  var childItem = item.items.find(function (temp) {
                    return typeof temp === 'string' && temp === dataItem.key || (typeof temp === 'undefined' ? 'undefined' : _typeof(temp)) === 'object' && temp.name === dataItem.key;
                  });
                  if (childItem) {
                    if ((typeof childItem === 'undefined' ? 'undefined' : _typeof(childItem)) === 'object') {
                      if (dataItem.value && !dataItem.title) dataItem.value = childItem.title || dataItem.value;
                      dataItem.title = childItem.title || dataItem.title;

                      dataItem.icon = childItem.icon || dataItem.icon;
                    }
                    _data.push(dataItem);
                  }
                });
              }
              if (_data.length > 0) {
                configMap.data = _data;
                configMap.title = item.title || configMap.title;
                configMap.icon = item.icon || configMap.icon;
                toolbarState[item.name] = configMap;
                _this2.executeGetter(toolbarState[item.name]);
                return;
              }
            }
            if (item.name) {
              setItemObject(item);
            }
          } else {
            var config = toolbarConfigMap[item] || {};
            toolbarState[item] = config;
            _this2.executeGetter(toolbarState[item]);
          }
        });
      });

      if (isPluginToolbar) {
        this.setState({
          pluginToolbar: nameList,
          pluginToolbarState: toolbarState
        });
      } else {
        this.setState({
          toolbar: nameList,
          toolbarState: toolbarState
        });
      }
    }
  }, {
    key: 'executeGetter',
    value: function executeGetter(item) {
      var engine = this.engine;
      var modified = false;
      if (item.getActive) {
        var active = item.getActive();
        if (Array.isArray(item.active) && Array.isArray(active)) {
          var _loop = function _loop(i) {
            if (item.active.find(function (val) {
              return val !== active[i];
            })) {
              modified = true;
            }
          };

          for (var i = 0; i < active.length; i++) {
            _loop(i);
          }
        } else if (item.active !== active) {
          modified = true;
        }
        item.active = active;
      }

      if (item.getCurrentText) {
        var currentText = item.getCurrentText(item.active);
        if (item.currentText !== currentText) {
          modified = true;
        }
        item.currentText = currentText;
      }

      if (item.getDisabled && (!engine || !engine.toolbar.isDisabled)) {
        var disabled = item.getDisabled();
        if (item.disabled !== disabled) {
          modified = true;
        }
        item.disabled = disabled;
      }
      return modified;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          engine = _props2.engine,
          toolbar = _props2.toolbar,
          hasMore = _props2.hasMore,
          mobile = _props2.mobile;
      var _state = this.state,
          toolbarState = _state.toolbarState,
          pluginToolbar = _state.pluginToolbar,
          pluginToolbarState = _state.pluginToolbarState;


      var toolbarLength = 0;
      var pluginToolbarLength = 0;
      pluginToolbar.forEach(function (group) {
        pluginToolbarLength += group.length;
      });
      toolbar.forEach(function (group) {
        toolbarLength += group.length;
      });
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('zacheditor-toolbar', {
            'zacheditor-mobile-toolbar': !!mobile
          }),
          'data-zacheditor-element': 'toolbar',
          onMouseDown: function onMouseDown(e) {
            e.preventDefault();
            // fix：在搜狗浏览器上丢失选中状态
            if (!mobile) {
              engine.focus();
            }
          },
          onMouseOver: function onMouseOver(e) {
            return e.preventDefault();
          },
          onMouseMove: function onMouseMove(e) {
            return e.preventDefault();
          },
          onContextMenu: function onContextMenu(e) {
            return e.preventDefault();
          }
        },
        pluginToolbar.length === 0 && _react2.default.createElement(
          'div',
          { className: 'zacheditor-toolbar-content zacheditor-toolbar-content-active' },
          _react2.default.createElement(
            _toolbarPlugins2.default,
            { hasMore: hasMore, toolbarLength: toolbarLength },
            toolbar.map(function (subToolbar, index) {
              return _react2.default.createElement(_toolbarGroup2.default, Object.assign({
                key: index,
                isFirstGroup: 0 === index
              }, _this3.props, {
                toolbarState: toolbarState,
                toolbar: subToolbar
              }));
            })
          )
        ),
        pluginToolbar.length > 0 && _react2.default.createElement(
          'div',
          { className: 'zacheditor-toolbar-content zacheditor-toolbar-content-active' },
          _react2.default.createElement(
            _toolbarPlugins2.default,
            { hasMore: hasMore, toolbarLength: pluginToolbarLength },
            pluginToolbar.map(function (subToolbar, index) {
              return _react2.default.createElement(_toolbarGroup2.default, Object.assign({
                key: index,
                isFirstGroup: 0 === index
              }, _this3.props, {
                toolbar: subToolbar,
                toolbarState: pluginToolbarState
              }));
            })
          )
        )
      );
    }
  }]);

  return Toolbar;
}(_react2.default.Component);

Toolbar.defaultProps = {
  toolbar: []
};
exports.default = Toolbar;