'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/modal/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OnlineDoc = function (_React$Component) {
  _inherits(OnlineDoc, _React$Component);

  function OnlineDoc() {
    _classCallCheck(this, OnlineDoc);

    var _this = _possibleConstructorReturn(this, (OnlineDoc.__proto__ || Object.getPrototypeOf(OnlineDoc)).call(this));

    _this.state = {
      visible: false,
      activated: false
    };

    _this.handleMouseDown = function (event) {
      // 弹窗时，禁止 focus 编辑器
      event.stopPropagation();
    };

    _this.handleClick = function (event) {
      var hideDropdown = _this.props.hideDropdown;

      event.preventDefault();
      event.stopPropagation();

      _this.setState({
        visible: true
      }, function () {
        if (hideDropdown) {
          hideDropdown();
        }
      });
    };

    _this.handleInsert = function (event, collapsed) {
      event.preventDefault();
      event.stopPropagation();
      var _this$props = _this.props,
          item = _this$props.item,
          removeSelect = _this$props.removeSelect;
      var fetchSelectedFile = _this.iframe.current.contentWindow.fetchSelectedFile;

      if (fetchSelectedFile) {
        var files = fetchSelectedFile();
        var file = files.length > 0 ? files[0] : undefined;
        if (file && item && item.onReadLocal) {
          item.onReadLocal({
            src: file.preView,
            download: file.download,
            name: file.fileName,
            size: 0,
            collapsed: collapsed
          });
        }
      }
      _this.setState({
        visible: false
      }, function () {
        if (removeSelect) {
          removeSelect();
        }
      });
    };

    _this.handleCancel = function (event) {
      event.preventDefault();
      event.stopPropagation();
      var removeSelect = _this.props.removeSelect;

      _this.setState({
        visible: false
      }, function () {
        if (removeSelect) {
          removeSelect();
        }
      });
    };

    _this.iframe = _react2.default.createRef();
    return _this;
  }

  _createClass(OnlineDoc, [{
    key: 'handleMouseEnter',
    value: function handleMouseEnter() {
      this.setState({
        activated: true
      });
    }
  }, {
    key: 'handleMouseLeave',
    value: function handleMouseLeave() {
      this.setState({
        activated: false
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var visible = this.state.visible;
      var _props = this.props,
          item = _props.item,
          index = _props.index,
          engine = _props.engine;

      var activeClass = this.state.activated ? ' zacheditor-collapse-list-item-active' : '';
      var style = item.subTitle ? {
        height: 'auto'
      } : {};
      var options = engine.options.onlinedoc || {};
      return _react2.default.createElement(
        'div',
        {
          key: index,
          'data-index': index,
          'data-aspm-click': ''.concat(item.name),
          accessbilityid: ''.concat(item.name, '-section-button'),
          className: 'zacheditor-collapse-list-item'.concat(activeClass),
          onClick: this.handleClick,
          onMouseEnter: this.handleMouseEnter.bind(this),
          onMouseLeave: this.handleMouseLeave.bind(this),
          onMouseDown: this.handleMouseDown,
          style: style
        },
        _react2.default.createElement('div', {
          className: 'zacheditor-collapse-item-icon',
          dangerouslySetInnerHTML: { __html: item.icon }
        }),
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-collapse-item-text' },
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-collapse-item-title' },
            item.title,
            item.subTitle && _react2.default.createElement(
              'span',
              { className: 'zacheditor-collapse-item-sub-title' },
              item.subTitle
            ),
            item.subNew && _react2.default.createElement(
              'span',
              { className: 'zacheditor-sub-new-tag' },
              item.subNew
            ),
            item.isNew ? _react2.default.createElement('span', { className: 'zacheditor-svg-icon-new-section' }) : ''
          )
        ),
        _react2.default.createElement(
          _antd.Modal,
          {
            title: '\u5D4C\u5165\u6587\u4EF6',
            getContainer: 'div[data-zacheditor-element=toolbar]',
            visible: visible,
            centered: true,
            mask: false,
            destroyOnClose: true,
            style: {
              minWidth: '1300px'
            },
            footer: _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _antd.Button,
                { onClick: function onClick(event) {
                    return _this2.handleInsert(event, false);
                  }, type: 'primary' },
                '\u9884\u89C8\u63D2\u5165'
              ),
              _react2.default.createElement(
                _antd.Button,
                { onClick: function onClick(event) {
                    return _this2.handleInsert(event, true);
                  }, type: 'primary' },
                '\u6587\u4EF6\u63D2\u5165'
              ),
              _react2.default.createElement(
                _antd.Button,
                { onClick: this.handleCancel },
                '\u53D6\u6D88'
              )
            )
          },
          _react2.default.createElement('iframe', {
            ref: this.iframe,
            style: { width: '100%', minHeight: '480px' },
            frameBorder: 0,
            allowFullScreen: true,
            src: options.action
          })
        )
      );
    }
  }]);

  return OnlineDoc;
}(_react2.default.Component);

exports.default = OnlineDoc;