'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _collapseButton = require('./collapse-button');

var _collapseButton2 = _interopRequireDefault(_collapseButton);

var _dropdownButton = require('./dropdown-button');

var _dropdownButton2 = _interopRequireDefault(_dropdownButton);

var _colorButton = require('./color-button');

var _colorButton2 = _interopRequireDefault(_colorButton);

var _uploadButton = require('./upload-button');

var _uploadButton2 = _interopRequireDefault(_uploadButton);

var _videoButton = require('./video-button');

var _videoButton2 = _interopRequireDefault(_videoButton);

var _tableButton = require('./table-button');

var _tableButton2 = _interopRequireDefault(_tableButton);

var _button = require('./button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ToolbarGroup = function (_React$Component) {
  _inherits(ToolbarGroup, _React$Component);

  function ToolbarGroup() {
    _classCallCheck(this, ToolbarGroup);

    return _possibleConstructorReturn(this, (ToolbarGroup.__proto__ || Object.getPrototypeOf(ToolbarGroup)).apply(this, arguments));
  }

  _createClass(ToolbarGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          engine = _props.engine,
          locale = _props.locale,
          toolbar = _props.toolbar,
          toolbarState = _props.toolbarState,
          mobile = _props.mobile,
          isFirstGroup = _props.isFirstGroup;


      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        !isFirstGroup && _react2.default.createElement('div', { className: 'zacheditor-toolbar-split' }),
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-toolbar-area' },
          toolbar.map(function (name, index) {
            //配置参数
            if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) === 'object') {
              if (name.items && name.items.length === 0) return;
              name = name.name;
            }

            var buttonProps = toolbarState[name] || {};
            var type = buttonProps.type;
            buttonProps.hasArrow = type === 'dropdown';
            buttonProps.engine = engine;
            buttonProps.mobile = mobile;
            if (!buttonProps.getEngine) {
              buttonProps.getEngine = function () {
                return engine;
              };
            }
            buttonProps.locale = locale;
            if (name === 'table') {
              return _react2.default.createElement(_tableButton2.default, Object.assign({}, { key: index }, buttonProps));
            }
            if (type === 'collapse') {
              return _react2.default.createElement(_collapseButton2.default, Object.assign({}, { key: index }, buttonProps));
            }

            if (type === 'dropdown') {
              return _react2.default.createElement(_dropdownButton2.default, Object.assign({}, { key: index }, buttonProps));
            }

            if (type === 'color') {
              buttonProps.activeColors = [buttonProps.active];
              return _react2.default.createElement(_colorButton2.default, Object.assign({}, { key: index }, buttonProps));
            }

            if (type === 'upload') {
              return _react2.default.createElement(_uploadButton2.default, Object.assign({}, { key: index }, buttonProps));
            }

            if (type === 'video') {
              return _react2.default.createElement(_videoButton2.default, Object.assign({}, { key: index }, buttonProps));
            }

            return _react2.default.createElement(_button2.default, Object.assign({}, { key: index }, buttonProps));
          })
        )
      );
    }
  }]);

  return ToolbarGroup;
}(_react2.default.Component);

ToolbarGroup.defaultProps = {
  isFirstGroup: false
};
exports.default = ToolbarGroup;