'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _icons = require('@ant-design/icons');

require('antd/lib/message/style');

require('antd/lib/modal/style');

require('antd/lib/button/style');

require('antd/lib/tabs/style');

require('antd/lib/input/style');

require('antd/lib/icon/style');

var _videoUploader = require('./video-uploader');

var _videoUploader2 = _interopRequireDefault(_videoUploader);

var _button = require('./button');

var _button2 = _interopRequireDefault(_button);

var _youku = require('../section/youku');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputGroup = _antd.Input.Group;

var _class = function (_React$Component) {
  _inherits(_class, _React$Component);

  function _class() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, _class);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      visible: false,
      embedUrl: ''
    }, _this.handleMouseDown = function (event) {
      // 弹窗时，禁止 focus 编辑器
      event.stopPropagation();
    }, _this.handleClick = function (event) {
      event.preventDefault();
      event.stopPropagation();

      _this.setState({
        visible: true
      });
    }, _this.handleCancel = function (event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }
      _this.setState({
        visible: false
      });
    }, _this.handleOnlineVideo = function (event) {
      event.stopPropagation();
      var embedUrl = _this.state.embedUrl;
      var _this$props = _this.props,
          engine = _this$props.engine,
          setOnline = _this$props.setOnline;

      var url = (0, _youku.getDocEmbedURL)(embedUrl);
      if (!url) {
        engine.messageError('链接错误，请检查后重新输入');
      } else if (setOnline) {
        _this.handleCancel();
        _this.setState({
          embedUrl: ''
        });
        setOnline({
          url: url,
          name: embedUrl
        });
      }
    }, _this.onUrlChange = function (event) {
      _this.setState({
        embedUrl: event.target.value
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(_class, [{
    key: 'videoError',


    /**
     * -100 网络错误
     * @param {object} err 错误对象
     */
    value: function videoError() {
      var err = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _antd.message.error(err.code === -100 ? '网络异常：Failed to fetch' : err.message);
    }
  }, {
    key: 'formatAcceptExts',
    value: function formatAcceptExts() {
      return '.3gp,.asf,.avi,.dv,.flv,.f4v,.gif,.m2t,.m4v,.mj2,.mjpeg,.mkv,.mov,.mp4,.mpg,.mpeg,.mts,.ogg,.rm,.rmvb,.swf,.ts,.vob,.wmv,.webm';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          visible = _state.visible,
          embedUrl = _state.embedUrl;
      var engine = this.props.engine;

      return _react2.default.createElement(_button2.default, _extends({}, this.props, {
        isPrevent: false,
        outerVisible: visible,
        contentVisible: visible,
        content: _react2.default.createElement(
          _antd.Modal,
          {
            title: null,
            className: 'zacheditor-toolbar-uploader-modal',
            getContainer: 'div[data-zacheditor-element=toolbar]',
            visible: true,
            centered: true,
            mask: false,
            destroyOnClose: true,
            style: {
              minWidth: '600px'
            },
            onCancel: this.handleCancel,
            footer: null
          },
          _react2.default.createElement(
            _antd.Tabs,
            null,
            _react2.default.createElement(
              _antd.Tabs.TabPane,
              { tab: '\u672C\u5730\u4E0A\u4F20', key: 'local-upload' },
              _react2.default.createElement(
                'div',
                {
                  className: 'zacheditor-toolbar-uploader',
                  onMouseDown: function onMouseDown(event) {
                    event.preventDefault();
                    event.stopPropagation();
                  },
                  onClick: function onClick(event) {
                    event.stopPropagation();
                    if (!_this2.videoUploader) {
                      _this2.videoUploader = new _videoUploader2.default({
                        trigger: _this2.videoTrigger,
                        engine: engine,
                        onToolBarClick: _this2.handleCancel,
                        onToolBarError: _this2.videoError
                      });
                    }
                    _this2.videoTrigger.click();
                  }
                },
                _react2.default.createElement('input', {
                  ref: function ref(trigger) {
                    return _this2.videoTrigger = trigger;
                  },
                  type: 'file',
                  accept: this.formatAcceptExts(),
                  className: 'input-uploader'
                }),
                _react2.default.createElement(_icons.UploadOutlined, null),
                _react2.default.createElement(
                  'p',
                  { className: 'uploader-text' },
                  '\u5355\u51FB\u6B64\u533A\u57DF\u9009\u62E9\u9700\u8981\u4E0A\u4F20\u7684\u6587\u4EF6'
                )
              )
            ),
            _react2.default.createElement(
              _antd.Tabs.TabPane,
              { tab: '\u5728\u7EBF\u89C6\u9891', key: 'online-upload' },
              _react2.default.createElement(
                InputGroup,
                { size: 'large', compact: true },
                _react2.default.createElement(_antd.Input, {
                  value: embedUrl,
                  onChange: this.onUrlChange,
                  onMouseDown: function onMouseDown(event) {
                    return event.stopPropagation();
                  },
                  onMouseMove: function onMouseMove(event) {
                    return event.stopPropagation();
                  },
                  onPressEnter: this.handleOnlineVideo,
                  placeholder: '\u8BF7\u8F93\u5165\u89C6\u9891\u94FE\u63A5\uFF0C\u652F\u6301\u4F18\u9177\u3001\u54D4\u54E9\u54D4\u54E9',
                  style: { width: '86%' }
                }),
                _react2.default.createElement(
                  _antd.Button,
                  {
                    size: 'large',
                    type: 'primary',
                    style: { width: '14%' },
                    onClick: this.handleOnlineVideo
                  },
                  '\u786E\u5B9A'
                )
              )
            )
          )
        ),
        onClick: this.handleClick
      }));
    }
  }]);

  return _class;
}(_react2.default.Component);

exports.default = _class;