'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _codeblock = require('../section/codeblock');

var _string = require('../utils/string');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var locale = {
  'zh-cn': {
    hereIsOnlineVideo: '\u6B64\u5904\u4E3A\u89C6\u9891\uFF0C\u70B9\u51FB\u94FE\u63A5\u67E5\u770B\uFF1A',
    hereIsOnlineDoc: '此处为在线文档，点击链接查看：',
    hereIsLockText: '\u6B64\u5904\u4E3A\u8BED\u96C0\u52A0\u5BC6\u6587\u672C\uFF0C\u70B9\u51FB\u94FE\u63A5\u67E5\u770B\uFF1A'
  },
  en: {
    hereIsVideo: 'Here is the video, click on the link to view:',
    hereIsOnlineDoc: 'Here is online doc section, click on the link to view:',
    hereIsLockText: 'Here is the zacheditor lock text section, click on the link to view:'
  }
}[window.appData && 'zh-cn' !== window.appData.locale ? 'en' : 'zh-cn'];

function getUrl(section) {
  section.empty();
  var value = _tinsoEditorEngine2.default.section.getValue(section);
  if (value && value.url) {
    section.append('<img src="'.concat(value.url, '" />'));
  }
}

function getLink(href, html) {
  return '<a href="'.concat(href, '" style="\n    word-wrap: break-word;\n    color: #096DD9;\n    touch-action: manipulation;\n    background-color: rgba(0,0,0,0);\n    text-decoration: none;\n    outline: none;\n    cursor: pointer;\n    transition: color .3s;\n  ">').concat(html, '</a>');
}

function setStyle(root, attrs) {
  _tinsoEditorEngine2.default.NodeUtils.walkTree(root, function (node) {
    if (node.nodeType === Node.ELEMENT_NODE && node.classList.length > 0) {
      var style = window.getComputedStyle(node);
      attrs.forEach(function (attr) {
        node.style[attr] = style.getPropertyValue(attr);
      });
    }
  });
}

var ExportParser = function (_Engine$ExportParser) {
  _inherits(ExportParser, _Engine$ExportParser);

  function ExportParser() {
    _classCallCheck(this, ExportParser);

    return _possibleConstructorReturn(this, (ExportParser.__proto__ || Object.getPrototypeOf(ExportParser)).apply(this, arguments));
  }

  _createClass(ExportParser, [{
    key: 'getDocUrl',
    value: function getDocUrl() {
      if (this.options.docUrl) return this.options.docUrl;
      var location = window.location;
      var url = location.origin + location.pathname.replace('/edit', '');
      return url;
    }
  }, {
    key: 'getDefaultSectionParsers',
    value: function getDefaultSectionParsers() {
      var _this2 = this;

      return Object.assign({}, _get(ExportParser.prototype.__proto__ || Object.getPrototypeOf(ExportParser.prototype), 'getDefaultSectionParsers', this).call(this), {
        table: function table(section) {
          var table = section.find('table');
          section.empty();
          if (table.length > 0) {
            table.css({
              outline: 'none',
              'border-collapse': 'collapse'
            });
            table.find('td').css({
              'min-width': '90px',
              'font-size': '14px',
              'white-space': 'normal',
              'word-wrap': 'break-word',
              border: '1px solid #d9d9d9',
              padding: '4px 8px',
              cursor: 'default'
            });
            section.append(table);
          }
        },
        image: function image(section) {
          var img = section.find('img');
          section.empty();
          if (img.length > 0) {
            var value = _tinsoEditorEngine2.default.section.getValue(section);
            img.attr('src', value.src);
            img.css('visibility', 'visible');
            section.append(img);
          }
        },
        file: function file(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.src) {
            section.append(getLink(value.src, '<span style="font-size: 14px;">\uD83D\uDCCE</span>' + value.name));
          }
        },
        math: function math(section) {
          var img = section.find('img');
          section.empty();
          if (img.length > 0) {
            img.css('vertical-align', 'middle');
            section.append(img);
          }
        },
        codeblock: function codeblock(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.code) {
            var mode = _codeblock.MODE_NAME_MAP[value.mode] ? value.mode : 'plain';
            section.append((0, _codeblock.template)({
              mode: mode
            }));
            var content = section.find('.zacheditor-codeblock-content');
            content.css({
              border: '1px solid #e8e8e8',
              'max-width': '750px'
            });
            (0, _codeblock.setMode)(content, mode, value.code);
            content.addClass('zacheditor-engine-view');
            content.hide();
            document.body.appendChild(content[0]);
            setStyle(content, ['color', 'margin', 'padding', 'background']);
            section.find('.zacheditor-codeblock').remove();
            content.show();
            content.css('background', '#f9f9f9');
            section.append(content);
            content.removeClass('zacheditor-engine-view');
          }
        },
        emoji: function emoji(section) {
          var emoji = section.find('.zacheditor-emoji');
          section.empty();
          if (emoji.length > 0) {
            emoji.attr('width', '18');
            emoji.attr('height', '18');
            emoji.css({
              display: 'inline-block',
              width: '18px',
              height: '18px',
              'vertical-align': 'middle',
              'background-size': 'contain',
              'background-position': '0 0',
              'background-repeat': 'no-repeat',
              'margin-top': '-3px',
              'margin-left': '1px',
              'margin-right': '1px',
              border: '1px solid transparent'
            });
            section.append(emoji);
          }
        },
        label: function label(section) {
          var label = section.find('.zacheditor-section-label-container');
          section.empty();
          if (label.length > 0) {
            label.css({
              'font-weight': 400,
              'font-size': '12px',
              overflow: 'hidden',
              'max-width': '200px',
              display: 'inline-block',
              'white-space': 'nowrap',
              'margin-bottom': '-4px',
              'border-radius': '4px',
              border: 'none',
              padding: '2px 5px',
              'text-overflow': 'ellipsis',
              'line-height': '14px',
              'margin-left': '1px',
              'margin-right': '1px'
            });
            section.append(label);
          }
        },
        diagram: getUrl,
        mermaid: getUrl,
        flowchart: getUrl,
        graphviz: getUrl,
        puml: getUrl,
        mindmap: function mindmap(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.src) {
            var height = value.height;
            section.append('<img src="'.concat(value.src, '" ').concat(height ? 'height=' + height : '', '/>'));
          }
        },
        onlinedoc: function onlinedoc(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.src) {
            section.append('<span>'.concat(locale.hereIsOnlineDoc, '</span>'));
            section.append(getLink(value.src, value.src));
          }
        },
        localdoc: function localdoc(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.src) {
            section.append(getLink(window.location.origin + (0, _string.getPreviewUrl)(value.src), value.name));
          }
        },
        video: function video(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.status && 'done' === value.status) {
            section.append(getLink(_this2.getDocUrl() + '#' + value.id, value.name));
          }
        },
        mention: function mention(section) {
          var mention = section.find('a');
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.login) {
            section.append(mention);
          }
        },
        lockedtext: function lockedtext(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.id) {
            section.append('<span>'.concat(locale.hereIsLockText, '</span>'));
            var url = _this2.getDocUrl() + '#' + value.id;
            section.append(getLink(url, url));
          }
        },
        riddle: function riddle(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.src) {
            section.append(getLink(value.src, value.src));
          }
        },
        youku: function youku(section) {
          section.empty();
          var value = _tinsoEditorEngine2.default.section.getValue(section);
          if (value && value.src) {
            section.append('<span>'.concat(locale.hereIsOnlineVideo, '</span>'));
            section.append(getLink(value.src, value.src));
          }
        }
      });
    }
  }]);

  return ExportParser;
}(_tinsoEditorEngine2.default.ExportParser);

exports.default = ExportParser;