'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _export = require('./export');

var _export2 = _interopRequireDefault(_export);

var _dom = require('../utils/dom');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WordParser = function (_ExportParser) {
  _inherits(WordParser, _ExportParser);

  function WordParser() {
    _classCallCheck(this, WordParser);

    return _possibleConstructorReturn(this, (WordParser.__proto__ || Object.getPrototypeOf(WordParser)).apply(this, arguments));
  }

  _createClass(WordParser, [{
    key: 'after',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(element) {
        var tables, images, widthArray, i, img, src, canvas, context, image;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                tables = element.find('table');
                images = element.find('img');

                tables.css('width', ''.concat(560, 'px'));
                widthArray = [];

                tables.each(function (table) {
                  table = _tinsoEditorEngine2.default.$(table);
                  var colgroup = table.find('colgroup');
                  var colgroupChildren = colgroup.children();
                  var colgroupWidth = 0;
                  colgroupChildren.each(function (child) {
                    var width = parseInt(child.getAttribute('width'));
                    colgroupWidth += width;
                  });
                  for (var i = 0; i < colgroupChildren.length; i++) {
                    var width = parseInt(colgroupChildren[i].getAttribute('width'));
                    widthArray.push(parseInt(width / colgroupWidth * 560));
                  }
                  table.find('tr').each(function (tr) {
                    _tinsoEditorEngine2.default.$(tr).children().each(function (td, index) {
                      td.setAttribute('width', widthArray[index]);
                    });
                  });
                  colgroup.remove();
                });
                images.each(function (img) {
                  if (img.style.width && img.style.height) {
                    img.width = parseInt(img.style.width);
                    img.height = parseInt(img.style.height);
                    img.style['background-color'] = '';
                    img.style['background-repeat'] = '';
                    img.style['background-position'] = '';
                    img.style['background-image'] = '';
                  }
                });
                i = 0;

              case 7:
                if (!(i <= images.length)) {
                  _context.next = 27;
                  break;
                }

                img = images[i];
                src = img.getAttribute('src');

                if (!(src && src.endsWith('.svg'))) {
                  _context.next = 24;
                  break;
                }

                canvas = document.createElement('canvas');
                context = canvas.getContext('2d');
                _context.next = 15;
                return (0, _dom.loadImage)(src);

              case 15:
                image = _context.sent;

                canvas.width = 2 * image.width;
                canvas.height = 2 * image.height;
                canvas.style.width = image.width + 'px';
                canvas.style.height = image.height + 'px';
                context.drawImage(image, 0, 0, 2 * image.width, 2 * image.height);
                img.src = canvas.toDataURL();
                if (!img.style.width) {
                  img.style.width = image.width + 'px';
                }
                if (!img.style.height) {
                  img.style.height = image.height + 'px';
                }

              case 24:
                i++;
                _context.next = 7;
                break;

              case 27:
                this.done();

              case 28:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function after(_x) {
        return _ref.apply(this, arguments);
      }

      return after;
    }()
  }, {
    key: 'done',
    value: function done() {}
  }, {
    key: 'parseLists',
    value: function parseLists(element) {
      return (0, _utils.lists)(element);
    }
  }]);

  return WordParser;
}(_export2.default);

exports.default = WordParser;