'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _config = require('../schema/config');

var _config2 = _interopRequireDefault(_config);

var _zhCn = require('../lang/zh-cn');

var _zhCn2 = _interopRequireDefault(_zhCn);

var _string = require('../utils/string');

var _html = require('./html');

var _html2 = _interopRequireDefault(_html);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (text) {
  var root = document.createElement('div');
  var child = document.createElement('div');
  root.style.display = 'none';
  root.appendChild(child);
  document.body.appendChild(root);

  var engine = _tinsoEditorEngine2.default.create(child, {
    onBeforeRenderImage: function onBeforeRenderImage(url) {
      return url;
    }
  });
  engine.schema.add(_config2.default);
  engine.locale = _zhCn2.default;
  engine.setValue('<p><cursor /></p>');
  engine.command.execute('paste', text);
  var value = (0, _string.addMentionAttrs)(engine.getValue());
  var html = engine.getHtml(new _html2.default());
  engine.destroy();
  document.body.removeChild(root);
  return {
    value: value,
    html: html
  };
};