'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  initialize: function initialize() {
    var _this = this;

    // 创建命令
    this.command.add('emoji', {
      execute: function execute(point) {
        var options = _this.change.engine.options.emoji || {};
        var url = options.action || '/emoji/';
        var src = url.concat(point, '.svg');
        _this.change.insertSection('emoji', src);
      }
    });
    // 转换粘贴过来的 emoji
    this.on('paste:schema', function (schema) {
      schema.add([{
        img: {
          class: 'zacheditor-emoji'
        }
      }, {
        span: {
          'data-type': '*',
          style: {
            'background-image': '*'
          }
        }
      }]);
    });
    this.on('paste:each', function (node) {
      // 只复制了 emoji 图片
      if (node.name === 'img' && node.hasClass('zacheditor-emoji')) {
        var match = /((https|http)?:\/\/.+?\.svg)/i.exec(node[0].outerHTML);
        if (match) {
          _this.section.replaceNode(node, 'emoji', match[1]);
        }
        return;
      }
      // 阅读页面
      if (node.name === 'span' && node.attr('data-type') === 'emoji') {
        var _match = /((https|http)?:\/\/.+?\.svg)/i.exec(node[0].outerHTML);
        if (_match) {
          node.empty();
          _this.section.replaceNode(node, 'emoji', _match[1]);
        }
        return;
      }
    });
  }
};