'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _dom = require('../../utils/dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var URL = window.URL || window.webkitURL;

var ImageCompress = function () {
  function ImageCompress(options) {
    _classCallCheck(this, ImageCompress);

    this.options = _extends({
      ratio: 0.8,
      isOverSize: function isOverSize() {}
    }, options);
  }

  _createClass(ImageCompress, [{
    key: '_canvasToFile',
    value: function _canvasToFile(canvas, name) {
      var dataURI = canvas.toDataURL('image/jpeg', this.options.ratio);
      var file = _tinsoEditorEngine2.default.ImageUtils.dataURIToFile(dataURI);
      return new File([file], name);
    }
  }, {
    key: 'compress',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(files) {
        var isOverSize, fileArray, i, file, canvas, context, image;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                isOverSize = this.options.isOverSize;
                fileArray = [];
                i = 0;

              case 3:
                if (!(i < files.length)) {
                  _context.next = 23;
                  break;
                }

                file = files[i];

                if (!isOverSize(file)) {
                  _context.next = 19;
                  break;
                }

                canvas = document.createElement('canvas');
                context = canvas.getContext('2d');
                _context.next = 10;
                return (0, _dom.loadImage)(URL.createObjectURL(file));

              case 10:
                image = _context.sent;

                canvas.width = image.width;
                canvas.height = image.height;
                canvas.style.width = image.width + 'px';
                canvas.style.height = image.height + 'px';
                context.drawImage(image, 0, 0, image.width, image.height);
                fileArray.push(this._canvasToFile(canvas, file.name));
                _context.next = 20;
                break;

              case 19:
                fileArray.push(file);

              case 20:
                i++;
                _context.next = 3;
                break;

              case 23:
                return _context.abrupt('return', fileArray);

              case 24:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function compress(_x) {
        return _ref.apply(this, arguments);
      }

      return compress;
    }()
  }]);

  return ImageCompress;
}();

exports.default = ImageCompress;