'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lang = require('./lang');

var _lang2 = _interopRequireDefault(_lang);

var _string = require('tinso-editor-engine/lib/utils/string');

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinkEditor = function (_React$Component) {
  _inherits(LinkEditor, _React$Component);

  function LinkEditor(props) {
    _classCallCheck(this, LinkEditor);

    var _this = _possibleConstructorReturn(this, (LinkEditor.__proto__ || Object.getPrototypeOf(LinkEditor)).call(this, props));

    var type = props.type,
        target = props.target,
        lang = props.lang;

    _this.locale = _lang2.default[lang];
    _this.nativeEvents = [];
    _this.rect = target.getBoundingClientRect();
    _this.link = target.getAttribute('href');

    _this.state = {
      type: type,
      invalidLink: _this.isInvalidLink(_this.link)
    };
    _this.preventScrollCancel = false;
    _this.setContainerPosition();
    return _this;
  }

  _createClass(LinkEditor, [{
    key: 'setContainerPosition',
    value: function setContainerPosition() {
      var _props = this.props,
          container = _props.container,
          target = _props.target;

      var _target$getBoundingCl = target.getBoundingClientRect(),
          bottom = _target$getBoundingCl.bottom;

      container.className = 'zacheditor-prevent-section-activated';
      container.style.top = ''.concat(+window.pageYOffset + bottom + 4, 'px');
      container.style.left = ''.concat(window.pageXOffset, 'px');
      container.style.position = 'absolute';
      container.style['z-index'] = '1400';
    }
  }, {
    key: 'adjustPosition',
    value: function adjustPosition() {
      var _props2 = this.props,
          container = _props2.container,
          target = _props2.target;

      var _target$getBoundingCl2 = target.getBoundingClientRect(),
          top = _target$getBoundingCl2.top,
          left = _target$getBoundingCl2.left,
          bottom = _target$getBoundingCl2.bottom;

      var _container$getBoundin = container.getBoundingClientRect(),
          height = _container$getBoundin.height,
          width = _container$getBoundin.width;

      var styleLeft = left + width > window.innerWidth - 20 ? window.pageXOffset + window.innerWidth - width - 20 : 20 > left - window.pageXOffset ? window.pageXOffset + 20 : window.pageXOffset + left;
      var styleTop = bottom + height > window.innerHeight - 20 ? window.pageYOffset + top - height - 4 : window.pageYOffset + bottom + 4;
      container.style.top = styleTop + 'px';
      container.style.left = styleLeft + 'px';
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.bindNativeEvents();
      this.adjustPosition();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.adjustPosition();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeNativeEvents();
    }
  }, {
    key: 'bindNativeEvents',
    value: function bindNativeEvents() {
      var _this2 = this;

      var container = this.props.container;

      var isMouseDown = false;
      this.addNativeEvent(window, 'scroll', function (event) {
        var target = event.target;

        if (_this2.preventScrollCancel) {
          event.preventDefault();
        } else if (!target.className || target.className.indexOf('zacheditor-link') === -1) {
          _this2.cancel();
        }
      }, true);

      this.addNativeEvent(window, 'resize', function () {
        _this2.cancel();
      }, true);

      this.addNativeEvent(window, 'mousedown', function (event) {
        if (!container.contains(event.target)) {
          isMouseDown = true;
        }
      }, true);

      this.addNativeEvent(window, 'mouseup', function (event) {
        if (isMouseDown && !container.contains(event.target)) {
          _this2.cancel();
        }
        isMouseDown = false;
      }, true);

      this.addNativeEvent(container, 'keydown', function (event) {
        var keyCode = event.keyCode;


        if (13 === keyCode && !_this2.state.invalidLink) {
          _this2.confirm();
        }
        if (27 === keyCode) {
          _this2.cancel();
        }
      });
    }
  }, {
    key: 'cancel',
    value: function cancel() {
      var _props3 = this.props,
          target = _props3.target,
          onCancel = _props3.onCancel;

      onCancel({
        link: target ? target.getAttribute('href') : null
      });
    }
  }, {
    key: 'addNativeEvent',
    value: function addNativeEvent(dom, name, callback, useCapture) {
      dom.addEventListener(name, callback, useCapture);
      this.nativeEvents.push({
        dom: dom,
        name: name,
        callback: callback,
        useCapture: useCapture
      });
    }
  }, {
    key: 'removeNativeEvents',
    value: function removeNativeEvents() {
      this.nativeEvents.forEach(function (nativeEvent) {
        var dom = nativeEvent.dom,
            name = nativeEvent.name,
            callback = nativeEvent.callback,
            useCapture = nativeEvent.useCapture;

        dom.removeEventListener(name, callback, useCapture);
      });
      this.nativeEvents = [];
    }
  }, {
    key: 'confirm',
    value: function confirm() {
      var onConfirm = this.props.onConfirm;
      var invalidLink = this.state.invalidLink;

      var text = this.getText();
      var link = this.getLink();

      if (!invalidLink) {
        onConfirm(text, link);
      }
    }
  }, {
    key: 'renderPreview',
    value: function renderPreview() {
      var _this3 = this;

      var _props4 = this.props,
          onDeleteLink = _props4.onDeleteLink,
          shouldTargetBlank = _props4.shouldTargetBlank;

      var link = this.getLink();
      var locale = this.locale;
      var text = link || locale.emptyLink;

      var linkContainer = link ? shouldTargetBlank(link) ? _react2.default.createElement(
        'a',
        {
          className: 'zacheditor-link-editor-link-container',
          href: (0, _string.sanitizeUrl)(link),
          target: '_blank'
        },
        text
      ) : _react2.default.createElement(
        'a',
        { className: 'zacheditor-link-editor-link-container', href: (0, _string.sanitizeUrl)(link) },
        text
      ) : _react2.default.createElement(
        'span',
        { className: 'zacheditor-link-editor-link-empty' },
        text
      );

      return _react2.default.createElement(
        'div',
        {
          className: 'zacheditor-link-editor zacheditor-link-editor-preview',
          ref: function ref(_ref) {
            return _this3.containerDom = _ref;
          }
        },
        _react2.default.createElement('span', { className: 'zacheditor-icon zacheditor-icon-link' }),
        linkContainer,
        _react2.default.createElement('span', { className: 'zacheditor-link-editor-slash' }),
        _react2.default.createElement(
          _antd.Tooltip,
          { title: locale.editLink },
          _react2.default.createElement('a', {
            className: 'zacheditor-icon zacheditor-icon-edit zacheditor-link-editor-button',
            onClick: function onClick() {
              _this3.setState({
                type: 'edit'
              });
            }
          })
        ),
        _react2.default.createElement(
          _antd.Tooltip,
          { title: locale.deleteLink },
          _react2.default.createElement('a', {
            className: 'zacheditor-icon zacheditor-icon-unlink zacheditor-link-editor-button',
            onClick: onDeleteLink
          })
        )
      );
    }
  }, {
    key: 'isInvalidLink',
    value: function isInvalidLink(link) {
      return !link || link && !link.match(/^[\x00-\x7F]/) || link.startsWith('javascript:');
    }
  }, {
    key: 'renderEditor',
    value: function renderEditor() {
      var _this4 = this;

      var invalidLink = this.state.invalidLink;

      var text = this.getText();
      var link = this.getLink();
      var locale = this.locale;

      return _react2.default.createElement(
        'div',
        {
          className: 'zacheditor-link-editor zacheditor-link-editor-edit',
          ref: function ref(element) {
            return _this4.containerDom = element;
          }
        },
        _react2.default.createElement(
          'p',
          null,
          locale.text
        ),
        _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(_antd.Input, {
            className: 'zacheditor-link-text-input',
            defaultValue: text,
            ref: function ref(element) {
              _this4.preventScrollCancel = true;
              if (element) element.focus();
              _this4.textInputDom = element;
              setTimeout(function () {
                _this4.preventScrollCancel = false;
              }, 32);
            },
            placeholder: locale.addDescription,
            onChange: function onChange(event) {
              _this4.text = event.target.value;
            }
          })
        ),
        _react2.default.createElement(
          'p',
          null,
          locale.link
        ),
        _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(_antd.Input, {
            className: 'zacheditor-link-text-input',
            defaultValue: link,
            ref: function ref(element) {
              if (element) {
                element.focus();
              }
              _this4.linkInputDom = element;
            },
            placeholder: locale.linkAddress,
            onChange: function onChange(event) {
              _this4.link = event.target.value;
              _this4.setState({
                invalidLink: _this4.isInvalidLink(_this4.link)
              });
            }
          })
        ),
        invalidLink && link !== '' ? _react2.default.createElement(
          'p',
          { className: 'zacheditor-link-invalid-link' },
          locale.pleaseEnterCorrectLink
        ) : '',
        _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(
            _antd.Button,
            {
              className: 'zacheditor-link-confirm-button',
              onClick: function onClick() {
                _this4.confirm();
              },
              disabled: !this.link || invalidLink
            },
            '\u786E\u5B9A'
          )
        )
      );
    }
  }, {
    key: 'getLink',
    value: function getLink() {
      var _props5 = this.props,
          target = _props5.target,
          getLink = _props5.getLink;

      return this.link && getLink(this.link) || target.getAttribute('href') || '';
    }
  }, {
    key: 'getText',
    value: function getText() {
      return this.text || this.props.target.innerText;
    }
  }, {
    key: 'render',
    value: function render() {
      return 'edit' === this.state.type ? this.renderEditor() : this.renderPreview();
    }
  }]);

  return LinkEditor;
}(_react2.default.Component);

LinkEditor.defaultProps = {
  container: {},
  target: {},
  type: 'preview',
  lang: 'zh-cn',
  onDeleteLink: function onDeleteLink() {},
  onConfirm: function onConfirm() {},
  onCancel: function onCancel() {},
  shouldTargetBlank: function shouldTargetBlank() {},
  getLink: function getLink(e) {
    return e;
  }
};

exports.default = LinkEditor;