'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/button/style');

require('antd/lib/notification/style');

var _string = require('../utils/string');

var _request = require('../utils/request');

var _engine = require('../editor/engine');

var _engine2 = _interopRequireDefault(_engine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_antd.notification.config({
  top: 105
});

function openConfirm(text, prevValue) {
  var _this = this;

  var locale = this.locale.markdown || {};
  var key = 'zacheditor-paste-markdown';
  var markdown = this.options.markdown;

  var serviceUrl = markdown ? markdown.action : null;
  if (!serviceUrl) return;
  var onOk = function onOk() {
    (0, _request.post)(serviceUrl, {
      from: 'markdown',
      to: 'section',
      content: text
    }).then(function (res) {
      if (res.result) {
        var data = res.data;
        _this.history.stop();
        _this.change.setValue(prevValue);
        _this.command.execute('paste', data.content);
        _this.history.save();
        _antd.notification.close(key);
      }
    });
  };

  var btn = _react2.default.createElement(
    _antd.Button,
    { type: 'primary', size: 'small', onClick: onOk },
    locale.pasteButton
  );

  _antd.notification.open({
    placement: 'topRight',
    message: locale.pasteTitle,
    description: locale.pasteContent,
    btn: btn,
    key: key
  });
}

exports.default = {
  initialize: function initialize() {
    var _this2 = this;

    // 监听粘贴文本事件
    this.on('paste:string', function (data, prevValue) {
      // command+shift+v 纯文本粘贴，不处理
      if (data.isPasteText) {
        return;
      }

      var text = '';
      var html = data.html || '';

      if (html) {
        text = new _engine2.default.HTMLParser(html).toText();
      } else if (data.text) {
        text = data.text;
      }
      // 没有检测到 markdown 文本
      if (!(0, _string.isMarkdown)(data)) {
        return;
      }
      // 提示 markdown 粘贴

      openConfirm.call(_this2, text, prevValue);
    });
  }
};