'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NodeUtils = _tinsoEditorEngine2.default.NodeUtils,
    $ = _tinsoEditorEngine2.default.$;


var PLUGIN_NAME = 'math';
exports.default = {
  initialize: function initialize() {
    var _this = this;

    // 创建命令
    this.command.add(PLUGIN_NAME, {
      execute: function execute() {
        var sectionRoot = _this.change.insertSection(PLUGIN_NAME);
        var component = _this.section.getComponent(sectionRoot);
        _this.change.activateSection(sectionRoot);
        window.setTimeout(function () {
          component.focusTextarea();
        }, 10);
      }
    });
    // 转换页面粘贴过来的代码块
    this.on('paste:origin', function (root) {
      NodeUtils.walkTree(root, function (node) {
        node = $(node);
        // 阅读页面
        if (node.isBlock() && node.attr('data-type') === PLUGIN_NAME) {
          var src = node.attr('data-src');
          var code = node.attr('data-text');
          var width = node.attr('data-width');
          var height = node.attr('data-height');
          code = unescape(code);
          _this.section.replaceNode(node, PLUGIN_NAME, {
            src: src,
            code: code,
            width: width,
            height: height
          });
        }
      });
    });
  }
};