'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleKeydownAt = undefined;

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function handleKeydownAt(e) {
  var range = this.change.getRange();
  if (!range.collapsed) {
    return;
  }

  var bookmark = _tinsoEditorEngine2.default.RangeUtils.createBookmark(range);
  var prevNode = _tinsoEditorEngine2.default.$(bookmark.anchor).prev();
  var prevText = prevNode && prevNode.isText() ? prevNode[0].nodeValue : '';
  _tinsoEditorEngine2.default.RangeUtils.moveToBookmark(range, bookmark);
  // 前面有非空格文本时，应该要输入普通 at 字符

  if (/[^\s@]$/.test(prevText)) {
    return;
  }

  e.preventDefault(); // 插入 @，并弹出选择器

  this.history.stop();
  var sectionRoot = this.change.insertSection('mention');
  var component = this.section.getComponent(sectionRoot);
  component.renderSuggestion();
  this.history.start(); // 焦点移动到 A 标签输入区域，用于继续输入搜索关键词

  var input = sectionRoot.find('.zacheditor-mention-at');
  range.selectNodeContents(input[0]);
  range.collapse(false);
  this.change.select(range);
}

exports.default = {
  initialize: function initialize() {
    var _this = this;

    this.on('keydown:at', function (e) {
      handleKeydownAt.call(_this, e);
    });
  }
};
exports.handleKeydownAt = handleKeydownAt;