'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PLUGIN_NAME = 'save';
exports.default = {
  initialize: function initialize() {
    var _this = this;

    // 创建命令
    this.command.add(PLUGIN_NAME, {
      execute: function execute() {
        _this.event.trigger('save:before');
        _this.asyncEvent.emitAsync('save:before').then(function () {
          _this.options.onSave && _this.options.onSave();
        }).catch(function (error) {
          _this.messageError(error);
        });
      }
    });
    // save 快捷键，所有插件都统一用，所以绑定在 document
    this.domEvent.onDocument('keydown', function (e) {
      if (_tinsoEditorEngine2.default.isHotkey('mod+s', e)) {
        e.preventDefault();
        _this.command.execute('save');
      }
    });
  }
};