'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _command = require('../utils/command');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PLUGIN_NAME = 'search';

function getConfig() {
  var locale = this.locale[PLUGIN_NAME];
  return {
    name: PLUGIN_NAME,
    title: locale.title,
    className: 'zacheditor-dialog-' + PLUGIN_NAME // data: {},
  };
}

exports.default = {
  initialize: function initialize() {
    var _this = this;

    // 创建命令
    (0, _command.addDialogCommand)(this, PLUGIN_NAME, getConfig);
    this.domEvent.onDocument('keydown', function (e) {
      if (_tinsoEditorEngine2.default.isHotkey('mod+shift+f', e)) {
        e.preventDefault();
        _this.command.execute(PLUGIN_NAME);
      }
    });
  }
};