'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleKeydownSlash = undefined;

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var safari = _tinsoEditorEngine2.default.userAgent.safari;


function handleKeydownSlash(e) {
  var range = this.change.getRange();
  var block = _tinsoEditorEngine2.default.ChangeUtils.getClosestBlock(range.startContainer);
  var chars = block.text().trim();
  if (chars === '/' && safari) {
    block.empty();
  }

  if ('' === chars || '/' === chars && safari || e.ctrlKey || e.metaKey) {
    range = this.change.getRange();
    if (range.collapsed) {
      e.preventDefault();
      this.history.stop();
      var section = this.change.insertSection('sectionselect');
      this.change.activateSection(section);
      range = this.change.getRange();
      this.history.start();
      var node = section.find('.zacheditor-sectionselect-keyword');
      range.selectNodeContents(node[0]);
      range.collapse(false);
      this.change.select(range);
    }
  }
}

exports.default = {
  initialize: function initialize() {
    var _this = this;

    this.on('keydown:slash', function (e) {
      handleKeydownSlash.call(_this, e);
    });
  }
};
exports.handleKeydownSlash = handleKeydownSlash;