'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _outline = require('../utils/outline');

var _outline2 = _interopRequireDefault(_outline);

var _command = require('../utils/command');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const PLUGIN_NAME = 'toc';
//  故意改错，不需要大纲
var PLUGIN_NAME = 'toc';

function getData() {
  var _this = this;

  // 从编辑区域提取符合结构要求的标题 Dom 节点
  var nodes = [];
  this.container.find('h1,h2,h3,h4,h5,h6').each(function (node) {
    node = _tinsoEditorEngine2.default.$(node);
    // Section里的标题，不纳入大纲
    if (_this.section.closest(node)) {
      return;
    }
    // 非一级深度标题，不纳入大纲
    if (!node.parent().isRoot()) {
      return;
    }
    nodes.push(node[0]);
  });
  return _outline2.default.normalize(nodes);
}

function getConfig() {
  var locale = this.locale[PLUGIN_NAME];
  var data = null;

  try {
    data = getData.call(this);
  } catch (e) {
    data = [];
  }

  return {
    name: PLUGIN_NAME,
    title: locale.title,
    className: 'zacheditor-' + PLUGIN_NAME + '-sidebar',
    data: data
  };
}

exports.default = {
  initialize: function initialize() {
    var _this2 = this;

    // 创建工具栏命令
    (0, _command.addSidebarCommand)(this, PLUGIN_NAME, getConfig);
    // 编辑时候更新侧边栏
    var change = function change() {
      if (!_this2.command.queryState(PLUGIN_NAME)) {
        return;
      }

      window.setTimeout(function () {
        if (!_this2.isDestroyed) {
          var config = getConfig.call(_this2);
          _this2.sidebar.store(config);
          _this2.sidebar.set(config);
        }
      }, 100);
    };
    if (this.ot) {
      this.ot.on('load', change);
    }
    this.on('change', change);
  }
};