'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ['cursor', 'anchor', 'focus', {
  section: {
    type: /^[\w\-]+$/,
    name: /^[\w\-]+$/,
    value: '*',
    focus: ['true', 'false']
  }
}, {
  span: {
    class: /^zacheditor-fontsize-\d+$|zacheditor\-section\-[\w\-]{1,100}/,
    style: {
      color: '@color',
      'background-color': '@color'
    }
  }
}, 'strong', 'em', 'del', 'u', {
  h1: {
    id: /^[\w\.\-]+$/
  }
}, {
  h2: {
    id: /^[\w\.\-]+$/
  }
}, {
  h3: {
    id: /^[\w\.\-]+$/
  }
}, {
  h4: {
    id: /^[\w\.\-]+$/
  }
}, {
  h5: {
    id: /^[\w\.\-]+$/
  }
}, {
  h6: {
    id: /^[\w\.\-]+$/
  }
}, 'p', 'hr', 'code', {
  mark: {
    'data-type': '*'
  }
}, {
  pre: {
    'data-lang': /^[\w\.\-]+$/
  }
}, {
  blockquote: {
    class: ['zacheditor-alert', 'zacheditor-alert-info', 'zacheditor-alert-warning', 'zacheditor-alert-danger', 'zacheditor-alert-success', 'zacheditor-alert-tips'],
    'data-type': ['question', 'answer', 'analysis']
  }
}, 'sub', 'sup', 'br', {
  img: {
    src: '@url',
    width: '@number',
    height: '@number',
    style: {
      'max-width': '@length',
      'max-height': '@length',
      width: '@length',
      height: '@length'
    },
    alt: '*',
    title: '*',
    'data-size': '@number',
    'data-width': '@number',
    'data-height': '@number'
  }
}, {
  image: {
    src: '@url',
    width: '@number',
    height: '@number',
    style: {
      'max-width': '@length',
      width: '@length',
      height: '@length'
    },
    alt: '*',
    title: '*',
    'data-size': '@number',
    'data-width': '@number',
    'data-height': '@number'
  }
}, {
  a: {
    name: '*',
    href: '@url',
    target: ['_blank', '_parent', '_top'],
    ref: '*',
    class: ['zacheditor-video-link']
  }
}, {
  ul: {
    class: ['zacheditor-list'],
    'data-zacheditor-indent': '@number'
  }
}, {
  ol: {
    start: '@number',
    'data-zacheditor-indent': '@number'
  }
}, {
  li: {
    class: ['zacheditor-list-node', 'zacheditor-list-task']
  }
}, {
  table: {
    class: 'zacheditor-table',
    style: {
      width: '@length',
      height: '@length'
    }
  }
}, 'colgroup', {
  col: {
    width: '@length'
  }
}, 'tbody', 'th', 'tr', {
  td: {
    rowspan: '@number',
    colspan: '@number'
  }
}, {
  block: {
    style: {
      'text-align': ['left', 'center', 'right', 'justify'],
      'text-indent': '@length',
      'padding-left': '@length',
      'background-color': '@color'
    }
  }
}, {
  input: {
    type: ['checkbox'],
    checked: 'checked',
    $allow: {
      type: ['checkbox']
    }
  }
}, {
  video: {
    src: '@url',
    'data-size': '@number',
    'data-type': /^\w{1,100}\/\w{1,100}$/,
    'data-name': '*',
    controls: true
  }
}, {
  iframe: {
    src: /^https?:\/\/(?:riddle\.alibaba\-inc\.com|\w{0,100}\.youku\.com|\w{0,100}\.bilibili\.com)\//,
    height: '@number',
    frameborder: ['yes', 'no'],
    allowtransparency: ['true', 'false'],
    allowfullscreen: ['true', 'false']
  }
}];