'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _dom = require('../utils/dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SectionBase = function () {
  function SectionBase() {
    var _this = this;

    _classCallCheck(this, SectionBase);

    this.onBeforeRenderImage = function (src) {
      return _this.getOptions().onBeforeRenderImage(src);
    };
    this.events = [];
  }

  _createClass(SectionBase, [{
    key: 'embedToolbar',
    value: function embedToolbar() {}
  }, {
    key: 'toolbar',
    value: function toolbar() {}
  }, {
    key: 'maximize',
    value: function maximize() {}
  }, {
    key: 'restore',
    value: function restore() {}
  }, {
    key: 'render',
    value: function render() {}
  }, {
    key: 'activate',
    value: function activate() {}
  }, {
    key: 'unactivate',
    value: function unactivate() {}
  }, {
    key: 'saveValue',
    value: function saveValue() {}
  }, {
    key: 'select',
    value: function select() {
      var container = this.container;

      if (container[0].childNodes.length > 0) {
        container.addClass('background' === this.constructor.selectStyleType ? 'zacheditor-selected-background' : 'zacheditor-selected-outline');
      }
    }
  }, {
    key: 'unselect',
    value: function unselect() {
      var container = this.container;

      if (container[0].childNodes.length > 0) {
        container.removeClass('background' === this.constructor.selectStyleType ? 'zacheditor-selected-background' : 'zacheditor-selected-outline');
      }
    }
  }, {
    key: 'selectByOther',
    value: function selectByOther(outline, background) {
      var container = this.container;

      if (container[0].childNodes.length > 0) {
        if ('background' === this.constructor.selectStyleType) {
          container.css('background', background);
        } else {
          container.css('outline', '2px solid ' + outline);
        }
      }
    }
  }, {
    key: 'unselectByOther',
    value: function unselectByOther() {
      var container = this.container;

      if (container[0].childNodes.length > 0) {
        container.css('background' === this.constructor.selectStyleType ? 'background' : 'outline', '');
      }
    }
  }, {
    key: 'activateByOther',
    value: function activateByOther(outline, background) {
      return this.selectByOther(outline, background);
    }
  }, {
    key: 'unactivateByOther',
    value: function unactivateByOther() {
      this.unselectByOther();
    }
  }, {
    key: 'getContainerWidth',
    value: function getContainerWidth() {
      return (0, _dom.getWidth)(this.container[0]);
    }
  }, {
    key: 'getContainerHeight',
    value: function getContainerHeight() {
      return (0, _dom.getHeight)(this.container[0]);
    }
  }, {
    key: 'addResizeController',
    value: function addResizeController(container) {
      var _this2 = this;

      var height = void 0,
          start = void 0,
          cssHeight = void 0;
      this.resizeController = this.createResizeController({
        container: this.container,
        dragstart: function dragstart() {
          height = (0, _dom.getHeight)(container[0]);
          start = true;
        },
        dragmove: function dragmove(y) {
          if (start) {
            container.css('height', (cssHeight = 80 > (cssHeight = height + y) ? 80 : cssHeight) + 'px');
          }
        },
        dragend: function dragend() {
          if (start) {
            _this2.setValue({
              height: (0, _dom.getHeight)(container[0])
            });
            start = false;
          }
        }
      });
      this.resizeController.hide();
    }
  }, {
    key: 'createResizeController',
    value: function createResizeController(cfg) {
      var container = cfg.container,
          dragstart = cfg.dragstart,
          dragmove = cfg.dragmove,
          dragend = cfg.dragend;

      var resizeImg = _tinsoEditorEngine2.default.$('<div class="section-resize-button-ud" draggable="true" />');
      var point = void 0;
      container.append(resizeImg);
      this.bindEvent(resizeImg, 'dragstart', function (e) {
        e.preventDefault();
        e.stopPropagation();
        e.cancelBubble = true;
        point = {
          x: e.clientX,
          y: e.clientY
        };
        dragstart(point);
      });

      this.bindEvent(_tinsoEditorEngine2.default.$(document), 'mousemove', function (e) {
        if (point) {
          dragmove(e.clientY - point.y);
        }
      });

      this.bindEvent(_tinsoEditorEngine2.default.$(document), 'mouseup', function () {
        point = undefined;
        dragend();
      });

      resizeImg.on('click', function (event) {
        event.stopPropagation();
      });
      return resizeImg;
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.destroyed = true;
      this.removeEvent();
    }
  }, {
    key: 'removeEvent',
    value: function removeEvent() {
      this.events.forEach(function (event) {
        var element = event.element,
            type = event.type,
            callback = event.callback;

        element.off(type, callback);
      });
      this.events = [];
    }
  }, {
    key: 'getViewEngine',
    value: function getViewEngine() {
      return this.engine || this.contentView;
    }
  }, {
    key: 'bindEvent',
    value: function bindEvent(element, type, callback) {
      element.on(type, callback);
      this.events.push({
        element: element,
        callback: callback,
        type: type
      });
    }
  }, {
    key: 'getOptions',
    value: function getOptions() {
      return this.state.readonly ? this.contentView.options : this.engine.options;
    }
  }, {
    key: 'getLang',
    value: function getLang() {
      return this.getOptions().lang;
    }
  }, {
    key: 'setValue',
    value: function setValue(value, saveHistory) {
      var sectionRoot = this.sectionRoot;
      var readonly = this.state.readonly;

      if (!readonly && value) {
        var _engine = this.engine,
            section = _engine.section,
            history = _engine.history,
            change = _engine.change;

        section.setValue(sectionRoot, Object.assign(this.value, value));

        if (saveHistory) {
          history.save();
        } else {
          change.change();
        }
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (!this.state.readonly) {
        this.engine.change.removeSection(this.sectionRoot);
      }
    }
  }]);

  return SectionBase;
}();

SectionBase.canSearch = false;
exports.default = SectionBase;