'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _embed = require('./embed');

var _embed2 = _interopRequireDefault(_embed);

var _error = require('../../tips/error');

var _error2 = _interopRequireDefault(_error);

var _string = require('tinso-editor-engine/lib/utils/string');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Upload = function (_Embed) {
  _inherits(Upload, _Embed);

  function Upload(props) {
    _classCallCheck(this, Upload);

    var _this = _possibleConstructorReturn(this, (Upload.__proto__ || Object.getPrototypeOf(Upload)).call(this, _extends({
      defaultHeight: 467
    }, props)));

    _this.downloadFile = function () {
      var src = _this.value.download || _this.value.src;
      if (src) {
        window.open(src);
      }
    };

    _this.onSaveBefore = function () {
      return new Promise(function (resolve, reject) {
        if ('uploading' === _this.value.status) {
          reject(_this.locale.stillUploading);
          return;
        }
        if ('transfering' !== _this.value.status) {
          resolve();
        } else {
          reject(_this.locale.stillTransfering);
        }
      });
    };

    return _this;
  }

  _createClass(Upload, [{
    key: 'hitBlack',
    value: function hitBlack(src) {
      src = new URL(src, window.location.href);
      //!src.pathname.startsWith("/office/") && !src.pathname.startsWith("/preview/")
      return false;
    }
  }, {
    key: 'embedToolbar',
    value: function embedToolbar() {
      var _this2 = this;

      var toolbar = [{
        type: 'separator'
      }, {
        type: 'dnd'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }, {
        type: 'separator'
      }, {
        type: 'expand'
      }, {
        type: 'collapse'
      }, {
        type: 'preferences',
        onClick: function onClick() {
          _this2.setSidebar();
        }
      }];
      if (!this.state.readonly || this.value.allowDownload) {
        toolbar.unshift({
          type: 'download',
          onClick: this.downloadFile.bind(this)
        });
      }
      return toolbar;
    }
  }, {
    key: 'setSidebar',
    value: function setSidebar() {}
  }, {
    key: 'collapse',
    value: function collapse() {
      this.setValue({
        collapsed: true
      });
      this.render();
    }
  }, {
    key: 'expand',
    value: function expand() {
      this.setValue({
        collapsed: false
      });
      this.render();
    }
  }, {
    key: 'getUrl',
    value: function getUrl() {
      var _value = this.value,
          preview = _value.preview,
          src = _value.src;

      return (0, _string.sanitizeUrl)(preview || src);
    }
  }, {
    key: 'getAcceptExt',
    value: function getAcceptExt() {
      var _value2 = this.value,
          ext = _value2.ext,
          name = _value2.name;

      if (name && /\.mindnode\.zip$/.test(name)) {
        ext = 'mindnode';
      } else if (name && /\.xmind\.zip$/.test(name)) {
        ext = 'xmind';
      }
      return ext;
    }
  }, {
    key: 'renderCollapse',
    value: function renderCollapse() {
      var value = this.value;
      var url = this.getUrl();
      var ext = this.getAcceptExt();
      var size = value.size ? '<span class="zacheditor-embed-upload-collapse-file-size">'.concat(_tinsoEditorEngine2.default.StringUtils.escape(_tinsoEditorEngine2.default.UploadUtils.getFileSize(value.size)), '</span>\n') : '';
      var root = this.container.append('\n      <div class="zacheditor-embed zacheditor-embed-upload zacheditor-embed-upload-collapse" style="position: relative">\n        <div class="zacheditor-embed-upload-file-icon zacheditor-svg-icon-'.concat(_tinsoEditorEngine2.default.StringUtils.escape(ext), '"></div>\n        <div class="zacheditor-embed-upload-collapse-body">\n          <div class="zacheditor-embed-upload-collapse-name" >\n            <a href="').concat(url, '" target="_blank">').concat(_tinsoEditorEngine2.default.StringUtils.escape(value.name), '</a>\n ').concat(size, '</div>\n        </div>\n        <a class="zacheditor-embed-upload-icon zacheditor-svg-icon-preview" href="').concat(url, '" target="_blank"></a>\n      </div>\n    '));
      this.root = root;
    }
  }, {
    key: 'getStatusTips',
    value: function getStatusTips() {
      return 'uploading' === this.value.status ? this.locale.uploading : '';
    }
  }, {
    key: 'renderExpand',
    value: function renderExpand() {
      var value = this.value,
          options = this.options;
      var status = value.status,
          ext = value.ext;

      var height = this.getHeight();
      var url = this.getUrl();
      var transition = options.transition;

      var readonlyClass = this.state.readonly ? ' zacheditor-section-readonly' : '';
      var tips = this.getStatusTips();
      var acceptExt = this.getAcceptExt();
      var root = _tinsoEditorEngine2.default.$('\n      <div class="zacheditor-embed zacheditor-embed-upload'.concat(readonlyClass, '">\n        <div class="zacheditor-embed-upload-header">\n          <span class="zacheditor-embed-upload-icon zacheditor-embed-upload-file-icon zacheditor-svg-icon-').concat(_tinsoEditorEngine2.default.StringUtils.escape(acceptExt), '"></span>\n          <a href="').concat(url, '" target="_blank">\n            <span class="zacheditor-embed-upload-file-name" style="max-width: calc(100% - 60px)"> ').concat(_tinsoEditorEngine2.default.StringUtils.escape(value.name), ' </span>\n            <span data-role="status-tips">').concat(tips, '</span> <span data-role="percent"></span>\n          </a>\n          <a class="zacheditor-embed-upload-icon zacheditor-svg-icon-preview" href="').concat(url, '" target="_blank"></a>\n        </div>\n        <div class="zacheditor-embed-upload-body">\n          <div class="zacheditor-embed-content-bg">\n            <span class="zacheditor-icon zacheditor-icon-loading"></span>\n          </div>\n          <iframe\n            frameborder="0"\n            allowfullscreen="true"\n            style="height: ').concat(_tinsoEditorEngine2.default.StringUtils.escape(height), 'px; transition: ').concat(_tinsoEditorEngine2.default.StringUtils.escape(transition), '"\n          ></iframe>\n          <div class="zacheditor-embed-mask"></div>\n        </div>\n      </div>\n    '));

      var iframe = root.find('iframe');
      this.container.append(root);
      this.root = root;
      this.iframe = iframe;
      iframe.on('load', function () {
        root.find('.zacheditor-embed-content-bg').hide();
      });
      this.mask = root.find('.zacheditor-embed-mask');
      if (value.height) {
        iframe.attr('data-height', height);
      }
      if (status === 'done') {
        if ('xls' === ext || 'xlsx' === ext) {
          iframe.css('border-top', 'none');
        }
        var src = url;
        if (src.indexOf('?') > -1) {
          src += '&view=doc_embed';
        } else {
          src += '?view=doc_embed';
        }
        this.renderIframe(iframe, src, 2e3);
      }
      if (true === this.state.activated) {
        this.hideMask();
      }
    }
  }, {
    key: 'renderReadView',
    value: function renderReadView() {
      if (this.state.collapsed) {
        this.renderCollapse();
      } else {
        this.renderExpand();
        this.hideMask();
      }
    }
  }, {
    key: 'didInsert',
    value: function didInsert(value) {
      if ('uploading' === value.status || 'transfering' === value.status) {
        this.bindEvent(this.engine.asyncEvent, 'save:before', this.onSaveBefore);
      }
    }
  }, {
    key: 'getEmbedEmbedTitle',
    value: function getEmbedEmbedTitle() {
      var ext = this.getAcceptExt();
      var value = this.value;
      return '\n        <span class="zacheditor-svg-icon-'.concat(_tinsoEditorEngine2.default.StringUtils.escape(ext), '" style="\n          float: left;\n          margin-top: 5px;\n          margin-right: 6px;\n          width: 12.6px;\n          height: 13.5px;\n          background-size: 12.6px 13.5px;\n        "></span>\n        ').concat(_tinsoEditorEngine2.default.StringUtils.escape(value.name), '\n    ');
    }
  }, {
    key: 'renderEditView',
    value: function renderEditView() {
      if (this.state.collapsed) {
        this.renderCollapse();
      } else {
        this.renderExpand();
        this.renderResizeController();
      }
    }
  }, {
    key: 'isError',
    value: function isError() {
      return 'error' === this.value.status;
    }
  }, {
    key: 'renderError',
    value: function renderError() {
      var value = this.value,
          container = this.container;

      _reactDom2.default.render(_react2.default.createElement(_error2.default, {
        sectionIcon: '<span class="zacheditor-svg-icon zacheditor-svg-icon-error-file"></span>',
        variableContent: (value.message ? value.message : this.locale.invalid) + ' ' + value.name,
        fixedContent: value.ext ? value.ext : '',
        message: value,
        block: true,
        docWidth: this.getContainerWidth()
      }), container[0]);
    }
  }, {
    key: 'render',
    value: function render(_, value) {
      value = _extends({}, this.value, {
        value: value
      });
      var _value3 = value,
          collapsed = _value3.collapsed;

      this.value = value;
      value.status = value.status || 'done';
      this.state.collapsed = undefined !== collapsed && collapsed;
      if (!value.ext && value.src) {
        value.ext = _tinsoEditorEngine2.default.UploadUtils.getFileExtname(value.src);
      }
      value.ext = value.ext || 'html';
      _get(Upload.prototype.__proto__ || Object.getPrototypeOf(Upload.prototype), 'render', this).call(this);
    }
  }]);

  return Upload;
}(_embed2.default);

Upload.type = 'block';
exports.default = Upload;