'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _upload = require('./upload');

var _upload2 = _interopRequireDefault(_upload);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Url = function (_Upload) {
  _inherits(Url, _Upload);

  function Url() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Url);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Url.__proto__ || Object.getPrototypeOf(Url)).call.apply(_ref, [this].concat(args))), _this), _this.handleInputKeydown = function (e) {
      if (_tinsoEditorEngine2.default.isHotkey('enter', e)) _this.handleSubmit();
    }, _this.handleSubmit = function () {
      var url = _this.find('url')[0].value.trim();
      var options = _this.getOptions();
      var embedUrl = options.getDocEmbedURL ? options.getDocEmbedURL(url) : _this.getDocEmbedURL(url);
      if (embedUrl) {
        _this.setValue({
          url: embedUrl,
          src: url,
          name: url,
          size: undefined,
          ext: 'html'
        });
        _this.render();
      } else {
        _this.engine.messageError(_this.locale.addressInvalid);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Url, [{
    key: 'getDocEmbedURL',
    value: function getDocEmbedURL() {
      return false;
    }
  }, {
    key: 'getUrl',
    value: function getUrl() {
      var _value = this.value,
          src = _value.src,
          url = _value.url;

      return url || src;
    }
  }, {
    key: 'embedToolbar',
    value: function embedToolbar() {
      var toolbarExtends = [];
      if (this.engine.options.type === 'max') {
        toolbarExtends = toolbarExtends.concat([{
          type: 'dnd'
        }]);
      }
      toolbarExtends = toolbarExtends.concat([{
        type: 'copy'
      }, {
        type: 'delete'
      }, {
        type: 'separator'
      }, {
        type: 'expand'
      }, {
        type: 'collapse'
      }]);
      return toolbarExtends;
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      _get(Url.prototype.__proto__ || Object.getPrototypeOf(Url.prototype), 'unactivate', this).call(this);
      this.container.find('.zacheditor-embed-content').removeClass('zacheditor-embed-content-active');
    }
  }, {
    key: 'find',
    value: function find(role) {
      return this.container.find('[data-role='.concat(role, ']'));
    }
  }, {
    key: 'focusInput',
    value: function focusInput() {
      var _this2 = this;

      setTimeout(function () {
        var urlElement = _this2.find('url');
        if (urlElement.length > 0) {
          urlElement[0].focus();
        }
      }, 50);
    }
  }, {
    key: 'getPlaceHolder',
    value: function getPlaceHolder() {
      return _tinsoEditorEngine2.default.StringUtils.escape(this.locale.placeholder);
    }
  }, {
    key: 'renderInput',
    value: function renderInput() {
      var embedNode = _tinsoEditorEngine2.default.$('\n    <div class="zacheditor-embed zacheditor-embed-active">\n      <div class="zacheditor-embed-form">\n        <span class="zacheditor-embed-editor">\n          <input data-role="url" placeholder="'.concat(this.getPlaceHolder(), '" spellcheck="false" class="zacheditor-embed-input" value="" autocomplete="off"/>\n        </span>\n        <span class="zacheditor-embed-button"><button class="zacheditor-ui-button" data-role="submit"><span>').concat(_tinsoEditorEngine2.default.StringUtils.escape(this.locale.submit), '</span></button></span>\n      </div>\n    </div>\n    '));
      this.container.append(embedNode);
      this.find('url').on('keydown', this.handleInputKeydown);
      this.find('submit').on('click', this.handleSubmit);
    }
  }, {
    key: 'renderEditView',
    value: function renderEditView() {
      if (this.value.url) {
        _get(Url.prototype.__proto__ || Object.getPrototypeOf(Url.prototype), 'renderEditView', this).call(this);
      } else this.renderInput();
    }
  }]);

  return Url;
}(_upload2.default);

Url.type = 'block';
exports.default = Url;