'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _error = require('../../tips/error');

var _error2 = _interopRequireDefault(_error);

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var canPreview = function canPreview(ext) {
  // return false;
  //  暂不支持预览
  ext = String(ext || '');
  return ext === 'pdf' ? true : false;
  // return (
  //   Engine.UploadUtils.isOffice(ext) ||
  //   Engine.UploadUtils.isImage(ext) ||
  //   Engine.UploadUtils.isVideo(ext) || ['pdf', 'mp3'].indexOf(ext) >= 0
  // );
};

var template = function template(value, locale) {
  if (value.status === 'error') {
    var messageElement = document.createElement('div');

    _reactDom2.default.render(_react2.default.createElement(_error2.default, {
      sectionIcon: '<span class="zacheditor-svg-icon zacheditor-svg-icon-error-file"></span>',
      variableCo: value.message ? value.message : locale.invalid,
      fixedContent: value.name ? value.name : '',
      message: value
    }), messageElement);
    return messageElement;
  }
  var iconHtml = '<span class="zacheditor-icon zacheditor-icon-attachment"></span>';

  if (value.status === 'uploading' || 'transfering' === value.status) {
    iconHtml = '\n    <i class="zacheditor-anticon zacheditor-anticon-loading">\n      <svg viewBox="0 0 1024 1024" class="zacheditor-anticon-spin" data-icon="loading" width="1em" height="1em" fill="currentColor" aria-hidden="true">\n        <path d="M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 0 0-94.3-139.9 437.71 437.71 0 0 0-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z"></path>\n      </svg>\n    </i>\n    ';
  }

  var fileSizeHtml = '';
  var fileSize = null;
  if (value.size) {
    fileSize = _tinsoEditorEngine2.default.UploadUtils.getFileSize(value.size);
  }

  if (fileSize) {
    fileSizeHtml = '\n    <span class="zacheditor-file-size">('.concat(_tinsoEditorEngine2.default.StringUtils.escape(fileSize), ')</span>\n    ');
  }

  var percent = '';
  if (value.status === 'uploading') percent = '<span data-role="percent"></span> &nbsp;';else if ('transfering' === value.status) percent = '<span></span> &nbsp;';

  return '\n  <span class="zacheditor-file zacheditor-file-'.concat(value.status, '">\n    <span class="zacheditor-file-icon">').concat(iconHtml, '</span>\n    ').concat(percent, '\n    <span class="zacheditor-file-title">').concat(_tinsoEditorEngine2.default.StringUtils.escape(value.name), '</span>').concat(fileSizeHtml, '\n  </span>\n  ');
};

var File = function (_SectionBase) {
  _inherits(File, _SectionBase);

  function File(engine, contentView) {
    _classCallCheck(this, File);

    var _this = _possibleConstructorReturn(this, (File.__proto__ || Object.getPrototypeOf(File)).call(this));

    _this.destroy = function () {
      window.removeEventListener('resize', _this.onWindowResize);
      if (_this.engine) {
        _this.engine.asyncEvent.off('save:before', _this.onSaveBefore);
      }
    };

    _this.getMaxWidth = function () {
      var block = _tinsoEditorEngine2.default.ChangeUtils.getClosestBlock(_this.sectionRoot);
      return block[0].clientWidth - 6;
    };

    _this.onWindowResize = function () {
      _this.maxWidth = _this.getMaxWidth();
      _this.updateMaxWidth();
    };

    _this.onSaveBefore = function () {
      return new Promise(function (resolve, reject) {
        if (_this.value.status === 'uploading') {
          reject(_this.locale.stillUploading);
        } else if ('transfering' !== _this.value.status) {
          resolve();
        } else {
          reject(_this.locale.stillTransfering);
        }
      });
    };

    _this.updateMaxWidth = function () {
      _this.sectionRoot.find('.zacheditor-file-title').css('max-width', _this.maxWidth - 100 + 'px');
    };

    _this.focusSection = function () {
      _this.engine.change.focusSection(_this.sectionRoot);
    };

    _this.previewFile = function () {
      var _this$value = _this.value,
          src = _this$value.src,
          name = _this$value.name,
          ext = _this$value.ext;

      var onBeforePreviewFile = _this.engine ? _this.engine.options.onBeforePreviewFile : _this.contentView.options.onBeforePreviewFile;

      var handleGetBlob = function handleGetBlob(url) {
        // console.log(url)
        return new Promise(function (resolve) {
          var xhr = new XMLHttpRequest();
          xhr.open('GET', url, true);
          xhr.responseType = 'blob';
          xhr.onload = function () {
            if (xhr.status === 200) {
              resolve(xhr.response);
            }
          };
          xhr.send();
        });
      };

      var handlePreview = function handlePreview(blob, filename) {
        var newBlob = new Blob([blob], {
          type: 'application/pdf;chartset=UTF-8'
        });

        var fileURL = URL.createObjectURL(newBlob);
        window.open(fileURL);
      };

      handleGetBlob(_tinsoEditorEngine2.default.StringUtils.sanitizeUrl(onBeforePreviewFile(src))).then(function (blob) {
        // window.console.log(blob);
        handlePreview(blob, name);
      }).catch(function (err) {
        alert('下载错误');
      });
    };

    _this.downloadFile = function () {
      var _this$value2 = _this.value,
          src = _this$value2.src,
          name = _this$value2.name;


      var onBeforeDownloadFile = _this.engine ? _this.engine.options.onBeforeDownloadFile : _this.contentView.options.onBeforeDownloadFile;

      var handleGetBlob = function handleGetBlob(url) {
        // console.log(url)
        return new Promise(function (resolve) {
          var xhr = new XMLHttpRequest();
          xhr.open('GET', url, true);
          xhr.responseType = 'blob';
          xhr.onload = function () {
            if (xhr.status === 200) {
              resolve(xhr.response);
            }
          };
          xhr.send();
        });
      };

      var handleSaveAs = function handleSaveAs(blob, filename) {
        if (window.navigator.msSaveOrOpenBlob) {
          navigator.msSaveBlob(blob, filename);
        } else {
          var link = document.createElement('a');
          var body = document.querySelector('body');
          link.href = window.URL.createObjectURL(blob);
          link.download = filename;
          // fix Firefox
          link.style.display = 'none';
          body.appendChild(link);
          link.click();
          body.removeChild(link);
          window.URL.revokeObjectURL(link.href);
        }
      };

      handleGetBlob(_tinsoEditorEngine2.default.StringUtils.sanitizeUrl(onBeforeDownloadFile(src))).then(function (blob) {
        handleSaveAs(blob, name);
      }).catch(function (err) {
        alert('下载错误');
      });
      // window.open(
      //   Engine.StringUtils.sanitizeUrl(
      //     this.engine.options.onBeforePreviewFile(src),
      //   ),
      // );
    };

    _this.section = _tinsoEditorEngine2.default.section;
    _this.engine = engine;
    _this.contentView = contentView;
    _this.isEditMode = !!engine;
    _this.maxWidth = 752;
    return _this;
  }

  _createClass(File, [{
    key: 'getToolbarConfig',
    value: function getToolbarConfig() {
      var items = [];
      if (this.value.status === 'done') {
        if (canPreview(this.value.ext)) {
          items.push({
            type: 'button',
            name: 'preview',
            iconName: 'preview',
            title: this.locale.preview,
            onClick: this.previewFile
          });
        }

        items.push({
          type: 'button',
          name: 'download',
          iconName: 'download',
          title: this.locale.download,
          onClick: this.downloadFile
        });

        if (this.isEditMode) {
          items.push({
            type: 'copy'
          });
          items.push({
            type: 'separator'
          });
        }
      }

      if (this.isEditMode) {
        items.push({
          type: 'delete'
        });
      }
      return items;
    }
  }, {
    key: 'didInsert',
    value: function didInsert(value) {
      if (value.status === 'uploading' || 'transfering' === value.status) {
        this.engine.asyncEvent.on('save:before', this.onSaveBefore);
      }
    }
  }, {
    key: 'activate',
    value: function activate() {
      this.container.find('zacheditor-file').addClass('zacheditor-file-active');
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      this.container.find('zacheditor-file').removeClass('zacheditor-file-active');
    }
  }, {
    key: 'renderViewMode',
    value: function renderViewMode() {
      var _this2 = this;

      // 默认点击都是预览
      this.sectionRoot.on('click', this.downloadFile);
      // Section工具栏
      var config = this.getToolbarConfig();
      var embedToolbar = new _tinsoEditorEngine2.default.EmbedToolbar({
        list: config
      });
      var toolbarRoot = embedToolbar.root;
      toolbarRoot.addClass('zacheditor-section-toolbar');
      embedToolbar.render(this.sectionRoot.first());
      // 显示或隐藏工具栏
      var canHide = true;

      var handleMouseleave = function handleMouseleave() {
        canHide = true;
        window.setTimeout(function () {
          if (canHide) {
            _this2.section.hideSectionToolbar(_this2.sectionRoot);
          }
        }, 300);
      };

      var handleMouseEnter = function handleMouseEnter() {
        canHide = false;
        _this2.contentView.container.find('[data-section-key="file"]').each(function (node) {
          _this2.section.hideSectionToolbar(_tinsoEditorEngine2.default.$(node));
        });
        _this2.section.showSectionToolbar(_this2.sectionRoot);
      };

      this.sectionRoot.on('mouseenter', handleMouseEnter);
      this.sectionRoot.on('mouseleave', handleMouseleave);
      toolbarRoot.on('mouseenter', function () {
        canHide = false;
      });
      toolbarRoot.on('mouseleave', handleMouseleave);
    }
  }, {
    key: 'renderEditMode',
    value: function renderEditMode() {
      // Section工具栏
      this.embedToolbar = function () {
        return this.getToolbarConfig();
      };

      this.section.setToolbar({
        sectionRoot: this.sectionRoot,
        engine: this.engine,
        component: this
      });
    }
  }, {
    key: 'render',
    value: function render(container, value) {
      this.locale = this.engine ? this.engine.locale.file : this.contentView.locale.file;
      this.maxWidth = this.getMaxWidth();
      value = value || {};
      this.value = value;
      value.status = value.status || 'done';
      // 补齐文件扩展名
      if (!value.ext && value.src) {
        value.ext = _tinsoEditorEngine2.default.UploadUtils.getFileExtname(value.src);
      }

      var root = _tinsoEditorEngine2.default.$(template(value, this.locale));
      if (!this.state.readonly) {
        root.attr('draggable', true);
      }
      container.append(root);
      this.updateMaxWidth();
      window.removeEventListener('resize', this.onWindowResize);
      window.addEventListener('resize', this.onWindowResize);
      // 阅读模式
      if (!this.engine) {
        this.renderViewMode();
        return;
      }
      // 编辑模式
      this.renderEditMode();
    }
  }]);

  return File;
}(_base2.default);

File.type = 'inline';
File.selectStyleType = 'background';
File.uid = true;
exports.default = File;