'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

var _command = require('../command');

var _command2 = _interopRequireDefault(_command);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Editor = function (_Base) {
    _inherits(Editor, _Base);

    function Editor() {
        _classCallCheck(this, Editor);

        return _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).apply(this, arguments));
    }

    _createClass(Editor, [{
        key: 'getDefaultCfg',
        value: function getDefaultCfg() {
            return {
                _components: [],
                _command: {
                    zoomDelta: 0.1,
                    // 缩放步长
                    queue: [],
                    // 回退堆栈
                    current: 0,
                    // 不是索引，是第 N 个数组元素
                    clipboard: [] // 剪贴板
                }
            };
        }
    }, {
        key: 'commandEnable',
        value: function commandEnable(name) {
            return _command2.default.enable(name, this);
        }
    }, {
        key: '_getComponentsBy',
        value: function _getComponentsBy(callback) {
            var components = this.get('_components');
            return components.filter(callback);
        }
    }, {
        key: 'executeCommand',
        value: function executeCommand(param, cfg) {
            if (_util2.default.isString(param)) {
                _command2.default.execute(param, this, cfg);
            } else {
                _command2.default.execute('common', this, {
                    method: param
                }, cfg);
            }
        }
    }, {
        key: '_afterAddPage',
        value: function _afterAddPage(page) {
            this._bindShortcut(page);
        }
    }, {
        key: 'getComponentsByType',
        value: function getComponentsByType(type) {
            return this._getComponentsBy(function (component) {
                return component.type === type;
            });
        }
        /**
         * 获取激活的页面
         * @return  {Page} page
         */

    }, {
        key: 'getCurrentPage',
        value: function getCurrentPage() {
            var pages = this.getComponentsByType('page');
            var rst = void 0;
            pages.every(function (page) {
                if (page.isActived) {
                    rst = page;
                    return false;
                }
                return true;
            });

            if (!rst) {
                rst = pages[0];
            }

            return rst;
        }

        // 判断该快捷键下命令是否执行

    }, {
        key: '_shortcutEnable',
        value: function _shortcutEnable(command, domEvent) {
            var shortcutCodes = command.shortcutCodes;
            var key = _util2.default.getKeyboradKey(domEvent);
            var bool = false;
            for (var i = 0; i < shortcutCodes.length; i++) {
                var shortcutCode = shortcutCodes[i];
                if (_util2.default.isArray(shortcutCode)) {
                    var l = shortcutCode.length;
                    var subBool = true;

                    for (var j = 0; j < l - 1; j++) {
                        if (!domEvent[shortcutCode[j]]) {
                            subBool = false;
                            break;
                        }
                    }

                    if ((shortcutCode[l - 1] === key || shortcutCode[l - 1] === _util2.default.lowerFirst(key)) && subBool) {
                        bool = true;
                    }
                } else {
                    if (shortcutCode === key) {
                        bool = true;
                    }
                }

                if (bool) {
                    break;
                }
            }
            return bool;
        }
        /**
         * 绑定快捷键
         * @param  {object} page page or array
         */

    }, {
        key: '_bindShortcut',
        value: function _bindShortcut(page) {
            var _this2 = this;

            var shortcut = page.get('shortcut');
            var graph = page.getGraph();
            graph.on('keydown', function (ev) {
                var domEvent = ev.domEvent;
                domEvent.preventDefault();
                domEvent.stopPropagation();
                var commandList = _command2.default.list.filter(function (item) {
                    return item.shortcutCodes && shortcut[item.name];
                });
                for (var i = 0; i < commandList.length; i++) {
                    var command = commandList[i];
                    if (_this2._shortcutEnable(command, domEvent)) {
                        _this2.executeCommand(command.name);
                        return false;
                    }
                }
            });
        }
    }, {
        key: 'add',
        value: function add(component) {
            var components = this.get('_components');
            var type = _util2.default.upperFirst(component.type);
            component.editor = this;
            this['_beforeAdd' + type] && this['_beforeAdd' + type](component);
            components.push(component);
            this['_afterAdd' + type] && this['_afterAdd' + type](component);
        }
    }, {
        key: 'destroy',
        value: function destroy() {
            var components = this.get('_components');
            components.forEach(function (component) {
                component.destroy();
            });
            _get(Editor.prototype.__proto__ || Object.getPrototypeOf(Editor.prototype), 'destroy', this).call(this);
        }
    }]);

    return Editor;
}(_base2.default);

exports.default = Editor;