'use strict';

var _page = require('../page');

var _page2 = _interopRequireDefault(_page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_page2.default.registerBehaviour('clickExpandedButton', function (page) {
    var graph = page.getGraph();
    graph.behaviourOn('click', function (ev) {
        var item = ev.item;
        var shape = ev.shape;

        if (item && shape && shape.isExpandedButton) {
            var editor = page.editor;
            if (editor) {
                editor.executeCommand('collapseExpand', {
                    itemId: item.id
                });
            } else {
                graph.update(item, {
                    collapsed: false
                });
            }
        }
    });
});