'use strict';

var _page = require('../page');

var _page2 = _interopRequireDefault(_page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_page2.default.registerBehaviour('hoverNodeActived', function (page) {
    var graph = page.getGraph();
    var hoverItem = void 0;
    graph.behaviourOn('node:mouseenter', function (ev) {
        if (page.getSignal('panningItem') || page.getSignal('dragEdge') || ev.item && ev.item.isSelected) {
            return;
        }

        hoverItem = ev.item;
        page.setActived(hoverItem, true);
    });
    graph.behaviourOn('node:mouseleave', function (ev) {
        var toShape = ev.toShape;

        if (!hoverItem) {
            return;
        }

        if (toShape && toShape.isAnchor && toShape.getItem() === hoverItem || page.getSignal('dragEdge')) {
            return;
        }

        if (!hoverItem.isSelected) {
            page.setActived(hoverItem, false);
        }

        resetStatus();
    });

    function resetStatus() {
        hoverItem = undefined;
    }
});