'use strict';

var _page = require('../page');

var _page2 = _interopRequireDefault(_page);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_page2.default.registerBehaviour('panItem', function (diagram) {
    var graph = diagram.getGraph();
    graph.behaviourOn('drop', function () {
        var panItems = diagram.get('panItems');
        if (!panItems) {
            return;
        }

        var panItem = panItems[0];
        var panItemIds = panItems.map(function (panItem) {
            return panItem.id;
        });
        var delegation = diagram.get('panItemDelegation');
        var startBox = diagram.get('panItemStartBox');
        var panItemId = panItem.id;
        var dx = delegation.attr('x') - startBox.minX;
        var dy = delegation.attr('y') - startBox.minY;
        graph.emit('afterpanitemdrop', {
            panItems: panItems
        });

        var method = function method() {
            panItemIds.forEach(function (itemId) {
                var item = graph.find(itemId);
                var model = item.getModel();

                if (item.isGroup) {
                    _util2.default.panGroup(item, dx, dy, graph);
                } else {
                    graph.update(item, {
                        x: model.x + dx,
                        y: model.y + dy
                    });
                    graph.toFront(item);
                }
            });

            if (panItemIds.length === 1) {
                diagram.clearSelected();
                diagram.setSelected(panItemId, true);
            }
        };

        diagram.clearAlignLine();
        var editor = diagram.editor;
        graph.emit('panitemend');

        if (!editor || diagram.getSignal('dragaddnodetogroup')) {
            method();
        } else {
            editor.executeCommand(method);
        }
    });
}, ['startPanItem', 'processPanItem', 'endPanItem']);