'use strict';

var _page = require('../page');

var _page2 = _interopRequireDefault(_page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_page2.default.registerBehaviour('processPanItem', function (page) {
    var graph = page.getGraph();
    graph.behaviourOn('mousemove', function (ev) {
        var delegation = page.get('panItemDelegation');
        if (delegation) {
            var startPoint = page.get('panItemStartPoint');
            var startBox = page.get('panItemStartBox');
            var dx = ev.x - startPoint.x;
            var dy = ev.y - startPoint.y;
            var point = page.align({
                x: startBox.minX + dx,
                y: startBox.minY + dy
            }, {
                width: startBox.width,
                height: startBox.height
            });
            delegation.attr({
                x: point.x,
                y: point.y
            });
            graph.emit('itempanning', ev);
            graph.draw();
        }
    });
});