'use strict';

var _page = require('../page');

var _page2 = _interopRequireDefault(_page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_page2.default.registerBehaviour('startPanItem', function (page) {
    var graph = page.getGraph();
    var rootGroup = graph.getRootGroup();
    graph.behaviourOn('mouseenter', function (_ref) {
        var item = _ref.item;
        if (item && (item.isGroup || item.isNode)) {
            var shapeObj = item.getShapeObj();

            if (shapeObj.panAble !== false) {
                page.css({
                    cursor: 'move'
                });
            }
        }
    });
    graph.behaviourOn('dragstart', function (ev) {
        if (ev.button === 2 || !ev.item || !ev.item.isNode && !ev.item.isGroup) {
            return;
        }

        var panItem = ev.item;
        var panItems = void 0;

        if (panItem.isSelected) {
            panItems = page.getSelected();
        } else {
            panItems = [panItem];
        }

        panItems = panItems.filter(function (item) {
            return item.isNode || item.isGroup;
        });

        if (panItems[0] && panItems[0].dragable !== false) {
            graph.emit('beforepanitem', {
                items: panItems
            });
            graph.emit('beforeshowdelegation', {
                items: panItems
            });
            var delegation = page.getDelegation(panItems, rootGroup);
            var startBox = delegation.getBBox();
            page.setSignal('panningItem', true);
            page.set('panItems', panItems);
            page.set('panItemDelegation', delegation);
            page.set('panItemStartBox', startBox);
            page.set('panItemStartPoint', {
                x: ev.x,
                y: ev.y
            });
            graph.draw();
        }
    });
});