'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * @fileOverview Page entry file
                                                                                                                                                                                                                                                                   */


var _g = require('@antv/g6');

var _g2 = _interopRequireDefault(_g);

var _page = require('./page');

var _page2 = _interopRequireDefault(_page);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseShape = {
    getActivedStyle: function getActivedStyle() {},
    getSelectedStyle: function getSelectedStyle() {}
};
_g2.default.registerNode('page-base', _extends({}, baseShape));
_g2.default.registerEdge('page-base', _extends({}, baseShape));
_g2.default.registerGroup('page-base', _extends({}, baseShape));
_g2.default.registerGuide('page-base', _extends({}, baseShape));

function getExtendShape(extend, baseExtend, parentConstructorName) {
    var rst = [];

    if (_util2.default.isString(extend)) {
        rst = [baseExtend, extend];
    } else if (_util2.default.isArray(extend)) {
        extend.unshift(baseExtend);
        rst = extend;
    } else {
        rst = [baseExtend];
    }
    parentConstructorName && rst.unshift(parentConstructorName + '-base');
    return rst;
}

_page2.default.setRegister = function (Constructor, constructorName, parentConstructorName) {
    Constructor.registerNode = function (name, cfg, extend) {
        _g2.default.registerNode(name, cfg, getExtendShape(extend, constructorName + '-base', parentConstructorName));
    };

    Constructor.registerEdge = function (name, cfg, extend) {
        _g2.default.registerEdge(name, cfg, getExtendShape(extend, constructorName + '-base', parentConstructorName));
    };

    Constructor.registerGroup = function (name, cfg, extend) {
        _g2.default.registerGroup(name, cfg, getExtendShape(extend, constructorName + '-base', parentConstructorName));
    };

    Constructor.registerGuide = function (name, cfg, extend) {
        _g2.default.registerGuide(name, cfg, getExtendShape(extend, constructorName + '-base', parentConstructorName));
    };

    Constructor.registerBehaviour = function (name, behaviour, dependences) {
        _g2.default.registerBehaviour(name, function (graph) {
            var page = graph.get('page');
            page.set('_graph', graph);
            behaviour(page);
        }, dependences);
    };
};

_page2.default.setRegister(_page2.default, 'page');
require('./behaviour');
exports.default = _page2.default;