'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _grid = require('../controller/grid');

var _grid2 = _interopRequireDefault(_grid);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Mixin = {};
Mixin.CFG = {
    /**
     * grid cfg
     * @type {object|undefined}
     */
    grid: undefined
};
Mixin.INIT = '_initGrid';
Mixin.AUGMENT = {
    _initGrid: function _initGrid() {
        var gridCfg = this.get('grid');
        var graph = this.get('_graph');

        if (gridCfg) {
            var gridController = new _grid2.default(_extends({
                page: this,
                graph: graph
            }, gridCfg));
            this.setController('grid', gridController);
        }
    },
    showGrid: function showGrid(cfg) {
        var graph = this.get('_graph');
        var gridController = this.getController('grid');
        if (!gridController) {
            if (!cfg) {
                this.set('grid', true);
            } else if (_util2.default.isObject(cfg)) {
                this.set('grid', cfg);
            }
            this._initGrid();
        }

        gridController = this.getController('grid');
        gridController.update();
        gridController.show(cfg);
        graph.draw();
    },
    hideGrid: function hideGrid() {
        var graph = this.get('_graph');
        var gridController = this.getController('grid');
        gridController && gridController.hide();
        graph.draw();
    },
    getGridCell: function getGridCell() {
        var gridController = this.getController('grid');
        return gridController.getCell();
    }
};
exports.default = Mixin;