'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _g = require('@antv/g6');

var _g2 = _interopRequireDefault(_g);

var _base = require('../../base');

var _base2 = _interopRequireDefault(_base);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

var _global = require('./global');

var _global2 = _interopRequireDefault(_global);

var _graph = require('./mixin/graph');

var _graph2 = _interopRequireDefault(_graph);

var _grid = require('./mixin/grid');

var _grid2 = _interopRequireDefault(_grid);

var _event = require('./mixin/event');

var _event2 = _interopRequireDefault(_event);

var _select = require('./mixin/select');

var _select2 = _interopRequireDefault(_select);

var _active = require('./mixin/active');

var _active2 = _interopRequireDefault(_active);

var _align = require('./mixin/align');

var _align2 = _interopRequireDefault(_align);

var _editLabel = require('./mixin/edit-label');

var _editLabel2 = _interopRequireDefault(_editLabel);

var _status = require('./mixin/status');

var _status2 = _interopRequireDefault(_status);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @fileOverview page
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * abstract class
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Mixins = [_graph2.default, _select2.default, _active2.default, _grid2.default, _event2.default, _align2.default, _editLabel2.default, _status2.default];

var Page = function (_Base) {
    _inherits(Page, _Base);

    function Page(inputCfg) {
        _classCallCheck(this, Page);

        var cfg = {
            /**
             * 图类构造函数
             * graph constructor
             * @type {string}
             */
            graphConstructor: _g2.default.Graph,
            defaultData: null,
            shortcut: {
                redo: true,
                undo: true,
                delete: true,
                resetZoom: true,
                autoZoom: true,
                zoomIn: true,
                zoomOut: true
            },
            _controllers: {},
            _signals: {}
        };
        _util2.default.each(Mixins, function (Mixin) {
            _util2.default.mix(cfg, Mixin.CFG);
        });
        _util2.default.mix(true, cfg, inputCfg);

        var _this = _possibleConstructorReturn(this, (Page.__proto__ || Object.getPrototypeOf(Page)).call(this, cfg));

        _this.isPage = true;
        _this.type = 'page';
        _this._init();
        return _this;
    }

    _createClass(Page, [{
        key: 'getTextDomLactions',
        value: function getTextDomLactions() {
            var graph = this.getGraph();
            var rootGroup = graph.getRootGroup();
            var canvas = graph.getCanvas();
            var data = [];
            _util2.default.traverseTree(canvas, function (child) {
                if ("text" === child.type) {
                    var box = _util2.default.getBBox(child, rootGroup);
                    var point = [box.minX, box.minY, 1];
                    data.push({
                        text: child.attr("text"),
                        x: point[0],
                        y: point[1],
                        fontSize: +child.attr("fontSize")
                    });
                }
            }, function (e) {
                return e.get("children");
            });
            return data;
        }
    }, {
        key: 'getDelegation',
        value: function getDelegation(items, group) {
            if (!group) {
                var graph = this.getGraph();
                group = graph.getRootGroup();
            }

            var delegation = void 0;
            if (items.length === 1 && !items[0].isNode && !items[0].isGroup) {
                if (items[0].isEdge) {
                    // 边的委托图形
                    delegation = group.addShape('path', {
                        attrs: _extends({
                            path: 'M0 0L 1 1'
                        }, _global2.default.edgeDelegationStyle),
                        capture: false
                    });
                } else {
                    // 新拖出节点委托图形
                    delegation = _util2.default.getRectByBox(items[0], group, _global2.default.nodeDelegationStyle);
                    delegation.set('capture', false);
                }
            } else {
                // 移动节点委托图形
                var startBox = _util2.default.getTotalBBox(items.map(function (item) {
                    return item.getBBox();
                }));
                delegation = _util2.default.getRectByBox(startBox, group, _global2.default.nodeDelegationStyle);
                delegation.set('capture', false);
            }

            return delegation;
        }
    }, {
        key: 'focusGraphWrapper',
        value: function focusGraphWrapper() {
            var graph = this.getGraph();
            graph.getKeyboardEventWrapper().focus();
        }
    }, {
        key: 'saveImage',
        value: function saveImage(options) {
            var _this2 = this;

            var graph = this.getGraph();
            var box = graph.getBBox();
            var padding = graph.getFitViewPadding();
            var seletedIds = void 0;
            var activedIds = void 0;
            return graph.saveImage(_extends({
                width: box.width + padding[1] + padding[3],
                height: box.height + padding[0] + padding[2],
                beforeTransform: function beforeTransform() {
                    seletedIds = _this2.getSelected().map(function (item) {
                        return item.id;
                    });
                    activedIds = _this2.getSelected().map(function (item) {
                        return item.id;
                    });
                    _this2.clearSelected();
                    _this2.clearActived();
                },
                afterTransform: function afterTransform() {
                    _this2.setSelected(seletedIds, true);
                    _this2.setActived(activedIds, true);
                }
            }, options));
        }
    }, {
        key: '_init',
        value: function _init() {
            var _this3 = this;

            _util2.default.each(Mixins, function (Mixin) {
                Mixin.INIT && _this3[Mixin.INIT]();
            });
            this.bindEvent();
            this._cacheBBox();
        }
        /**
         * 执行命令
         * @param  {string|funciton} callback 回调函数
         * @param  {obj|undefined} cfg 配置项
         */

    }, {
        key: 'executeCommand',
        value: function executeCommand(callback, cfg) {
            var eidtor = this.editor;
            if (eidtor) {
                eidtor.executeCommand(callback, cfg);
            } else {
                callback();
            }
        }
        // cache graph box

    }, {
        key: '_cacheBBox',
        value: function _cacheBBox() {
            var graph = this.getGraph();
            this.set('bboxCache', graph.getBBox());
        }
    }, {
        key: 'bindEvent',
        value: function bindEvent() {
            var _this4 = this;

            var graph = this.getGraph();
            graph.on('afterchange', function () {
                _this4._cacheBBox();
            });
            graph.on('mouseenter', function (shape) {
                if (shape && shape.isKeyShape) {
                    _this4.css({
                        cursor: 'default'
                    });
                }
            });
        }
        /**
         * 限制画布滚动、拖拽区域
         * Limit the canvas scroll, drag and drop area
         * @param  {object} matrix to matrix
         * @return {boolean} shape
         */

    }, {
        key: 'translateLimt',
        value: function translateLimt(matrix) {
            var graph = this.getGraph();
            var bboxCache = this.get('bboxCache');
            var width = graph.getWidth();
            var height = graph.getHeight();
            var horizontal = width / 2;
            var vertical = height / 2;
            var tl = [bboxCache.minX, bboxCache.minY, 1];
            var br = [bboxCache.maxX, bboxCache.maxY, 1];
            _util2.default.vec3.transformMat3(tl, tl, matrix);
            _util2.default.vec3.transformMat3(br, br, matrix);

            if (br[0] < horizontal) {
                _util2.default.mat3.translate(matrix, matrix, [horizontal - br[0], 0]);
            }
            if (br[1] < vertical) {
                _util2.default.mat3.translate(matrix, matrix, [0, vertical - br[1]]);
            }
            if (tl[1] > height - vertical) {
                _util2.default.mat3.translate(matrix, matrix, [0, height - vertical - tl[1]]);
            }
            if (tl[0] > width - horizontal) {
                _util2.default.mat3.translate(matrix, matrix, [width - horizontal - tl[0], 0]);
            }
            return true;
        }
        /**
         * @param  {String} name signal name
         * @param  {Boolean} value set value
         */

    }, {
        key: 'setSignal',
        value: function setSignal(name, value) {
            var signals = this.get('_signals');
            signals[name] = value;
        }
        /**
         * @param  {object} name signal name
         * @return {Boolean} signal value
         */

    }, {
        key: 'getSignal',
        value: function getSignal(name) {
            var signals = this.get('_signals');
            return signals[name];
        }
        /**
         * @param  {String} name controller name
         * @param  {object} controller controller object
         */

    }, {
        key: 'setController',
        value: function setController(name, controller) {
            var controllers = this.get('_controllers');
            controllers[name] = controller;
        }
        /**
         * @param  {String} name controller name
         * @return {object} controller controller object
         */

    }, {
        key: 'getController',
        value: function getController(name) {
            var controllers = this.get('_controllers');
            return controllers[name];
        }
    }, {
        key: 'destroy',
        value: function destroy() {
            var graph = this.get('_graph');
            var controllers = this.get('_controllers');
            _util2.default.each(controllers, function (controller) {
                controller.destroy();
            });
            graph.destroy();
            this.destroyed = true;
        }
    }]);

    return Page;
}(_base2.default);

_util2.default.each(Mixins, function (Mixin) {
    _util2.default.mix(Page.prototype, Mixin.AUGMENT);
});
exports.default = Page;