'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _util = require('../../../util');

var _util2 = _interopRequireDefault(_util);

var _global = require('../global');

var _global2 = _interopRequireDefault(_global);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var canvas = _util2.default.createDOM('<canvas>');
var ctx = canvas.getContext('2d');

exports.default = _extends({}, _util2.default, {
    // 移动画布
    getPanCanvasBehaviour: function getPanCanvasBehaviour(bool) {
        return function (page) {
            var graph = page.getGraph();
            var startPoint = void 0;
            var startMatrix = void 0;
            graph.behaviourOn('canvas:mouseenter', function () {
                page.css({
                    cursor: _global2.default.cursor.beforePanCanvas
                });
            });
            graph.behaviourOn('mouseleave', function (ev) {
                if (!ev.toShape) {
                    page.css({
                        cursor: _global2.default.cursor.beforePanCanvas
                    });
                }
            });
            graph.behaviourOn('dragstart', function (ev) {
                if (ev.button !== 2 && !bool || !ev.shape || ev.item && ev.item.dragable === false && !page.getSignal('dragEdge')) {
                    startPoint = {
                        x: ev.domX,
                        y: ev.domY
                    };
                    page.css({
                        cursor: _global2.default.cursor.panningCanvas
                    });
                    startMatrix = graph.getMatrix();
                    page.setCapture(false);
                }
            });
            graph.behaviourOn('drag', function (ev) {
                if (startPoint) {
                    var dx = ev.domX - startPoint.x;
                    var dy = ev.domY - startPoint.y;
                    var matrix = [];
                    _util2.default.mat3.translate(matrix, startMatrix, [dx, dy]);
                    if (page.translateLimt(matrix)) {
                        graph.updateMatrix(matrix);
                        graph.draw();
                    }
                }
            });
            graph.behaviourOn('mouseup', function () {
                if (startPoint) {
                    resetStatus();
                    page.css({
                        cursor: _global2.default.cursor.beforePanCanvas
                    });
                    page.emit('afterpancanvas');
                }
            });

            function resetStatus() {
                startPoint = undefined;
                startMatrix = undefined;
                page.setCapture(true);
            }
        };
    },
    getLabelTextByTextLineWidth: function getLabelTextByTextLineWidth(labelText, font) {
        var maxTextLineWidth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 320;
        ctx.font = font;
        var lineWidth = ctx.measureText(labelText).width;

        if (lineWidth > maxTextLineWidth) {
            lineWidth = 0;
            for (var i = 1; i < labelText.length; i++) {
                lineWidth += ctx.measureText(labelText[i]).width;

                if (lineWidth >= maxTextLineWidth) {
                    labelText = labelText.substring(0, i) + '\n' + labelText.substring(i, labelText.length);
                    i = i + 1;
                    lineWidth = 0;
                }
            }
        }

        return labelText;
    }
});