'use strict';

var _base = require('../../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_base2.default.registerBehaviour('hoverMindExpandButton', function (mind) {
    var graph = mind.getGraph();
    graph.behaviourOn('mouseenter', function (ev) {
        var shape = ev.shape;
        if (shape && shape.isExpandedButton) {
            shape.attr('fillOpacity', 0.8);
            graph.draw();
        }
    });
    graph.behaviourOn('mouseleave', function (ev) {
        var shape = ev.shape;
        if (shape && !shape.get('destroyed') && shape.isExpandedButton) {
            shape.attr('fillOpacity', 1);
            graph.draw();
        }
    });
}); /**
     * @fileOverview hover tree ExpandButton
     */