'use strict';

var _mind = require('../../mind');

var _mind2 = _interopRequireDefault(_mind);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_mind2.default.registerEdge('mind-edge', {
    getEdetal: function getEdetal(targetModel) {
        if (targetModel.children && targetModel.children.length > 0 && !targetModel.collapsed) {
            return targetModel.hierarchy === 2 ? 24 : 18;
        }
        return 0;
    },
    getPath: function getPath(item) {
        var points = item.getPoints();
        var source = item.getSource();
        var target = item.getTarget();
        var sourceBox = source.getBBox();
        var targetBox = target.getBBox();
        var targetModel = target.getModel();
        var controlPointDetal1 = 14;
        var controlPointDetal2 = 4;

        if (targetModel.hierarchy === 2) {
            controlPointDetal1 = 66;
            controlPointDetal2 = 30;
        }

        if (points[0].y === points[1].y) {
            var sDetal = targetModel.hierarchy === 3 ? 24 : 18;
            var _eDetal = this.getEdetal(targetModel);
            if (sourceBox.centerX < targetBox.centerX) {
                return [['M', points[0].x + sDetal, points[0].y], ['L', targetBox.maxX + _eDetal, targetBox.maxY]];
            }
            return [['M', points[0].x + 2, points[0].y], ['L', targetBox.minX - _eDetal, targetBox.maxY]];
        }

        if (targetModel.hierarchy >= 3) {
            var _sDetal = targetModel.hierarchy === 3 ? 24 : 18;
            var _eDetal2 = this.getEdetal(targetModel);
            if (sourceBox.centerX < targetBox.centerX) {
                var _dpx = points[0].x + _sDetal;
                return [['M', points[0].x, points[0].y], ['M', _dpx, points[0].y], ['C', _dpx + controlPointDetal2, points[0].y, targetBox.minX - controlPointDetal1, targetBox.maxY, targetBox.minX, targetBox.maxY], ['L', targetBox.maxX + _eDetal2, targetBox.maxY]];
            }
            var dpx = points[0].x - _sDetal;
            return [['M', points[0].x, points[0].y], ['M', dpx, points[0].y], ['C', dpx - controlPointDetal2, points[0].y, targetBox.maxX + controlPointDetal1, targetBox.maxY, targetBox.maxX, targetBox.maxY], ['L', targetBox.minX - _eDetal2, targetBox.maxY]];
        }

        var eDetal = this.getEdetal(targetModel);
        if (sourceBox.centerX < targetBox.centerX) {
            return [['M', points[0].x, points[0].y], ['C', points[0].x + controlPointDetal2, points[0].y, targetBox.minX - controlPointDetal1, targetBox.maxY, targetBox.minX, targetBox.maxY], ['L', targetBox.maxX + eDetal, targetBox.maxY]];
        }
        return [['M', points[0].x, points[0].y], ['C', points[0].x - controlPointDetal2, points[0].y, targetBox.maxX + controlPointDetal1, targetBox.maxY, targetBox.maxX, targetBox.maxY], ['L', targetBox.minX - eDetal, targetBox.maxY]];
    },
    getStyle: function getStyle(item) {
        var target = item.getTarget();
        var lineWidth = 1;

        if (target) {
            var targetModel = target.getModel();

            if (targetModel.hierarchy <= 3) {
                lineWidth = 3;
            } else if (targetModel.hierarchy <= 5) {
                lineWidth = 2;
            } else {
                lineWidth = 1;
            }
        }

        return {
            stroke: '#959EA6',
            lineWidth: lineWidth
        };
    }
});