'use strict';

var _mind = require('../../mind');

var _mind2 = _interopRequireDefault(_mind);

var _util = require('../../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_mind2.default.registerNode('mind-placeholder', {
    afterDraw: function afterDraw(item) {
        var keyShape = item.getKeyShape();
        keyShape.isPlaceholder = true;
    },
    getPath: function getPath(item) {
        var model = item.getModel();
        var parentModel = model.parentModel;
        var style = this.getStyle(item);
        var width = 55;
        var height = void 0;
        var Edetal = 0;

        if (parentModel.hierarchy <= 2) {
            height = 28;
        } else {
            height = 20;
            Edetal = 4;
        }

        return _util2.default.getRectPath(-width / 2, -height / 2 + Edetal, width, height, style.radius);
    },
    getStyle: function getStyle() {
        return {
            fill: '#91D5FF',
            radius: 4,
            lineWidth: 3
        };
    },
    drawExpandedButton: function drawExpandedButton() {},
    drawCollapsedButton: function drawCollapsedButton() {},
    anchor: function anchor() {
        return [[0, 1], [1, 1]];
    }
});