'use strict';

var _mind = require('../../mind');

var _mind2 = _interopRequireDefault(_mind);

var _util = require('../../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_mind2.default.registerNode('mind-root', {
    adjustLabelPosition: function adjustLabelPosition(item, labelShape) {
        var box = labelShape.getBBox();
        labelShape.attr({
            x: -box.width / 2,
            y: -box.height / 2 - 1
        });
    },
    getPath: function getPath(item) {
        var size = this.getSize(item);
        var style = this.getStyle(item);
        return _util2.default.getRectPath(-size[0] / 2, -size[1] / 2, size[0], size[1], style.radius);
    },
    getButtonPositon: function getButtonPositon(keyShapeBox, buttonBox, side) {
        if (side === 'right') {
            return {
                x: keyShapeBox.maxX + 2,
                y: (keyShapeBox.maxY + keyShapeBox.minY) / 2 - (buttonBox.maxY - buttonBox.minY) / 2
            };
        }

        return {
            x: keyShapeBox.minX - (buttonBox.maxX - buttonBox.minX) - 2,
            y: (keyShapeBox.maxY + keyShapeBox.minY) / 2 - (buttonBox.maxY - buttonBox.minY) / 2
        };
    },
    getPadding: function getPadding() {
        return _util2.default.toAllPadding([12, 24]);
    },
    getStyle: function getStyle() {
        return {
            fill: '#587EF7',
            stroke: '#587EF7',
            fillOpacity: 1,
            radius: 4
        };
    },
    getLabelStyle: function getLabelStyle() {
        return {
            fontSize: 20,
            fill: 'white',
            lineHeight: 28
        };
    },
    drawExpandedButton: function drawExpandedButton() {},
    drawCollapsedButton: function drawCollapsedButton() {},
    panAble: false,
    anchor: [[0.45, 0.5], [0.55, 0.5]]
}, 'mind-first-sub');