'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _antd = require('antd');

require('antd/lib/menu/style');

require('antd/lib/dropdown/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $ = _tinsoEditorEngine2.default.$;
/**
 * @fileOverview 图Section工具
 */

exports.default = {
  // 变更缩放控件缩放数值
  _updateToolZoom: function _updateToolZoom() {
    var tool = this.tool;
    if (!tool) {
      return;
    }
    var page = this.page;
    var zoom = page.getZoom();
    this.currentZoom = zoom;
    this.tool.find('.zoom-precent').html(Math.round(zoom * 100) + '%');
  },
  // 点击缩放放大按钮
  _clickZoomUp: function _clickZoomUp() {
    var page = this.page;
    var maxZoom = page.getMaxZoom();
    var zoom = page.getZoom();
    zoom += this.zoomStep;
    zoom = zoom > maxZoom ? maxZoom : zoom;

    this._changeZoom(zoom);
  },
  // 点击缩放缩小按钮
  _clickZoomDown: function _clickZoomDown() {
    var page = this.page;
    var minZoom = page.getMinZoom();
    var zoom = page.getZoom();
    zoom -= this.zoomStep;
    zoom = zoom < minZoom ? minZoom : zoom;

    this._changeZoom(zoom);
  },
  // 点击缩放下拉框
  _clickZoomMenu: function _clickZoomMenu(_ref) {
    var item = _ref.item;
    var zoom = item.props.value;
    this._changeZoom(zoom);
  },
  // // 点击折叠
  // _clickCollapse() {
  //   this.graphEditor.executeCommand('collapse');
  // }
  // // 点击展开
  // _clickExpand() {
  //   this.graphEditor.executeCommand('expand');
  // }
  // 渲染图缩放控件
  _renderTool: function _renderTool() {
    var _this = this;

    if (this.tool) {
      return;
    }

    var page = this.page;
    var tool = $('<div class="tool"></div>');
    var menu = _react2.default.createElement(
      _antd.Menu,
      {
        className: 'zoom-menu',
        ref: function ref(element) {
          return _this.pageZoomMenu = _reactDom2.default.findDOMNode(element);
        },
        onClick: this._clickZoomMenu.bind(this)
      },
      _react2.default.createElement(
        _antd.Menu.Item,
        { value: 0.2 },
        '20%'
      ),
      _react2.default.createElement(
        _antd.Menu.Item,
        { value: 0.5 },
        '50%'
      ),
      _react2.default.createElement(
        _antd.Menu.Item,
        { value: 1 },
        '100%'
      ),
      _react2.default.createElement(
        _antd.Menu.Item,
        { value: 2 },
        '200%'
      ),
      _react2.default.createElement(
        _antd.Menu.Item,
        { value: 'autoZoom' },
        '\u9002\u5408\u753B\u5E03'
      )
    );
    $(this.page.getGraphContainer()).append(tool);
    tool.hide();
    _reactDom2.default.render(_react2.default.createElement(
      'div',
      null,
      _react2.default.createElement('span', {
        className: 'zacheditor-icon zacheditor-icon-zoom-out',
        onClick: this._clickZoomDown.bind(this)
      }),
      _react2.default.createElement(
        _antd.Dropdown,
        {
          className: 'zoom-dropdown',
          overlay: menu,
          placement: 'bottomCenter',
          trigger: ['click'],
          getPopupContainer: function getPopupContainer() {
            return _this.pageContainer[0];
          }
        },
        _react2.default.createElement(
          'span',
          { className: 'zoom-precent' },
          Math.round(this.currentZoom * 100),
          '%'
        )
      ),
      _react2.default.createElement('span', {
        className: 'zacheditor-icon zacheditor-icon-zoom-in',
        onClick: this._clickZoomUp.bind(this)
      })
    ), tool[0], function () {
      _this._updateToolZoom();
    });
    page.on('afterzoom', function () {
      _this._updateToolZoom();
    });
    this.tool = tool;
  }
};