'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var dataURLToImage = exports.dataURLToImage = function dataURLToImage(dataURL) {
    var contentType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'png';
    var sliceSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 512;

    var byteArrays = [];

    for (var offset = 0; offset < dataURL.length; offset += sliceSize) {
        var slice = dataURL.slice(offset, offset + sliceSize);
        var byteNumbers = new Array(slice.length);

        for (var i = 0; i < slice.length; i++) {
            byteNumbers[i] = slice.charCodeAt(i);
        }

        var byteArray = new Uint8Array(byteNumbers);
        byteArrays.push(byteArray);
    }

    var blob = new Blob(byteArrays, {
        type: contentType
    });
    return blob;
};