'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _engine = require('../../editor/engine');

var _engine2 = _interopRequireDefault(_engine);

var _imageNode = require('./image-node');

var _imageNode2 = _interopRequireDefault(_imageNode);

var _string = require('../../utils/string');

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Image = function (_SectionBase) {
    _inherits(Image, _SectionBase);

    function Image(engine, contentView) {
        _classCallCheck(this, Image);

        var _this = _possibleConstructorReturn(this, (Image.__proto__ || Object.getPrototypeOf(Image)).call(this));

        _this.onRemove = function () {
            _this.imageNode.blur();
            _this.engine.change.removeSection(_this.sectionRoot);
        };

        _this.onSaveBefore = function () {
            return new Promise(function (resolve, reject) {
                if (_this.value.status === 'uploading') {
                    reject(_this.locale.stillUploading);
                    return;
                }
                resolve();
            });
        };

        _this.saveSectionValue = function () {
            var value = _this.imageNode.getValue();
            _this.section.setValue(_this.sectionRoot, value);
            _this.engine.history.save();
        };

        _this.section = _engine2.default.section;
        _this.engine = engine;
        _this.contentView = contentView;
        _this.docEmbedView = window.location.search.indexOf("view=doc_embed") > 0;
        return _this;
    }

    _createClass(Image, [{
        key: 'embedToolbar',
        value: function embedToolbar() {
            var _this2 = this;

            var engine = this.engine;
            if (!engine) {
                return;
            }
            var locale = this.engine.locale.image;
            var options = this.getOptions();
            var items = [];
            if (this.value.status === 'done') {
                var rootParent = this.sectionRoot ? this.sectionRoot.closest("h1,h2,h3,h4,h5,h6,blockquote,ul,ol,div.sub-editor") : [];
                if (rootParent.length === 0) {
                    items.push({
                        type: 'button',
                        name: 'mode',
                        style: "min-width:64px",
                        getTitle: function getTitle() {
                            return _this2.value.display === "block" ? locale.inlineMode : locale.blockMode;
                        },
                        onLoad: function onLoad(item) {
                            _this2.modeButton = item;
                        },
                        onClick: function onClick() {
                            var display = _this2.value.display === "block" ? "inline" : "block";
                            if (_this2.engine) {
                                _this2.imageNode.changeDisplay(_this2.sectionRoot, display);
                                _this2.saveSectionValue();
                                if (_this2.modeButton) {
                                    _this2.modeButton.find("span.embed-text").html(display === "block" ? locale.inlineMode : locale.blockMode);
                                }
                            }
                        }
                    });
                    items.push({
                        type: 'separator'
                    });
                }

                items.push({
                    type: 'copy'
                });
                if (!engine.sidebar.disable && !engine.isSub() && (!options.type || options.type === "max")) {
                    items.push({
                        type: "preferences",
                        onClick: function onClick() {
                            _this2.imageNode.setSidebar();
                        }
                    });
                }

                items.push({
                    type: 'separator'
                });
            }

            items.push({
                type: 'delete'
            });
            var config = options.image || {};
            if (Array.isArray(config.embed)) {
                return config.embed;
            } else if (_typeof(config.embed) === "object") {
                var embedArray = [];
                items.forEach(function (item) {
                    if (config.embed[item.type] !== false) {
                        embedArray.push(item);
                    }
                });
                return embedArray;
            } else {
                return items;
            }
        }
    }, {
        key: 'destroy',
        value: function destroy() {
            this.imageNode.destroy();
            if (this.engine) {
                this.engine.asyncEvent.off('save:before', this.onSaveBefore);
            }
        }
    }, {
        key: 'didInsert',
        value: function didInsert(value) {
            if (value.status === 'uploading') {
                this.engine.asyncEvent.on('save:before', this.onSaveBefore);
            }
        }
    }, {
        key: 'activate',
        value: function activate() {
            this.imageNode.focus();
        }
    }, {
        key: 'unselect',
        value: function unselect() {
            if (!this.state.activated) {
                _get(Image.prototype.__proto__ || Object.getPrototypeOf(Image.prototype), 'unselect', this).call(this);
            }
        }
    }, {
        key: 'unactivate',
        value: function unactivate() {
            if (this.engine) {
                this.engine.sidebar.restore();
                _get(Image.prototype.__proto__ || Object.getPrototypeOf(Image.prototype), 'unselect', this).call(this);
            }
            this.imageNode.blur();
        }
    }, {
        key: 'changeSize',
        value: function changeSize(width, height) {
            this.imageNode.changeSize(width, height);
            this.saveSectionValue();
        }
    }, {
        key: 'changeLink',
        value: function changeLink(link, linkTarget) {
            this.imageNode.changeLink(link, linkTarget);
            this.saveSectionValue();
        }
    }, {
        key: 'getSrc',
        value: function getSrc() {
            if (this.value.src) return this.value.src;
            if (this.engine && this.engine.uploader) {
                var uploader = this.engine.uploader;
                if (uploader && this.value.uid) {
                    var file = uploader.uploadingFiles[this.value.uid];
                    if (file) return file.src;
                }
            }
            return "";
        }
    }, {
        key: 'render',
        value: function render(container, value) {
            var options = this.getOptions().image || {};
            var align = options.align || "left";
            var display = options.display || "inline";

            var readonly = !this.engine;

            var rootParent = this.sectionRoot.closest("h1,h2,h3,h4,h5,h6,blockquote,ul,ol,div.sub-editor");
            if (rootParent.length > 0) {
                align = "left";
                display = "inline";
            }

            var locale = readonly ? this.contentView.locale.image : this.engine.locale.image;
            this.locale = locale;
            var section = this.section;
            var src = this.getSrc();
            value = value || {};
            this.value = value;
            value.status = value.status || 'done';
            // uploading, done, error
            value.align = value.align || align;
            value.linkTarget = value.linkTarget === undefined ? '_blank' : value.linkTarget;
            // 新交互只有 inline 样式
            if (readonly) {
                // 阅读模式继续保持原来的 display
                value.display = value.display || display;
            } else {
                // 编辑模式
                value.display = value.display || display;
            }

            if (value.src && (0, _string.isBase64Image)(value.src)) {
                value.src = "";
                this.section.setValue(this.sectionRoot, value);
            }

            value.message = value.message || locale.uploadFailed;
            var sectionRoot = this.section.closest(container);

            var imageNode = new _imageNode2.default({
                locale: locale,
                engine: this.engine,
                contentView: this.contentView,
                section: section,
                src: src,
                value: value,
                sectionRoot: sectionRoot,
                onChange: this.onChange,
                onRemove: this.onRemove,
                docEmbedView: this.docEmbedView
            });

            if (this.engine || this.contentView) {
                imageNode.changeDisplay(sectionRoot, value.display);
            }

            imageNode.render(container);
            this.imageNode = imageNode;
            // Section工具栏
            this.section.setToolbar({
                sectionRoot: sectionRoot,
                engine: this.engine,
                component: this
            });
        }
    }]);

    return Image;
}(_base2.default);

Image.type = 'inline';
exports.default = Image;