'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _eventemitter = require('eventemitter2');

var _photoswipe = require('photoswipe');

var _photoswipe2 = _interopRequireDefault(_photoswipe);

var _photoswipeUiDefault = require('photoswipe/dist/photoswipe-ui-default');

var _photoswipeUiDefault2 = _interopRequireDefault(_photoswipeUiDefault);

var _zoom = require('./zoom');

var _zoom2 = _interopRequireDefault(_zoom);

require('./pswp.css');

require('photoswipe/dist/photoswipe.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mobile = _tinsoEditorEngine2.default.userAgent.mobile;

var Pswp = function (_EventEmitter) {
  _inherits(Pswp, _EventEmitter);

  function Pswp(options) {
    _classCallCheck(this, Pswp);

    var _this = _possibleConstructorReturn(this, (Pswp.__proto__ || Object.getPrototypeOf(Pswp)).call(this));

    _this.options = Object.assign({
      pswpOptions: {
        shareEl: false,
        fullscreenEl: false,
        zoomEl: false,
        history: false,
        dragging: mobile,
        closeOnScroll: false,
        preloaderEl: false,
        captionEl: false,
        counterEl: false,
        clickToCloseNonZoomable: false,
        showAnimationDuration: 0,
        hideAnimationDuration: 0,
        closeOnVerticalDrag: mobile,
        tapToClose: true,
        barsSize: {
          top: 44,
          bottom: 80
        }
      }
    }, options);
    _this.images = [];
    _this.pswpDestroy = true;
    _this.timeouts = {};
    _this._initRoot();
    return _this;
  }

  _createClass(Pswp, [{
    key: '_initRoot',
    value: function _initRoot() {
      var _this2 = this;

      var root = _tinsoEditorEngine2.default.$('\n    <div class="pswp" tabindex="-1" role="dialog" aria-hidden="true">\n        <div class="pswp__bg"></div>\n        <div class="pswp__scroll-wrap">\n            <div class="pswp__container">\n                <div class="pswp__item"></div>\n                <div class="pswp__item"></div>\n                <div class="pswp__item"></div>\n            </div>\n            <div class="pswp__ui pswp__ui--hidden">\n                <button class="pswp__button zacheditor-pswp-button-close" title="Close (Esc)"></button>\n                <div class="zacheditor-pswp-custom-top-bar"></div>\n            </div>\n        </div>\n    </div>\n    ');
      var toolbarContainer = root.find('.zacheditor-pswp-custom-top-bar');
      var closeBtnContainer = root.find('.zacheditor-pswp-button-close');
      this.root = root;
      this.toolbarContainer = toolbarContainer;
      this.closeBtnContainer = closeBtnContainer;
      root.addClass(mobile ? 'zacheditor-pswp-mobile' : 'zacheditor-pswp-pc');
      _tinsoEditorEngine2.default.$(document.body).append(root);
      _reactDom2.default.render(_react2.default.createElement(_zoom2.default, { imageBrowser: this }), toolbarContainer[0], function () {
        if (!mobile) {
          _this2.bindKeyboardEvnet();
          _this2.bindClickEvent();
          _this2.hoverControllerFadeInAndOut(toolbarContainer);
        }
      });
    }
  }, {
    key: 'hoverControllerFadeInAndOut',
    value: function hoverControllerFadeInAndOut() {
      var _this3 = this;

      var toolbarContainer = this.toolbarContainer,
          closeBtnContainer = this.closeBtnContainer;


      toolbarContainer.on('mouseenter', function () {
        _this3.removeFadeOut(toolbarContainer, 'toolbarFadeInAndOut');
        _this3.removeFadeOut(closeBtnContainer, 'closeFadeInAndOut');
      });

      toolbarContainer.on('mouseleave', function () {
        _this3.fadeOut(toolbarContainer, 'toolbarFadeInAndOut');
        _this3.fadeOut(closeBtnContainer, 'closeFadeInAndOut');
      });

      closeBtnContainer.on('mouseenter', function () {
        _this3.removeFadeOut(toolbarContainer, 'toolbarFadeInAndOut');
        _this3.removeFadeOut(closeBtnContainer, 'closeFadeInAndOut');
      });

      closeBtnContainer.on('mouseleave', function () {
        _this3.fadeOut(toolbarContainer, 'toolbarFadeInAndOut');
        _this3.fadeOut(closeBtnContainer, 'closeFadeInAndOut');
      });
    }
  }, {
    key: 'removeFadeOut',
    value: function removeFadeOut(node, id) {
      var timeouts = this.timeouts;

      if (timeouts[id]) {
        clearTimeout(timeouts[id]);
      }
      node.removeClass('pswp-fade-out');
    }
  }, {
    key: 'fadeOut',
    value: function fadeOut(node, id) {
      var timeouts = this.timeouts;

      if (timeouts[id]) {
        clearTimeout(timeouts[id]);
      }
      timeouts[id] = setTimeout(function () {
        node.addClass('pswp-fade-out');
      }, 3e3);
    }
  }, {
    key: 'bindClickEvent',
    value: function bindClickEvent() {
      var _this4 = this;

      var closeBtnContainer = this.closeBtnContainer;

      this.root.on('click', function (event) {
        var target = event.target;

        target = _tinsoEditorEngine2.default.$(target);
        if (target.hasClass('pswp__img')) {
          setTimeout(function () {
            _this4.currentZoom = null;
            _this4.afterZoom();
          }, 366);
        }
        if (target.hasClass('pswp__bg') || target.hasClass('zacheditor-pswp-tool-bar')) {
          _this4.close();
        }
      });
      closeBtnContainer.on('click', function () {
        _this4.close();
      });
    }
  }, {
    key: 'prev',
    value: function prev() {
      this.pswp.prev();
    }
  }, {
    key: 'next',
    value: function next() {
      this.pswp.next();
    }
  }, {
    key: 'renderCounter',
    value: function renderCounter() {
      var pswp = this.pswp;

      this.toolbarContainer.find('.zacheditor-pswp-counter').html(''.concat(pswp.getCurrentIndex() + 1, ' / ').concat(pswp.items.length));
    }
  }, {
    key: 'getCurrentZoomLevel',
    value: function getCurrentZoomLevel() {
      return this.currentZoom && +this.currentZoom.toFixed(2) || this.pswp && +this.pswp.getZoomLevel().toFixed(2);
    }
  }, {
    key: 'zoomTo',
    value: function zoomTo(zoom) {
      var pswp = this.pswp;

      pswp.zoomTo(zoom, {
        x: pswp.viewportSize.x / 2,
        y: pswp.viewportSize.y / 2
      }, 100);
      this.currentZoom = zoom;
      this.afterZoom();
    }
  }, {
    key: 'zoomIn',
    value: function zoomIn() {
      var zoom = this.getCurrentZoomLevel();
      var newZoom = zoom + 0.2;
      if (5 !== zoom) {
        if (newZoom > 5) newZoom = 5;
        this.zoomTo(newZoom);
      }
    }
  }, {
    key: 'zoomOut',
    value: function zoomOut() {
      var zoom = this.getCurrentZoomLevel();
      if (0.05 !== zoom) {
        var newZoom = zoom - 0.2;
        if (0.05 > newZoom) {
          newZoom = 0.05;
        }
        this.zoomTo(newZoom);
      }
    }
  }, {
    key: 'bindKeyboardEvnet',
    value: function bindKeyboardEvnet() {
      var _this5 = this;

      this.root.on('keydown', function (event) {
        if ((event.metaKey || event.ctrlKey) && 187 === event.keyCode) {
          event.preventDefault();
          _this5.zoomIn();
        }
        if (_tinsoEditorEngine2.default.isHotkey('mod+-', event)) {
          event.preventDefault();
          _this5.zoomOut();
        }
      });
    }
  }, {
    key: 'zoomToOriginSize',
    value: function zoomToOriginSize() {
      this.zoomTo(1);
    }
  }, {
    key: 'zoomToBestSize',
    value: function zoomToBestSize() {
      var zoom = this.getInitialZoomLevel();
      this.zoomTo(zoom);
    }
  }, {
    key: 'updateCursor',
    value: function updateCursor() {
      var root = this.root;

      var currentZoomLevel = this.getCurrentZoomLevel();
      var initialZoomLevel = this.getInitialZoomLevel();
      if (currentZoomLevel === 1) {
        root.addClass('pswp--zoomed-in');
      } else if (initialZoomLevel === initialZoomLevel) {
        root.removeClass('pswp--zoomed-in');
      }
    }
  }, {
    key: 'getInitialZoomLevel',
    value: function getInitialZoomLevel() {
      return +this.pswp.currItem.initialZoomLevel.toFixed(2);
    }
  }, {
    key: 'afterZoom',
    value: function afterZoom() {
      this.updateCursor();
      this.emit('afterzoom');
    }
  }, {
    key: 'getCount',
    value: function getCount() {
      return this.pswp.items.length;
    }
  }, {
    key: 'afterChange',
    value: function afterChange() {
      var _this6 = this;

      if (!mobile) {
        var initialZoomLevel = this.getInitialZoomLevel();
        this.renderCounter();
        this.currentZoom = initialZoomLevel;
        setTimeout(function () {
          _this6.afterZoom();
        }, 100);
        this.emit('afterchange');
        this.currentZoom = this.getInitialZoomLevel();
      }
      this.setWhiteBackground();
    }
  }, {
    key: 'bindPswpEvent',
    value: function bindPswpEvent() {
      var _this7 = this;

      var pswp = this.pswp;

      pswp.listen('afterChange', function () {
        _this7.afterChange();
      });
      pswp.listen('destroy', function () {
        _this7.pswpDestroy = true;
      });
      pswp.listen('resize', function () {
        _this7.emit('resize');
      });
      pswp.listen('imageLoadComplete', function () {
        _this7.setWhiteBackground();
      });
    }
  }, {
    key: 'setWhiteBackground',
    value: function setWhiteBackground() {
      this.root.find('.pswp__img').each(function (img) {
        if (img.complete) {
          img.style.background = 'white';
          img.style['box-shadow'] = '0 0 10px rgba(0, 0, 0, 0.5)';
        } else {
          img.onload = function () {
            img.style.background = 'white';
            img.style['box-shadow'] = '0 0 10px rgba(0, 0, 0, 0.5)';
          };
        }
      });
    }
  }, {
    key: 'open',
    value: function open(items, index) {
      if (true === this.pswpDestroy) {
        var root = this.root;

        var pswp = new _photoswipe2.default(root[0], _photoswipeUiDefault2.default, items, Object.assign({
          index: index
        }, this.options.pswpOptions));
        pswp.items = items;
        pswp.init();
        this.pswp = pswp;
        this.pswpDestroy = false;
        if (!mobile) {
          this.toolbarContainer.removeClass('pswp-fade-out');
          this.fadeOut(this.toolbarContainer, 'toolbarFadeInAndOut');
          this.closeBtnContainer.removeClass('pswp-fade-out');
          this.fadeOut(this.closeBtnContainer, 'closeFadeInAndOut');
        }
        root.removeClass('pswp-fade-in');
        root.addClass('pswp-fade-in');
        this.afterChange();
        this.bindPswpEvent();
      }
    }
  }, {
    key: 'close',
    value: function close() {
      this.pswp.close();
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.close();
      this.options = null;
    }
  }]);

  return Pswp;
}(_eventemitter.EventEmitter2);

exports.default = Pswp;