'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var template = function template(data) {
  return '\n  <div class="zacheditor-image-editor">\n    <img data-role="image-bg" class="zacheditor-image-editor-bg zacheditor-image-editor-bg-active" src="'.concat(data.src, '">\n    <div data-role="holder-45" class="zacheditor-image-editor-holder zacheditor-image-editor-holder-45"></div>\n    <div data-role="holder-135" class="zacheditor-image-editor-holder zacheditor-image-editor-holder-135"></div>\n    <div data-role="holder-225" class="zacheditor-image-editor-holder zacheditor-image-editor-holder-225"></div>\n    <div data-role="holder-315" class="zacheditor-image-editor-holder zacheditor-image-editor-holder-315"></div>\n    <span data-role="number" class="zacheditor-image-editor-number"></span>\n  </div>\n  '); //    <span data-role="maximize" class="zacheditor-image-editor-maximize"><span class="zacheditor-icon zacheditor-icon-full-screen"></span></span>
};

var Resizer = function () {
  function Resizer(config) {
    var _this = this;

    _classCallCheck(this, Resizer);

    this.onMouseDown = function (e, angle) {
      e.preventDefault();
      e.stopPropagation();
      _this.root.css('top', angle === 45 || angle === 315 ? 'auto' : 0);
      _this.root.css('left', angle === 225 || angle === 315 ? 'auto' : 0);
      _this.root.css('bottom', angle === 225 || angle === 135 ? 'auto' : 0);
      _this.root.css('right', angle === 45 || angle === 135 ? 'auto' : 0);
      _this.mouse = {
        x: e.clientX,
        y: e.clientY
      };
      _this.angle = angle;
      _this.resizing = true;
      _this.find('number')[0].className = 'zacheditor-image-editor-number zacheditor-image-editor-number-'.concat(angle, ' zacheditor-image-editor-number-active');
      _this.image.show();
      document.addEventListener('mousemove', _this.onMouseMove);
      document.addEventListener('mouseup', _this.onMouseUp);
    };

    this.onMouseMove = function (e) {
      e.preventDefault();
      e.stopPropagation();
      var X = e.clientX;
      var Y = e.clientY;

      if (X !== _this.mouse.x || Y !== _this.mouse.y) {
        var x = _this.mouse.x - X;
        var y = _this.mouse.y - Y;
        _this.updateImageSize(x, y);
      }
      _this.resizing = true;
    };

    this.onMouseUp = function (e) {
      e.preventDefault();
      e.stopPropagation();
      _this.width = _this.root[0].clientWidth;
      _this.height = _this.root[0].clientHeight;
      _this.angle = 0;
      _this.resizing = false;
      _this.find('number')[0].className = 'zacheditor-image-editor-number';
      document.removeEventListener('mousemove', _this.onMouseMove);
      document.removeEventListener('mouseup', _this.onMouseUp);

      _this.config.onChange(_this.width, _this.height);
      _this.image.hide();
    };

    this.updateImageSize = function (x) {
      var width = void 0;

      if (_this.angle < 180) {
        width = _this.width - x;
      } else {
        width = _this.width + x;
      }
      if (width < 24) {
        width = 24;
      }

      if (width > _this.maxWidth) {
        width = _this.maxWidth;
      }

      var height = width * _this.config.rate;
      if (height < 24) {
        height = 24;
        width = height / _this.config.rate;
      }
      width = Math.round(width);
      height = Math.round(height);
      _this.setSize(width, height);
    };

    this.setSize = function (width, height) {
      _this.root.css({
        width: width + 'px',
        height: height + 'px'
      });
      _this.find('number').html(''.concat(width, '\xB7').concat(height));
    };

    this.closeZoom = function () {
      var container = _tinsoEditorEngine2.default.$('#zacheditor-image-zoom-container');
      if (container[0]) {
        _reactDom2.default.unmountComponentAtNode(container[0]);
      }
      container.remove();
      _this.config.onClose();
    };

    this.config = config;
    this.root = _tinsoEditorEngine2.default.$(template(config));
    this.image = this.find('image-bg');
    // 默认状态
    this.resizing = false;
    this.width = config.width;
    this.height = config.height;
    this.maxWidth = config.maxWidth;
    this.openZoom = config.openZoom;
  }

  _createClass(Resizer, [{
    key: 'find',
    value: function find(role) {
      var expr = '[data-role='.concat(role, ']');
      return this.root.find(expr);
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.root.remove();
      document.removeEventListener('mousemove', this.onMouseMove);
      document.removeEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'render',
    value: function render(container) {
      var _this2 = this;

      var _config = this.config,
          width = _config.width,
          height = _config.height;

      this.root.css({
        width: ''.concat(width, 'px'),
        height: ''.concat(height, 'px')
      });
      container.append(this.root);
      this.image.on('dblclick', this.openZoom);
      // this.find('maximize').on('click', this.openZoom);
      this.find('holder-45').on('mousedown', function (e) {
        return _this2.onMouseDown(e, 45);
      });
      this.find('holder-135').on('mousedown', function (e) {
        return _this2.onMouseDown(e, 135);
      });
      this.find('holder-225').on('mousedown', function (e) {
        return _this2.onMouseDown(e, 225);
      });
      this.find('holder-315').on('mousedown', function (e) {
        return _this2.onMouseDown(e, 315);
      });
    }
  }]);

  return Resizer;
}();

exports.default = Resizer;