'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/tooltip/style');

var _lang = require('./lang');

var _lang2 = _interopRequireDefault(_lang);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Zoom = function (_React$Component) {
  _inherits(Zoom, _React$Component);

  function Zoom() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Zoom);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Zoom.__proto__ || Object.getPrototypeOf(Zoom)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      prevStatus: 'default',
      nextStatus: 'default',
      zoomInStatus: 'default',
      zoomOutStatus: 'default',
      originSizeStatus: 'default',
      bestSizeStatus: 'default'
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Zoom, [{
    key: 'afterZoom',
    value: function afterZoom() {
      var imageBrowser = this.props.imageBrowser;

      var currentLevel = imageBrowser.getCurrentZoomLevel();
      var initLevel = imageBrowser.getInitialZoomLevel();
      var status = void 0;
      if (currentLevel === initLevel) {
        status = 'activated';
      }
      if (1 === initLevel) {
        status = 'disable';
      }
      this.setState({
        zoomOutStatus: 0.05 === currentLevel ? 'disable' : 'default',
        zoomInStatus: 5 === currentLevel ? 'disable' : 'default',
        originSizeStatus: 1 === currentLevel ? 'activated' : 'default',
        bestSizeStatus: status
      });
    }
  }, {
    key: 'afterChange',
    value: function afterChange() {
      var count = this.props.imageBrowser.getCount();
      this.setState({
        nextStatus: 1 === count ? 'disable' : 'default',
        prevStatus: 1 === count ? 'disable' : 'default'
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var imageBrowser = this.props.imageBrowser;

      imageBrowser.on('afterzoom', function () {
        _this2.afterZoom();
      });

      imageBrowser.on('afterchange', function () {
        _this2.afterChange();
      });

      imageBrowser.on('resize', function () {
        setTimeout(function () {
          _this2.afterChange();
          _this2.afterZoom();
        }, 333);
      });
      this.setState({
        tooltipContainer: this.tooltipContainer
      });
    }
  }, {
    key: 'renderBtn',
    value: function renderBtn(zoomClass, title, status, onClick) {
      var tooltipContainer = this.state.tooltipContainer;

      return tooltipContainer ? _react2.default.createElement(
        _antd.Tooltip,
        {
          title: title,
          getPopupContainer: function getPopupContainer() {
            return tooltipContainer;
          },
          mouseEnterDelay: 1
        },
        _react2.default.createElement('span', {
          onClick: onClick,
          className: 'zacheditor-pswp-'.concat(zoomClass, ' btn ').concat(status)
        }),
        ' '
      ) : '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var imageBrowser = this.props.imageBrowser;
      var _state = this.state,
          prevStatus = _state.prevStatus,
          nextStatus = _state.nextStatus,
          zoomInStatus = _state.zoomInStatus,
          zoomOutStatus = _state.zoomOutStatus,
          originSizeStatus = _state.originSizeStatus,
          bestSizeStatus = _state.bestSizeStatus;

      return _react2.default.createElement(
        'div',
        { className: 'zacheditor-pswp-tool-bar' },
        _react2.default.createElement('div', { ref: function ref(e) {
            return _this3.tooltipContainer = e;
          } }),
        ' ',
        _react2.default.createElement(
          'div',
          { className: 'pswp-toolbar-content' },
          this.renderBtn('arrow-left', _lang2.default.prev, prevStatus, function () {
            if ('disable' !== prevStatus) imageBrowser.prev();
          }),
          ' ',
          _react2.default.createElement(
            'span',
            { className: 'zacheditor-pswp-counter' },
            ' '
          ),
          ' ',
          this.renderBtn('arrow-right', _lang2.default.next, nextStatus, function () {
            if ('disable' !== nextStatus) imageBrowser.next();
          }),
          ' ',
          _react2.default.createElement(
            'span',
            { className: 'separation' },
            ' '
          ),
          ' ',
          this.renderBtn('zoom-in', _lang2.default.zoomIn, zoomInStatus, function () {
            if ('disable' !== zoomInStatus) imageBrowser.zoomIn();
          }),
          ' ',
          this.renderBtn('zoom-out', _lang2.default.zoomOut, zoomOutStatus, function () {
            if ('disable' !== zoomOutStatus) imageBrowser.zoomOut();
          }),
          ' ',
          this.renderBtn('origin-size', _lang2.default.originSize, originSizeStatus, function () {
            if ('disable' !== originSizeStatus) imageBrowser.zoomToOriginSize();
          }),
          ' ',
          this.renderBtn('best-size', _lang2.default.bestSize, bestSizeStatus, function () {
            if ('disable' !== bestSizeStatus) imageBrowser.zoomToBestSize();
          }),
          ' '
        ),
        ' '
      );
    }
  }]);

  return Zoom;
}(_react2.default.Component);

exports.default = Zoom;