'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

var _event = require('../../utils/event');

var _palette = require('../../utils/palette');

var _palette2 = _interopRequireDefault(_palette);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _input = require('./input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var colors = _palette2.default.getColors();
var backgroundColors = [[colors[2][0], colors[6][0]], [colors[2][3], colors[6][3]], [colors[2][4], colors[6][4]], [colors[0][6], colors[0][2]], [colors[2][6], colors[6][6]], [colors[2][7], colors[6][7]]];

var locale = {
  en: {
    defaultLabel: 'SET A STATUS'
  },
  'zh-cn': {
    defaultLabel: '\u8BBE\u7F6E\u72B6\u6001'
  }
};

var Label = function (_SectionBase) {
  _inherits(Label, _SectionBase);

  function Label() {
    _classCallCheck(this, Label);

    return _possibleConstructorReturn(this, (Label.__proto__ || Object.getPrototypeOf(Label)).apply(this, arguments));
  }

  _createClass(Label, [{
    key: 'onChange',
    value: function onChange(value) {
      this.setValue(value);
      this.updateLabel();
    }
  }, {
    key: 'focusInput',
    value: function focusInput() {
      this.editorContainer.find('input')[0].focus();
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      if (this.state.readonly) return;
      this.editorContainer.hide();
      this.setValue({}, true);
      this.labelContainer.removeClass('zacheditor-label-selected');
      this.engine.readonly(false);
      (0, _event.removeScrollAndResizeEventListener)(this);
    }
  }, {
    key: 'updateEditorPosition',
    value: function updateEditorPosition() {
      var client_rect = this.labelContainer.getBoundingClientRect();
      this.editorContainer.css('left', ''.concat(client_rect.left, 'px'));
      this.editorContainer.css('top', ''.concat(client_rect.top + 24, 'px'));
    }
  }, {
    key: 'activate',
    value: function activate() {
      if (this.state.readonly) return;
      this.editorContainer.show();
      this.labelContainer.addClass('zacheditor-label-selected');
      this.updateEditorPosition();
      (0, _event.addScrollAndResizeEventListener)(this);
    }
  }, {
    key: 'select',
    value: function select() {
      this.labelContainer.addClass('zacheditor-label-selected');
    }
  }, {
    key: 'unselect',
    value: function unselect() {
      if (!this.state.activated || this.state.readonly) {
        this.labelContainer.removeClass('zacheditor-label-selected');
      }
    }
  }, {
    key: 'selectByOther',
    value: function selectByOther(color) {
      this.labelContainer.css('border', '2px solid ' + color);
    }
  }, {
    key: 'unselectByOther',
    value: function unselectByOther() {
      this.labelContainer.css('border', '');
    }
  }, {
    key: 'updateLabel',
    value: function updateLabel() {
      var _value = this.value,
          colorIndex = _value.colorIndex,
          label = _value.label;

      var color = backgroundColors[colorIndex][1];
      var text = label;
      var opacity = 1;
      if (!label) {
        text = this.locale.defaultLabel;
        opacity = 0.45;
      }
      this.labelContainer.css('background', backgroundColors[colorIndex][0]);
      this.labelContainer.css('color', color);
      this.labelContainer.css('opacity', opacity);
      this.state.activated ? this.labelContainer.addClass('zacheditor-label-selected') : this.labelContainer.removeClass('zacheditor-label-selected');
      this.labelContainer.html(text);
    }
  }, {
    key: 'renderView',
    value: function renderView() {
      this.labelContainer = _tinsoEditorEngine2.default.$('\n      <span class="zacheditor-section-label-container"></span>\n    ');
      this.container.append(this.labelContainer);
      this.updateLabel();
      if (!this.state.readonly) {
        (0, _event.setCursor)(this.labelContainer);
      }
    }
  }, {
    key: 'renderEditor',
    value: function renderEditor() {
      var _this2 = this;

      var container = this.container,
          value = this.value,
          engine = this.engine,
          sectionRoot = this.sectionRoot;

      var editorContainer = _tinsoEditorEngine2.default.$('<div class="zacheditor-section-label-editor"></div>');
      this.editorContainer = editorContainer;
      container.append(editorContainer);
      (0, _event.bindKeydownEvent)({
        editorContainer: editorContainer,
        engine: engine,
        sectionRoot: sectionRoot
      });
      _reactDom2.default.render(_react2.default.createElement(_input2.default, {
        colors: backgroundColors.map(function (color) {
          return color[0];
        }),
        onChange: function onChange(value) {
          _this2.onChange(value);
        },
        onFocus: function onFocus() {
          editorContainer.addClass('input-focus');
          _this2.engine.readonly(true);
        },
        onBlur: function onBlur() {
          editorContainer.removeClass('input-focus');
        },
        sectionValue: value,
        defaultValue: this.defaultValue
      }), editorContainer[0]);
    }
  }, {
    key: 'getDefaultValue',
    value: function getDefaultValue() {
      return {
        label: '',
        colorIndex: 0
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var lang = this.getLang();
      this.locale = locale[lang];
      var value = this.getDefaultValue();
      this.value = this.value || {};
      this.value = Object.assign({}, value, {}, this.value);
      this.defaultValue = value;
      this.renderView();
      if (!this.state.readonly) {
        this.renderEditor();
      }
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      _get(Label.prototype.__proto__ || Object.getPrototypeOf(Label.prototype), 'destroy', this).call(this);
      (0, _event.removeScrollAndResizeEventListener)(this);
    }
  }]);

  return Label;
}(_base2.default);

Label.type = 'inline';
exports.default = Label;