'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/input/style');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _colorPicker = require('../../toolbar/color-picker');

var _colorPicker2 = _interopRequireDefault(_colorPicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputLabel = function (_React$Component) {
  _inherits(InputLabel, _React$Component);

  function InputLabel(props) {
    _classCallCheck(this, InputLabel);

    var _this = _possibleConstructorReturn(this, (InputLabel.__proto__ || Object.getPrototypeOf(InputLabel)).call(this));

    _this.state = {
      activeColors: [props.colors[props.sectionValue.colorIndex]]
    };
    return _this;
  }

  _createClass(InputLabel, [{
    key: 'change',
    value: function change(e) {
      this.props.onChange(Object.assign({}, this.props.sectionValue, {}, e));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          colors = _props.colors,
          label = _props.sectionValue.label,
          onFocus = _props.onFocus,
          onBlur = _props.onBlur,
          onPressEnter = _props.onPressEnter;
      var activeColors = this.state.activeColors;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_antd.Input, {
          defaultValue: label,
          onChange: function onChange(event) {
            _this2.change({
              label: _tinsoEditorEngine2.default.StringUtils.escape(event.target.value.trim())
            });
          },
          draggable: false,
          onDragStart: function onDragStart(event) {
            event.preventDefault();
            event.stopPropagation();
          },
          onClick: function onClick(event) {
            event.stopPropagation();
          },
          onMouseDown: function onMouseDown(event) {
            event.stopPropagation();
            event.target.focus();
          },
          onFocus: onFocus,
          onBlur: onBlur,
          onPressEnter: onPressEnter
        }),
        _react2.default.createElement(_colorPicker2.default, {
          activeColors: activeColors,
          setStroke: true,
          onSelect: function onSelect(color) {
            _this2.change({
              colorIndex: colors.indexOf(color)
            });
            _this2.setState({
              activeColors: [color]
            });
          },
          colors: [colors]
        })
      );
    }
  }]);

  return InputLabel;
}(_react2.default.Component);

exports.default = InputLabel;