'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lang = require('./lang');

var _lang2 = _interopRequireDefault(_lang);

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _Lock = require('./Lock');

var _Lock2 = _interopRequireDefault(_Lock);

var _Unlock = require('./Unlock');

var _Unlock2 = _interopRequireDefault(_Unlock);

var _ajax = require('../../utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var template = function template(isTitle, locale) {
  return '\n    <div class="zacheditor-lockedtext">\n      '.concat(isTitle ? '\n      <div class="zacheditor-lockedtext-header">\n        <h5>'.concat(locale.title, '</h5>\n        <span class="locktrigger">\n          <span class="zacheditor-icon zacheditor-icon-lock"></span>\n          <span class="text">').concat(locale.setPassword, '</span>\n        </span>\n      </div>') : '', '\n      <div class="zacheditor-lockedtext-content">\n        <textarea class="lockedtext"></textarea>\n      </div>\n      <div class="unlock-container ').concat(isTitle ? 'editing' : 'reading', '"></div>\n      <div class="lock-container"></div>\n    </div>\n  ');
};

var uid = Math.random();
var cacheList = {};

var LockedText = function (_SectionBase) {
  _inherits(LockedText, _SectionBase);

  function LockedText(engine, contentView) {
    _classCallCheck(this, LockedText);

    var _this = _possibleConstructorReturn(this, (LockedText.__proto__ || Object.getPrototypeOf(LockedText)).call(this));

    _this.destroy = function () {
      if (_this.engine) _this.engine.toolbar.disable(false);
    };

    _this.updateValue = function (fore) {
      if (_this.password) {
        if (_this.crypting && !fore) return;
        _this.crypting = true;
        (0, _ajax2.default)({
          url: _this.cyptoApi,
          data: {
            pwd: _this.password,
            text: _this.originData,
            action: 'encrypt'
          },
          method: 'POST',
          success: function success(res) {
            if (!res.result) {
              _this.crypting = false;
              _this.engine.messageError(_this.locale.encryptoError);
              return;
            }
            _this.crypting = false;
            _this.cryptoData = res.data;
            _this.setValue({
              pageUid: uid,
              locked: _this.locked,
              cryptoData: _this.cryptoData,
              originData: ''
            }, true);
            if (fore) {
              _this.showUnLockpanel();
              _this.showStatus();
            }
          },
          error: function error() {
            _this.crypting = false;
            if (fore) {
              _this.engine.messageError(_this.locale.encryptoError);
            }
          }
        });
      } else {
        _this.setValue({
          pageUid: uid,
          locked: false,
          originData: _this.originData
        }, true);
      }
    };

    _this.lock = function (key) {
      if (key !== undefined) _this.cachePassword(key);
      if (_this.engine) {
        if (!_this.password) {
          _this.showLockPanel();
          return;
        }
        _this.updateValue(true);
      }
    };

    _this.unLock = function (key) {
      if (key && _this.cryptoData && !_this.disabled && !_this.crypting) {
        _this.crypting = true;
        (0, _ajax2.default)({
          url: _this.cyptoApi,
          data: {
            pwd: key,
            text: _this.cryptoData,
            action: 'decrypt'
          },
          method: 'POST',
          success: function success(res) {
            if (!res.result) {
              _this.crypting = false;
              _this.showError();
              return;
            }
            _this.crypting = false;
            _this.originData = res.data !== undefined ? res.data : '';
            _this.cachePassword(key);
            _this.showOriginData(_this.originData);
            _this.locktrigger.find('.text').html(_this.locale.lock);
            _this.showStatus();
          },
          error: function error() {
            _this.crypting = false;
            _this.showError();
          }
        });
      }
    };

    _this.showError = function () {
      _this.errorCount += 1;
      if (5 === _this.errorCount) {
        _this.disabled = true;
        _tinsoEditorEngine2.default.$(_this.unLockContainer).addClass('locked');
        _this.delayClearLockStatus();
      }
      _tinsoEditorEngine2.default.$(_this.unLockContainer).addClass('error');
    };

    _this.delayClearLockStatus = function () {
      setTimeout(function () {
        _this.disabled = false;
        _this.errorCount = 0;
        _tinsoEditorEngine2.default.$(_this.unLockContainer).removeClass('error');
        _tinsoEditorEngine2.default.$(_this.unLockContainer).removeClass('locked');
      }, 60000);
    };

    _this.showOriginData = function (value) {
      _this.clear();
      _this.textarea[0].value = value;
      _this.textarea.attr('data-origin-data', value);
      _this.originData = value;
      _this.locked = false;
    };

    _this.showLockPanel = function () {
      _this.clear();
      _reactDom2.default.render(_react2.default.createElement(_Lock2.default, { onLock: _this.lock, onCancelLock: _this.onCancelLock, locale: _this.locale }), _this.lockContainer);
    };

    _this.showUnLockpanel = function () {
      _this.locked = true;
      _this.clear();
      _reactDom2.default.render(_react2.default.createElement(_Unlock2.default, { onUnlock: _this.unLock, locale: _this.locale }), _this.unLockContainer);
    };

    _this.cachePassword = function (password) {
      _this.password = password;
      cacheList[_this.value.uid] = password;
    };

    _this.clear = function () {
      _tinsoEditorEngine2.default.$(_this.unLockContainer).removeClass('error');
      _tinsoEditorEngine2.default.$(_this.unLockContainer).removeClass('locked');
      _reactDom2.default.unmountComponentAtNode(_this.unLockContainer);
      if (_this.lockContainer) _reactDom2.default.unmountComponentAtNode(_this.lockContainer);
    };

    _this.onCancelLock = function () {
      _this.clear();
    };

    _this.onChangeValue = function (e) {
      var value = e.target.value;
      if (_this.originData !== value) {
        _this.originData = value;
        _this.updateValue();
      }
    };

    _this.onInput = function (e) {
      if (_this.timer) {
        clearTimeout(_this.timer);
      }
      _this.timer = setTimeout(function () {
        _this.onChangeValue(e);
      }, 3000);
    };

    _this.bindLockEvent = function () {
      _this.locktrigger = _this.container.find('.locktrigger');
      _this.locktrigger.on('click', function () {
        _this.lock();
      });
    };

    _this.showStatus = function () {
      if (_this.engine) {
        _this.lockstatus.html(_this.value.cryptoData ? '' : _this.locale.unLockedInfo);
      }
    };

    _this.renderHTML = function (isTitle) {
      _this.cryptoData = _this.value.cryptoData || '';
      _this.originData = _this.value.originData || '';
      _this.pageUid = _this.value.pageUid || '';
      _this.container.append(_tinsoEditorEngine2.default.$(template(isTitle, _this.locale)));
      _this.textarea = _this.container.find('.lockedtext');
      _this.unLockContainer = _this.container.find('.unlock-container')[0];
      _this.lockContainer = _this.container.find('.lock-container')[0];
      _this.lockstatus = _this.container.find('.lockstatus');
      _this.bindLockEvent();
      _this.showStatus();
      _this.locked = _this.pageUid === uid ? _this.value.locked : _this.locked;
      if (!isTitle) {
        if (_this.cryptoData) {
          _this.locked = true;
        } else if (_this.originData) {
          _this.showOriginData(_this.originData);
          return;
        }
      }
      if (!_this.locked) {
        if (_this.originData) {
          _this.showOriginData(_this.originData);
          return;
        }
        if (cacheList[_this.value.uid]) {
          _this.unLock(cacheList[_this.value.uid]);
          return;
        }
      }
      if (_this.cryptoData) _this.showUnLockpanel();
    };

    _this.engine = engine;
    _this.contentView = contentView;
    if (engine) {
      _this.section = engine.section;
      _this.locale = _lang2.default[engine.options.lang];
      _this.cyptoApi = engine.options.lockedtext && engine.options.lockedtext.action ? engine.options.lockedtext.action : '';
    } else {
      _this.locale = _lang2.default[contentView.options.lang];
      _this.cyptoApi = contentView.options.lockedtext && contentView.options.lockedtext.action ? contentView.options.lockedtext.action : '';
      _this.originData = '';
      _this.cryptoData = '';
      _this.password = '';
      _this.locked = false;
      _this.errorCount = 0;
    }
    return _this;
  }

  _createClass(LockedText, [{
    key: 'embedToolbar',
    value: function embedToolbar() {
      var engine = this.engine;
      var config = (engine ? engine.options.lockedtext : this.contentView.options.lockedtext) || {};
      var embed = [{
        type: 'dnd'
      }, {
        type: 'copy'
      }, {
        type: 'separator'
      }, {
        type: 'delete'
      }];
      if (Array.isArray(config.embed)) {
        return config.embed;
      } else if (_typeof(config.embed) === 'object') {
        var embedArray = [];
        embed.forEach(function (item) {
          if (config.embed[item.type] !== false) {
            embedArray.push(item);
          }
        });
        return embedArray;
      } else {
        return embed;
      }
    }
  }, {
    key: 'activate',
    value: function activate() {
      if (this.engine) this.engine.toolbar.disable(true);
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      if (this.engine) this.engine.toolbar.disable(false);
    }
  }, {
    key: 'renderView',
    value: function renderView() {
      this.renderHTML();
      this.textarea.attr('readonly', true);
    }
  }, {
    key: 'renderEditor',
    value: function renderEditor() {
      this.renderHTML(true);
      this.textarea.on('change', this.onChangeValue);
      this.textarea.on('input', this.onInput);
    }
  }, {
    key: 'render',
    value: function render(e, value) {
      this.value = value || {};
      if (this.contentView) this.renderView();else this.renderEditor();
    }
  }]);

  return LockedText;
}(_base2.default);

LockedText.type = 'block';
LockedText.uid = true;
exports.default = LockedText;