'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _imageGenerator = require('../../utils/image-generator');

var _toolbar = require('./toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _event = require('../../utils/event');

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Math = function (_SectionBase) {
  _inherits(Math, _SectionBase);

  function Math() {
    _classCallCheck(this, Math);

    var _this = _possibleConstructorReturn(this, (Math.__proto__ || Object.getPrototypeOf(Math)).call(this));

    _this.renderMath = (0, _debounce2.default)(_this._renderMath, 300);
    return _this;
  }

  _createClass(Math, [{
    key: 'renderImage',
    value: function renderImage(ele) {
      var maxWidth = this.getMaxWidth();
      var node = ele[0];
      var naturalWidth = node.naturalWidth,
          naturalHeight = node.naturalHeight;


      var width = parseInt(14 / 17.4 * naturalWidth);
      var height = parseInt(14 / 17.4 * naturalHeight);
      ele.css('width', ''.concat(width, 'px'));
      ele.css('height', ''.concat(height, 'px'));
      ele.css('max-width', ''.concat(maxWidth, 'px'));
      this.setValue({
        width: width,
        height: height
      });
    }
  }, {
    key: 'exConvertToPx',
    value: function exConvertToPx(svg) {
      var regWidth = /width="([\d\.]+ex)"/;
      var widthMaths = regWidth.exec(svg);
      var exWidth = widthMaths ? widthMaths[1] : null;

      var regHeight = /height="([\d\.]+ex)"/;
      var heightMaths = regHeight.exec(svg);
      var exHeight = heightMaths ? heightMaths[1] : null;

      if (exWidth) {
        var pxWidth = exWidth.substring(0, exWidth.length - 2) * 9;
        svg = svg.replace('width="' + exWidth + '"', 'width="' + pxWidth + 'px"');
      }

      if (exHeight) {
        var pxHeight = exHeight.substring(0, exHeight.length - 2) * 9;
        svg = svg.replace('height="' + exHeight + '"', 'height="' + pxHeight + 'px"');
      }
      return svg;
    }
  }, {
    key: '_renderMath',
    value: function _renderMath(code) {
      var _this2 = this;

      (0, _imageGenerator.preview)('latex', code).then(function (res) {
        _this2.hasSave = false;
        if (res.success) {
          res.svg = _this2.exConvertToPx(res.svg);
          var svg = 'data:image/svg+xml,' + encodeURIComponent(res.svg).replace(/'/g, '%27').replace(/"/g, '%22');
          var image = new Image();
          image.src = svg;
          image.onload = function () {
            _this2.renderImage(_tinsoEditorEngine2.default.$(image));
            _this2.viewContainer.empty();
            _this2.viewContainer.append(image);
            _this2.updateEditorPosition();
          };
          _this2.svg = res.svg;
          _this2.setValue({
            src: svg,
            code: code
          }, false);
        } else {
          _this2.renderPureText(code);
          _this2.svg = undefined;
          _this2.setValue({
            src: null,
            code: code
          }, false);
        }
      });
    }
  }, {
    key: 'getMaxWidth',
    value: function getMaxWidth() {
      var engine = this.getViewEngine();
      var style = window.getComputedStyle(engine.container[0]);
      var width = parseInt(style.width) - parseInt(style['padding-left']) - parseInt(style['padding-right']);
      return this.state.readonly ? width : width - 2;
    }
  }, {
    key: 'renderPureText',
    value: function renderPureText(text) {
      var maxWidth = this.getMaxWidth();
      this.viewContainer.html('<span class="zacheditor-math-content-tmp" style="max-width: '.concat(maxWidth, 'px">').concat(text, '</span>'));
      this.updateEditorPosition();
    }
  }, {
    key: 'focusTextarea',
    value: function focusTextarea() {
      this.editorContainer.find('textarea')[0].focus();
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      if (!this.state.readonly) {
        this.engine.readonly(false);
        this.editorContainer.hide();
        (0, _event.removeScrollAndResizeEventListener)(this);
      }
    }
  }, {
    key: 'updateEditorPosition',
    value: function updateEditorPosition() {
      if (this.editorContainer) {
        var clientRect = this.viewContainer.getBoundingClientRect();
        this.editorContainer.css('left', ''.concat(clientRect.left, 'px'));
        this.editorContainer.css('top', ''.concat(clientRect.bottom + 8, 'px'));
      }
    }
  }, {
    key: 'activate',
    value: function activate() {
      if (!this.state.readonly) {
        this.editorContainer.show();
        this.updateEditorPosition();
        (0, _event.addScrollAndResizeEventListener)(this);
      }
    }
  }, {
    key: 'renderView',
    value: function renderView() {
      var _this3 = this;

      var value = this.value,
          container = this.container,
          locale = this.locale;
      var src = value.src,
          code = value.code,
          width = value.width,
          height = value.height;

      var mathContainer = _tinsoEditorEngine2.default.$('<span class="zacheditor-math-container"></span>');
      container.append(mathContainer);
      this.viewContainer = mathContainer;
      if (src) {
        var image = _tinsoEditorEngine2.default.$('<img src="'.concat(src, '" />'));
        mathContainer.append(image);
        if (width) {
          image.css('width', ''.concat(width, 'px'));
        }
        if (height) {
          image.css('height', ''.concat(height, 'px'));
        }
        this.img = image;
        image[0].onload = function () {
          _this3.renderImage(image);
        };

        image[0].onerror = function () {
          _this3._renderMath(code);
        };
      } else if (code) {
        if (this.state.readonly) {
          this.renderPureText(code);
        } else {
          this._renderMath(code);
        }
      } else {
        this.renderPureText(locale.placeholder);
      }
      if (!this.state.readonly) {
        (0, _event.setCursor)(mathContainer);
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(code) {
      this.code = code;
      this.renderMath(code);
    }
  }, {
    key: 'renderEditor',
    value: function renderEditor() {
      var _this4 = this;

      var container = this.container,
          value = this.value,
          engine = this.engine,
          sectionRoot = this.sectionRoot,
          locale = this.locale;

      var editorContainer = _tinsoEditorEngine2.default.$('<div class="zacheditor-section-math-editor"></div>');
      this.editorContainer = editorContainer;
      container.append(editorContainer);
      (0, _event.bindKeydownEvent)({
        editorContainer: editorContainer,
        engine: engine,
        sectionRoot: sectionRoot,
        callback: function callback(event) {
          return 27 === event.keyCode || 13 === event.keyCode && (event.ctrlKey || event.metaKey);
        }
      });
      var options = engine.options.math || {};
      _reactDom2.default.render(_react2.default.createElement(_toolbar2.default, {
        code: value.code,
        locale: locale,
        options: options,
        onFocus: function onFocus() {
          editorContainer.addClass('textarea-focus');
          _this4.engine.readonly(true);
        },
        onBlur: function onBlur() {
          editorContainer.removeClass('textarea-focus');
        },
        onChange: function onChange(code) {
          _this4.onChange(code);
        }
      }), editorContainer[0], function () {
        editorContainer.find('[data-role="save"]').on('click', function (event) {
          event.stopPropagation();
          event.preventDefault();
          engine.change.activateSection(document.body, 'manual');
          engine.change.focusSection(sectionRoot);
        });
        var textarea = editorContainer.find('textarea');
        textarea.on('mousedown', function () {
          textarea[0].focus();
        });
      });
      this.bindEvent(engine.asyncEvent, 'save:before', function () {
        if (false === _this4.hasSave) {
          return (0, _imageGenerator.preview)('latex', _this4.code).then(function (res) {
            if (!res.success) return;
            res.svg = _this4.exConvertToPx(res.svg);
            var src = 'data:image/svg+xml,' + encodeURIComponent(res.svg).replace(/'/g, '%27').replace(/"/g, '%22');
            _this4.svg = res.svg;
            _this4.hasSave = true;
            _this4.setValue({
              src: src,
              code: _this4.code
            }, false);
          });
        }
      });
    }
  }, {
    key: 'getDefaultValue',
    value: function getDefaultValue() {
      return {
        src: null,
        code: ''
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var locale = this.getViewEngine().locale.math;
      var value = this.getDefaultValue();
      this.locale = locale;
      this.value = this.value || {};
      this.value = Object.assign({}, value, {}, this.value);
      this.defaultValue = value;
      this.value.code ? this.code = this.value.code : this.value.src = null;
      this.renderView();
      this.state.readonly || this.renderEditor();
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      _get(Math.prototype.__proto__ || Object.getPrototypeOf(Math.prototype), 'destroy', this).call(this);
      (0, _event.removeScrollAndResizeEventListener)(this);
    }
  }]);

  return Math;
}(_base2.default);

Math.type = 'inline';
Math.selectStyleType = 'background';
exports.default = Math;