'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _antd = require('antd');

require('antd/lib/tooltip/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Toolbar = function Toolbar(props) {
  var locale = props.locale,
      _onChange = props.onChange,
      onFocus = props.onFocus,
      onBlur = props.onBlur,
      code = props.code,
      options = props.options;


  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement('textarea', {
      onFocus: onFocus,
      onBlur: onBlur,
      rows: 8,
      defaultValue: code,
      onChange: function onChange(event) {
        _onChange(event.target.value);
      }
    }),
    _react2.default.createElement(
      'div',
      { className: 'zacheditor-math-editor-toolbar' },
      _react2.default.createElement(
        'div',
        { className: 'zacheditor-math-editor-toolbar-tips' },
        _react2.default.createElement(
          'a',
          { className: 'text', href: 'http://www.wiris.com/editor/demo/en/developers', target: '_blank' },
          _react2.default.createElement('span', { className: 'zacheditor-icon zacheditor-icon-question' }),
          '\u5E2E\u52A9'
        )
      ),
      _react2.default.createElement(
        'div',
        { className: 'zacheditor-embed-toolbar zacheditor-embed-toolbar-inline zacheditor-embed-toolbar-active' },
        _react2.default.createElement(
          _antd.Tooltip,
          { title: locale.enterTooltips },
          _react2.default.createElement(
            'a',
            { className: 'zacheditor-embed-toolbar-btn', 'data-role': 'save' },
            _react2.default.createElement(
              'span',
              { className: 'text' },
              _tinsoEditorEngine2.default.StringUtils.escape(locale.save)
            )
          )
        )
      )
    )
  );
};

exports.default = Toolbar;