'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _graphsection = require('../graphsection');

var _graphsection2 = _interopRequireDefault(_graphsection);

var _graphEditor = require('../graphsection/graph-editor');

var _graphEditor2 = _interopRequireDefault(_graphEditor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var userAgent = _tinsoEditorEngine2.default.userAgent;
/**
 * @fileOverview 思维脑图
 */

var MindMap = function (_GraphSection) {
  _inherits(MindMap, _GraphSection);

  function MindMap(engine, contentView) {
    _classCallCheck(this, MindMap);

    return _possibleConstructorReturn(this, (MindMap.__proto__ || Object.getPrototypeOf(MindMap)).call(this, {
      engine: engine,
      contentView: contentView,
      pageType: 'mindmap'
    }));
  }

  _createClass(MindMap, [{
    key: 'topToolbar',
    value: function topToolbar() {
      var engine = this.engine,
          locale = this.locale,
          graphEditor = this.graphEditor;

      return [{
        name: 'save',
        title: locale.save,
        hotkey: userAgent.macos ? '⌘+S' : 'Ctrl+S',
        icon: '<span class="zacheditor-icon zacheditor-icon-save" />',
        onClick: function onClick() {
          engine.command.execute('save');
        }
      }, {
        name: 'mindmap:undo',
        title: locale.undo,
        hotkey: userAgent.macos ? '⌘+Z' : 'Ctrl+Z',
        icon: '<span class="zacheditor-icon zacheditor-icon-undo" />',
        getDisabled: function getDisabled() {
          return !graphEditor.commandEnable('undo');
        },
        onClick: function onClick() {
          graphEditor.executeCommand('undo');
        }
      }, {
        name: 'mindmap:redo',
        title: locale.redo,
        hotkey: userAgent.macos ? '⌘+Y' : 'Ctrl+Y',
        icon: '<span class="zacheditor-icon zacheditor-icon-redo" />',
        getDisabled: function getDisabled() {
          return !graphEditor.commandEnable('redo');
        },
        onClick: function onClick() {
          graphEditor.executeCommand('redo');
        }
      }, {
        type: 'separator'
      }, {
        name: 'mindmap:append',
        title: locale.insertSibling,
        hotkey: 'Enter',
        icon: '<span class="zacheditor-icon zacheditor-icon-sister-node" />',
        getDisabled: function getDisabled() {
          return !graphEditor.commandEnable('append');
        },
        onClick: function onClick() {
          graphEditor.executeCommand('append');
        }
      }, {
        name: 'mindmap:appendChild',
        title: locale.insertChild,
        hotkey: 'Tab',
        icon: '<span class="zacheditor-icon zacheditor-icon-sub-node" />',
        getDisabled: function getDisabled() {
          return !graphEditor.commandEnable('appendChild');
        },
        onClick: function onClick() {
          graphEditor.executeCommand('appendChild');
        }
      }, {
        name: 'mindmap:collapse',
        title: locale.collapse,
        hotkey: userAgent.macos ? '⌘+/' : 'Ctrl+/',
        icon: '<span class="zacheditor-icon zacheditor-icon-collapse-subtree" />',
        getDisabled: function getDisabled() {
          return !graphEditor.commandEnable('collapse');
        },
        onClick: function onClick() {
          graphEditor.executeCommand('collapse');
        }
      }, {
        name: 'mindmap:expand',
        title: locale.expand,
        hotkey: userAgent.macos ? '⌘+/' : 'Ctrl+/',
        icon: '<span class="zacheditor-icon zacheditor-icon-expand-subtree" />',
        getDisabled: function getDisabled() {
          return !graphEditor.commandEnable('expand');
        },
        onClick: function onClick() {
          graphEditor.executeCommand('expand');
        }
      }, {
        type: 'separator'
      }];
    }
  }, {
    key: 'getChangeDataCommandNames',
    value: function getChangeDataCommandNames() {
      return ['update', 'append', 'appendChild', 'collapseExpand', 'redo', 'undo', 'delete', 'selectAll', 'moveMindNode'];
    }
  }, {
    key: 'renderPage',
    value: function renderPage() {
      var mind = new _graphEditor2.default.Mind({
        graph: _extends({}, this.defaultGraphCfg, {
          container: this.pageContainer[0]
        })
      });
      this.graphEditor.add(mind);
      this.page = mind;
    }
  }]);

  return MindMap;
}(_graphsection2.default);

exports.default = MindMap;