'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _embed = require('../embed/embed');

var _embed2 = _interopRequireDefault(_embed);

var _graphView = require('./graph-view');

var _graphView2 = _interopRequireDefault(_graphView);

var _antd = require('antd');

require('antd/lib/modal/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Visio = function (_Embed) {
  _inherits(Visio, _Embed);

  function Visio() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Visio);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Visio.__proto__ || Object.getPrototypeOf(Visio)).call.apply(_ref, [this].concat(args))), _this), _this.setGraphMessage = function (jsonMsg) {
      var iframeWindow = _this.iframe ? _this.iframe[0].contentWindow : null;
      if (iframeWindow && iframeWindow.postMessage) {
        iframeWindow.postMessage(JSON.stringify(jsonMsg), '*');
      }
    }, _this.onGraphMessage = function (event) {
      var msg = JSON.parse(event.data);
      if (msg.event == 'configure') {
        _this.setGraphMessage({
          action: 'configure',
          config: { defaultFonts: ['Humor Sans', 'Helvetica', 'Times New Roman'] }
        });
      } else if (msg.event == 'init') {
        _this.setGraphMessage({ action: 'load', autosave: 1, xml: _this.value.xml });
      } else if (msg.event === 'load') {
        _this.setGraphMessage({ action: 'status' });
      } else if (msg.event == 'autosave') {
        _this.setValue({
          draft: msg.xml
        });
      } else if (msg.event == 'save') {
        _this.setGraphMessage({
          action: 'export',
          format: 'xmlsvg',
          xml: msg.xml,
          spin: 'Updating page'
        });
      } else if (msg.event == 'export') {
        var dataWidth = Math.ceil(msg.width / msg.scale);
        var dataHeight = Math.ceil(msg.height / msg.scale);
        _this.setValue({
          draft: null,
          xml: msg.xml,
          data: msg.data,
          format: msg.format,
          dataWidth: dataWidth,
          dataHeight: dataHeight
        });
        _this.hideGraphEditor();
      } else if (msg.event == 'exit') {
        _this.hideGraphEditor();
      }
    }, _this.showGraphEditor = function () {
      var _this2 = _this,
          sectionRoot = _this2.sectionRoot,
          engine = _this2.engine,
          contentView = _this2.contentView;

      engine.section.maximize({
        sectionRoot: sectionRoot,
        engine: engine,
        contentView: contentView
      });
    }, _this.hideGraphEditor = function () {
      var _this3 = _this,
          contentView = _this3.contentView,
          sectionRoot = _this3.sectionRoot,
          engine = _this3.engine;

      engine.section.restore({
        sectionRoot: sectionRoot,
        engine: engine,
        contentView: contentView
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Visio, [{
    key: 'hitBlack',
    value: function hitBlack() {
      return false;
    }
  }, {
    key: 'embedToolbar',
    value: function embedToolbar() {
      var config = this.getGraphOptions();
      var embed = [{
        type: 'dnd'
      }, {
        type: 'maximize'
      }, {
        type: 'separator'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }];
      if (Array.isArray(config.embed)) {
        return config.embed;
      } else if (_typeof(config.embed) === 'object') {
        var embedArray = [];
        embed.forEach(function (item) {
          if (config.embed[item.type] !== false) {
            embedArray.push(item);
          }
        });
        return embedArray;
      } else {
        return embed;
      }
    }
  }, {
    key: 'getGraphOptions',
    value: function getGraphOptions() {
      var engine = this.engine,
          contentView = this.contentView;

      var options = engine ? engine.options : contentView.options;
      return options.mxgraph || {};
    }
  }, {
    key: 'getUrl',
    value: function getUrl() {
      var _value = this.value,
          src = _value.src,
          url = _value.url;

      return url || src || undefined;
    }
  }, {
    key: 'activate',
    value: function activate() {
      if (this.state.maximize) {
        this.hideRisizeController();
      } else {
        this.showRisizeController();
      }
      this.hideMask();
    }

    // 最大化

  }, {
    key: 'maximize',
    value: function maximize() {
      if (this.state.readonly) return;
      this.view.setState(this.state);
      this.renderIframeView();
      this.engine.toolbar.hide();
      this.iframe.css('height', this.getHeight());
      this.hideRisizeController();
    }
    //还原之前

  }, {
    key: 'restoreBefore',
    value: function restoreBefore() {
      var _this4 = this;

      if (this.value.draft && this.value.draft !== this.value.xml) {
        _reactDom2.default.render(_react2.default.createElement(
          _antd.Modal,
          {
            okText: '\u7EE7\u7EED\u7F16\u8F91',
            cancelText: '\u53D6\u6D88\u66F4\u6539',
            zIndex: 2000,
            onOk: function onOk() {
              _reactDom2.default.unmountComponentAtNode(_this4.modal[0]);
            },
            onCancel: function onCancel() {
              _this4.setValue({
                draft: null
              });
              _this4.hideGraphEditor();
              _reactDom2.default.unmountComponentAtNode(_this4.modal[0]);
            },
            visible: true
          },
          '\u6240\u6709\u4FEE\u6539\u5747\u5C06\u4F1A\u4E22\u5931\uFF01\u786E\u8BA4\u8981\u53D6\u6D88\u66F4\u6539\u5417?'
        ), this.modal[0]);
        return false;
      }
    }

    // 还原

  }, {
    key: 'restore',
    value: function restore() {
      if (this.state.readonly) return;
      // 未返回值的情况下，删除 Section
      if (!this.value.xml) {
        this.destroy();
        this.engine.change.removeSection(this.sectionRoot);
      }
      this.view.setState(this.state);
      this.removeIframeView();
      this.engine.toolbar.show();
      if (this.state.activated) {
        this.showRisizeController();
      }
    }
  }, {
    key: 'getHeight',
    value: function getHeight() {
      return this.getContainerHeight();
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.removeIframeView();
      _get(Visio.prototype.__proto__ || Object.getPrototypeOf(Visio.prototype), 'destroy', this).call(this);
    }
  }, {
    key: 'removeIframeView',
    value: function removeIframeView() {
      window.removeEventListener('message', this.onGraphMessage);
      this.iframe = null;
      if (this.warp) {
        this.warp.empty();
      }
    }
  }, {
    key: 'renderIframeView',
    value: function renderIframeView() {
      var _this5 = this;

      var container = this.container,
          value = this.value,
          options = this.options;

      var height = this.getHeight();
      var transition = options.transition;

      var embedNode = _tinsoEditorEngine2.default.$('\n      <div class="zacheditor-embed zacheditor-embed-active">\n   <div class="zacheditor-embed-modal"></div>     <div class="zacheditor-embed-content">\n          <div class="zacheditor-embed-content-bg">\n            <span class="zacheditor-icon zacheditor-icon-loading"></span>\n          </div>\n          <iframe data-role="iframe" \n            class="zacheditor-embed-content-frame" \n            frameborder="0" \n            allowfullscreen="true" \n            style="height: '.concat(height, 'px; transition: ').concat(transition, '"\n            >\n          </iframe>\n        </div>\n      </div>\n    '));

      var iframe = embedNode.find('iframe');

      if (value.height) {
        iframe.attr('data-height', height);
      }

      iframe.on('load', function () {
        iframe.addClass('zacheditor-embed-content-frame-loaded');
        window.addEventListener('message', _this5.onGraphMessage, false);
      });
      var url = this.getUrl();
      this.warp = container.find('.zacheditor-mxgraph-warp');
      this.modal = embedNode.find('.zacheditor-embed-modal');
      this.warp.append(embedNode);
      this.iframe = iframe;
      this.renderIframe(iframe, _tinsoEditorEngine2.default.StringUtils.sanitizeUrl(url));
      if (true === this.state.activated) this.hideMask();
    }
  }, {
    key: 'renderEditView',
    value: function renderEditView() {
      var _this6 = this;

      var _getGraphOptions = this.getGraphOptions(),
          url = _getGraphOptions.url;

      this.setValue({
        url: url
      });

      var value = this.value;

      _reactDom2.default.render(_react2.default.createElement(_graphView2.default, {
        showGraphEditor: this.showGraphEditor,
        value: value,
        onLoad: function onLoad(ref) {
          _this6.view = ref.view;
        }
      }), this.container[0], function () {
        _this6.root = _this6.container.find('.zacheditor-mxgraph-preview');
        var height = _this6.value.height;

        _this6.addResizeController(_this6.root);
        if (!value.xml) {
          _this6.showGraphEditor();
        }
        if (height) {
          _this6.root.css('height', height + 'px');
        }
      });
    }
  }, {
    key: 'renderReadView',
    value: function renderReadView() {
      _reactDom2.default.render(_react2.default.createElement(_graphView2.default, { value: this.value }), this.container[0]);
    }
  }]);

  return Visio;
}(_embed2.default);

Visio.type = 'block';
Visio.uid = true;
exports.default = Visio;