'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _collapse = require('../../toolbar/collapse');

var _collapse2 = _interopRequireDefault(_collapse);

var _toolbar = require('../../config/toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _keymaster = require('keymaster');

var _keymaster2 = _interopRequireDefault(_keymaster);

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCOPE_NAME = 'zacheditor-plugin-sectionselect';

var SectionSelect = function (_SectionBase) {
  _inherits(SectionSelect, _SectionBase);

  function SectionSelect(_engine) {
    _classCallCheck(this, SectionSelect);

    var _this = _possibleConstructorReturn(this, (SectionSelect.__proto__ || Object.getPrototypeOf(SectionSelect)).call(this));

    _this.handlePreventDefault = function (e) {
      // Section已被删除
      if (_this.sectionRoot.closest('body').length !== 0) {
        e.preventDefault();
        return false;
      }
    };

    _this.getClickNode = function (listRoot) {
      var node = listRoot.find('.zacheditor-collapse-list-item-active');
      var uploadNode = node.closest('div.ant-upload-select');

      if (uploadNode.length > 0) {
        node = uploadNode.parent();
      }

      return node;
    };

    _this.scrollItem = function (direction) {
      var listRoot = _this.container.find('.zacheditor-toolbar-collapse');
      var nodeList = listRoot.find('.zacheditor-collapse-list-item');
      var activeNode = listRoot.find('.zacheditor-collapse-list-item-active');
      var activeIndex = 0;
      nodeList.each(function (node, index) {
        if (node === activeNode[0]) {
          activeIndex = index;
        }
      });
      var nextNode = nodeList.eq(direction === 'up' ? activeIndex - 1 : activeIndex + 1);
      if (!nextNode) {
        return;
      }
      _this.selectItem(nextNode);

      var offset = listRoot.find('.ant-collapse-header')[0].clientHeight;
      var collapseItem = nextNode.closest('.ant-collapse-item');
      collapseItem.parent().find('.ant-collapse-item').each(function (node) {
        if (node === collapseItem[0]) {
          return false;
        }

        offset += node.clientHeight;
      });
      offset += activeNode[0].clientHeight * nextNode.attr('data-index');
      listRoot[0].scrollTop = offset - listRoot[0].clientHeight / 2;
    };

    _this.selectItem = function (node) {
      var listRoot = _this.container.find('.zacheditor-toolbar-collapse');
      listRoot.find('.zacheditor-collapse-list-item-active').removeClass('zacheditor-collapse-list-item-active');
      node.addClass('zacheditor-collapse-list-item-active');
    };

    _this.searchData = function (keyword) {
      var items = [];
      // search with case insensitive
      if (typeof keyword === 'string') keyword = keyword.toLowerCase();

      _this.data.forEach(function (group) {
        group.items.forEach(function (item) {
          if (item.title.toLowerCase().indexOf(keyword) >= 0 || item.pinyin.toLowerCase().indexOf(keyword) >= 0) {
            if (!items.find(function (dataItems) {
              return dataItems.name === item.name;
            })) {
              items.push(_extends({}, item));
            }
          }
        });
      });
      var newData = [];
      if (items.length > 0) {
        newData.push({
          title: '',
          items: items
        });
      }
      return newData;
    };

    _this.handleInput = function () {
      var engine = _this.engine;
      if (engine.domEvent.isComposing) {
        return;
      }
      var content = _this.keywordNode[0].innerText;
      // 内容为空
      if (content === '') {
        _this.removeSectionSelect();

        engine.change.removeSection(_this.sectionRoot);
        return;
      }

      var keyword = content.substr(1);
      // 搜索关键词为空
      if (keyword === '') {
        _this.renderSectionSelect(_this.data);

        return;
      }
      var newData = _this.searchData(keyword);
      // 有搜索结果
      if (newData.length > 0) {
        _this.renderSectionSelect(newData);
        return;
      }
      // 搜索结果为空
      _this.changeToText();
    };

    _this.removeSectionSelect = function () {
      var sectionSelectNode = _this.container.find('.zacheditor-sectionselect-list');

      if (sectionSelectNode.length > 0) {
        (0, _reactDom.unmountComponentAtNode)(sectionSelectNode[0]);
        sectionSelectNode.remove();
      }
    };

    _this.removeSection = function () {
      _this.removeSectionSelect();
      _this.engine.change.removeSection(_this.sectionRoot);
    };

    _this.changeToText = function () {
      if (!_this.sectionRoot.isEditable()) {
        return;
      }

      var content = _this.keywordNode[0].innerText;
      _this.removeSection();
      _this.engine.change.insertText(content);
    };

    _this.handleClick = function () {
      _this.removeSectionSelect();
      _this.engine.change.removeSection(_this.sectionRoot);
    };

    _this.handleBeforeUpload = function () {
      _this.sectionRoot.hide();
      _tinsoEditorEngine2.default.$(document.body).append(_this.sectionRoot);
    };

    _this.handleAfterUpload = function () {
      // 上传结束之后删除Section
      _this.removeSectionSelect();
      _this.sectionRoot.remove();
    };

    _this.renderSectionSelect = function (data) {
      _this.unbindEvents();
      var engine = _this.engine;
      _this.removeSectionSelect();
      var sectionSelectNode = _tinsoEditorEngine2.default.$('<div class="zacheditor-sectionselect-list" />');

      _this.container.append(sectionSelectNode);
      var classArray = [];
      var rootOffset = _this.sectionRoot.offset();
      var editorHeader = _tinsoEditorEngine2.default.$('.lark-editor-header');
      var height = 0;
      if (editorHeader.length > 0) {
        var toolbarElement = engine.container.closest('.zacheditor-pro').find('.zacheditor-toolbar');
        if (toolbarElement.length > 0) height = editorHeader[0].clientHeight + toolbarElement[0].clientHeight;
      }
      if (rootOffset.top - height > 482) {
        classArray.push('zacheditor-button-set-list-to-top');
      }
      if ('' === data[0].title) {
        classArray.push('zacheditor-button-set-list-search');
      }

      var collapseProps = {
        className: classArray.length > 0 ? classArray.join(' ') : undefined,
        active: true,
        engine: engine,
        locale: engine.locale,
        data: data,
        activeKeys: data.map(function (item, index) {
          return String(index);
        }),
        onClick: _this.handleClick,
        hideDropdown: function hideDropdown() {
          _this.container.hide();
        },
        removeSelect: _this.handleClick,
        onBeforeUpload: _this.handleBeforeUpload,
        onAfterUpload: _this.handleAfterUpload
      };
      _reactDom2.default.render(_react2.default.createElement(_collapse2.default, collapseProps), sectionSelectNode[0]);
      var listItem = sectionSelectNode.find('.zacheditor-collapse-list-item');
      if (listItem.length > 0) {
        _this.selectItem(listItem.eq(0));
      }
      _this.bindEvents();
    };

    _this.engine = _engine;
    _this.readonly = !_engine;

    if (_this.readonly) {
      return _possibleConstructorReturn(_this);
    }
    var toolbar = _engine.options.toolbar;

    var toolbarConfigMap = {};
    //let data = []
    (0, _toolbar2.default)(_engine).forEach(function (row) {
      toolbarConfigMap[row.name] = row;
    });
    /*const toolbarSection = toolbar['section'] || {}
        if(typeof toolbarSection === "object"){
            const sectionConfigMap = toolbarConfigMap['section']
            sectionConfigMap.data.forEach(group => {
                const items = group.items.filter(sectionItem => toolbarSection.items && toolbarSection.items.find(item => typeof item === "object" && item.name === sectionItem.name || item === sectionItem.name) || !toolbarSection.items)
                if(items && items.length > 0){
                    data.push({
                        title:group.title,
                        items:items
                    })
                }
            })
        }else if(toolbarSection === true){
            data = toolbarConfigMap['section'].data
        }*/

    _this.data = toolbarConfigMap['section'].data;
    return _this;
  }

  _createClass(SectionSelect, [{
    key: 'destroy',
    value: function destroy() {
      this.unbindEvents();
      this.removeSectionSelect();
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      this.unbindEvents();
      this.changeToText();
    }
  }, {
    key: 'unbindEvents',
    value: function unbindEvents() {
      (0, _keymaster.deleteScope)(SCOPE_NAME);
      (0, _keymaster.unbind)('enter', SCOPE_NAME);
      (0, _keymaster.unbind)('up', SCOPE_NAME);
      (0, _keymaster.unbind)('down', SCOPE_NAME);
      (0, _keymaster.unbind)('esc', SCOPE_NAME);
      this.engine.off('keydown:enter', this.handlePreventDefault);
    }
  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this2 = this;

      this.unbindEvents();
      (0, _keymaster.setScope)(SCOPE_NAME);
      (0, _keymaster2.default)('enter', SCOPE_NAME, function (e) {
        // Section已被删除
        if (_this2.sectionRoot.closest('body').length === 0) {
          return;
        }

        e.preventDefault();
        var listRoot = _this2.container.find('.zacheditor-toolbar-collapse');

        var node = _this2.getClickNode(listRoot);
        var fileInput = node.find('input[type=file]');
        if (fileInput.length > 0) {
          fileInput[0].click();
        } else {
          node[0].click();
        }
      });
      (0, _keymaster2.default)('up', SCOPE_NAME, function (e) {
        // Section已被删除
        if (_this2.sectionRoot.closest('body').length === 0) {
          return;
        }
        e.preventDefault();
        _this2.scrollItem('up');
      });
      (0, _keymaster2.default)('down', SCOPE_NAME, function (e) {
        // Section已被删除
        if (_this2.sectionRoot.closest('body').length === 0) {
          return;
        }
        e.preventDefault();
        _this2.scrollItem('down');
      });
      (0, _keymaster2.default)('esc', SCOPE_NAME, function (e) {
        e.preventDefault();

        _this2.unbindEvents();

        _this2.changeToText();
      });
      this.engine.on('keydown:enter', this.handlePreventDefault);
    }
  }, {
    key: 'resetPlaceHolder',
    value: function resetPlaceHolder() {
      if ('/' === this.keywordNode[0].innerText) this.placeholder.show();else this.placeholder.hide();
    }
  }, {
    key: 'render',
    value: function render(container) {
      var _this3 = this;

      // 阅读模式
      if (this.readonly) {
        return;
      }
      this.sectionRoot.attr('data-transient', 'true');
      this.sectionRoot.attr('contenteditable', false);
      // 编辑模式
      container.append('\n      <span class="zacheditor-sectionselect-keyword" contenteditable="true">/</span>\n      <span class="zacheditor-sectionselect-placeholder" style="\n        color: rgba(0,0,0,0.25);\n        pointer-events: none;\n        position: absolute;\n        width: 76px;\n        left: 7px;\n      ">'.concat(this.engine.locale.section.placeholder, '</span>\n    '));
      var keywordNode = container.find('.zacheditor-sectionselect-keyword');
      this.keywordNode = keywordNode;
      this.placeholder = container.find('.zacheditor-sectionselect-placeholder');
      // 监听输入事件
      keywordNode.on('keydown', function (e) {
        if (_tinsoEditorEngine2.default.isHotkey('enter', e)) {
          e.preventDefault();
        }
      });
      var renderTime = Date.now();
      keywordNode.on('input', function () {
        _this3.resetPlaceHolder();
        // 在 Windows 上使用中文输入法，在 keydown 事件里无法阻止用户的输入，所以在这里删除用户的输入
        if (Date.now() - renderTime < 100) {
          var textNode = keywordNode.first();
          if (textNode && textNode.isText() && textNode[0].nodeValue === '/、' || textNode[0].nodeValue === '//') {
            var rightTextNode = textNode[0].splitText(1);
            _tinsoEditorEngine2.default.$(rightTextNode).remove();
          }
        }

        setTimeout(function () {
          _this3.handleInput();
        }, 10);
      });
      // 显示下拉列表
      this.renderSectionSelect(this.data);
    }
  }]);

  return SectionSelect;
}(_base2.default);

SectionSelect.type = 'inline';
SectionSelect.singleSelectable = false;
exports.default = SectionSelect;