'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _eventemitter = require('eventemitter2');

var _antd = require('antd');

require('antd/lib/input-number/style');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var $ = _tinsoEditorEngine2.default.$;

var ControllBar = function (_EventEmitter) {
  _inherits(ControllBar, _EventEmitter);

  function ControllBar(section) {
    _classCallCheck(this, ControllBar);

    var _this = _possibleConstructorReturn(this, (ControllBar.__proto__ || Object.getPrototypeOf(ControllBar)).call(this, section));

    _this.render = function (action) {
      var needRenderCol = true;
      var needRenderRow = true;
      var opts = void 0;

      switch (action) {
        case 'insertRow':
        case 'removeRow':
          needRenderCol = false;
          break;
        case 'clearFormat':
        case 'align':
        case 'fontcolor':
        case 'background':
          needRenderRow = false;
          needRenderCol = false;
          break;
        case 'input':
        case 'select':
        case 'paste':
          needRenderCol = false;
          opts = _this.section.selection.getEffectRows();
          break;
        default:
          break;
      }
      if (needRenderRow) {
        _this.renderRowBars(opts);
      }
      if (needRenderCol) {
        _this.renderColBars();
      }
    };

    _this.renderColBars = function () {
      var _this$section = _this.section,
          tableRoot = _this$section.tableRoot,
          selection = _this$section.selection,
          template = _this$section.template;

      var tableModel = selection.tableModel;
      var table = tableModel.table;
      var colBars = _this.colsHeader.find(template.COLS_HEADER_ITEM_CLASS);
      var cols = tableRoot.find('col');
      var isNew = true;
      var tableWidth = tableRoot[0].offsetWidth;
      tableRoot.css('width', ''.concat(tableWidth, 'px'));
      _this.colsHeader.css('width', ''.concat(tableWidth, 'px'));
      var colWidthArray = {};
      var allColWidth = 0;
      var colIndex = 0;
      cols.each(function (col, i) {
        var colWidth = $(col).attr('width');
        if (colWidth) {
          colWidthArray[i] = colWidth;
          allColWidth += parseInt(colWidth);
          isNew = false;
        } else {
          colIndex++;
        }
      });

      if (isNew) {
        var tdWidth = [];
        table.forEach(function (trModel) {
          trModel.forEach(function (tdModel, c) {
            if (!tdWidth[c] && !tdModel.isEmpty && !tdModel.isMulti && tdModel.element) {
              tdWidth[c] = tdModel.element.offsetWidth;
            }
          });
        });
        // 合并单元格的存在，可能出现某些列全部属于合并单元格，导致无法通过 td 的 offsetWidth 直接获得，需要把剩余zhi
        var unkownCount = 0;
        var knownWidth = 0;
        for (var c = 0; c < cols.length; c++) {
          if (!tdWidth[c]) {
            unkownCount++;
          } else {
            knownWidth += tdWidth[c];
          }
        }
        var averageWidth = 0;
        if (unkownCount > 0) {
          averageWidth = Math.round((tableWidth - knownWidth) / unkownCount);
        }
        for (var _c = 0; _c < cols.length; _c++) {
          var width = tdWidth[_c] || averageWidth;
          $(colBars[_c]).css('width', width + 'px');
          $(cols[_c]).attr('width', width);
        }
      } else if (colIndex) {
        var _averageWidth = Math.round((tableWidth - allColWidth) / colIndex);
        cols.each(function (col, index) {
          var width = undefined === colWidthArray[index] ? _averageWidth : colWidthArray[index];
          $(colBars[index]).css('width', width + 'px');
          $(col).attr('width', width);
        });
      } else {
        cols.each(function (col, index) {
          var width = Math.round(tableWidth * colWidthArray[index] / allColWidth);
          $(colBars[index]).css('width', width + 'px');
          $(col).attr('width', width);
        });
      }
      _this.width = tableWidth;
    };

    _this.renderRowBars = function (opts) {
      var _this$section2 = _this.section,
          tableRoot = _this$section2.tableRoot,
          template = _this$section2.template;

      var trs = tableRoot[0].rows;
      var rowBars = _this.rowsHeader.find(template.ROWS_HEADER_ITEM_CLASS);

      var start = 0;
      var end = trs.length - 1;
      if (opts) {
        start = opts.row_min;
        end = opts.row_max;
      }
      for (var renderIndex = start; renderIndex <= end; renderIndex++) {
        $(rowBars[renderIndex]).css('height', trs[renderIndex].offsetHeight + 'px');
      }
      _this.height = tableRoot[0].offsetHeight;
      _this.rowsAddition.css('width', tableRoot[0].offsetWidth + 'px');
      _this.colsAddition.css('height', _this.height + 'px');
    };

    _this.onDragCol = function (e) {
      e.stopPropagation();
      if (!_this.colDragging) return;
      if (undefined === _this.rowDraggingPosiX) {
        _this.rowDraggingPosiX = e.offsetX;
      }
      // dragover会不断的触发事件，这里做一个截流，鼠标在3像素以内不去计算
      if (Math.abs(_this.rowDraggingPosiX - e.offsetX) < 3) return;
      _this.rowDraggingPosiX = e.offsetX;
      _this.dragBar.removeClass('dragging');
      var td = $(e.target).closest('td');
      var colBar = $(e.target).closest(_this.section.template.COLS_HEADER_ITEM_CLASS);
      if (!td[0] && !colBar[0]) return;

      if (colBar[0]) {
        var currentCol = colBar.index();
        var _dropCol = e.offsetX > colBar[0].offsetWidth / 2 ? currentCol + 1 : currentCol;
        _this.showPlaceHolder(_dropCol);
        return;
      }
      var colBars = _this.colsHeader.find(_this.section.template.COLS_HEADER_ITEM_CLASS);
      var colSpan = td[0].colSpan;

      var _this$section$selecti = _this.section.selection.getTdRowCol(td[0]),
          col = _this$section$selecti.col;

      var dropCol = col;
      var _passWidth = 0;

      for (var i = 0; i < colSpan; i++) {
        if (_passWidth + colBars[col + i].offsetWidth / 2 > e.offsetX) {
          dropCol = col + i;
          break;
        }
        if (_passWidth + colBars[col + i].offsetWidth > e.offsetX) {
          dropCol = col + i + 1;
          break;
        }
        _passWidth += colBars[col + i].offsetWidth;
      }
      _this.showPlaceHolder(dropCol);
    };

    _this.onDragRow = function (e) {
      e.stopPropagation();
      if (!_this.rowDragging) return;
      if (undefined === _this.rowDraggingPosiY) {
        _this.rowDraggingPosiY = e.offsetY;
      }
      // dragover会不断的触发事件，这里做一个截流，鼠标在3像素以内不去计算
      if (Math.abs(_this.rowDraggingPosiY - e.offsetY) < 3) return;
      _this.rowDraggingPosiY = e.offsetY;
      _this.dragBar.removeClass('dragging');
      var td = $(e.target).closest('td');
      var rowBar = $(e.target).closest(_this.section.template.ROWS_HEADER_ITEM_CLASS);
      if (!td[0] && !rowBar[0]) return;

      if (rowBar[0]) {
        var currentRow = rowBar.index();
        var _dropRow = e.offsetY > rowBar[0].offsetHeight / 2 ? currentRow + 1 : currentRow;
        _this.showPlaceHolder(_dropRow);
        return;
      }
      var rowBars = _this.rowsHeader.find(_this.section.template.ROWS_HEADER_ITEM_CLASS);
      var rowSpan = td[0].rowSpan;

      var _this$section$selecti2 = _this.section.selection.getTdRowCol(td[0]),
          row = _this$section$selecti2.row;

      var dropRow = row;
      var _passHeight = 0;

      for (var i = 0; i < rowSpan; i++) {
        if (_passHeight + rowBars[row + i].offsetHeight / 2 > e.offsetY) {
          dropRow = row + i;
          break;
        }
        if (_passHeight + rowBars[row + i].offsetHeight > e.offsetY) {
          dropRow = row + i + 1;
          break;
        }
        _passHeight += rowBars[row + i].offsetHeight;
      }
      _this.showPlaceHolder(dropRow);
    };

    _this.showPlaceHolder = function (dropIndex) {
      if (_this.colDragging) {
        if (dropIndex === _this.dropCol) return;
        if (_this.colDraggingIndex.col_min <= dropIndex && dropIndex <= _this.colDraggingIndex.col_max + 1) {
          delete _this.dropCol;
          _this.placeholder.css('display', 'none');
          return;
        }

        _this.dropCol = dropIndex;
        var colBars = _this.colsHeader.find(_this.section.template.COLS_HEADER_ITEM_CLASS);
        var left = _this.dropCol !== colBars.length ? colBars[_this.dropCol].offsetLeft + 2 : colBars[_this.dropCol - 1].offsetLeft + colBars[_this.dropCol - 1].offsetWidth + 2;
        var _this$viewport$ = _this.viewport[0],
            scrollLeft = _this$viewport$.scrollLeft,
            offsetWidth = _this$viewport$.offsetWidth;

        if (left < scrollLeft) {
          _this.viewport[0].scrollLeft = left - 5;
        }
        if (left > scrollLeft + offsetWidth) {
          _this.viewport[0].scrollLeft = left - offsetWidth + 5;
        }
        _this.placeholder.css('width', '3px');
        _this.placeholder.css('height', _this.height + (_this.section.options.type === 'mini' && !_this.section.state.maximize ? 0 : 24) + 'px');
        _this.placeholder.css('left', left + 'px');
        _this.placeholder.css('top', 0 + 'px');
        _this.placeholder.css('display', 'block');
      }

      if (_this.rowDragging) {
        if (dropIndex === _this.dropRow) return;
        if (_this.rowDraggingIndex.row_min <= dropIndex && dropIndex <= _this.rowDraggingIndex.row_max + 1) {
          delete _this.dropRow;
          _this.placeholder.css('display', 'none');
          return;
        }
        _this.dropRow = dropIndex;
        var rowBars = _this.rowsHeader.find(_this.section.template.ROWS_HEADER_ITEM_CLASS);
        var top = _this.dropRow !== rowBars.length ? rowBars[_this.dropRow].offsetTop + 2 : rowBars[_this.dropRow - 1].offsetTop + rowBars[_this.dropRow - 1].offsetHeight + 2;
        _this.placeholder.css('height', '3px');
        _this.placeholder.css('width', _this.width + 'px');
        _this.placeholder.css('left', '3px');
        _this.placeholder.css('top', 21 + top + 'px');
        _this.placeholder.css('display', 'block');
      }
    };

    _this.onDragColEnd = function () {
      _this.unBindDragColEvent();
      if (!_this.colDragging || _this.dropCol === undefined) return;
      var _this$section3 = _this.section,
          command = _this$section3.command,
          selection = _this$section3.selection;

      var _selection$normalizeA = selection.normalizeArea(),
          col_min = _selection$normalizeA.col_min,
          col_max = _selection$normalizeA.col_max;

      var colBars = _this.section.container.find(_this.section.template.COLS_HEADER_ITEM_CLASS);
      var widths = [];
      for (var c = col_min; c <= col_max; c++) {
        widths.push(colBars[c].offsetWidth);
      }
      var dragCount = selection.colCount();
      command.mockCopy();
      if (col_min > _this.dropCol) {
        command.insertColAt(_this.dropCol, dragCount, false, true, widths);
        selection.selectCols(_this.dropCol, _this.dropCol + dragCount - 1);
        command.mockPaste(true);
        selection.selectCols(col_min + dragCount, col_max + dragCount);
        command.removeCol();
        selection.selectCols(_this.dropCol, _this.dropCol + dragCount - 1);
      } else {
        command.insertColAt(_this.dropCol, dragCount, false, true, widths);
        selection.selectCols(_this.dropCol, _this.dropCol + dragCount - 1);
        command.mockPaste(true);
        selection.selectCols(col_min, col_max);
        command.removeCol();
        selection.selectCols(_this.dropCol - dragCount, _this.dropCol - 1);
      }
      _this.placeholder.css('display', 'none');
      _this.colDragging = false;
      delete _this.dropCol;
    };

    _this.onDragRowEnd = function () {
      _this.unBindDragRowEvent();
      if (!_this.rowDragging || _this.dropRow === undefined) return;
      var _this$section4 = _this.section,
          command = _this$section4.command,
          selection = _this$section4.selection;

      var _selection$normalizeA2 = selection.normalizeArea(),
          row_min = _selection$normalizeA2.row_min,
          row_max = _selection$normalizeA2.row_max;

      command.mockCopy();
      if (row_min > _this.dropRow) {
        command.insertRowAt(_this.dropRow, _this.dragCount, false, true);
        selection.selectRows(_this.dropRow, _this.dropRow + _this.dragCount - 1);
        command.mockPaste(true);
        selection.selectRows(row_min + _this.dragCount, row_max + _this.dragCount);
        command.removeRow();
        selection.selectRows(_this.dropRow, _this.dropRow + _this.dragCount - 1);
      } else {
        command.insertRowAt(_this.dropRow, _this.dragCount, false, true);
        selection.selectRows(_this.dropRow, _this.dropRow + _this.dragCount - 1);
        command.mockPaste(true);
        selection.selectRows(row_min, row_max);
        command.removeRow();
        selection.selectRows(_this.dropRow - _this.dragCount, _this.dropRow - 1);
      }
      _this.placeholder.css('display', 'none');
      _this.rowDragging = false;
      delete _this.dropRow;
    };

    _this.unBindDragColEvent = function () {
      var colBars = _this.colsHeader.find(_this.section.template.COLS_HEADER_ITEM_CLASS);
      colBars.removeClass('dragging');
      _this.colsHeader.removeClass('dragging');
      _this.section.container.off('dragover', _this.onDragCol);
      _this.section.container.off('drop', _this.onDragColEnd);
      _this.section.container.off('dragend', _this.onDragColEnd);
    };

    _this.unBindDragRowEvent = function () {
      var rowBars = _this.rowsHeader.find(_this.section.template.ROWS_HEADER_ITEM_CLASS);
      rowBars.removeClass('dragging');
      _this.rowsHeader.removeClass('dragging');
      _this.section.container.off('dragover', _this.onDragRow);
      _this.section.container.off('drop', _this.onDragRowEnd);
      _this.section.container.off('dragend', _this.onDragRowEnd);
    };

    _this.bindDragColEvent = function () {
      _this.section.container.on('dragover', _this.onDragCol);
      _this.section.container.on('drop', _this.onDragColEnd);
      _this.section.container.on('dragend', _this.onDragColEnd);
    };

    _this.bindDragRowEvent = function () {
      _this.section.container.on('dragover', _this.onDragRow);
      _this.section.container.on('drop', _this.onDragRowEnd);
      _this.section.container.on('dragend', _this.onDragRowEnd);
    };

    _this.onDragStartColsHeader = function (e) {
      e.stopPropagation();
      var area = _this.section.selection.area;
      if (!area || !area.total_col) return;
      var colBar = $(e.target).closest(_this.section.template.COLS_HEADER_ITEM_CLASS);
      if (!colBar[0]) return;
      var drag_col = colBar.index();

      var _this$section$selecti3 = _this.section.selection.normalizeArea(),
          col_min = _this$section$selecti3.col_min,
          col_max = _this$section$selecti3.col_max;

      if (drag_col < col_min || drag_col > col_max) return;
      _this.colDragging = true;
      _this.dragBar = colBar;
      _this.colDraggingIndex = {
        col_min: col_min,
        col_max: col_max
      };
      _this.dragCount = _this.section.selection.colCount();
      _this.dragBar.addClass('dragging');
      _this.dragBar.find('.drag-info').html('\u6B63\u5728\u79FB\u52A8 '.concat(_this.dragCount, ' \u5217'));
      _this.colsHeader.addClass('dragging');
      (0, _utils.fixDragEvent)(e);
      _this.bindDragColEvent();
    };

    _this.onDragStartRowsHeader = function (e) {
      e.stopPropagation();
      var area = _this.section.selection.area;
      if (!area || !area.total_row) return;
      var rowBar = $(e.target).closest(_this.section.template.ROWS_HEADER_ITEM_CLASS);
      if (!rowBar[0]) return;
      var drag_row = rowBar.index();

      var _this$section$selecti4 = _this.section.selection.normalizeArea(),
          row_min = _this$section$selecti4.row_min,
          row_max = _this$section$selecti4.row_max;

      if (drag_row < row_min || drag_row > row_max) return;
      _this.rowDragging = true;
      _this.dragBar = rowBar;
      _this.rowDraggingIndex = {
        row_min: row_min,
        row_max: row_max
      };
      _this.dragCount = _this.section.selection.rowCount();
      _this.dragBar.addClass('dragging');
      _this.dragBar.find('.drag-info').html('\u6B63\u5728\u79FB\u52A8 '.concat(_this.dragCount, ' \u884C'));
      _this.rowsHeader.addClass('dragging');
      (0, _utils.fixDragEvent)(e);
      _this.bindDragRowEvent();
    };

    _this.onMouseDownColsHeader = function (e) {
      var _this$section5 = _this.section,
          template = _this$section5.template,
          selection = _this$section5.selection;

      _this.trigger = $(e.target).closest(template.COLS_HEADER_TRIGGER_CLASS);
      if (!_this.trigger[0]) {
        if (e.button === 2) {
          var colHeader = $(e.target).closest(template.COLS_HEADER_ITEM_CLASS);
          if (!colHeader[0]) return;
          var col = colHeader.index();
          var currentColSelected = false;
          if (selection.area && selection.area.total_col) {
            var _selection$normalizeA3 = selection.normalizeArea(),
                col_min = _selection$normalizeA3.col_min,
                col_max = _selection$normalizeA3.col_max;

            if (col >= col_min && col <= col_max) {
              currentColSelected = true;
            }
          }

          if (!currentColSelected) {
            _this.emit('clickColsHeader', col);
          }
          _this.showContextMenu(e);
        }
        return;
      }
      _this.startChangeCol(_this.trigger, e);
    };

    _this.startChangeCol = function (trigger, e) {
      e.stopPropagation();
      e.preventDefault();
      _this.emit('startChangeCellSize');
      _this.dragging = 'col';
      _this.draggingX = e.clientX;
      _this.currentCol = $(trigger[0].parentNode);
      _this.currentColWidth = _this.currentCol[0].offsetWidth;
      _this.width = _this.colsHeader[0].offsetWidth;
      _this.currentColIndex = _this.currentCol.index();
      _this.bindChangeSizeEvent();
    };

    _this.onMouseDownRowsHeader = function (e) {
      var _this$section6 = _this.section,
          template = _this$section6.template,
          selection = _this$section6.selection;

      _this.trigger = $(e.target).closest(template.ROWS_HEADER_TRIGGER_CLASS);
      if (!_this.trigger[0]) {
        if (e.button === 2) {
          var rowHeader = $(e.target).closest(template.ROWS_HEADER_ITEM_CLASS);
          if (!rowHeader[0]) return;
          var row = rowHeader.index();
          var currentRowSelected = false;
          if (selection.area && selection.area.total_row) {
            var _selection$normalizeA4 = selection.normalizeArea(),
                row_min = _selection$normalizeA4.row_min,
                row_max = _selection$normalizeA4.row_max;

            if (row >= row_min && row <= row_max) {
              currentRowSelected = true;
            }
          }

          if (!currentRowSelected) {
            _this.emit('clickRowsHeader', row);
          }
          _this.showContextMenu(e);
        }
        return;
      }
      _this.startChangeRow(_this.trigger, e);
    };

    _this.startChangeRow = function (trigger, e) {
      e.stopPropagation();
      e.preventDefault();
      _this.emit('startChangeCellSize');
      _this.dragging = 'row';
      _this.draggingY = e.clientY;
      _this.currentRow = $(trigger[0].parentNode);
      _this.currentRowHeight = _this.currentRow[0].offsetHeight;
      _this.currentRowIndex = _this.currentRow.index();
      _this.bindChangeSizeEvent();
    };

    _this.onChangeSize = function (e) {
      if (!_this.dragging) return;
      if (_this.dragging === 'row') {
        _this.onChangeRowHeight(e);
      } else if (_this.dragging === 'col') {
        _this.onChangeColWidth(e);
      }
    };

    _this.onChangeColWidth = function (e) {
      var dx = e.clientX - _this.draggingX;
      var itemWidth = Math.max(_this.MIN_WIDTH, _this.currentColWidth + dx);
      dx = itemWidth - _this.currentColWidth;
      var tableWidth = _this.width + dx;
      _this.currentCol.css('width', itemWidth + 'px');
      _this.colsHeader.css('width', tableWidth + 'px');
      var viewport = _this.viewport[0];
      // 拖到边界时，需要滚动表格视窗的滚动条
      var currentColRightSide = _this.currentCol[0].offsetLeft + _this.currentCol[0].offsetWidth;
      if (currentColRightSide - viewport.scrollLeft + 20 > viewport.offsetWidth) {
        // 拖宽单元格时，若右侧已经到边，需要滚动左侧的滚动条
        viewport.scrollLeft = currentColRightSide + 20 - viewport.offsetWidth;
      } else if (viewport.scrollLeft + viewport.offsetWidth === viewport.scrollWidth) {
        // 拖窄单元格时，若右侧已经到边，需要滚动左侧的滚动条
        viewport.scrollLeft = Math.max(0, tableWidth + 34 - viewport.offsetWidth);
      }
      _this.clearActiveStatus();
      _this.hideContextMenu();
      _this.renderRowBars();
      _this.renderColSplitBars();
      _this.changeColWidth(itemWidth, tableWidth);
    };

    _this.onChangeRowHeight = function (e) {
      var dy = e.clientY - _this.draggingY;
      var itemHeight = Math.max(_this.MIN_HEIGHT, _this.currentRowHeight + dy);
      dy = itemHeight - _this.currentRowHeight;
      _this.currentRow.css('height', itemHeight + 'px');
      _this.clearActiveStatus();
      _this.hideContextMenu();
      _this.renderRowSplitBars();
      _this.changeRowHeight(itemHeight);
      _this.emit('heightchanging');
    };

    _this.changeColWidth = function (colWidth, tableWidth) {
      var tableRoot = _this.section.tableRoot;
      var cols = tableRoot.find('col');
      tableRoot.css('width', tableWidth + 'px');
      $(cols[_this.currentColIndex]).attr('width', colWidth);
    };

    _this.changeRowHeight = function (rowHeight) {
      var tableRoot = _this.section.tableRoot;
      var trs = tableRoot.find('tr');
      $(trs[_this.currentRowIndex]).css('height', rowHeight + 'px');
    };

    _this.renderColSplitBars = function () {
      _this.trigger.addClass('dragging').css('height', _this.height + (_this.section.options.type === 'mini' && !_this.section.state.maximize ? 0 : 24) + 'px');
    };

    _this.renderRowSplitBars = function () {
      var width = Math.min(_this.viewport[0].offsetWidth, _this.width);
      _this.trigger.addClass('dragging').css('width', width + (_this.section.options.type === 'mini' && !_this.section.state.maximize ? 0 : 24) + 'px');
    };

    _this.onChangeSizeEnd = function (e) {
      if (e.type === 'mouseleave' && _this.section.container.contains(e.toElement)) {
        return;
      }

      if (_this.dragging) {
        if (_this.section.options.type === 'mini' && !_this.section.state.maximize) {
          var triggerCols = _this.section.container.find(_this.section.template.COLS_HEADER_TRIGGER_CLASS);
          var triggerRows = _this.section.container.find(_this.section.template.ROWS_HEADER_TRIGGER_CLASS);
          triggerCols.css('height', _this.section.tableRoot[0].offsetHeight + 'px');
          var tableWidth = _this.section.tableRoot[0].offsetWidth;
          var wrapperWidth = _this.section.tableWrapper[0].offsetWidth;
          triggerRows.css('width', (tableWidth > wrapperWidth ? wrapperWidth : tableWidth) + 'px');
        }
        _this.trigger.removeClass('dragging');
        if (_this.dragging === 'col' && _this.section.options.type !== 'mini') {
          _this.trigger.css('height', '17px');
        }

        if (_this.dragging === 'row' && _this.section.options.type !== 'mini') {
          _this.trigger.css('width', '17px');
        }
        _this.dragging = null;
        // 拖完再渲染一次，行高会受内容限制，无法拖到你想要的高度
        _this.renderRowBars();
        _this.unBindChangeSizeEvent();
        _this.width = _this.section.tableRoot[0].offsetWidth;
        _this.height = _this.section.tableRoot[0].offsetHeight;
        _this.emit('sizeChanged');
      }
    };

    _this.hide = function () {
      _this.tableWrapper.removeClass('editing');
      _this.hideContextMenu();
      _this.hideMultiAddition();
    };

    _this.show = function () {
      _this.tableWrapper.addClass('editing');
    };

    _this.clearActiveStatus = function () {
      var template = _this.section.template;
      var colBars = _this.colsHeader.find(template.COLS_HEADER_ITEM_CLASS);
      var rowBars = _this.rowsHeader.find(template.ROWS_HEADER_ITEM_CLASS);
      colBars.removeClass('active');
      colBars.removeClass('selected');
      colBars.removeClass('no-dragger');
      rowBars.removeClass('active');
      rowBars.removeClass('selected');
      rowBars.removeClass('no-dragger');
      _this.tableHeader.removeClass('selected');
    };

    _this.activeHeader = function () {
      var _this$section7 = _this.section,
          selection = _this$section7.selection,
          template = _this$section7.template;
      var area = selection.area,
          tableModel = selection.tableModel;

      _this.clearActiveStatus();
      if (!area) return;
      var colBars = _this.colsHeader.find(template.COLS_HEADER_ITEM_CLASS);
      var rowBars = _this.rowsHeader.find(template.ROWS_HEADER_ITEM_CLASS);
      var total_col = area.total_col,
          total_row = area.total_row,
          total_table = area.total_table;

      var _selection$normalizeA5 = selection.normalizeArea(),
          row_min = _selection$normalizeA5.row_min,
          row_max = _selection$normalizeA5.row_max,
          col_min = _selection$normalizeA5.col_min,
          col_max = _selection$normalizeA5.col_max;

      for (var r = row_min; r <= row_max; r++) {
        $(rowBars[r]).addClass('active');
        if (total_row || total_table) {
          $(rowBars[r]).addClass('selected');
        }

        if (total_table) {
          $(rowBars[r]).addClass('no-dragger');
        }
      }

      for (var c = col_min; c <= col_max; c++) {
        $(colBars[c]).addClass('active');
        if (total_col || total_table) {
          $(colBars[c]).addClass('selected');
        }
        if (total_table) {
          $(colBars[c]).addClass('no-dragger');
        }
      }
      var table_select = row_min === 0 && row_max === tableModel.rows - 1 && col_min === 0 && col_max === tableModel.cols - 1;
      if (table_select) {
        _this.tableHeader.addClass('selected');
      } else {
        _this.tableHeader.removeClass('selected');
      }
    };

    _this.removeRow = function (index) {
      var template = _this.section.template;
      var rowsHeaderItem = _this.rowsHeader.find(template.ROWS_HEADER_ITEM_CLASS);
      _this.rowsHeader[0].removeChild(rowsHeaderItem[index]);
    };

    _this.removeCol = function (index) {
      var template = _this.section.template;
      var colsHeaderItem = _this.colsHeader.find(template.COLS_HEADER_ITEM_CLASS);
      _this.colsHeader.css('width', _this.colsHeader[0].offsetWidth - colsHeaderItem[index].offsetWidth + 'px');
      _this.colsHeader[0].removeChild(colsHeaderItem[index]);
      _this.section.tableRoot.css('width', _this.colsHeader.css('width'));
    };

    _this.clickRowsHeader = function (e) {
      var template = _this.section.template;
      var trigger = $(e.target).closest(template.ROWS_HEADER_TRIGGER_CLASS);
      if (trigger[0]) return;
      var rowHeader = $(e.target).closest(template.ROWS_HEADER_ITEM_CLASS);
      if (!rowHeader[0]) return;
      _this.emit('clickRowsHeader', rowHeader.index());
    };

    _this.clickColsHeader = function (e) {
      var template = _this.section.template;
      var trigger = $(e.target).closest(template.COLS_HEADER_TRIGGER_CLASS);
      if (trigger[0]) return;
      var colHeader = $(e.target).closest(template.COLS_HEADER_ITEM_CLASS);
      if (!colHeader[0]) return;
      _this.emit('clickColsHeader', colHeader.index());
    };

    _this.clickTableHeader = function () {
      _this.emit('clickTableHeader');
    };

    _this.handleClickContainer = function (e) {
      var td = $(e.target).closest('td');
      if (!td[0]) {
        var mask = $(e.target).closest('.mask');
        if (!mask[0]) {
          return;
        }
      }
      if (e.button === 2) {
        e.preventDefault();
        _this.showContextMenu(e);
      } else {
        _this.hideContextMenu();
        _this.hideMultiAddition();
      }
    };

    _this.handleHoverMenu = function (e) {
      var menu = $(e.target).closest('.table-menubar-item');
      if (!menu[0]) return;
      e.stopPropagation();
      if (!menu.hasClass('disabled')) {
        var action = menu.attr('data-action');
        _this.section.selection.preview(action);
      }
    };

    _this.handleLeaveMenu = function (e) {
      e.stopPropagation();
      _this.section.selection.preview();
    };

    _this.handleClickMenu = function (e) {
      var menu = $(e.target).closest('.table-menubar-item');
      if (!menu[0]) return;
      e.stopPropagation();
      if (!menu.hasClass('disabled')) {
        var action = menu.attr('data-action');
        _this.section.command[action]();
      }
      _this.hideContextMenu();
    };

    _this.hideContextMenu = function () {
      if (!_this.contextVisible) {
        return;
      }
      _this.contextVisible = false;
      _this.menuBar.css('display', 'none');
    };

    _this.getMenuDisabled = function (action) {
      switch (action) {
        case 'splitCell':
          return !_this.section.selection.hasMergeCell();
        case 'mergeCell':
          return _this.section.selection.isSingleArea();
        case 'mockPaste':
          return !_this.section.command.hasCopyData();
        case 'removeCol':
        case 'insertColLeft':
        case 'insertColRight':
          return _this.section.selection.isRowSelected();
        case 'removeRow':
        case 'insertRowUp':
        case 'insertRowDown':
          return _this.section.selection.isColSelected();
        default:
          return false;
      }
    };

    _this.showContextMenu = function (e) {
      var area = _this.section.selection.area;
      var currentTd = $(e.target).closest('td')[0];
      if (!currentTd && !area) return;

      var menuItems = _this.menuBar.find(_this.section.template.MENUBAR_ITEM_CLASS);
      var y = Math.min(Math.max(120, document.body.offsetHeight - 500), e.clientY);
      menuItems.removeClass('disabled');
      menuItems.each(function (menu) {
        var action = $(menu).attr('data-action');
        if (_this.getMenuDisabled(action)) {
          $(menu).addClass('disabled');
        }
      });
      _this.menuBar.css('left', e.clientX + 30 + 'px');
      _this.menuBar.css('top', y + 'px');
      _this.menuBar.css('display', 'block');
      _this.contextVisible = true;
    };

    _this.focusTextArea = function () {
      if (_this.focusTimer) {
        clearTimeout(_this.focusTimer);
      }
      _this.focusTimer = setTimeout(function () {
        // 先失焦再聚焦，保证能真的 focus,否则可能出现多次聚焦失效的情况
        _this.textArea[0].value = '';
        _this.textArea[0].blur();
        _this.textArea[0].focus();
      }, 100);
    };

    _this.filterEvent = function (e) {
      var template = _this.section.template;
      var tagName = (e.target || e.srcElement).tagName.toLocaleUpperCase();
      var target = $(e.target).closest(template.TABLE_TEXTAREA_CLASS);
      return !!target[0] || !(tagName === 'INPUT' || tagName === 'SELECT' || tagName === 'TEXTAREA');
    };

    _this.bindChangeSizeEvent = function () {
      _this.colsHeader.addClass('resize');
      _this.rowsHeader.addClass('resize');
      document.addEventListener('mousemove', _this.onChangeSize);
      document.addEventListener('mouseup', _this.onChangeSizeEnd);
      document.addEventListener('mouseleave', _this.onChangeSizeEnd);
    };

    _this.unBindChangeSizeEvent = function () {
      _this.colsHeader.removeClass('resize');
      _this.rowsHeader.removeClass('resize');
      document.removeEventListener('mousemove', _this.onChangeSize);
      document.removeEventListener('mouseup', _this.onChangeSizeEnd);
      document.removeEventListener('mouseleave', _this.onChangeSizeEnd);
    };

    _this.onMultiChangeRowCol = function (value, type) {
      var _this$section$selecti5 = _this.section.selection.tableModel,
          rows = _this$section$selecti5.rows,
          cols = _this$section$selecti5.cols;

      if (type === 'row') {
        value = Math.max(_this.contentRow + 1, value);
        if (value > rows) {
          _this.section.command.insertRow('end', value - rows);
        } else if (value < rows) {
          _this.section.selection.selectRows(value, rows - 1);
          _this.section.command.removeRow();
        }
      }
      if (type === 'col') {
        value = Math.max(_this.contentCol + 1, value);
        if (value > cols) {
          _this.section.command.insertCol('end', value - cols);
        } else if (value < cols) {
          _this.section.selection.selectCols(value, cols - 1);
          _this.section.command.removeCol();
        }
      }
      _this.section.selection.clear();
    };

    _this.showMultiAddition = function (e, type) {
      var trigger = $(e.target).closest('.multi-trigger');
      if (!trigger[0]) return;
      var offsetX = e.offsetX,
          offsetY = e.offsetY,
          clientX = e.clientX,
          clientY = e.clientY;

      _this.section.selection.clear();

      var _getContentArea = (0, _utils.getContentArea)(_this.section.selection.tableModel),
          row = _getContentArea.row,
          col = _getContentArea.col;

      _this.contentRow = row;
      _this.contentCol = col;
      var left = void 0;
      var top = void 0;
      var count = void 0;
      var min = void 0;
      var max = void 0;

      if (type === 'row') {
        left = clientX - offsetX - 44;
        top = clientY - offsetY;
        count = _this.section.selection.tableModel.rows;
        min = row + 1;
        max = Math.max(min + 50, count);
      }

      if (type === 'col') {
        left = clientX - offsetX - 28;
        top = clientY - offsetY - 17;
        count = _this.section.selection.tableModel.cols;
        min = col + 1;
        max = Math.max(min + 10, count);
      }

      left = Math.max(0, left);
      _this.multiAddition.css('left', left + 'px');
      _this.multiAddition.css('top', top + 'px');
      _this.multiAddition.css('display', 'block');
      _this.multiAdditionVisible = true;
      _reactDom2.default.unmountComponentAtNode(_this.multiAddition[0]);
      _reactDom2.default.render(_react2.default.createElement(_antd.InputNumber, {
        defaultValue: count,
        min: min,
        max: max,
        step: 1,
        onChange: function onChange(value) {
          _this.onMultiChangeRowCol(Math.max(min, Math.min(max, value)), type);
        }
      }), _this.multiAddition[0]);
    };

    _this.hideMultiAddition = function () {
      if (!_this.multiAdditionVisible) {
        return;
      }
      _this.multiAdditionVisible = false;
      _this.multiAddition.css('display', 'none');
    };

    _this.refresh = function (action) {
      _this.hideContextMenu();
      _this.render(action);
      _this.show();
      _this.activeHeader();
      _this.focusTextArea();
    };

    _this.bindEvents = function () {
      _this.colsHeader.on('mousedown', _this.onMouseDownColsHeader).on('click', _this.clickColsHeader).on('dragstart', _this.onDragStartColsHeader);
      _this.rowsHeader.on('mousedown', _this.onMouseDownRowsHeader).on('click', _this.clickRowsHeader).on('dragstart', _this.onDragStartRowsHeader);
      _this.tableHeader.on('click', _this.clickTableHeader);
      _this.rowsAddition.on('click', function () {
        _this.section.command.insertRow();
      });
      _this.colsAddition.on('click', function () {
        _this.section.command.insertCol();
      });
      _this.rowsAdditionHeader.on('click', function (e) {
        _this.showMultiAddition(e, 'row');
      });
      _this.colsAdditionHeader.on('click', function (e) {
        _this.showMultiAddition(e, 'col');
      });
      _this.section.container.on('mousedown', _this.handleClickContainer);
      _this.section.container.on('dragover', function (e) {
        return e.stopPropagation();
      });
      _this.menuBar.on('click', _this.handleClickMenu);
      _this.menuBar.on('mouseover', _this.handleHoverMenu);
      _this.menuBar.on('mouseleave', _this.handleLeaveMenu);
      _this.textArea.on('paste', _this.section.command.shortcutPaste);
      _this.textArea.on('copy', _this.section.command.shortcutCopy);
      _this.textArea.on('cut', _this.section.command.shortcutCut);
    };

    _this.section = section;
    _this.dragging = false;
    _this.draggingX = 0;
    _this.draggingY = 0;
    _this.width = 0;
    _this.height = 0;
    _this.MIN_WIDTH = 40;
    _this.MIN_HEIGHT = 33;
    _this.currentCol = null;
    _this.currentColWidth = 0;
    _this.currentColIndex = 0;
    _this.currentRow = null;
    _this.currentRowHeight = 0;
    _this.currentRowIndex = 0;
    return _this;
  }

  _createClass(ControllBar, [{
    key: 'init',
    value: function init() {
      var _section = this.section,
          container = _section.container,
          template = _section.template;

      this.colsHeader = container.find(template.COLS_HEADER_CLASS);
      this.rowsHeader = container.find(template.ROWS_HEADER_CLASS);
      this.rowsAddition = container.find(template.ROWS_ADDITION_CLASS);
      this.colsAddition = container.find(template.COLS_ADDITION_CLASS);
      this.rowsAdditionHeader = container.find(template.ROWS_ADDITION_HEADER_CLASS);
      this.colsAdditionHeader = container.find(template.COLS_ADDITION_HEADER_CLASS);
      this.multiAddition = container.find(template.MULTI_ADDITION_CLASS);
      this.tableHeader = container.find(template.HEADER_CLASS);
      this.menuBar = container.find(template.MENUBAR_CLASS);
      this.textArea = container.find(template.TABLE_TEXTAREA_CLASS);
      this.viewport = container.find(template.VIEWPORT);
      this.placeholder = container.find(template.PLACEHOLDER_CLASS);
      this.tableWrapper = container.find(template.TABLE_WRAPPER_CLASS);
      this.render();
      this.hide();
      this.bindEvents();
    }
  }]);

  return ControllBar;
}(_eventemitter.EventEmitter2);

exports.default = ControllBar;