"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MAX_UNDO_COUNT = 100;

var History = function () {
    function History(section) {
        _classCallCheck(this, History);

        this.section = section;
        this.data = [];
        this.index = 0;
    }

    _createClass(History, [{
        key: "undo",
        value: function undo() {
            if (this.index === 0) return;
            this.index--;
            this.section.reRender(this.data[this.index]);
        }
    }, {
        key: "redo",
        value: function redo() {
            if (!this.data[this.index + 1]) return;
            this.index++;
            this.section.reRender(this.data[this.index]);
        }
    }, {
        key: "isEnd",
        value: function isEnd() {
            return this.index >= this.data.length - 1;
        }
    }, {
        key: "clear",
        value: function clear() {
            this.data = [];
            this.index = 0;
        }
    }, {
        key: "save",
        value: function save(value) {
            if (this.data[this.index]) {
                this.index++;
            }
            this.data = this.data.slice(0, this.index);
            if (this.data.length >= MAX_UNDO_COUNT) {
                this.data.shift();
                this.index--;
            }
            this.data[this.index] = value;
            this.index++;
        }
    }]);

    return History;
}();

exports.default = History;