'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _keymaster = require('keymaster');

var _keymaster2 = _interopRequireDefault(_keymaster);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var $ = _tinsoEditorEngine2.default.$;


var hotkey = {
  handler: {},
  filter: function filter(section) {
    _keymaster2.default.filter = function (e) {
      var template = section.template;
      var tagName = (e.target || e.srcElement).tagName.toLocaleUpperCase();
      var target = $(e.target).closest(template.TABLE_TEXTAREA_CLASS);
      if (!!target[0]) return true;
      return !(tagName === 'INPUT' || tagName === 'SELECT' || tagName === 'TEXTAREA');
    };
  },
  add: function add(key, callback) {
    var _this = this;

    if (this.handler[key]) {
      this.handler[key].push(callback);
      return;
    }
    this.handler[key] = [callback];
    (0, _keymaster2.default)(key, function (e) {
      _this.handler[key].forEach(function (fn) {
        fn(e);
      });
    });
  },
  clear: function clear() {}
};

var Hotkey = function () {
  function Hotkey(section) {
    _classCallCheck(this, Hotkey);

    this.section = section;
    hotkey.filter(section);
  }

  _createClass(Hotkey, [{
    key: 'add',
    value: function add(key, callback) {
      var _this2 = this;

      hotkey.add(key, function (e) {
        if (!_this2.section || !_this2.section.active) return;
        callback(e);
      });
    }
  }]);

  return Hotkey;
}();

exports.default = Hotkey;