'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _en = require('./locale/en');

var _en2 = _interopRequireDefault(_en);

var _zhCn = require('./locale/zh-cn');

var _zhCn2 = _interopRequireDefault(_zhCn);

var _toolbar = require('./toolbar');

var _toolbar2 = _interopRequireDefault(_toolbar);

var _toolbarMini = require('./toolbar-mini');

var _toolbarMini2 = _interopRequireDefault(_toolbarMini);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

var _template = require('./template');

var _template2 = _interopRequireDefault(_template);

var _controllbar = require('./controllbar');

var _controllbar2 = _interopRequireDefault(_controllbar);

var _command = require('./command');

var _command2 = _interopRequireDefault(_command);

var _hotkey = require('./hotkey');

var _hotkey2 = _interopRequireDefault(_hotkey);

var _history = require('./history');

var _history2 = _interopRequireDefault(_history);

var _selection = require('./selection');

var _selection2 = _interopRequireDefault(_selection);

var _scrollbar = require('../../scrollbar');

var _scrollbar2 = _interopRequireDefault(_scrollbar);

var _schema = require('./schema');

var _schema2 = _interopRequireDefault(_schema);

var _utils = require('./utils');

var _engine = require('../../editor/engine');

var _engine2 = _interopRequireDefault(_engine);

var _config = require('../../schema/config');

var _config2 = _interopRequireDefault(_config);

var _dom = require('../../utils/dom');

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getKeys = function getKeys(keyString) {
  var keys = null;
  if (keyString) {
    keys = [];
    keyString.split('+').forEach(function (key) {
      keys.push(key.trim(), '+');
    });
    if (keys.length > 0) delete keys[keys.length - 1];
  }
  return keys;
};

var locale = {
  en: _en2.default,
  'zh-cn': _zhCn2.default
};

var Table = function (_SectionBase) {
  _inherits(Table, _SectionBase);

  function Table(engine, contentView) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this));

    _this.destroy = function () {
      _this.active = false;
      _this.unBindKeyEvents();
      _this.engine.toolbar.restore();
    };

    _this.activate = function () {
      _this.active = true;
      _this.container.css('user-select', 'none');
      if (!_this.mobile) {
        if (_this.engine.options.type === 'mini') {
          _this.engine.toolbar.set((0, _toolbarMini2.default)(_this));
        } else {
          _this.engine.toolbar.set((0, _toolbar2.default)(_this));
        }
      }
      _this.controllBar.refresh();
    };

    _this.unactivate = function () {
      _this.active = false;
      _this.container.css('user-select', 'auto');
      _this.selection.clear();
      _this.controllBar.hide();
      _this.removeEditor();
      _this.engine.toolbar.restore();
    };

    _this.embedToolbar = function () {
      var options = _this.engine ? _this.engine.options : _this.contentView.options;
      var config = options.table || {};
      var embed = [{
        type: 'dnd'
      }, {
        type: 'maximize'
      }, {
        type: 'separator'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }];
      if (_this.mobile) {
        embed = [{
          type: 'copy'
        }, {
          type: 'delete'
        }];
      } else if (options.type === 'mini') {
        embed = [{
          type: 'maximize'
        }, {
          type: 'separator'
        }, {
          type: 'copy'
        }, {
          type: 'delete'
        }];
      }

      if (Array.isArray(config.embed)) {
        return config.embed;
      } else if (_typeof(config.embed) === 'object') {
        var embedArray = [];
        embed.forEach(function (item) {
          if (config.embed[item.type] !== false) {
            embedArray.push(item);
          }
        });
        return embedArray;
      } else {
        return embed;
      }
    };

    _this.maximize = function () {
      _this.scrollbar.refresh();
      if (_this.engine) {
        _this.fullscreen = true;
        _this.setSectionValue();
        _this.controllBar.hideMultiAddition();
      }
      if (_this.options.type === 'mini') {
        var triggerCols = _this.container.find(_this.template.COLS_HEADER_TRIGGER_CLASS);
        var triggerRows = _this.container.find(_this.template.ROWS_HEADER_TRIGGER_CLASS);
        triggerCols.css('height', '100%');
        triggerRows.css('width', '100%');
        _this.onTableSizeChange();
      }
    };

    _this.restore = function () {
      _this.scrollbar.refresh();
      if (_this.engine) {
        _this.fullscreen = false;
        _this.history.clear();
        _this.controllBar.hideMultiAddition();
      }
      if (_this.options.type === 'mini') {
        _this.onTableSizeChange();
      }
    };

    _this.handleTdChanged = function () {
      if (!_this.subEngine) {
        return;
      }
      // 输入字符的时候可能会撑大单元格，需要同步调整选区和控制条
      _this.subEngine.td.html(_engine2.default.StringUtils.transformCustomTags(_this.subEngine.change.getValue()));
      _this.subEngine.section.renderAll(_this.subEngine.td, undefined, _this.subEngine);
      _this.command.changed();
      _this.delayToUpdateToolbar();
      var tdHeight = _this.subEngine.td[0].offsetHeight;
      if (!_this.tdHeight || tdHeight !== _this.tdHeight) {
        _this.tdHeight = tdHeight;
        _this.controllBar.render('input');
        _this.selection.reRenderActiveBox();
      }
      _this.onTableSizeChange();
    };

    _this.startEdit = function (e) {
      if (!_this.active) {
        return;
      }
      var hideTextarea = _engine2.default.$(e.target).closest(_this.template.TABLE_TEXTAREA_CLASS);
      if (!hideTextarea[0]) {
        return;
      }
      // 兼容 输入英文 和 输入中文 两种情况
      // 中文通过 compositionend 触发
      // 英文通过 input 触发
      // safari 的 input 事件对象没有 isComposing 属性，而是 inputType
      // safari 输入中文的事件顺序包括：
      //   1.输入字母触发，inputType 为 insertCompositionText 的 input 事件
      //   2.选中中文字符时，依次再触发 deleteCompositionText 的 input 事件 将字母删掉，然后是 insertFromComposition 将中文字符输入
      // 同时 safari 也支持 compositionend 事件，只需要将输中文的字母事件都阻止掉即可
      if (e.type === 'input' && (e.isComposing || e.inputType === 'insertCompositionText' || e.inputType === 'deleteCompositionText' || e.inputType === 'insertFromComposition')) {
        return;
      }
      // 已经有激活的编辑单元格时
      if (_this.subEngine) return;
      if (_this.selection.td && _this.selection.single) {
        // firefox 输入英文是，e.data 为 undefined 需要从 target 里取
        _this.createEditor(_engine2.default.$(_this.selection.td), '<p>'.concat(e.data || e.target.value, '</p>'));
      }
    };

    _this.saveValue = function () {
      _this.setSectionValue(true);
    };

    _this.setSectionValue = function (self) {
      var tableModel = _this.selection.tableModel;
      var html = _this.tableRoot[0].outerHTML;
      if (html === _this.lastSaveHtml) return;
      _this.lastSaveHtml = html;
      // 根据主编辑器的过滤和转换规则，处理 HTML 代码
      html = new _engine2.default.HTMLParser(html, _this.engine.schema, _this.engine.conversion).toValue();
      var value = {
        rows: tableModel.rows,
        cols: tableModel.cols,
        html: html
      };
      _this.sectionManage.setValue(_this.sectionRoot, value);
      // 自己撤销时的渲染，也需要设置value, 但不记录历史记录
      if (self) {
        return;
      }
      // 保存 undo 记录
      if (_this.fullscreen) {
        _this.history.save(value);
      }
      _this.engine.history.save();
    };

    _this.tryUndo = function () {
      if (_this.subEngine) {
        if (_this.subEngine.history.index === 0) {
          _this.removeEditor(true);
        }
        return;
      }
      _this.undo();
    };

    _this.tryRedo = function () {
      if (_this.subEngine) {
        return;
      }
      _this.redo();
    };

    _this.undo = function () {
      if (_this.subEngine && _this.subEngine.history.hasUndo) {
        _this.subEngine.command.execute('undo');
        return;
      }

      if (_this.subEngine) {
        _this.removeEditor(true);
        return;
      }

      if (_this.fullscreen) {
        _this.history.undo();
      } else {
        _this.focusSection();
        _this.engine.command.execute('undo');
      }
    };

    _this.focusSection = function () {
      _this.engine.change.selectSection(_this.sectionRoot);
      _this.engine.change.focus();
    };

    _this.redo = function () {
      if (_this.subEngine) {
        _this.subEngine.command.execute('redo');
        return;
      }

      if (_this.fullscreen) {
        _this.history.redo();
      } else {
        _this.engine.command.execute('redo');
      }
    };

    _this.delayToUpdateToolbar = function () {
      if (_this.toolbarTimer) {
        clearTimeout(_this.toolbarTimer);
      }
      _this.toolbarTimer = setTimeout(function () {
        _this.engine.toolbar.updateState();
      }, 100);
    };

    _this.isEditing = function (td) {
      return _this.subEngine && td[0] === _this.subEngine.td[0];
    };

    _this.createEditor = function (td, content) {
      // 已经创建
      if (_this.isEditing(td)) {
        return;
      }
      // 开始创建小编辑器
      _this.selection.showSubEditor();
      var imageOptions = _extends({}, _this.engine.options.image, {
        fixSize: true,
        hideEmbedToolbar: false
      });

      _this.subEngine = _engine2.default.create(_this.selection.editAreaContent, {
        plugins: ['bold', 'italic', 'fontcolor', 'fontsize', 'strikethrough', 'underline', 'backcolor', 'removeformat', 'code', 'file', 'label', 'list', 'link', 'image', 'tasklist', 'indent', 'emoji'],
        lang: _this.engine.options.lang,
        image: imageOptions,
        emoji: _this.engine.options.emoji,
        onBeforeRenderImage: _this.engine.options.onBeforeRenderImage,
        file: _this.engine.options.file
      });
      _this.subEngine.uploader = _this.engine.uploader;
      _this.subEngine.td = td;
      _this.subEngine.locale = _this.engine.locale;
      _this.subEngine.schema.add(_this.innerSchema);
      _this.delayToUpdateToolbar();
      _this.subEngine.change.setValue((0, _utils.unWrapperTableHTML)(td.html()));
      if (content) {
        // 拷贝过来的 html 中可能会包含 table Section的容器层，需要去掉，否则还会被 render 出来。
        var html = (0, _utils.unWrapperTableHTML)(content);
        html = new _engine2.default.HTMLParser(html, _this.subEngine.schema, _this.subEngine.conversion).toValue();
        _this.subEngine.command.execute('selectall');
        _this.subEngine.change.setValue(html);
        _this.handleTdChanged();
      }

      setTimeout(function () {
        if (!_this.subEngine) return;
        _this.subEngine.focusToEnd();
      }, 10);
      _this.subEngine.on('change', _this.handleTdChanged);
      _this.subEngine.on('select', _this.delayToUpdateToolbar);
      _this.subEngine.on('paste:origin', _utils.unWrapperTable);
      // 单元格内不允许输入 tab，外部会切换单元格，用户需要用空格代替
      _this.subEngine.on('keydown:tab', function () {
        return false;
      });
    };

    _this.removeEditor = function (silence) {
      // 已经被移除
      if (!_this.subEngine) {
        return;
      }
      _this.handleTdChanged();
      _this.subEngine.destroy();
      _this.subEngine = null;
      _this.selection.hideSubEditor();
      // 更新Section数据
      if (!silence) {
        _this.setSectionValue();
      }
    };

    _this.prevent = function (e) {
      var table = _engine2.default.$(e.target).closest('.zacheditor-table');
      if (table[0]) {
        e.preventDefault();
      }
    };

    _this.unBindKeyEvents = function () {
      document.removeEventListener('contextmenu', _this.prevent);
    };

    _this.bindKeyEvents = function () {
      _this.hotkey.add('backspace, del, delete', _this.command.clear);
      _this.hotkey.add('up', _this.selection.selectUp);
      _this.hotkey.add('down', _this.selection.selectDown);
      _this.hotkey.add('left', _this.selection.selectLeft);
      _this.hotkey.add('right', _this.selection.selectRight);
      _this.hotkey.add('tab, shift+tab', _this.tab);
      _this.hotkey.add('enter', _this.selection.selectEnter);
      _this.hotkey.add('esc', _this.selection.cancelSelect);
      _this.hotkey.add('command+a, ctrl+a', _this.selection.selectTable);
      _this.hotkey.add('command+z, ctrl+z', _this.tryUndo);
      _this.hotkey.add('command+b, ctrl+b', function () {
        _this.command.execute('bold');
      });
      _this.hotkey.add('command+i, ctrl+i', function () {
        _this.command.execute('italic');
      });
      _this.hotkey.add('command+u, ctrl+u', function () {
        _this.command.execute('underline');
      });
      _this.hotkey.add('command+shift+x, ctrl+shift+x', function () {
        _this.command.execute('strikethrough');
      });

      _this.hotkey.add('command+y, command+shift+z, ctrl+y, ctrl+shift+z', _this.tryRedo);
      document.addEventListener('contextmenu', _this.prevent);
    };

    _this.tab = function (e) {
      if (_this.subEngine) {
        _this.subEngine.command.queryState('tasklist');
      } else _this.selection.selectTab(e);
    };

    _this.bindEditEvents = function () {
      if (_this.inited) return;
      _this.controllBar.on('startChangeCellSize', _this.selection.clear);
      _this.controllBar.on('clickColsHeader', _this.selection.selectCol);
      _this.controllBar.on('clickRowsHeader', _this.selection.selectRow);
      _this.controllBar.on('clickTableHeader', _this.selection.selectTable);
      _this.controllBar.on('sizeChanged', function () {
        _this.setSectionValue();
        _this.scrollbar.refresh();
      });

      _this.controllBar.on('heightchanging', function () {
        _this.onTableSizeChange();
      });

      _this.command.on('actioned', function (action, silence) {
        if (action === 'paste' || action === 'fontstyle') {
          _engine2.default.section.renderAll(_this.container, undefined, _this.engine);
        }
        _this.removeEditor();
        _this.controllBar.render(action);
        _this.selection.render(action);
        _this.scrollbar.refresh();
        if (!silence) {
          _this.setSectionValue();
        }
      });

      _this.command.on('tableRemoved', _this.destroy);
      _this.selection.on('select', function () {
        _this.delayToUpdateToolbar();
        _this.removeEditor();
        _this.controllBar.refresh('select');
      });

      _this.selection.on('cancelSelect', function () {
        _this.removeEditor();
        _this.controllBar.clearActiveStatus();
      });
      _this.selection.on('active', _this.createEditor);
      _this.container.on('compositionend', _this.startEdit);
      _this.container.on('input', _this.startEdit);
      _this.container.on('select', _this.prevent);
      _this.bindKeyEvents();
      _this.engine.on('save:before', function () {
        return _this.setSectionValue();
      });
      _this.inited = true;
    };

    _this.reRender = function (value) {
      _this.delayToUpdateToolbar();
      if (!value) return;
      _this.container.html('');
      _this.render(_this.container, value, true);
    };

    _this.engine = engine;
    _this.contentView = contentView;
    var options = engine ? engine.options : contentView.options;
    _this.locale = locale[options.lang || 'en'];
    _this.constants = (0, _constants2.default)(_this);
    _this.options = options.table || {};
    _this.options.type = _this.options.type || (['mini', 'mobile', 'line'].indexOf(options.type) > -1 ? 'mini' : 'max');
    _this.template = (0, _template2.default)(_this);

    if (!engine) {
      return _possibleConstructorReturn(_this);
    }

    _this.change = engine.change;
    _this.sectionManage = engine.section;
    _this.controllBar = new _controllbar2.default(_this);
    _this.selection = new _selection2.default(_this);
    _this.command = new _command2.default(_this);
    _this.hotkey = new _hotkey2.default(_this);
    _this.innerSchema = (0, _utils.tableInnerSchema)(_config2.default);
    _this.history = new _history2.default(_this);
    _this.mobile = 'mobile' === _this.engine.options.type;
    return _this;
  }

  _createClass(Table, [{
    key: 'select',
    value: function select() {
      if (this.state.readonly) _get(Table.prototype.__proto__ || Object.getPrototypeOf(Table.prototype), 'select', this).call(this);else {
        var container = this.container;

        if (container[0].childNodes.length > 0) {
          container.addClass('zacheditor-table-selected');
        }
      }
    }
  }, {
    key: 'unselect',
    value: function unselect() {
      if (this.state.readonly) {
        _get(Table.prototype.__proto__ || Object.getPrototypeOf(Table.prototype), 'unselect', this).call(this);
      } else {
        var container = this.container;

        if (container[0].childNodes.length > 0) {
          container.removeClass('zacheditor-table-selected');
        }
      }
    }
  }, {
    key: 'selectByOther',
    value: function selectByOther(color) {
      var container = this.container;

      if (container[0].childNodes.length > 0) {
        container.css('outline', '2px solid ' + color);
      }
    }
  }, {
    key: 'unselectByOther',
    value: function unselectByOther() {
      var container = this.container;

      if (container[0].childNodes.length > 0) {
        container.css('outline', '');
      }
    }
  }, {
    key: 'getTableHeight',
    value: function getTableHeight() {
      var height = (0, _dom.getHeight)(this.tableRoot[0]);
      return this.options.type === 'mini' && !this.state.maximize ? height + 6 : height;
    }
  }, {
    key: 'onTableSizeChange',
    value: function onTableSizeChange() {
      this.container.css({
        'min-height': this.getTableHeight() + 'px'
      });
      if (this.options.type === 'mini' && !this.state.maximize) {
        var triggerCols = this.container.find(this.template.COLS_HEADER_TRIGGER_CLASS);
        var triggerRows = this.container.find(this.template.ROWS_HEADER_TRIGGER_CLASS);
        triggerCols.css('height', this.tableRoot[0].offsetHeight + 'px');
        var tableWidth = this.tableRoot[0].offsetWidth;
        var wrapperWidth = this.tableWrapper[0].offsetWidth;
        triggerRows.css('width', (tableWidth > wrapperWidth ? wrapperWidth : tableWidth) + 'px');
      }
    }
  }, {
    key: 'render',
    value: function render(container, value, self) {
      var engine = this.engine;
      container.on('dragstart', function (event) {
        event.stopPropagation();
        event.preventDefault();
      });
      if (value.html) {
        if (!engine) {
          this.contentView.schema.add(_schema2.default);
          value.html = new _engine2.default.HTMLParser(value.html, this.contentView.schema, this.contentView.conversion).toValue();
        }
        value.html = _engine2.default.StringUtils.transformCustomTags(value.html);
      }

      if (!engine) {
        var _sectionHTML = this.template.htmlView(value);
        container.append(_sectionHTML);
        _engine2.default.section.renderAll(container, undefined, this.contentView);
        this.viewport = container.find(this.template.VIEWPORT_READER);
        this.scrollbar = new _scrollbar2.default(this.viewport, true, false, true);
        if (0 === this.contentView.docVerstion) {
          this.container.css({
            'margin-top': '24px',
            'margin-bottom': '24px'
          });
        }
        return;
      }

      var sectionHTML = this.template.htmlEdit(value);
      container.append(sectionHTML);
      _engine2.default.section.renderAll(container, undefined, engine);
      if (this.options.type === 'mini') {
        var root = container.closest('div[data-section-key=table]');
        if (root.length > 0) {
          root.attr('data-section-table', 'mini');
        }
      }
      this.tableRoot = container.find(this.template.TABLE_CLASS);
      this.viewport = container.find(this.template.VIEWPORT);
      this.tableWrapper = container.find(this.template.TABLE_WRAPPER_CLASS);
      this.selection.init();
      this.controllBar.init();
      this.scrollbar = new _scrollbar2.default(this.viewport, true, false, true);
      this.bindEditEvents();

      if (!value.html || self) {
        // 新插入表格的时候设置sectionValue，这样外部立刻保存的时候，服务端不会报错
        this.setSectionValue(self);
      }
      this.onTableSizeChange();
    }
  }]);

  return Table;
}(_base2.default);

Table.type = 'block';
Table.canSearch = true;
Table.uid = true;
exports.default = Table;