'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (section) {
  return {
    TABLE_WRAPPER_CLASS: '.'.concat(TABLE_WRAPPER_CLASS),
    TABLE_CLASS: '.'.concat(TABLE_CLASS),
    COLS_HEADER_CLASS: '.'.concat(COLS_HEADER_CLASS),
    COLS_HEADER_ITEM_CLASS: '.'.concat(COLS_HEADER_ITEM_CLASS),
    COLS_HEADER_TRIGGER_CLASS: '.'.concat(COLS_HEADER_TRIGGER_CLASS),
    COLS_ADDITION_CLASS: '.'.concat(COLS_ADDITION_CLASS),
    COLS_ADDITION_HEADER_CLASS: '.'.concat(COLS_ADDITION_HEADER_CLASS),
    ROWS_HEADER_CLASS: '.'.concat(ROWS_HEADER_CLASS),
    ROWS_HEADER_ITEM_CLASS: '.'.concat(ROWS_HEADER_ITEM_CLASS),
    ROWS_HEADER_TRIGGER_CLASS: '.'.concat(ROWS_HEADER_TRIGGER_CLASS),
    ROWS_ADDITION_CLASS: '.'.concat(ROWS_ADDITION_CLASS),
    ROWS_ADDITION_HEADER_CLASS: '.'.concat(ROWS_ADDITION_HEADER_CLASS),
    HEADER_CLASS: '.'.concat(HEADER_CLASS),
    ACTIVE_TD_CLASS: '.'.concat(ACTIVE_TD_CLASS),
    ACTIVE_TD_TRIGGER_CLASS: '.'.concat(ACTIVE_TD_TRIGGER_CLASS),
    AREA_MASK: '.'.concat(AREA_MASK),
    ROW_MASK: '.'.concat(ROW_MASK),
    COL_MASK: '.'.concat(COL_MASK),
    SUB_EDITOR_CLASS: '.'.concat(SUB_EDITOR_CLASS),
    SUB_EDITOR_CONTENT_CLASS: '.'.concat(SUB_EDITOR_CONTENT_CLASS),
    MENUBAR_CLASS: '.'.concat(MENUBAR_CLASS),
    MENUBAR_ITEM_CLASS: '.'.concat(MENUBAR_ITEM_CLASS),
    TABLE_TEXTAREA_CLASS: '.'.concat(TABLE_TEXTAREA_CLASS),
    VIEWPORT: '.'.concat(VIEWPORT),
    VIEWPORT_READER: '.'.concat(VIEWPORT_READER),
    PLACEHOLDER_CLASS: '.'.concat(PLACEHOLDER_CLASS),
    MULTI_ADDITION_CLASS: '.'.concat(MULTI_ADDITION_CLASS),
    SHADOW_LEFT_CLASS: '.'.concat(SHADOW_LEFT_CLASS),
    SHADOW_RIGHT_CLASS: '.'.concat(SHADOW_RIGHT_CLASS),
    EmptyCell: '<p><br /></p>',
    SubEditor: '<div class="'.concat(SUB_EDITOR_CLASS, '"><div class="').concat(SUB_EDITOR_CONTENT_CLASS, '"></div></div>'),

    /**
     * 用于Section渲染
     * @param {object} value 参数
     * @param {number} value.rows 行数
     * @param {number} value.cols 列数
     * @param {string} value.html html 字符串
     * @return {string} 返回 html 字符串
     */
    htmlEdit: function htmlEdit(value) {
      var rows = value.rows,
          cols = value.cols,
          html = value.html;
      var tds = '<td><p><br /></p></td>'.repeat(cols);
      var trs = '<tr>'.concat(tds, '</tr>').repeat(rows);
      var col = '<col />'.repeat(cols);
      var colgroup = '<colgroup>'.concat(col, '</colgroup>');
      var colsAddition = '<div class="'.concat(COLS_ADDITION_HEADER_CLASS, '">\n        <div class="multi-trigger"></div>\n        <div class="').concat(COLS_ADDITION_CLASS, '"> + </div>\n      </div>');
      var rowsAddition = '<div class="'.concat(ROWS_ADDITION_CLASS, '">\n        <div class="plus"> + </div>\n      </div>');
      var rowsAdditionHead = '<div class="'.concat(ROWS_ADDITION_HEADER_CLASS, '">\n        <div class="multi-trigger"></div>\n      </div>');
      var multiAddition = '<div class="'.concat(MULTI_ADDITION_CLASS, '">\n        <div class="number">1</div>\n        <div class="up"><span class="zacheditor-icon zacheditor-icon-arrow-up"></span></div>\n        <div class="down"><span class="zacheditor-icon zacheditor-icon-arrow-down"></span></div>\n      </div>');

      var colsHeader = '\n        <div class="'.concat(COLS_HEADER_CLASS, '">\n          ').concat('<div class="'.concat(COLS_HEADER_ITEM_CLASS, '" draggable="true">\n              <div class="col-dragger">\n                <span class="zacheditor-icon zacheditor-icon-drag"></span>\n                <p class="drag-info"></p>\n              </div>\n              <div class="').concat(COLS_HEADER_TRIGGER_CLASS, '"></div>\n            </div>').repeat(cols), '\n          ').concat(colsAddition, '\n        </div>\n      ');

      var rowsHeader = '\n        <div class="'.concat(ROWS_HEADER_CLASS, '">\n          ').concat('<div class="'.concat(ROWS_HEADER_ITEM_CLASS, '" draggable="true">\n              <div class="row-dragger">\n                <span class="zacheditor-icon zacheditor-icon-drag"></span>\n                <span class="drag-info"></span>\n              </div>\n              <div class="').concat(ROWS_HEADER_TRIGGER_CLASS, '"></div>\n            </div>').repeat(rows), '\n          ').concat(rowsAdditionHead, '\n        </div>\n      ');

      var tableHeader = '<div class="'.concat(HEADER_CLASS, '"></div>');

      var textArea = '<textarea class="'.concat(TABLE_TEXTAREA_CLASS, '"></textarea>');
      var activeBox = '<div class="'.concat(ACTIVE_TD_CLASS, '">\n        ').concat(textArea, '\n        <div class="').concat(COL_MASK, '"></div>\n        <div class="').concat(ROW_MASK, '"></div>\n        <div class="l"></div>\n        <div class="r"></div>\n        <div class="t"></div>\n        <div class="b"></div>\n        <div class="').concat(AREA_MASK, '"></div>\n        <div class="nw ').concat(ACTIVE_TD_TRIGGER_CLASS, '" direction="drag_nw"></div>\n        <div class="se ').concat(ACTIVE_TD_TRIGGER_CLASS, '" direction="drag_se"></div>\n        <div class="n ').concat(ACTIVE_TD_TRIGGER_CLASS, '" direction="drag_n"></div>\n        <div class="w ').concat(ACTIVE_TD_TRIGGER_CLASS, '" direction="drag_w"></div>\n        <div class="s ').concat(ACTIVE_TD_TRIGGER_CLASS, '" direction="drag_s"></div>\n        <div class="e ').concat(ACTIVE_TD_TRIGGER_CLASS, '" direction="drag_e"></div>\n        ').concat(this.SubEditor, '\n      </div>');
      var placeholder = '<div class="'.concat(PLACEHOLDER_CLASS, '"></div>');
      var shadowLeft = '<div class="'.concat(SHADOW_LEFT_CLASS, '"></div>');
      var shadowRight = '<div class="'.concat(SHADOW_RIGHT_CLASS, '"></div>');
      var menuBar = section.constants.MENU.map(function (menu) {
        if (menu.split) {
          return '<div class="split"></div>';
        }
        return '<div class="'.concat(MENUBAR_ITEM_CLASS, '" data-action="').concat(menu.action, '">\n          <span class="zacheditor-icon zacheditor-icon-table-').concat(menu.icon, '"></span>\n          ').concat(menu.text, '\n        </div>');
      });
      menuBar = '<div class="'.concat(MENUBAR_CLASS, '">').concat(menuBar.join(''), '</div>');

      if (html) {
        var hasColGroup = html.includes('<colgroup>');

        if (!hasColGroup) {
          html = html.replace(/^(<table[^>]+>)/, function (match) {
            return match + colgroup;
          });
        }

        html = (0, _utils.normalizeTable)($(html)[0]).outerHTML;
      }

      var table = html || '\n        <table class="'.concat(TABLE_CLASS, '">\n          ').concat(colgroup, '\n          ').concat(trs, '\n        </table>');

      var sectionClass = TABLE_WRAPPER_CLASS + (section.options.type === 'mini' ? ' ' + TABLE_WRAPPER_CLASS + '-mini' : '');
      var sectionHTML = '\n        <div class="'.concat(sectionClass, '">\n          ').concat(tableHeader, '\n          <div class="').concat(VIEWPORT, '">\n            ').concat(colsHeader, '\n            ').concat(activeBox, '\n            ').concat(table, '\n            ').concat(rowsAddition, '\n            ').concat(placeholder, '\n            ').concat(shadowLeft, '\n            ').concat(shadowRight, '\n          </div>\n          ').concat(rowsHeader, '\n          ').concat(multiAddition, '\n          ').concat(menuBar, '\n        </div>');
      return sectionHTML;
    },
    htmlView: function htmlView(value) {
      var html = value.html;
      return '<div class="'.concat(VIEWPORT_READER, '">\n        ').concat(html, '\n      </div>');
    }
  };
};

var _utils = require('./utils');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $ = _tinsoEditorEngine2.default.$;


var TABLE_WRAPPER_CLASS = 'table-wrapper';
var TABLE_CLASS = 'zacheditor-table';
var COLS_HEADER_CLASS = 'table-cols-header';
var COLS_HEADER_ITEM_CLASS = 'table-cols-header-item';
var COLS_HEADER_TRIGGER_CLASS = 'cols-trigger';
var COLS_ADDITION_CLASS = 'cols-addition';
var COLS_ADDITION_HEADER_CLASS = 'cols-addition-header';
var ROWS_HEADER_CLASS = 'table-rows-header';
var ROWS_HEADER_ITEM_CLASS = 'table-rows-header-item';
var ROWS_HEADER_TRIGGER_CLASS = 'rows-trigger';
var ROWS_ADDITION_CLASS = 'rows-addition';
var ROWS_ADDITION_HEADER_CLASS = 'rows-addition-header';
var HEADER_CLASS = 'table-header';
var ACTIVE_TD_CLASS = 'table-active-td';
var ACTIVE_TD_TRIGGER_CLASS = 'table-active-td-trigger';
var AREA_MASK = 'mask';
var ROW_MASK = 'mask-row';
var COL_MASK = 'mask-col';
var SUB_EDITOR_CLASS = 'sub-editor';
var SUB_EDITOR_CONTENT_CLASS = 'sub-editor-content';
var MENUBAR_CLASS = 'table-menubar';
var MENUBAR_ITEM_CLASS = 'table-menubar-item';
var TABLE_TEXTAREA_CLASS = 'table-textarea';
var VIEWPORT = 'table-viewport';
var VIEWPORT_READER = 'zacheditor-table-reader';
var PLACEHOLDER_CLASS = 'table-placeholder';
var MULTI_ADDITION_CLASS = 'multi-addition';
var SHADOW_LEFT_CLASS = 'table-shadow-left';
var SHADOW_RIGHT_CLASS = 'table-shadow-right';