'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (section) {
  var command = section.command,
      locale = section.locale;

  return [
  //   {
  //   name: 'table:emoji',
  //   type: 'dropdown',
  //   title: locale.emoji,
  //   icon: '<span class="zacheditor-icon zacheditor-icon-emoji" />',
  //   data: emoji,
  //   onClick: value => {
  //     section.subEngine && section.subEngine.command.execute('emoji', value);
  //   },
  // },
  {
    name: 'table:bold',
    title: locale.bold,
    hotkey: macos ? '\u2318+B' : 'Ctrl+B',
    icon: '<span class="zacheditor-icon zacheditor-icon-bold" />',
    getDisabled: function getDisabled() {
      return !section.selection.area;
    },
    getActive: function getActive() {
      return command.queryState('bold');
    },
    onClick: function onClick() {
      command.execute('bold');
    }
  }, {
    name: 'table:italic',
    title: locale.italic,
    hotkey: macos ? '\u2318+I' : 'Ctrl+I',
    icon: '<span class="zacheditor-icon zacheditor-icon-italic" />',
    getDisabled: function getDisabled() {
      return !section.selection.area;
    },
    getActive: function getActive() {
      return command.queryState('italic');
    },
    onClick: function onClick() {
      command.execute('italic');
    }
  }, {
    name: 'table:strikethrough',
    title: locale.strikethrough,
    key: macos ? '\u2318+Shift+X' : 'Ctrl+Shift+X',
    icon: '<span class="zacheditor-icon zacheditor-icon-strikethrough" />',
    getDisabled: function getDisabled() {
      return !section.selection.area;
    },
    getActive: function getActive() {
      return command.queryState('strikethrough');
    },
    onClick: function onClick() {
      command.execute('strikethrough');
    }
  }, {
    name: 'table:underline',
    title: locale.underline,
    key: macos ? '\u2318+U' : 'Ctrl+U',
    icon: '<span class="zacheditor-icon zacheditor-icon-underline" />',
    getDisabled: function getDisabled() {
      return !section.selection.area;
    },
    getActive: function getActive() {
      return command.queryState('underline');
    },
    onClick: function onClick() {
      command.execute('underline');
    }
  }, {
    type: 'separator'
  }, {
    name: 'table:alignment',
    type: 'dropdown',
    title: locale.align,
    icon: '<span class="zacheditor-icon zacheditor-icon-align-left" />',
    className: 'zacheditor-button-icon-list',
    data: [{
      key: 'left',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-left" />',
      title: locale.alignLeft,
      className: 'zacheditor-button-set-list-item-icon'
    }, {
      key: 'center',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-center" />',
      title: locale.alignCenter,
      className: 'zacheditor-button-set-list-item-icon'
    }, {
      key: 'right',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-right" />',
      title: locale.alignRight,
      className: 'zacheditor-button-set-list-item-icon'
    }, {
      key: 'justify',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-justify" />',
      title: locale.alignJustify,
      className: 'zacheditor-button-set-list-item-icon'
    }],
    getActive: function getActive() {
      return command.queryState('alignment');
    },
    onClick: function onClick(value) {
      command.align(value);
    }
  }, {
    name: 'table:verticalAlignment',
    type: 'dropdown',
    title: locale.verticalAlign,
    icon: '<span class="zacheditor-icon zacheditor-icon-align-top" />',
    className: 'zacheditor-button-icon-list',
    data: [{
      key: 'top',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-top" />',
      title: locale.alignTop,
      className: 'zacheditor-button-set-list-item-icon'
    }, {
      key: 'middle',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-middle" />',
      title: locale.alignMiddle,
      className: 'zacheditor-button-set-list-item-icon'
    }, {
      key: 'bottom',
      icon: '<span class="zacheditor-icon zacheditor-icon-align-bottom" />',
      title: locale.alignBottom,
      className: 'zacheditor-button-set-list-item-icon'
    }],
    getActive: function getActive() {
      return command.queryState('alignment');
    },
    onClick: function onClick(value) {
      command.valign(value);
    }
  }, {
    type: 'separator'
  }, {
    name: 'table:unorderedlist',
    title: locale.unorderedList,
    hotkey: macos ? '\u2318+Shift+8' : 'Ctrl+Shift+8',
    icon: '<span class="zacheditor-icon zacheditor-icon-unordered-list" />',
    getDisabled: function getDisabled() {
      return !section.subEngine;
    },
    getActive: function getActive() {
      return section.subEngine && section.subEngine.command.queryState('tasklist') === 'unorderedlist';
    },
    onClick: function onClick() {
      section.subEngine && section.subEngine.command.execute('tasklist', 'unorderedlist');
    }
  }, {
    name: 'table:orderedlist',
    title: locale.orderedList,
    hotkey: macos ? '\u2318+Shift+7' : 'Ctrl+Shift+7',
    icon: '<span class="zacheditor-icon zacheditor-icon-ordered-list" />',
    getDisabled: function getDisabled() {
      return !section.subEngine;
    },
    getActive: function getActive() {
      return section.subEngine && section.subEngine.command.queryState('tasklist') === 'orderedlist';
    },
    onClick: function onClick() {
      section.subEngine && section.subEngine.command.execute('tasklist', 'orderedlist');
    }
  }, {
    name: 'table:tasklist',
    title: locale.taskList,
    icon: '<span class="zacheditor-icon zacheditor-icon-task-list" />',
    getDisabled: function getDisabled() {
      return !section.subEngine;
    },
    getActive: function getActive() {
      return section.subEngine && section.subEngine.command.queryState('tasklist') === 'tasklist';
    },
    onClick: function onClick() {
      section.subEngine && section.subEngine.command.execute('tasklist', 'tasklist');
    }
  }, {
    type: 'separator'
  }, {
    name: 'table:fontcolor',
    type: 'color',
    title: locale.fontcolor,
    moreTitle: locale.fontcolor,
    defaultColor: '#000000',
    currentColor: '#F5222D',
    getActive: function getActive() {
      return command.queryState('fontcolor') || [];
    },
    onClick: function onClick(value) {
      command.execute('fontcolor', value, '#000000');
    }
  }, {
    name: 'table:backcolor',
    type: 'color',
    title: locale.backcolor,
    moreTitle: locale.backcolor,
    defaultColor: '#FFFFFF',
    currentColor: '#f5f5f5',
    onClick: function onClick(value) {
      command.background(value);
    }
  }, {
    type: 'separator'
  }, {
    name: 'table:image',
    type: 'upload',
    title: locale.image,
    icon: '<span class="zacheditor-icon zacheditor-icon-image" />',
    getDisabled: function getDisabled() {
      return !section.subEngine;
    }
  }, {
    name: 'table:file',
    type: 'upload',
    title: locale.file,
    icon: '<span class="zacheditor-icon zacheditor-icon-attachment" />',
    getDisabled: function getDisabled() {
      return !section.subEngine;
    }
  }, {
    name: 'table:label',
    icon: '<span class="zacheditor-icon zacheditor-icon-label" />',
    title: locale.label,
    getDisabled: function getDisabled() {
      return !section.subEngine;
    },
    onClick: function onClick() {
      section.subEngine.command.execute('label');
    }
  }, {
    name: 'table:link',
    title: locale.link,
    className: 'zacheditor-button-link',
    hotkey: macos ? '\u2318+K' : 'Ctrl+K',
    icon: '<span class="zacheditor-icon zacheditor-icon-link" />',
    getDisabled: function getDisabled() {
      return !section.subEngine;
    },
    onClick: function onClick() {
      section.subEngine && section.subEngine.command.execute('link');
    }
  }];
};

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var macos = _tinsoEditorEngine2.default.userAgent.macos;