'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _imageGenerator = require('../../utils/image-generator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextDiagramViewer = function (_React$Component) {
  _inherits(TextDiagramViewer, _React$Component);

  function TextDiagramViewer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TextDiagramViewer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextDiagramViewer.__proto__ || Object.getPrototypeOf(TextDiagramViewer)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      // 图片地址
      url: _this.props.url,
      error: null
    }, _this.onImgLoad = function () {
      if (typeof _this.props.onLoad === 'function') {
        _this.props.onLoad();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TextDiagramViewer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // 优先使用 section src，没有时再使用 code 生成图片来渲染
      if (!this.state.url && this.props.code) {
        this.genImg();
      }
    }
    // 保证更新了 code 后，重新生成图片

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      // Typical usage (don't forget to compare props):
      if (this.props.code !== prevProps.code) {
        this.genImg();
      }
    }
  }, {
    key: 'genImg',
    value: function genImg() {
      var _this2 = this;

      (0, _imageGenerator.preview)(this.props.type, this.props.code).then(function (res) {
        if (!res.success) {
          _this2.setState({
            error: res.message
          });
        } else {
          var src = 'data:image/svg+xml,' + encodeURIComponent(res.svg).replace(/'/g, '%27').replace(/"/g, '%22');
          _this2.setState({
            url: src,
            error: null
          });
        }
      }).catch(function (error) {
        _this2.setState({
          error: error.message
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          type = _props.type,
          className = _props.className,
          onBeforeRenderImage = _props.onBeforeRenderImage;

      className = className === undefined ? '' : className;
      var _state = this.state,
          url = _state.url,
          error = _state.error;

      var src = onBeforeRenderImage(url);
      var children = error !== null ? _react2.default.createElement(
        'pre',
        null,
        error
      ) : src ? _react2.default.createElement('img', {
        src: src,
        onLoad: this.onImgLoad,
        onDragStart: function onDragStart(e) {
          e.preventDefault();
          e.stopPropagation();
        }
      }) : _react2.default.createElement('span', { className: 'zacheditor-icon zacheditor-icon-loading' });

      return _react2.default.createElement(
        'div',
        {
          className: 'zacheditor-text-diagram-viewer zacheditor-text-diagram-'.concat(type, ' ').concat(className)
        },
        children
      );
    }
  }]);

  return TextDiagramViewer;
}(_react2.default.Component);

exports.default = TextDiagramViewer;