'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _filesize = require('filesize');

var _filesize2 = _interopRequireDefault(_filesize);

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

var _en = require('./locale/en');

var _en2 = _interopRequireDefault(_en);

var _zhCn = require('./locale/zh-cn');

var _zhCn2 = _interopRequireDefault(_zhCn);

var _base = require('../base');

var _base2 = _interopRequireDefault(_base);

var _ajax = require('../../utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var locale = {
  en: _en2.default,
  'zh-cn': _zhCn2.default
};

var template = function template(data, locale) {
  var icons = {
    video: '\n      <div class="zacheditor-video-icon">\n        <svg width="32px" height="24px" viewBox="0 0 32 24" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">\n          <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" fill-opacity="0.25">\n            <g transform="translate(-704.000000, -550.000000)" fill="#000000" fill-rule="nonzero">\n              <g transform="translate(704.000000, 550.000000)">\n                <g>\n                  <path d="M13.09375,17.30625 L20.65625,12.375 C20.95,12.16875 20.95,11.809375 20.65625,11.603125 L13.09375,6.696875 C12.66875,6.4 12,6.6375 12,7.084375 L12,16.921875 C12,17.365625 12.671875,17.603125 13.09375,17.30625 Z" id="Path"></path>\n                  <path d="M30,0 L2,0 C0.896875,0 0,0.896875 0,2 L0,22 C0,23.103125 0.896875,24 2,24 L30,24 C31.103125,24 32,23.103125 32,22 L32,2 C32,0.896875 31.103125,0 30,0 Z M5.25,21.25 C5.25,21.525 5.025,21.75 4.75,21.75 L2.5,21.75 C2.225,21.75 2,21.525 2,21.25 L2,18.5 C2,18.225 2.225,18 2.5,18 L4.75,18 C5.025,18 5.25,18.225 5.25,18.5 L5.25,21.25 Z M5.25,13.375 C5.25,13.65 5.025,13.875 4.75,13.875 L2.5,13.875 C2.225,13.875 2,13.65 2,13.375 L2,10.625 C2,10.35 2.225,10.125 2.5,10.125 L4.75,10.125 C5.025,10.125 5.25,10.35 5.25,10.625 L5.25,13.375 Z M5.25,5.5 C5.25,5.775 5.025,6 4.75,6 L2.5,6 C2.225,6 2,5.775 2,5.5 L2,2.75 C2,2.475 2.225,2.25 2.5,2.25 L4.75,2.25 C5.025,2.25 5.25,2.475 5.25,2.75 L5.25,5.5 Z M24.75,21.75 L7.25,21.75 L7.25,2.25 L24.75,2.25 L24.75,21.75 Z M30,21.25 C30,21.525 29.775,21.75 29.5,21.75 L27.25,21.75 C26.975,21.75 26.75,21.525 26.75,21.25 L26.75,18.5 C26.75,18.225 26.975,18 27.25,18 L29.5,18 C29.775,18 30,18.225 30,18.5 L30,21.25 Z M30,13.375 C30,13.65 29.775,13.875 29.5,13.875 L27.25,13.875 C26.975,13.875 26.75,13.65 26.75,13.375 L26.75,10.625 C26.75,10.35 26.975,10.125 27.25,10.125 L29.5,10.125 C29.775,10.125 30,10.35 30,10.625 L30,13.375 Z M30,5.5 C30,5.775 29.775,6 29.5,6 L27.25,6 C26.975,6 26.75,5.775 26.75,5.5 L26.75,2.75 C26.75,2.475 26.975,2.25 27.25,2.25 L29.5,2.25 C29.775,2.25 30,2.475 30,2.75 L30,5.5 Z" id="Shape"></path>\n                </g>\n              </g>\n            </g>\n          </g>\n        </svg>\n      </div>\n    ',
    spin: '\n      <i class="zacheditor-video-anticon">\n        <svg viewBox="0 0 1024 1024" class="zacheditor-video-anticon-spin" data-icon="loading" width="1em" height="1em" fill="currentColor" aria-hidden="true">\n          <path d="M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 0 0-94.3-139.9 437.71 437.71 0 0 0-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z"></path>\n        </svg>\n      </i>\n    ',
    warn: '\n      <div class="zacheditor-video-icon">\n        <svg width="41px" height="29px" viewBox="0 0 41 29" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">\n          <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">\n            <g transform="translate(-704.000000, -550.000000)">\n              <g id="Group-2" transform="translate(704.000000, 550.000000)">\n                <g id="video" fill="#000000" fill-rule="nonzero" opacity="0.449999988">\n                  <path d="M13.09375,17.30625 C12.671875,17.603125 12,17.365625 12,16.921875 L12,7.084375 C12,6.6375 12.66875,6.4 13.09375,6.696875 L20.65625,11.603125 C20.95,11.809375 20.95,12.16875 20.65625,12.375 L13.09375,17.30625 Z M30,0 C31.103125,0 32,0.896875 32,2 L32,22 C32,23.103125 31.103125,24 30,24 L2,24 C0.896875,24 0,23.103125 0,22 L0,2 C0,0.896875 0.896875,0 2,0 L30,0 Z M5.25,21.25 L5.25,18.5 C5.25,18.225 5.025,18 4.75,18 L2.5,18 C2.225,18 2,18.225 2,18.5 L2,21.25 C2,21.525 2.225,21.75 2.5,21.75 L4.75,21.75 C5.025,21.75 5.25,21.525 5.25,21.25 Z M5.25,13.375 L5.25,10.625 C5.25,10.35 5.025,10.125 4.75,10.125 L2.5,10.125 C2.225,10.125 2,10.35 2,10.625 L2,13.375 C2,13.65 2.225,13.875 2.5,13.875 L4.75,13.875 C5.025,13.875 5.25,13.65 5.25,13.375 Z M5.25,5.5 L5.25,2.75 C5.25,2.475 5.025,2.25 4.75,2.25 L2.5,2.25 C2.225,2.25 2,2.475 2,2.75 L2,5.5 C2,5.775 2.225,6 2.5,6 L4.75,6 C5.025,6 5.25,5.775 5.25,5.5 Z M24.75,21.75 L24.75,2.25 L7.25,2.25 L7.25,21.75 L24.75,21.75 Z M30,21.25 L30,18.5 C30,18.225 29.775,18 29.5,18 L27.25,18 C26.975,18 26.75,18.225 26.75,18.5 L26.75,21.25 C26.75,21.525 26.975,21.75 27.25,21.75 L29.5,21.75 C29.775,21.75 30,21.525 30,21.25 Z M30,13.375 L30,10.625 C30,10.35 29.775,10.125 29.5,10.125 L27.25,10.125 C26.975,10.125 26.75,10.35 26.75,10.625 L26.75,13.375 C26.75,13.65 26.975,13.875 27.25,13.875 L29.5,13.875 C29.775,13.875 30,13.65 30,13.375 Z M30,5.5 L30,2.75 C30,2.475 29.775,2.25 29.5,2.25 L27.25,2.25 C26.975,2.25 26.75,2.475 26.75,2.75 L26.75,5.5 C26.75,5.775 26.975,6 27.25,6 L29.5,6 C29.775,6 30,5.775 30,5.5 Z" id="Combined-Shape"></path>\n                </g>\n                <g id="error-fill" transform="translate(21.000000, 10.000000)">\n                  <rect id="Rectangle" fill="#000000" opacity="0" x="0" y="0" width="20" height="20"></rect>\n                  <path d="M19.0267927,16.510301 L19.0272631,16.5111171 C19.4269215,17.2064579 18.9263267,18.0729167 18.125,18.0729167 L1.875,18.0729167 C1.07367326,18.0729167 0.573078461,17.2064579 0.973207261,16.510301 L9.0970084,2.44988987 C9.28650026,2.11750251 9.63068515,1.92708333 10,1.92708333 C10.368224,1.92708333 10.7098796,2.11659543 10.9017927,2.447801 L19.0267927,16.510301 Z" id="Path" stroke="#FFFFFF" stroke-width="0.833333333" fill="#FFFFFF"></path>\n                  <path d="M18.6660156,16.71875 L10.5410156,2.65625 C10.4199219,2.44726562 10.2109375,2.34375 10,2.34375 C9.7890625,2.34375 9.578125,2.44726562 9.45898438,2.65625 L1.33398438,16.71875 C1.09375,17.1367188 1.39453125,17.65625 1.875,17.65625 L18.125,17.65625 C18.6054688,17.65625 18.90625,17.1367188 18.6660156,16.71875 Z M9.375,8.125 C9.375,8.0390625 9.4453125,7.96875 9.53125,7.96875 L10.46875,7.96875 C10.5546875,7.96875 10.625,8.0390625 10.625,8.125 L10.625,11.71875 C10.625,11.8046875 10.5546875,11.875 10.46875,11.875 L9.53125,11.875 C9.4453125,11.875 9.375,11.8046875 9.375,11.71875 L9.375,8.125 Z M10,15 C9.48242188,15 9.0625,14.5800781 9.0625,14.0625 C9.0625,13.5449219 9.48242188,13.125 10,13.125 C10.5175781,13.125 10.9375,13.5449219 10.9375,14.0625 C10.9375,14.5800781 10.5175781,15 10,15 Z" id="Shape" fill="#FAAD14" fill-rule="nonzero"></path>\n                </g>\n              </g>\n            </g>\n          </g>\n        </svg>\n      </div>\n    ',
    error: '<span class="zacheditor-error-icon">X</span>'
  };

  if (data.status === 'uploading') {
    return '\n      <div class="zacheditor-video">\n        <div class="zacheditor-video-content zacheditor-video-uploading">\n          <div class="zacheditor-video-center">\n            '.concat(icons.video, '\n            <div class="zacheditor-video-name">').concat(_tinsoEditorEngine2.default.StringUtils.escape(data.name), ' (').concat((0, _filesize2.default)(data.size), ')</div>\n            <div data-role="progress" class="zacheditor-video-progress">\n              ').concat(icons.spin, '\n              <span data-role="percent" class="percent">').concat(_tinsoEditorEngine2.default.StringUtils.escape(data.percent), '%</span>\n            </div>\n          </div>\n        </div>\n      </div>\n    ');
  } else if (data.status === 'uploaded') {
    return '\n      <div class="zacheditor-video">\n        <div class="zacheditor-video-content zacheditor-video-uploaded">\n          <div class="zacheditor-video-center">\n            '.concat(icons.video, '\n            <div class="zacheditor-video-name">').concat(_tinsoEditorEngine2.default.StringUtils.escape(data.name), ' (').concat((0, _filesize2.default)(data.size), ')</div>\n            <div class="zacheditor-video-converting">\n              ').concat(icons.spin, '\n              <span>').concat(_tinsoEditorEngine2.default.StringUtils.escape(locale.transcoding), '</span>\n            </div>\n          </div>\n        </div>\n      </div>\n    ');
  } else if (data.status === 'error') {
    var message = '';
    /**
     * 错误码:
     * 1. reject 人工或机审不通过
     * 2. 其它类错误
     */

    switch (data.code) {
      case 'reject':
        message = locale.rejectError;
        break;

      default:
        message = locale.commonError;
        break;
    }
    // 内容审核不通过显示特殊处理
    var isReject = data.code === 'reject';
    return '\n      <div class="zacheditor-video">\n        <div class="zacheditor-video-content zacheditor-video-error">\n          <div class="zacheditor-video-center">\n            '.concat(isReject ? icons.warn : '', '\n            <div class="zacheditor-video-name">').concat(_tinsoEditorEngine2.default.StringUtils.escape(data.name), '</div>\n            <div class="zacheditor-video-message">').concat(isReject ? '' : icons.error).concat(_tinsoEditorEngine2.default.StringUtils.escape(data.message || message), '</div>\n          </div>\n        </div>\n      </div>\n    ');
  }
  return '\n    <div class="zacheditor-video">\n      <div class="zacheditor-video-content zacheditor-video-done"></div>\n    </div>\n  ';
};

var Video = function (_SectionBase) {
  _inherits(Video, _SectionBase);

  function Video(engine, contentView) {
    _classCallCheck(this, Video);

    var _this2 = _possibleConstructorReturn(this, (Video.__proto__ || Object.getPrototypeOf(Video)).call(this));

    _this2.focusSection = function () {
      _this2.engine.change.focusSection(_this2.sectionRoot);
    };

    _this2.startChecker = function (success, failed) {
      //debug('初始化状态轮询: %j', this.value)
      var handle = function handle() {
        _this2.queryStates(function () {
          success();
        }, function () {
          var err = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          if (err.code === 'reject') {
            failed(err);
          } else {
            setTimeout(handle, 3000);
          }
        });
      };
      handle();
    };

    _this2.updatePlayerState = function (state) {
      _this2.value.aliyunVideoSrc = state.aliyunVideoSrc || null;
      _this2.value.taobaoVideoId = state.taobaoVideoId || null;
      _this2.value.uploaderId = state.userId || null;
      _this2.value.authKey = state.auth_key || null;
      _this2.setValue(_this2.value);
    };

    _this2.queryStates = function (_success, failed) {
      _this2.num = _this2.num || 0;
      _this2.num++;
      var options = _this2.getOptions().video || {};
      (0, _ajax2.default)({
        url: options.action.query,
        dataType: 'json',
        data: {
          video_id: _this2.value.videoId
        },
        success: function success(_ref) {
          var result = _ref.result,
              data = _ref.data;

          //debug('第 %d 次查询结果: %j', this.num, this.value);
          // 设置状态前先清除状态
          _this2.value.coverUrl = null;
          _this2.value.aliyunVideoSrc = null;
          _this2.value.taobaoVideoId = null;
          _this2.value.uploaderId = null;
          _this2.value.authKey = null;

          if (!result) {
            failed();
          } else {
            _this2.value.coverUrl = data.cover_url;
            _this2.value.aliyunVideoSrc = data.play_list[data.play_list.length - 1].url;
            _success();
          }
        },
        error: function error(err) {
          failed({
            code: 'server-query'
          });
          //debug('状态轮询异常: %O', err)
        },
        method: 'GET',
        processData: true
      });
    };

    _this2.initPlayer = function (src) {
      // 针对阿里云视频的条件
      if (_this2.value.aliyunVideoSrc) {
        src = _this2.value.aliyunVideoSrc;
      }
      _this2.src = _tinsoEditorEngine2.default.StringUtils.sanitizeUrl(src);
      var video = document.createElement('video');
      video.preload = 'none';
      video.setAttribute('src', _this2.src);
      video.setAttribute('webkit-playsinline', 'webkit-playsinline');
      video.setAttribute('playsinline', 'playsinline');
      if (_this2.value.coverUrl) {
        video.poster = _this2.value.coverUrl;
      }

      _this2.container.find('.zacheditor-video-content').append(video);

      video.oncontextmenu = function () {
        return false;
      };
      // 一次渲染时序开启 controls 会触发一次内容为空的 window.onerror，疑似 chrome bug
      setTimeout(function () {
        video.controls = true;
        if (_this2.isContentView) video.controlsList = 'nodownload';
      }, 0);
    };

    _this2.engine = engine;
    _this2.contentView = contentView;
    _this2.isContentView = !engine;

    if (_this2.isContentView) {
      var _ret;

      return _ret = _this2, _possibleConstructorReturn(_this2, _ret);
    }
    _this2.section = engine.section;
    return _this2;
  }

  _createClass(Video, [{
    key: 'embedToolbar',
    value: function embedToolbar() {
      var _this3 = this;

      var toolbarExtends = [];
      var options = this.getOptions() || {};
      if (this.state.readonly && this.value.download) {
        toolbarExtends = [{
          type: 'download',
          onClick: this.downloadFile.bind(this)
        }];
      } else if (!this.state.readonly && 'done' === this.value.status) {
        toolbarExtends = [{
          type: 'download',
          onClick: this.downloadFile.bind(this)
        }, {
          type: 'separator'
        }];
      }
      if (options.type === 'max') {
        toolbarExtends = toolbarExtends.concat([{
          type: 'dnd'
        }]);
      }
      var embed = toolbarExtends.concat([{
        type: 'delete'
      }, {
        type: 'separator'
      }, {
        type: 'copy'
      }]);
      if (options.type === 'max') {
        embed = embed.concat([{
          type: 'preferences',
          onClick: function onClick() {
            _this3.setSidebar();
          }
        }]);
      }
      var config = options.video || {};
      if (Array.isArray(config.embed)) {
        return config.embed;
      } else if (_typeof(config.embed) === 'object') {
        var embedArray = [];
        embed.forEach(function (item) {
          if (config.embed[item.type] !== false) {
            embedArray.push(item);
          }
        });
        return embedArray;
      } else {
        return embed;
      }
    }
  }, {
    key: 'setSidebar',
    value: function setSidebar() {
      this.engine.sidebar.set({
        name: 'video',
        title: this.locale.preferences,
        className: 'zacheditor-video-sidebar',
        data: this.value
      });
    }
  }, {
    key: 'downloadFile',
    value: function downloadFile() {
      this.src && window.open(this.src);
    }
  }, {
    key: 'activate',
    value: function activate() {
      this.container.find('.zacheditor-video-content').addClass('zacheditor-video-content-active');
    }
  }, {
    key: 'unactivate',
    value: function unactivate() {
      this.container.find('.zacheditor-video-content').removeClass('zacheditor-video-content-active');
      if (this.engine) {
        this.engine.sidebar.restore();
      }
    }
  }, {
    key: 'isEqualValue',
    value: function isEqualValue(e, t) {
      return e.coverUrl === t.coverUrl && e.name === t.name && e.percent === t.percent && e.size === t.size && e.status === t.status && e.taobaoVideoId === t.taobaoVideoId && e.uploaderId === t.uploaderId && e.videoId === t.videoId;
    }
  }, {
    key: 'isInWhiteList',
    value: function isInWhiteList(e) {
      var src = e.aliyunVideoSrc || e.src;
      if (src) {
        try {
          var options = this.getOptions() || {};
          var hosts = options.hosts || ['zacheditor.com', 'www.zacheditor.com', 'cdn-video.zacheditor.com'];
          var hostname = new URL(src).hostname;
          if (hostname) return hosts.includes(hostname);
        } catch (e) {}
      }
      return true;
    }
  }, {
    key: 'render',
    value: function render(container, value) {
      var _this4 = this;

      this.container = container;
      this.value = value;
      this.locale = this.locale || locale[this.getLang()];
      container.empty();
      var root = _tinsoEditorEngine2.default.$(template(this.value, this.locale));
      /**
       * 兼容老的 section 格式
       */
      if (this.value.src) {
        if (!this.isInWhiteList(this.value)) return;
        container.append(root);
        this.initPlayer(this.value.src);
        return;
      }
      var _this = this;
      if (this.isContentView) {
        if (!this.isInWhiteList(this.value)) {
          return;
        }
        /**
         * 状态为 done 的时候查询一次状态后渲染
         * 状态为 error 时候直接同步渲染
         */
        if (this.value.status === 'done') {
          this.queryStates(function () {
            container.append(root);
            _this4.initPlayer();
          }, function () {
            var err = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            _this.value.status = 'error';
            _this.value.code = err.code;
            root = _tinsoEditorEngine2.default.$(template(_this.value, _this.locale));
            container.append(root);
          });
        } else if (this.value.status === 'error') {
          container.append(root);
        }
        return;
      }

      /**
       * 上传成功但未转码完成，轮询转码状态
       * 转码完成查询一次
       */

      if (this.value.status === 'uploaded') {
        container.append(root);
        this.startChecker(function () {
          _this4.value.status = 'done';
          _this4.setValue(_this4.value);
          _this4.render(_this4.container, _this4.value);
        }, function () {
          var err = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          _this.value.status = 'error';
          _this.value.code = err.code;
          _this.setValue(_this.value);
          _this.render(_this.container, _this.value);
        });
      } else if (this.value.status === 'done') {
        this.queryStates(function () {
          container.append(root);
          _this4.initPlayer();
        }, function () {
          var err = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          _this.value.status = 'error';
          _this.value.code = err.code;
          root = _tinsoEditorEngine2.default.$(template(_this.value, _this.locale));
          container.append(root);
        });
      } else {
        container.append(root);
      }
      container.on('click', this.selectSection);
      this.section.setToolbar({
        sectionRoot: this.sectionRoot,
        engine: this.engine,
        component: this
      });
    }
  }]);

  return Video;
}(_base2.default);

Video.type = 'block';
Video.uid = true;
exports.default = Video;