'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDocEmbedURL = exports.hitBlack = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _url = require('../embed/url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _getDocEmbedURL(url) {
  var match = url.match(/^https?:\/\/\w+\.youku\.com\/v_show\/id_([^\.]+)/i);
  var id = void 0;
  if (match) {
    id = match[1];
    return 'https://player.youku.com/embed/'.concat(id);
  }
  match = url.match(/^https?:\/\/\w+\.bilibili\.com\/video\/av(\d+)/i);
  if (match) {
    id = match[1];
    var p = url.match(/p=(\d+)/);
    if (p) p = p[1];
    return 'https://player.bilibili.com/player.html?aid='.concat(id).concat(p ? '&p='.concat(p) : '');
  }
}

function _hitBlack(url) {
  return !url.match(/^https:.*\.youku\.com\//) && !url.match(/^https:.*\.bilibili\.com\//);
}

var YouKu = function (_EmbedUrl) {
  _inherits(YouKu, _EmbedUrl);

  function YouKu(cfg) {
    _classCallCheck(this, YouKu);

    return _possibleConstructorReturn(this, (YouKu.__proto__ || Object.getPrototypeOf(YouKu)).call(this, _extends({
      resize: false
    }, cfg)));
  }

  _createClass(YouKu, [{
    key: 'getHeight',
    value: function getHeight() {
      return this.getContainerWidth() / (16 / 9);
    }
  }, {
    key: 'getPlaceHolder',
    value: function getPlaceHolder() {
      var lang = this.getLang();
      return 'en' === lang ? 'Please enter a video link to support Youku, Bilibili' : '请输入视频链接，支持优酷、哔哩哔哩';
    }
  }, {
    key: 'hitBlack',
    value: function hitBlack(url) {
      return _hitBlack(url);
    }
  }, {
    key: 'getDocEmbedURL',
    value: function getDocEmbedURL(url) {
      return _getDocEmbedURL(url);
    }
  }, {
    key: 'isError',
    value: function isError() {
      return window.appData && window.appData['isWechatMiniApp'] !== undefined ? window.appData['isWechatMiniApp'] : false;
    }
  }, {
    key: 'renderError',
    value: function renderError() {
      this.container.append('\n      <div class="youku-error">\n        <p><span class="zacheditor-icon zacheditor-icon-warning"></span></p>\n        <p>'.concat(this.locale.wechatAlert, '</p>\n      </div>\n    '));
    }
  }]);

  return YouKu;
}(_url2.default);

YouKu.type = 'block';
exports.default = YouKu;
exports.hitBlack = _hitBlack;
exports.getDocEmbedURL = _getDocEmbedURL;