'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/button/style');

require('antd/lib/input/style');

require('antd/lib/checkbox/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Group = _antd.Button.Group;

var ImageSidebar = function (_React$Component) {
  _inherits(ImageSidebar, _React$Component);

  function ImageSidebar(props) {
    _classCallCheck(this, ImageSidebar);

    var _this = _possibleConstructorReturn(this, (ImageSidebar.__proto__ || Object.getPrototypeOf(ImageSidebar)).call(this, props));

    _this.handleChangeWidth = function (e) {
      var width = parseInt(e.target.value, 10) || 0;
      var height = Math.round(width * _this.rate);
      _this.setState({
        width: width,
        height: height
      });
    };

    _this.handleChangeHeight = function (e) {
      var height = parseInt(e.target.value, 10) || 0;
      var width = Math.round(height / _this.rate);

      _this.setState({
        width: width,
        height: height
      });
    };

    _this.handleSizeKeyPress = function (e) {
      e.stopPropagation();
      if (e.key === 'Enter') {
        _this.handleUpdateSize();
      }
    };

    _this.handleUpdateSize = function () {
      var engine = _this.props.engine;
      var _this$state = _this.state,
          width = _this$state.width,
          height = _this$state.height;

      var sectionRoot = engine.change.activeSection;
      if (!sectionRoot) {
        return;
      }
      var component = engine.section.getComponent(sectionRoot);
      if (!component) {
        return;
      }
      component.changeSize(width, height);
    };

    _this.handleUpdateZoom = function (zoomRate) {
      var width = Math.round(_this.originWidth * zoomRate);
      var height = Math.round(_this.originHeight * zoomRate);
      _this.setState({
        width: width,
        height: height
      }, function () {
        return _this.handleUpdateSize();
      });
    };

    _this.handleChangeLink = function (e) {
      var link = e.target.value;
      _this.setState({
        link: link
      });
    };

    _this.handleLinkKeyPress = function (e) {
      e.stopPropagation();
      if (e.key === 'Enter') {
        _this.handleUpdateLink();
      }
    };

    _this.handleUpdateLink = function () {
      var engine = _this.props.engine;
      var _this$state2 = _this.state,
          link = _this$state2.link,
          linkTarget = _this$state2.linkTarget;

      var sectionRoot = engine.change.activeSection;

      if (!sectionRoot) {
        return;
      }
      var component = engine.section.getComponent(sectionRoot);
      if (!component) {
        return;
      }
      component.changeLink(link, linkTarget);
    };

    _this.handleChangeLinkTarget = function (e) {
      var linkTarget = e.target.checked ? '' : '_blank';
      _this.setState({
        linkTarget: linkTarget
      }, function () {
        return _this.handleUpdateLink();
      });
    };

    var data = props.data;
    _this.state = {
      width: data.width,
      height: data.height,
      link: data.link,
      linkTarget: data.linkTarget
    };
    _this.originWidth = data.originWidth;
    _this.originHeight = data.originHeight;
    _this.rate = data.originHeight / data.originWidth;
    return _this;
  }

  _createClass(ImageSidebar, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.handleUpdateSize();
      this.handleUpdateLink();
    }
  }, {
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(props) {
      var data = props.data;
      var width = data.width;

      if (width !== this.props.data.width) {
        this.setState({
          width: width,
          height: data.height
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var engine = this.props.engine;
      var _state = this.state,
          width = _state.width,
          height = _state.height,
          link = _state.link,
          linkTarget = _state.linkTarget;

      var locale = engine.locale.image;
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-sidebar-group' },
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-sidebar-group-title' },
            locale.sizeTitle
          ),
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-sidebar-group-item' },
            _react2.default.createElement(
              'div',
              { className: 'zacheditor-sidebar-size-input' },
              _react2.default.createElement(_antd.Input, {
                type: 'text',
                size: 'small',
                className: 'zacheditor-sidebar-width',
                defaultValue: width,
                value: width,
                onKeyPress: this.handleSizeKeyPress,
                onBlur: this.handleUpdateSize,
                onChange: this.handleChangeWidth
              }),
              _react2.default.createElement(
                'span',
                { className: 'zacheditor-sidebar-lock' },
                ' '
              ),
              _react2.default.createElement(_antd.Input, {
                type: 'text',
                size: 'small',
                className: 'zacheditor-sidebar-height',
                defaultValue: height,
                value: height,
                onKeyPress: this.handleSizeKeyPress,
                onBlur: this.handleUpdateSize,
                onChange: this.handleChangeHeight
              })
            ),
            _react2.default.createElement(
              'div',
              { className: 'zacheditor-sidebar-size-title' },
              _react2.default.createElement(
                'span',
                { className: 'zacheditor-sidebar-width-title' },
                locale.width
              ),
              _react2.default.createElement('span', { className: 'zacheditor-sidebar-lock' }),
              _react2.default.createElement(
                'span',
                { className: 'zacheditor-sidebar-height-title' },
                locale.height
              )
            )
          ),
          _react2.default.createElement(
            'div',
            {
              className: 'zacheditor-sidebar-group-item zacheditor-sidebar-image-percent',
              style: { marginBottom: '14px' }
            },
            _react2.default.createElement(
              Group,
              null,
              _react2.default.createElement(
                _antd.Button,
                {
                  size: 'small',
                  onClick: function onClick() {
                    return _this2.handleUpdateZoom(0.25);
                  }
                },
                '25%'
              ),
              _react2.default.createElement(
                _antd.Button,
                {
                  size: 'small',
                  onClick: function onClick() {
                    return _this2.handleUpdateZoom(0.5);
                  }
                },
                '50%'
              ),
              _react2.default.createElement(
                _antd.Button,
                {
                  size: 'small',
                  onClick: function onClick() {
                    return _this2.handleUpdateZoom(0.75);
                  }
                },
                '75%'
              ),
              _react2.default.createElement(
                _antd.Button,
                {
                  size: 'small',
                  onClick: function onClick() {
                    return _this2.handleUpdateZoom(1);
                  }
                },
                '100%'
              )
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-sidebar-group-item zacheditor-sidebar-image-100' },
            _react2.default.createElement(
              _antd.Button,
              {
                size: 'small',
                style: {
                  width: '100%'
                },
                onClick: function onClick() {
                  return _this2.handleUpdateZoom(1);
                }
              },
              locale.originSize
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-sidebar-group' },
            _react2.default.createElement(
              'div',
              { className: 'zacheditor-sidebar-group-title' },
              locale.linkTitle
            ),
            _react2.default.createElement(
              'div',
              { className: 'zacheditor-sidebar-group-item' },
              _react2.default.createElement(_antd.Input, {
                type: 'text',
                size: 'small',
                className: 'zacheditor-sidebar-link',
                placeholder: locale.linkPlaceholder,
                defaultValue: link,
                value: link,
                onKeyPress: this.handleLinkKeyPress,
                onBlur: this.handleUpdateLink,
                onChange: this.handleChangeLink,
                style: {
                  marginBottom: '12px'
                }
              })
            ),
            _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _antd.Checkbox,
                {
                  defaultChecked: linkTarget === '',
                  checked: linkTarget === '',
                  onChange: this.handleChangeLinkTarget
                },
                locale.linkTargetTips
              )
            )
          )
        )
      );
    }
  }]);

  return ImageSidebar;
}(_react2.default.Component);

exports.default = ImageSidebar;