'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _engine = require('../editor/engine');

var _engine2 = _interopRequireDefault(_engine);

var _toc = require('./toc');

var _toc2 = _interopRequireDefault(_toc);

var _image = require('./image');

var _image2 = _interopRequireDefault(_image);

var _translate = require('./translate');

var _translate2 = _interopRequireDefault(_translate);

var _localdoc = require('./localdoc');

var _localdoc2 = _interopRequireDefault(_localdoc);

var _video = require('./video');

var _video2 = _interopRequireDefault(_video);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Sidebar = function (_React$Component) {
  _inherits(Sidebar, _React$Component);

  function Sidebar() {
    _classCallCheck(this, Sidebar);

    var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this));

    _this.extends = function () {
      _this.props.engine.sidebar = {
        set: _this.set,
        close: _this.close,
        store: _this.store,
        restore: _this.restore
      };
    };

    _this.set = function (state) {
      if (!state) {
        _this.close();
      }
      var engine = _this.props.engine;

      _this.setState(state);
      localStorage.setItem('zacheditor-sidebar', state.name);
      engine.toolbar.updateState();
      engine.sidebar.activate = state.name;
    };

    _this.close = function () {
      _this.setState({
        name: 'none'
      });
      localStorage.setItem('zacheditor-sidebar', 'none');
    };

    _this.store = function (config) {
      var engine = _this.props.engine;

      _this.storeConfig = config;
      engine.sidebar.storeConfig = config;
    };

    _this.restore = function () {
      _this.set(_this.storeConfig);
    };

    _this.contentNode = _react2.default.createRef();
    _this.state = {
      name: 'none'
    };
    return _this;
  }

  _createClass(Sidebar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var engine = this.props.engine;

      this.extends();
      engine.command.execute('toc', true);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.name !== prevState.name && 'toc' === this.state.name) {
        new _engine2.default.Scrollbar(_engine2.default.$(this.contentNode.current), false, true);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          name = _state.name,
          title = _state.title,
          data = _state.data,
          className = _state.className,
          showCloseBtn = _state.showCloseBtn;
      var engine = this.props.engine;

      var contentProps = {
        engine: engine,
        data: data
      };
      return 'none' === name ? null : _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('zacheditor-sidebar', 'zacheditor-sidebar-active', 'zacheditor-common-sidebar', className),
          'data-zacheditor-element': 'sidebar',
          ref: function ref(e) {
            return _this2.current = e;
          }
        },
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-sidebar-content', ref: this.contentNode },
          name === 'image' && _react2.default.createElement(_image2.default, contentProps),
          name === 'translate' && _react2.default.createElement(_translate2.default, contentProps),
          name === 'localdoc' && _react2.default.createElement(_localdoc2.default, contentProps),
          name === 'video' && _react2.default.createElement(_video2.default, contentProps)
        )
      );
    }
  }]);

  return Sidebar;
}(_react2.default.Component);

exports.default = Sidebar;