'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _engine = require('../editor/engine');

var _engine2 = _interopRequireDefault(_engine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TocSidebar = function (_React$Component) {
  _inherits(TocSidebar, _React$Component);

  function TocSidebar() {
    _classCallCheck(this, TocSidebar);

    var _this = _possibleConstructorReturn(this, (TocSidebar.__proto__ || Object.getPrototypeOf(TocSidebar)).call(this));

    _this.handleClick = function (e, id) {
      var engine = _this.props.engine;
      e.preventDefault();
      var root = _engine2.default.$(_this.root.current);
      var currentItem = _engine2.default.$(e.target).closest('.zacheditor-toc-item');
      var itemList = root.find('a[href="#'.concat(id, '"]'));
      var itemIndex = 0;
      itemList.each(function (item, index) {
        if (item === currentItem[0]) {
          itemIndex = index;
          return false;
        }
      });
      root.find('.zacheditor-toc-item-active').removeClass('zacheditor-toc-item-active');
      itemList.eq(itemIndex).addClass('zacheditor-toc-item-active');
      var block = engine.container.find('[id="'.concat(id, '"]')).eq(itemIndex);
      var contentArea = engine.container.closest('.zacheditor-max-editor-wrapper-content');
      var toolbarArea = engine.container.closest('.zacheditor-max-editor').find('.zacheditor-toolbar');
      // 需要减掉工具栏和上面元素的高度
      contentArea[0].scrollTop += block.offset().top - toolbarArea.offset().top - toolbarArea[0].clientHeight;
    };

    _this.root = _react2.default.createRef();
    return _this;
  }

  _createClass(TocSidebar, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        { className: 'zacheditor-toc', ref: this.root },
        this.props.data.map(function (data, index) {
          return _react2.default.createElement(
            'a',
            {
              key: index,
              href: '#' + data.id,
              className: (0, _classnames2.default)('zacheditor-toc-item', 'zacheditor-toc-item-'.concat(data.depth)),
              onClick: function onClick(e) {
                return _this2.handleClick(e, data.id);
              }
            },
            data.text
          );
        })
      );
    }
  }]);

  return TocSidebar;
}(_react2.default.Component);

exports.default = TocSidebar;