'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/select/style');

require('antd/lib/button/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Translate = function (_React$Component) {
  _inherits(Translate, _React$Component);

  function Translate() {
    _classCallCheck(this, Translate);

    var _this = _possibleConstructorReturn(this, (Translate.__proto__ || Object.getPrototypeOf(Translate)).call(this));

    _this.state = {
      targetPlainText: '',
      errorMsg: null
    };

    _this.source = 'auto';
    _this.target = 'en';
    _this.events = [];
    return _this;
  }

  /**
   * 用于收敛 DOM 事件，便于插件销毁时，解除事件
   * @param  {object} element - 用 $ 包装过的虚拟 DOM
   * @param  {string} type - 事件类型
   * @param  {function} callback - 回掉函数
   */


  _createClass(Translate, [{
    key: '_bindEvent',
    value: function _bindEvent(element, type, callback) {
      element.on(type, callback);
      this.events.push({
        element: element,
        callback: callback,
        type: type
      });
    }
    // 移除事件

  }, {
    key: '_removeEvent',
    value: function _removeEvent() {
      this.events.forEach(function (_ref) {
        var element = _ref.element,
            type = _ref.type,
            callback = _ref.callback;

        element.off(type, callback);
      });
    }
  }, {
    key: '_translate',
    value: function _translate() {
      var engine = this.props.engine;
      var translate = engine.translate;
      var range = engine.change.getRange();

      if (!range) {
        return;
      }
      translate.translate(range, this.source, this.target);
    }
  }, {
    key: 'UNSAFE_componentWillMount',
    value: function UNSAFE_componentWillMount() {
      var engine = this.props.engine;
      var lang = engine.options.lang;
      if (lang === 'en') this.target = 'zh';
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var engine = this.props.engine;
      var translate = engine.translate;

      this._translate();

      this._bindEvent(engine, 'select', function () {
        _this2._translate();
      });

      this._bindEvent(translate, 'success', function (_ref) {
        var targetPlainText = _ref.targetPlainText,
            fragment = _ref.fragment;

        _this2.fragment = fragment;

        _this2.setState({
          errorMsg: null,
          targetPlainText: targetPlainText
        });
      });

      this._bindEvent(translate, 'fail', function (_ref) {
        _this2.setState({
          errorMsg: _ref.errorMsg
        });
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._removeEvent();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var engine = this.props.engine;
      var targetPlainText = this.state.targetPlainText;
      var errorMsg = this.state.errorMsg;
      var Option = _antd.Select.Option;
      var locale = engine.locale.translate;
      var isTargetPlainTextEmpty = !targetPlainText;
      var zhOption = _react2.default.createElement(
        Option,
        { value: 'zh' },
        locale.zh
      );
      var enOption = _react2.default.createElement(
        Option,
        { value: 'en' },
        locale.en
      );
      targetPlainText = isTargetPlainTextEmpty ? locale.placeholder : targetPlainText;
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'span',
          null,
          locale.subTitle
        ),
        _react2.default.createElement('br', null),
        _react2.default.createElement(
          _antd.Select,
          {
            style: {
              width: '100%',
              marginTop: '14px'
            },
            defaultValue: this.source,
            onChange: function onChange(e) {
              _this3.source = e;
              _this3._translate();
            }
          },
          _react2.default.createElement(
            Option,
            { value: 'auto' },
            locale.automaticDetection
          ),
          zhOption,
          enOption
        ),
        _react2.default.createElement('br', null),
        _react2.default.createElement(
          _antd.Select,
          {
            style: {
              width: '100%',
              marginTop: '14px'
            },
            defaultValue: this.target,
            onChange: function onChange(e) {
              _this3.target = e;
              _this3._translate();
            }
          },
          zhOption,
          enOption
        ),
        _react2.default.createElement(
          'p',
          { style: { margin: '14px 0px' } },
          locale.translation,
          '\uFF1A'
        ),
        _react2.default.createElement(
          'pre',
          { style: { color: isTargetPlainTextEmpty ? 'rgba(0,0,0,0.25)' : 'inherit' } },
          targetPlainText
        ),
        errorMsg && _react2.default.createElement(
          'p',
          { style: { marginBottom: '8px', color: '#CF1322' } },
          errorMsg
        ),
        _react2.default.createElement(
          _antd.Button,
          {
            onClick: function onClick() {
              _this3.fragment && engine.change.insertFragment(_this3.fragment.cloneNode(true));
            }
          },
          locale.insertDoc
        )
      );
    }
  }]);

  return Translate;
}(_react2.default.Component);

exports.default = Translate;