'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/popover/style');

require('antd/lib/message/style');

var _tinsoEditorEngine = require('tinso-editor-engine');

var _tinsoEditorEngine2 = _interopRequireDefault(_tinsoEditorEngine);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var msg_tip = {
  'zh-cn': {
    copyMessage: '\u590D\u5236\u9519\u8BEF\u4FE1\u606F',
    copySuccess: '\u590D\u5236\u6210\u529F\uFF01'
  },
  en: {
    copyMessage: 'Copy error information',
    copySuccess: 'Successful copy!'
  }
};

var copy_message = msg_tip[window.appData && 'zh-cn' !== window.appData.locale ? 'en' : 'zh-cn'];

var Error = function (_React$Component) {
  _inherits(Error, _React$Component);

  function Error() {
    _classCallCheck(this, Error);

    return _possibleConstructorReturn(this, (Error.__proto__ || Object.getPrototypeOf(Error)).apply(this, arguments));
  }

  _createClass(Error, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          variableContent = _props.variableContent,
          fixedContent = _props.fixedContent,
          message = _props.message,
          block = _props.block,
          docWidth = _props.docWidth,
          sectionIcon = _props.sectionIcon;

      return _react2.default.createElement(
        'div',
        { className: 'zacheditor-error-tips', style: { width: block ? '100%' : 'auto' } },
        _react2.default.createElement('div', {
          className: 'zacheditor-error-tips-section-icon',
          dangerouslySetInnerHTML: {
            __html: sectionIcon
          }
        }),
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-error-tips-info' },
          _react2.default.createElement(
            'span',
            {
              className: 'zacheditor-error-tips-variable-content',
              style: { maxWidth: block ? ''.concat(docWidth - 200, 'px') : '220px' }
            },
            variableContent
          ),
          _react2.default.createElement(
            'span',
            { className: 'zacheditor-error-tips-fixed-content' },
            fixedContent
          )
        ),
        message ? _react2.default.createElement(
          _antd.Popover,
          { title: copy_message.copyMessage, placement: 'bottom' },
          _react2.default.createElement('span', {
            className: 'zacheditor-svg-icon zacheditor-svg-icon-alert',
            onClick: function onClick() {
              var e = {
                mode: 'json',
                code: JSON.stringify(message, null, '  '),
                id: 'Yf9WB'
              };
              _tinsoEditorEngine2.default.ClipboardUtils.copyNode('<div data-section-type="block" data-section-key="codeblock" data-section-value="'.concat(_tinsoEditorEngine2.default.StringUtils.encodeSectionValue(e), '"></div>'));
              _antd.message.success(copy_message.copySuccess);
            }
          })
        ) : ''
      );
    }
  }]);

  return Error;
}(_react2.default.Component);

exports.default = Error;