'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

require('antd/lib/tooltip/style');

require('./collapse-group.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var locale = {
  'zh-cn': {
    supportFollowingExts: '\u652F\u6301\u4EE5\u4E0B\u683C\u5F0F'
  },
  en: {
    supportFollowingExts: 'The following file formats are supported'
  }
}[window.appData && 'en' === window.appData.locale ? 'en' : 'zh-cn'];

var tooltipContainer = document.createElement('div');
tooltipContainer.setAttribute('class', 'zacheditor-section-tooltip-container');
tooltipContainer.addEventListener('click', function (e) {
  e.stopPropagation();
  e.preventDefault();
});
document.body.appendChild(tooltipContainer);

var CollapseGroup = function (_React$Component) {
  _inherits(CollapseGroup, _React$Component);

  function CollapseGroup() {
    _classCallCheck(this, CollapseGroup);

    return _possibleConstructorReturn(this, (CollapseGroup.__proto__ || Object.getPrototypeOf(CollapseGroup)).apply(this, arguments));
  }

  _createClass(CollapseGroup, [{
    key: 'renderHierarchy',
    value: function renderHierarchy(data) {
      return data.map(function (item, key) {
        var children = item.children.map(function (child, child_key) {
          return _react2.default.createElement('span', {
            className: 'zacheditor-svg-icon zacheditor-svg-icon-'.concat(child.icon),
            key: ''.concat(key).concat(child_key)
          });
        });
        return _react2.default.createElement(
          'div',
          { key: ''.concat(key), className: 'zacheditor-section-tooltip-hierarchy-cell' },
          _react2.default.createElement(
            'p',
            { className: 'zacheditor-section-tooltip-hierarchy-name-container' },
            _react2.default.createElement(
              'span',
              { className: 'zacheditor-section-tooltip-hierarchy-name' },
              item.name
            ),
            _react2.default.createElement(
              'span',
              { className: 'zacheditor-section-tooltip-hierarchy-sub-name' },
              item.subName
            )
          ),
          _react2.default.createElement(
            'p',
            null,
            children
          )
        );
      });
    }
  }, {
    key: 'renderFlat',
    value: function renderFlat(data) {
      return data[0].children.map(function (item, index) {
        return _react2.default.createElement(
          'div',
          { key: '0'.concat(index), className: 'zacheditor-section-tooltip-flat-cell' },
          _react2.default.createElement(
            'span',
            null,
            item.name
          ),
          _react2.default.createElement('br', null),
          _react2.default.createElement('span', { className: 'zacheditor-svg-icon zacheditor-svg-icon-'.concat(item.icon) })
        );
      });
    }
  }, {
    key: 'renderTooltip',
    value: function renderTooltip() {
      var data = this.props.data;

      var tooltip = data.length > 1 ? this.renderHierarchy(data) : this.renderFlat(data);
      return _react2.default.createElement(
        'div',
        { className: 'zacheditor-section-tooltip-content-container' },
        _react2.default.createElement(
          'p',
          { className: 'zacheditor-section-tooltip-title' },
          locale.supportFollowingExts
        ),
        tooltip
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          data = _props.data;

      return data ? _react2.default.createElement(
        _antd.Tooltip,
        {
          title: this.renderTooltip(),
          placement: 'right',
          getPopupContainer: function getPopupContainer() {
            return tooltipContainer;
          }
        },
        children
      ) : _react2.default.createElement(
        'div',
        null,
        children
      );
    }
  }]);

  return CollapseGroup;
}(_react2.default.Component);

exports.default = CollapseGroup;