'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _videoUploader = require('./video-uploader');

var _videoUploader2 = _interopRequireDefault(_videoUploader);

var _collapseGroup = require('./collapse-group');

var _collapseGroup2 = _interopRequireDefault(_collapseGroup);

var _antd = require('antd');

var _onlineDoc = require('./online-doc');

var _onlineDoc2 = _interopRequireDefault(_onlineDoc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CollapseItem = function (_React$PureComponent) {
  _inherits(CollapseItem, _React$PureComponent);

  function CollapseItem() {
    _classCallCheck(this, CollapseItem);

    var _this = _possibleConstructorReturn(this, (CollapseItem.__proto__ || Object.getPrototypeOf(CollapseItem)).call(this));

    _this.state = {
      activated: false
    };

    _this.getIcon = function () {
      var icon = _this.props.item.icon;

      if (icon && typeof icon === 'string') {
        return _react2.default.createElement('div', { className: 'zacheditor-collapse-item-icon', dangerouslySetInnerHTML: { __html: icon } });
      }
      if (icon) {
        return _react2.default.createElement(
          'div',
          { className: 'zacheditor-collapse-item-icon' },
          icon
        );
      }
      return null;
    };

    _this.videoTrigger = null;
    _this.videoUploader = null;
    return _this;
  }

  _createClass(CollapseItem, [{
    key: 'onVideoTriggerClick',
    value: function onVideoTriggerClick() {
      var _props = this.props,
          engine = _props.engine,
          onToolBarClick = _props.onToolBarClick;

      if (!this.videoUploader) {
        this.videoUploader = new _videoUploader2.default({
          trigger: this.videoTrigger,
          engine: engine,
          onToolBarClick: onToolBarClick,
          onToolBarError: this.videoError
        });
      }
      this.videoTrigger.click();
    }

    /**
     * -100 网络错误
     * @param {object} err 错误对象
     */

  }, {
    key: 'videoError',
    value: function videoError() {
      var err = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _antd.message.error(err.code === -100 ? '网络异常：Failed to fetch' : err.message);
    }
  }, {
    key: 'handleMouseEnter',
    value: function handleMouseEnter() {
      this.setState({
        activated: true
      });
    }
  }, {
    key: 'handleMouseLeave',
    value: function handleMouseLeave() {
      this.setState({
        activated: false
      });
    }
  }, {
    key: 'renderCommon',
    value: function renderCommon() {
      var _props2 = this.props,
          item = _props2.item,
          index = _props2.index,
          itemOnClick = _props2.itemOnClick;

      var activeClass = this.state.activated ? ' zacheditor-collapse-list-item-active' : '';
      var style = item.subTitle ? {
        height: 'auto'
      } : {};

      return _react2.default.createElement(
        'div',
        {
          key: index,
          'data-index': index,
          'data-aspm-click': ''.concat(item.name),
          accessbilityid: ''.concat(item.name, '-section-button'),
          className: 'zacheditor-collapse-list-item'.concat(activeClass),
          onClick: itemOnClick,
          onMouseEnter: this.handleMouseEnter.bind(this),
          onMouseLeave: this.handleMouseLeave.bind(this),
          style: style
        },
        this.getIcon(),
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-collapse-item-text' },
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-collapse-item-title' },
            item.title,
            item.subTitle && _react2.default.createElement(
              'span',
              { className: 'zacheditor-collapse-item-sub-title' },
              item.subTitle
            ),
            item.subNew && _react2.default.createElement(
              'span',
              { className: 'zacheditor-sub-new-tag' },
              item.subNew
            ),
            item.isNew ? _react2.default.createElement('span', { className: 'zacheditor-svg-icon-new-section' }) : ''
          )
        )
      );
    }
  }, {
    key: 'formatAcceptExts',
    value: function formatAcceptExts() {
      return '.3gp,.asf,.avi,.dv,.flv,.f4v,.gif,.m2t,.m4v,.mj2,.mjpeg,.mkv,.mov,.mp4,.mpg,.mpeg,.mts,.ogg,.rm,.rmvb,.swf,.ts,.vob,.wmv,.webm';
    }
  }, {
    key: 'renderVideo',
    value: function renderVideo() {
      var _this2 = this;

      var _props3 = this.props,
          item = _props3.item,
          index = _props3.index;

      var activeClass = this.state.activated ? ' zacheditor-collapse-list-item-active' : '';
      return _react2.default.createElement(
        'div',
        {
          key: index,
          'data-index': index,
          'data-aspm-click': ''.concat(item.name),
          className: 'zacheditor-collapse-list-item'.concat(activeClass),
          onClick: this.onVideoTriggerClick.bind(this),
          onMouseEnter: this.handleMouseEnter.bind(this),
          onMouseLeave: this.handleMouseLeave.bind(this)
        },
        this.getIcon(),
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-collapse-item-text' },
          _react2.default.createElement(
            'div',
            { className: 'zacheditor-collapse-item-title' },
            item.title
          )
        ),
        _react2.default.createElement('input', {
          ref: function ref(e) {
            return _this2.videoTrigger = e;
          },
          type: 'file',
          accept: this.formatAcceptExts(),
          className: 'uploader'
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          item = _props4.item,
          type = _props4.type;

      var child = void 0;
      if (item.name === 'onlinedoc') {
        child = _react2.default.createElement(_onlineDoc2.default, this.props);
      } else if (type === 'video') {
        child = this.renderVideo();
      } else {
        child = this.renderCommon();
      }
      return _react2.default.createElement(
        _collapseGroup2.default,
        { data: item.tooltip },
        child
      );
    }
  }]);

  return CollapseItem;
}(_react2.default.PureComponent);

exports.default = CollapseItem;