'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableSelector = function (_React$Component) {
  _inherits(TableSelector, _React$Component);

  function TableSelector() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TableSelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TableSelector.__proto__ || Object.getPrototypeOf(TableSelector)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      maxRows: 10,
      maxCols: 10,
      minRows: 4,
      minCols: 4,
      currentCols: 4,
      currentRows: 4,
      selectedCols: 0,
      selectedRows: 0
    }, _this.onSelect = function (e, rows, cols) {
      _this.props.onSelect(e, rows + 1, cols + 1);
    }, _this.onHover = function (rows, cols) {
      var showRows = Math.max(_this.state.minRows, Math.min(_this.state.maxRows, rows + 2));
      var showCols = Math.max(_this.state.minCols, Math.min(_this.state.maxCols, cols + 2));

      _this.setState({
        currentRows: showRows,
        currentCols: showCols,
        selectedRows: rows + 1,
        selectedCols: cols + 1
      });
    }, _this.renderTr = function (r, cols) {
      var _this$state = _this.state,
          selectedRows = _this$state.selectedRows,
          selectedCols = _this$state.selectedCols;

      var tds = [];
      var _loop = function _loop(c) {
        var cls = (0, _classnames2.default)({
          'zacheditor-toolbar-table-selector-td': true,
          actived: r < selectedRows && c < selectedCols
        });
        tds.push(_react2.default.createElement('div', {
          className: cls,
          key: c,
          onMouseDown: function onMouseDown(e) {
            return _this.onSelect(e, r, c);
          },
          onMouseOver: function onMouseOver() {
            return _this.onHover(r, c);
          }
        }));
      };

      for (var c = 0; c < cols; c++) {
        _loop(c);
      }
      return tds;
    }, _this.renderTable = function (rows, cols) {
      var trs = [];
      for (var r = 0; r < rows; r++) {
        trs.push(_react2.default.createElement(
          'div',
          { className: 'zacheditor-toolbar-table-selector-tr', key: r },
          _this.renderTr(r, cols)
        ));
      }
      return trs;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TableSelector, [{
    key: 'render',
    value: function render() {
      var _state = this.state,
          currentCols = _state.currentCols,
          currentRows = _state.currentRows;

      var selectedRows = this.state.selectedRows === undefined ? 0 : this.state.selectedRows;
      var selectedCols = this.state.selectedCols === undefined ? 0 : this.state.selectedCols;
      return _react2.default.createElement(
        'div',
        { className: 'zacheditor-toolbar-table-selector', 'data-zacheditor-element': 'table-selector' },
        this.renderTable(currentRows, currentCols),
        _react2.default.createElement(
          'div',
          { className: 'zacheditor-toolbar-table-selector-info' },
          selectedRows,
          '" x "',
          selectedCols
        )
      );
    }
  }]);

  return TableSelector;
}(_react2.default.Component);

exports.default = TableSelector;