'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _throttle = require('lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

var _toolbarMore = require('./toolbar-more');

var _toolbarMore2 = _interopRequireDefault(_toolbarMore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ToolbarPlugins = function (_React$Component) {
  _inherits(ToolbarPlugins, _React$Component);

  function ToolbarPlugins() {
    _classCallCheck(this, ToolbarPlugins);

    var _this = _possibleConstructorReturn(this, (ToolbarPlugins.__proto__ || Object.getPrototypeOf(ToolbarPlugins)).call(this));

    _this.state = {
      elementWidths: null,
      menuContainerWidth: null
    };

    _this.onResize = function () {
      var setContainerWidth = (0, _throttle2.default)(function () {
        _this.setState({
          menuContainerWidth: _this.getMenuContainerWidth()
        });
      }, 200, {
        leading: false
      });
      setContainerWidth();
    };
    _this.rootRef = _react2.default.createRef();
    _this.calcWidthTimeout = null;
    return _this;
  }

  _createClass(ToolbarPlugins, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      window.addEventListener('resize', this.onResize, false);
      this.calcWidthTimeout = setTimeout(function () {
        _this2.updateContainerWidth();
      }, 200);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _this3 = this;

      if (this.props.toolbarLength !== prevProps.toolbarLength) {
        this.setState({
          elementWidths: null
        }, function () {
          _this3.updateContainerWidth();
        });
      }
    }
  }, {
    key: 'updateContainerWidth',
    value: function updateContainerWidth() {
      var elementWidths = this.state.elementWidths;
      if (!elementWidths) {
        var domNode = _reactDom2.default.findDOMNode(this);
        var menuContainerWidth = this.getMenuContainerWidth();
        elementWidths = Array.prototype.map.call(domNode.children, function (childDomNode) {
          return childDomNode.clientWidth;
        });
        this.setState({
          elementWidths: elementWidths,
          menuContainerWidth: menuContainerWidth
        });
      }
    }
  }, {
    key: 'getMenuContainerWidth',
    value: function getMenuContainerWidth() {
      var width = this.rootRef.current.parentElement.clientWidth;
      var moreWidth = 50;
      return width - moreWidth;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.calcWidthTimeout) {
        clearTimeout(this.calcWidthTimeout);
      }
      window.removeEventListener('resize', this.onResize, false);
    }
  }, {
    key: 'findMoreBoundary',
    value: function findMoreBoundary() {
      var _state = this.state,
          elementWidths = _state.elementWidths,
          menuContainerWidth = _state.menuContainerWidth;

      var length = Object.keys(elementWidths).length;
      var index = -1;
      var width = 0;
      for (var o = 0; length - 1 > o; o++) {
        width += elementWidths[o];
        if (width + elementWidths[o + 1] > menuContainerWidth) {
          index = o;
          break;
        }
      }
      return index;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          hasMore = _props.hasMore;
      var elementWidths = this.state.elementWidths;

      var pluginItems = [];
      var morePluginItems = [];

      if (hasMore && elementWidths) {
        var boundary = this.findMoreBoundary();
        if (boundary === -1) {
          pluginItems = children;
        } else {
          _react2.default.Children.map(children, function (element, index) {
            if (_react2.default.isValidElement(element)) {
              if (index > boundary) {
                morePluginItems.push(element);
              } else {
                pluginItems.push(element);
              }
            }
          });
        }
      } else {
        pluginItems = children;
      }

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('zacheditor-toolbar-content-plugins', {
            'zacheditor-toolbar-content-plugins-hide': !this.state.elementWidths
          }),
          ref: this.rootRef
        },
        pluginItems,
        _react2.default.createElement(
          _toolbarMore2.default,
          null,
          morePluginItems
        )
      );
    }
  }]);

  return ToolbarPlugins;
}(_react2.default.Component);

exports.default = ToolbarPlugins;