"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var addScrollAndResizeEventListener = exports.addScrollAndResizeEventListener = function addScrollAndResizeEventListener(instance) {
    var callback = function callback() {
        instance.updateEditorPosition();
    };
    instance.scrollAndResizeCallback = callback;
    window.addEventListener("scroll", callback, true);
    window.addEventListener("resize", callback, true);
};

var removeScrollAndResizeEventListener = exports.removeScrollAndResizeEventListener = function removeScrollAndResizeEventListener(instance) {
    var callback = instance.scrollAndResizeCallback;
    window.removeEventListener("scroll", callback, true);
    window.removeEventListener("resize", callback, true);
};

var setCursor = exports.setCursor = function setCursor(instance) {
    instance.css("cursor", "pointer");
    instance.attr("draggable", !0);
    instance.css("user-select", "none");
};

var bindKeydownEvent = exports.bindKeydownEvent = function bindKeydownEvent(instance) {
    var editorContainer = instance.editorContainer,
        engine = instance.engine,
        sectionRoot = instance.sectionRoot;

    var callback = instance.callback === undefined ? function (event) {
        return -1 !== [13, 27].indexOf(event.keyCode);
    } : instance.callback;
    editorContainer.attr("tabIndex", 0);
    editorContainer.on("keydown", function (event) {
        if (engine && callback(event)) {
            event.preventDefault();
            engine.change.activateSection(document.body, "manual");
            engine.change.focusSection(sectionRoot);
        }
    });
    editorContainer.hide();
};