'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
/**
 * @fileOverview 类型判断
 */
var toString = {}.toString;

var isType = function isType(value, type) {
    return toString.call(value) === '[object ' + type + ']';
};

var isNil = exports.isNil = function isNil(value) {
    /**
     * isNil(null) => true
     * isNil() => true
     */
    return value === null || value === undefined;
};
var isNumber = exports.isNumber = function isNumber(value) {
    return isType(value, 'Number');
};

var isString = exports.isString = function isString(value) {
    return isType(value, 'String');
};
var isFunction = exports.isFunction = function isFunction(value) {
    return isType(value, 'Function');
};